PROGRAM READER_CI
IMPLICIT NONE

INTEGER :: i, n, k, l, u, nrow
CHARACTER :: trash
CHARACTER(len=21), DIMENSION(1000) :: config
CHARACTER(len=10), DIMENSION(1000) :: term
CHARACTER(len=4) :: Jtemp
CHARACTER(len=11) :: termtemp
CHARACTER(len=23) :: configtemp
CHARACTER(len=20) :: Etemp
DOUBLE PRECISION, DIMENSION(1000) :: level, J, alpha, alpha_T0
DOUBLE PRECISION, DIMENSION(100000) :: wl, A, Elow, Ehigh
DOUBLE PRECISION, DIMENSION(1000,1000) :: UPSILON, UPSILON_T
DOUBLE PRECISION :: cutlevel, ionizationlimit

cutlevel = 0.95   ! Cut atom at this fraction of the ion. energy

ionizationlimit = 90753.

! ....................................................

OPEN(10, file='cI_levels.dat'); REWIND(10)

DO i = 1, 4
   READ(10,*) trash
END DO

i = 0
DO 

   READ(10,'(A23,A1,A11,A1,A5,A1,A20)',END=100, ADVANCE='YES') configtemp, trash, termtemp, trash, Jtemp, trash, Etemp

   IF (Jtemp .EQ. '     ') THEN   ! blank line

      print *, "blank"
      !READ(10,*) trash

   ELSE IF (termtemp .EQ. '         ') THEN   ! fine-structure level

      i = i + 1
      !READ(10,*) J(i), trash, level(i)
      read(Jtemp,*) J(i)
      read(Etemp,*) level(i)
      !J(i) = dble(Jtemp)
      !level(i) = dble(Etemp)
      term(i) = term(i-1)
      config(i) = ' '

   ELSE  ! New term

       i = i + 1
       !READ(10,*) J(i), trash, level(i)
       read(Jtemp,*) J(i)
       read(Etemp,*) level(i)
       !J(i) = dble(Jtemp)
       !level(i) = dble(Etemp)
       term(i) = termtemp
       config(i) = configtemp

   END IF
   
   IF (level(i) > cutlevel*ionizationlimit) EXIT   ! exit loop if E > Ecut
   
END DO

100 continue

PRINT *, 'Number of levels:', i

close(10)

OPEN(10, file='recrates_specific_CI_1000K.dat',STATUS='OLD')

READ(10,*) trash

DO WHILE (1 .EQ. 1)
   READ(10,*,END=300) k, alpha(k), alpha_T0(k)
END DO

300 close(10)

OPEN(20, file='cI.dat', STATUS='REPLACE')

WRITE(20,*) 'C I L&L from NIST. Rec: Nahar 1995 101. Coll. str:Pradhan online.'
WRITE(20,*) 'n       E        g'

DO k = 1, i

   WRITE(20,'(I5, F15.3, I7, ES15.2, I10, A25, A10)') k, level(k), INT(2*J(k)+1), alpha(k), INT(alpha_T0(k)), config(k), term(k)

END DO

! ----------- LINE READING --------------------------------------
OPEN(30, file='cI_lines.dat');REWIND(30)

DO k = 1, 23
   READ(30,*) trash
   print *, trash
END DO

n = 0
nrow = 23
DO 

   READ(30,*,END=200) wl(n+1), trash, A(n+1), trash, trash, trash, Elow(n+1), trash, Ehigh(n+1)

   print *, wl(n+1)
   
   IF (n>0) THEN
      IF (wl(n+1) .EQ. wl(n)) THEN
         WRITE(*,*) 'Same line!', nrow
         STOP 1
      END IF
   END IF

   IF (Elow(n+1) < cutlevel*ionizationlimit .AND. Ehigh(n+1) < cutlevel*ionizationlimit) n = n + 1   ! Is transition within boundary levels?

  nrow = nrow + 1

END DO

200 continue

close(30)

OPEN(40,file='cI_collisions.dat');REWIND(40)

DO k = 1, 2
   READ(40,*) trash
END DO

DO 
   
   READ(40,*,END=500) l, u, upsilon(u,l), upsilon_T(u,l)

END DO

500 close(40)

! --------------- WRITE LINES ---------------------------------------

WRITE(20,*) 'Lines'
WRITE(20,*) 'i   j    WL      A'

DO u = 2, i
   DO l = 1, (u-1)

      DO k = 1, n

         IF ( (Ehigh(k) .EQ. level(u)) .AND. (Elow(k) .EQ. level(l) ))THEN

               WRITE(20,'(2I5, F20.2, ES12.2, F10.2, I10)') u, l, wl(k), A(k), UPSILON(u,l), INT(UPSILON_T(u,l))

               GOTO 50

         END IF

      END DO

      IF (upsilon(u,l) > 0) THEN

        WRITE(20,'(2I5, F20.2, ES12.2, F10.2, I10)') u, l, 0., 0., UPSILON(u,l), INT(UPSILON_T(u,l))

      end if

   50 continue

   END DO

END DO


close(20)

END
