PROGRAM KURUCZ_READER
IMPLICIT NONE

DOUBLE PRECISION, DIMENSION(1000) :: levels, gvec, alpha=0, alpha_T0=0, beta=0
DOUBLE PRECISION, DIMENSION(13) :: alphaE
LOGICAL :: LOWNEW, HIGHNEW
DOUBLE PRECISION :: code, upsilon, A_old, Wl_old, alfa
DOUBLE PRECISION, DIMENSION(100000) :: wl, A, Elow, Ehigh, Jlow, Jhigh
DOUBLE PRECISION, DIMENSION(1000,1000) :: WLMAT, AMAT, UPSILONMAT, ALFAMAT, TMAT
CHARACTER(len=5) :: name
CHARACTER(len=13), DIMENSION(100000) :: config_low, config_high, config
INTEGER :: i, i_lev, j, line, i_line, j_line, FLAG, copies, contlevs, m, n, ii
CHARACTER :: trash, temp
INTEGER, DIMENSION(:), ALLOCATABLE :: indvec
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: tempvec, tempvec3
CHARACTER(len=13), DIMENSION(:), ALLOCATABLE :: tempvec2

INTEGER, DIMENSION(10,3) :: map
DOUBLE PRECISION, DIMENSION(10) :: gold
! ------------------------------------------------

WLMAT = 0
AMAT = 0
levels = 0
gvec = 0
FLAG = 2
alphaE = 0
alpha = 0
alpha_T0 = 0
!alpha_T0_long = 0
UPSILONMAT = 0
copies = 0
contlevs = 0
ALFAMAT = 0  ! IMPORTANT
TMAT = 0

! -------------------------------------------------

OPEN(10, file='mgI_data.dat'); rewind(10)

      DO i = 1,4
         READ(10,*) trash
      END DO

      i_lev = 0
      line = 0

      DO WHILE (1 == 1)
 
         READ(10,11, END=100, ERR=120) wl(line+1), A(line+1), Elow(line+1), Jlow(line+1), config_low(line+1), Ehigh(line+1), Jhigh(line+1), config_high(line+1)
11       FORMAT (F11.4, E11.3, F13.3, F6.1, A11, F13.3, F6.1, A11) 

         wl(line+1) = 10*wl(line+1)        ! transform to 

         line = line + 1

         IF (line > 2) THEN
            IF (wl(line) == wl(line-1)) THEN
               IF (Elow(line) .EQ. Elow(line-1) .AND. Jlow(line) .EQ. Jlow(line-1) .AND. Ehigh(line) .EQ. Ehigh(line-1) .AND. Jhigh(line) .EQ. Jhigh(line-1) .AND. config_low(line) .EQ. config_low(line-1) .AND. config_high(line) .EQ. config_high(line-1) ) THEN

                     WRITE(*,*) 'Identical lines!'
                     copies = copies + 1
                     line = line-1
                     GOTO 33
                     END IF


            END IF
         END IF     

         IF ( (Elow(line) > 61671) .OR. (Ehigh(line) > 61671) ) THEN
                WRITE(*,*) 'Line involves a continuum level!'
                line = line - 1
                contlevs = contlevs + 1
                GOTO 33
         END IF
            
         LOWNEW = .TRUE.
         HIGHNEW = .TRUE.

         DO j = 1, i_lev
            IF (levels(j) .EQ. Elow(line)) LOWNEW = .FALSE.

            IF (levels(j) .EQ. Ehigh(line)) HIGHNEW = .FALSE.
          
         END DO

         IF (LOWNEW) THEN
            i_lev = i_lev + 1
            levels(i_lev) = Elow(line)
            gvec(i_lev) = 2*Jlow(line)+1
            config(i_lev) = config_low(line)
         END IF

         IF (HIGHNEW) THEN
            i_lev = i_lev + 1
            levels(i_lev) = Ehigh(line)
            gvec(i_lev) = 2*Jhigh(line)+1
            config(i_lev) = config_high(line)
         END IF

33    continue
      END DO

CLOSE(10)

GOTO 100

120 PRINT *,'READ ERROR at line', line ;STOP

100 PRINT *, line, 'lines found'

PRINT *, copies, 'identical lines found.',contlevs,' continuum levels found.'

PRINT *, i_lev, 'levels found'


ALLOCATE(indvec(i_lev)); indvec = 0

CALL indexx(i_lev, REAL(levels(1:i_lev)), indvec)

ALLOCATE(tempvec(i_lev)); tempvec=0
ALLOCATE(tempvec3(i_lev)); tempvec3 = 0
ALLOCATE(tempvec2(i_lev));

DO i = 1, i_lev
   tempvec(i) = levels(indvec(i))
   tempvec2(i) = config(indvec(i))
   tempvec3(i) = gvec(indvec(i))
END DO

levels(1:i_lev) = tempvec
gvec(1:i_lev) = tempvec3
config(1:i_lev) = tempvec2

DO i = 1, line

   DO j = 1, i_lev

      IF (levels(j) .EQ. Elow(i)) THEN
         i_line = j
         EXIT
      END IF

   END DO

   DO j = 1, i_lev

      IF (levels(j) .EQ. Ehigh(i)) THEN

         j_line = j
         EXIT

      END IF

   END DO

   WLMAT(j_line,i_line) = wl(i)
   AMAT(j_line,i_line) = A(i)

END DO



!OPEN(50, file='OLD/mgI_old.dat');REWIND(50)

!DO i = 1, 25
!   READ(50,*) trash
!END DO

!map = 0
!map(1,1) = 1
!map(2,1:3) = (/2,3,4/)
!map(3,1) = 5
!map(4,1) = 6
!map(5,1) = 7
!map(6,1) = 8
!map(7,1:3) = (/9,10,11/)
!map(8,1:3) = (/12,13,14/)
!map(9,1) = 15
!map(10,1:3) = (/19,20,21/)

!gold = (/1,9,3,3,1,5,9,15,3,15/)

!DO WHILE (1==1)

!   READ(50,*,END=500) j, i, trash, trash, trash, trash, WL_old, A_old, upsilon, alfa

!   DO m = map(j,1), MAXval(map(j,1:3))
!      DO n = map(i,1), MAXval(map(i,1:3))

!         UPSILONMAT(m,n) = upsilon*gvec(m)*gvec(n)/(gold(j)*gold(i))

!         ALFAMAT(m,n) = alfa

!      END DO
!   END DO

!END DO

!500 close(50)

open(50,file='collisionrates.dat')

read(50,*) trash

read(50,*) trash

DO

  read(50,*,END=811) m, n, UPSILONMAT(m,n), TMAT(m,n), ALFAMAT(m,n)

END DO
   
811 close(50)

OPEN(10,file='mgI_recratesspecific.dat',STATUS='OLD')


READ(10,*) trash

DO

  READ(10,*,END=71) ii, alpha(ii), alpha_T0(ii), beta(ii)

END DO

71 close(10)

PRINT * ,' apa', sum(alpha)

       
! ------------- WRITING DATA FILE ----------------------------------

OPEN(20, file='mgI.dat', STATUS='REPLACE');

  WRITE(20,*) 'MgI - Kurusc data', i_lev, 'levels'
  WRITE(20,*) 'i        E [cm-1]         g'

  DO i = 1, i_lev 

      WRITE(20,'(I6, F15.3, F7.1,  ES12.2, F10.0, F10.2, A20)') i, levels(i), gvec(i), alpha(i), alpha_T0(i), beta(i), config(i)  

  END DO

  WRITE(20,*) 'Lines'
  WRITE(20,*) ' i   j               WL [A]          A           UPSILON        T'


  DO j = 2, i_lev
    DO i = 1, j-1
       
      IF (AMAT(j,i) > 0 .OR. UPSILONMAT(j,i) > 0) THEN
                 
         WRITE(20,21) j, i, WLMAT(j,i), AMAT(j,i), UPSILONMAT(j,i), INT(TMAT(j,i)), ALFAMAT(j,i)
         21 FORMAT(2I6, F20.2, ES15.2, ES10.2, I10, F5.1)

      END IF

    END DO
  END DO

CLOSE(20)


END PROGRAM
