PROGRAM READER
IMPLICIT NONE

INTEGER :: i, j, n, k, l, u, Jup, Jner, ii, jj, kk, ll
CHARACTER :: trash
CHARACTER(len=21), DIMENSION(100) :: config
CHARACTER(len=10), DIMENSION(100) :: term
CHARACTER(len=4) :: Jtemp
CHARACTER(len=8) :: termtemp
CHARACTER(len=27) :: configtemp
CHARACTER(len=2) :: Jupchar
CHARACTER(len=1) :: wlchar
DOUBLE PRECISION, DIMENSION(100) :: level, Jvec, alpha=0, alpha_T0=0, beta=0
DOUBLE PRECISION, DIMENSION(1000) :: wl, A, Elow, Ehigh
DOUBLE PRECISION, DIMENSION(100,100) :: UPSILON, UPSILON_T, UPSILON_ALFA
DOUBLE PRECISION :: ni, nj, nfactor, T, T4
DOUBLE PRECISION, DIMENSION(13) :: E, g
INTEGER, DIMENSION(13) :: ncorr 
DOUBLE PRECISION, DIMENSION(13,13) :: CMAT, RMAT, OMEGA
INTEGER, DIMENSION(13,13) :: CORR
DOUBLE PRECISION, PARAMETER :: eV=1.602E-12,h=6.626e-27,c=3e10

! ....................................................

UPSILON = 0

UPSILON_T = 0

UPSILON_ALFA = 0

OPEN(10, file='naI_levels.dat'); REWIND(10)

DO i = 1, 4
   READ(10,*) trash
END DO

i = 0
DO WHILE (1==1)

   !READ(10,'(A27,A1,A8,A2,I2,A1,I1,A2)',END=100, ADVANCE='NO') configtemp, trash, termtemp, trash, Jup, trash, Jner, trash 
   READ(10,'(A27,A1,A8,A2,A2)',END=100, ADVANCE='NO') configtemp, trash, termtemp, trash, Jupchar

   PRINT *, 'Jupchar',Jupchar

   IF (Jupchar .NE. '  ') THEN
   
      BACKSPACE(10)  ! Move back again

      READ(10,'(A27,A1,A8,A2,I2,A1,I1,A2)',END=100, ADVANCE='NO') configtemp, trash, termtemp, trash, Jup, trash, Jner, trash 


      IF (termtemp .EQ. '        ') THEN

         i = i + 1
         READ(10,*) level(i)
         term(i) = term(i-1)         
         config(i) = ' '
         Jvec(i) = DBLE(Jup)/DBLE(Jner)

      ELSE IF(Jup .NE. 0) THEN

         i = i + 1
         READ(10,*) level(i)
         term(i) = termtemp
         config(i) = configtemp
         Jvec(i) = DBLE(Jup)/DBLE(Jner)

      END IF

      PRINT *, level(i)

   ELSE

      READ(10,*) trash  ! Finish line

   END IF

      
END DO

100 continue

PRINT *, 'Number of levels:', i

close(10)

! Recombinations

OPEN(10,file='naI_recratesspecific.dat',STATUS='OLD')


READ(10,*) trash

DO

  READ(10,*,END=71) ii, alpha(ii), alpha_T0(ii), beta(ii)

END DO

71 close(10)


OPEN(20, file='naI.dat', STATUS='REPLACE')

WRITE(20,*) 'Na I L&L from NIST.'
WRITE(20,*) 'n       E        g'

DO k = 1, i

   WRITE(20,'(I5, F15.3, I7, A25, A10, ES10.3, F10.0, F10.2)') k, level(k), INT(2*Jvec(k)+1), config(k), term(k), alpha(k), alpha_T0(k), beta(k)

END DO

! ----------- LINE READING --------------------------------------

OPEN(30, file='naI_lines.dat');REWIND(30)

DO k = 1, 6
   READ(30,*) trash
END DO

n = 0
DO WHILE (1==1)

   READ(30,*,END=200) wlchar

   PRINT *, i, wlchar

   IF (wlchar .NE. '|') THEN

      BACKSPACE(30)

      READ(30,*,END=200) wl(n+1), trash, A(n+1), trash, trash, trash, Elow(n+1), trash, Ehigh(n+1)

      IF (n>0 .AND. wl(n+1) .EQ. wl(n)) THEN

         A(n) = MAXVAL([A(n),A(n+1)])
         
         WRITE(*,*) 'Same line!', n
           
      ELSE

         n = n + 1

      END IF
      
   END IF

   PRINT *, n


END DO

200 continue

close(30)

OPEN(40,file='naI_collstrengths.dat',STATUS='OLD');REWIND(40)

DO ii = 1, 13

   READ(40,*) trash, g(ii), E(ii)

END DO

READ(40,*) trash

DO 

   READ(40,*,END=222) ii, jj, CMAT(ii,jj), RMAT(ii,jj)

   ni = SQRT(13.6/(5.139-h*c*E(ii)/eV))

   nj = SQRT(13.6/(5.139-h*c*E(jj)/eV))

   nfactor = ni**5*nj**5*(1./ni**2 - 1./nj**2)**4

   T = 3000. ! CARE

   T4 = T/1E4

   omega(ii,jj) = CMAT(ii,jj)*T4**RMAT(ii,jj)*T**0.5*g(ii)*g(jj)/8.629e-6/nfactor

   PRINT *, ii, jj, OMEGA(ii,jj), RMAT(ii,jj)+0.5

END DO

222 close(40)

ncorr(1) = 1; corr(1,1) = 1
ncorr(2) = 2; corr(2,1) = 2; corr(2,2) = 3
ncorr(3) = 1; corr(3,1) = 4
ncorr(4) = 2; corr(4,1) = 5; corr(4,2) = 6
ncorr(5) = 2; corr(5,1) = 7; corr(5,2) = 8
ncorr(6) = 1; corr(6,1) = 9;
ncorr(7) = 2; corr(7,1) = 10; corr(7,2) = 11
ncorr(8) = 2; corr(8,1) = 12; corr(8,2) = 13

DO ii = 1, 7

   DO jj = ii+1, 8

      DO kk = 1, ncorr(ii)

         DO ll = 1, ncorr(jj)

            PRINT *, corr(ii,kk), corr(jj,ll), omega(ii,jj)

         END DO

      END DO

    END DO

END DO



!OPEN(40,file='cII_collstrengths.dat');REWIND(40)

!DO k = 1, 10
   
!   READ(40,*) u, l, upsilon(u,l), upsilon_T(u,l)

!END DO

!close(40)

UPSILON(2,1) = 4.5*0.33    ! My own computations from Trail 1994 (which agree very well with Kennedy 1977: 10.45*T4^0.837)
UPSILON_T(2,1) = 3000
UPSILON_ALFA(2,1) = 0.7

UPSILON(3,1) = 4.5*0.67
UPSILON_T(3,1) = 3000
UPSILON_ALFA(3,1) = 0.7



! --------------- WRITE LINES ---------------------------------------

WRITE(20,*) 'Lines'
WRITE(20,*) 'i   j    WL      A'

DO u = 2, i
   DO l = 1, (u-1)

      DO k = 1, n

         IF ( (Ehigh(k) .EQ. level(u) .AND. Elow(k) .EQ. level(l)  .AND. A(k) > 0))THEN

               WRITE(20,'(2I5, F20.2, ES12.2, F10.2, I10, F10.2)') u, l, wl(k), A(k), UPSILON(u,l), INT(UPSILON_T(u,l)), UPSILON_ALFA(u,l)

            !WRITE(20,'(2I5, F20.2, ES12.2)') u, l, wl(k), A(k)

               GOTO 50

         END IF

      END DO

      !IF (UPSILON(u,l) > 0) THEN
         
      !   WRITE(20,'(2I5, F20.2, ES12.2, F10.2, I10, F10.4)') u, l, 0., 0., UPSILON(u,l), INT(UPSILON_T(u,l))

      !END IF
         

   50 continue

   END DO

END DO


close(20)

END
