PROGRAM NIII_READER
IMPLICIT NONE

DOUBLE PRECISION, DIMENSION(1000) :: levels, gvec, alpha, alpha_T0_long
DOUBLE PRECISION, DIMENSION(13) :: alphaE, alpha_short, alpha_T0
LOGICAL :: LOWNEW, HIGHNEW
DOUBLE PRECISION :: code, upsilon, A_old, Wl_old, wl_temp, A_temp, Elower_temp, Eupper_temp, val
DOUBLE PRECISION, DIMENSION(100000) :: wl, A, Elow, Ehigh, Jlow, Jhigh
DOUBLE PRECISION, DIMENSION(1000,1000) :: WLMAT, AMAT, UPSILONMAT
CHARACTER(len=5) :: name
CHARACTER(len=13), DIMENSION(100000) :: config_low, config_high, config
INTEGER :: i, i_lev, j, line, i_line, j_line, FLAG
CHARACTER :: trash, temp
INTEGER, DIMENSION(:), ALLOCATABLE :: indvec
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: tempvec, tempvec3
CHARACTER(len=13), DIMENSION(:), ALLOCATABLE :: tempvec2

! ------------------------------------------------

WLMAT = 0
AMAT = 0
levels = 0
gvec = 0
FLAG = 2
alphaE = 0
alpha = 0
alpha_T0 = 0
alpha_T0_long = 0
UPSILONMAT = 0

! -------------------------------------------------

OPEN(10, file='NiII_kurucz.dat'); rewind(10)

      DO i = 1,4
         READ(10,*) trash
      END DO

      i_lev = 0
      line = 0

      DO WHILE (1 == 1)
 
         READ(10,11, END=100, ERR=120) wl(line+1), A(line+1), trash, Elow(line+1), Jlow(line+1), config_low(line+1), Ehigh(line+1), Jhigh(line+1), config_high(line+1)
11       FORMAT (F11.4, E11.3, A13, F16.3, F6.1, A11, F13.3, F6.1, A11) 


         wl(line+1) = 10*wl(line+1)        ! transform to 

         line = line + 1

         IF (line > 2) THEN
            IF (wl(line) == wl(line-1)) THEN
               IF (Elow(line) .EQ. Elow(line-1) .AND. Jlow(line) .EQ. Jlow(line-1) .AND. Ehigh(line) .EQ. Ehigh(line-1) .AND. Jhigh(line) .EQ. Jhigh(line-1) ) THEN

                     WRITE(*,*) 'Identical lines!'
                     stop 1
                     END IF


            END IF
         END IF     

         !PRINT *, line
            
         LOWNEW = .TRUE.
         HIGHNEW = .TRUE.

         DO j = 1, i_lev
            IF (levels(j) .EQ. Elow(line)) LOWNEW = .FALSE.

            IF (levels(j) .EQ. Ehigh(line)) HIGHNEW = .FALSE.
          
         END DO

         IF (LOWNEW) THEN
            i_lev = i_lev + 1
            levels(i_lev) = Elow(line)
            gvec(i_lev) = 2*Jlow(line)+1
            config(i_lev) = config_low(line)
         END IF

         IF (HIGHNEW) THEN
            i_lev = i_lev + 1
            levels(i_lev) = Ehigh(line)
            gvec(i_lev) = 2*Jhigh(line)+1
            config(i_lev) = config_high(line)
         END IF

33    continue
      END DO

CLOSE(10)

GOTO 100

120 PRINT *,'READ ERROR at line', line ;STOP

100 PRINT *, line, 'lines found'

PRINT *, i_lev, 'levels found'

PRINT *, i_lev, 'levels found'

ALLOCATE(indvec(i_lev)); indvec = 0

CALL indexx(i_lev, REAL(levels(1:i_lev)), indvec)

ALLOCATE(tempvec(i_lev)); tempvec=0
ALLOCATE(tempvec3(i_lev)); tempvec3 = 0
ALLOCATE(tempvec2(i_lev));

DO i = 1, i_lev
   tempvec(i) = levels(indvec(i))
   tempvec2(i) = config(indvec(i))
   tempvec3(i) = gvec(indvec(i))
END DO

levels(1:i_lev) = tempvec
gvec(1:i_lev) = tempvec3
config(1:i_lev) = tempvec2

DO i = 1, line

   DO j = 1, i_lev

      IF (levels(j) .EQ. Elow(i)) THEN
         i_line = j
         EXIT
      END IF

   END DO

   DO j = 1, i_lev

      IF (levels(j) .EQ. Ehigh(i)) THEN

         j_line = j
         EXIT

      END IF

   END DO

   WLMAT(j_line,i_line) = wl(i)
   AMAT(j_line,i_line) = A(i)

END DO

500 close(50)

OPEN(60,file='niII_NIST.dat')

DO i = 1, 5
   READ(60,*) trash
END DO

DO WHILE (1 .EQ. 1)

   READ(60,*,END=200) wl_temp, trash, A_temp, trash, trash, trash, Elower_temp, trash, Eupper_temp

   DO i = 1, i_lev

      IF (Elower_temp .EQ. levels(i)) THEN

         DO j = 1, i_lev

            IF (Eupper_temp .EQ. levels(j)) THEN

               AMAT(j,i) = AMAT(j,i) + A_temp

               WLMAT(j,i) = wl_temp

               PRINT *, 'Hit!', i, j

               GOTO 55

            END IF

         END DO

      END IF

   END DO

55 continue

END DO

200 close(60)

open(10,file='niII_cassidy2010.dat',STATUS='OLD')

DO i = 1, 54

  read(10,*) trash

END DO

DO

  read(10,*,END=432) i, j, trash, trash, trash, trash, trash, UPSILONMAT(j,i)

END DO

432 close(10)

! -----------------

open(10,file='niII_cassidy2011.dat',STATUS='OLD')

DO i = 1, 4

  read(10,*) trash

END DO

DO

  read(10,*,END=433) i, j, trash, trash, trash, trash, val 

  if (j > 81 .or. (i == 63) .or. (j == 63) .or. (i == 64) .or. (j == 64)) then  ! Dont include very high states  or states 63 or 64 (not in model atom)

     cycle

  end if

  if (i >= 65) i = i - 2   ! Adjust for missing 63 and 64 levels

  if (j >= 65) j = j - 2 

  UPSILONMAT(j,i) = val

END DO

433 close(10)
! ------------- WRITING DATA FILE ----------------------------------

OPEN(20, file='niII.dat', STATUS='REPLACE');

  WRITE(20,*) 'NiII - Kurusc data', i_lev, 'levels'

  WRITE(20,*) 'i        E [cm-1]         g'

  DO i = 1, 500    ! TEMP

      WRITE(20,'(I6, F15.3, F7.1, A20)') i, levels(i), gvec(i), config(i) 

  END DO

  WRITE(20,*) 'Lines'
  WRITE(20,*) ' i   j          WL [A]       A      Upsilon(5000K)'


  !DO j = 2, i_lev
  DO j = 2, 500    ! TEMP
   DO i = 1, j-1
       
      IF (AMAT(j,i) > 0 .OR. UPSILONMAT(j,i) > 0) THEN
 

                IF (WLMAT(j,i) < 0.0001) THEN   ! replace zero wavelengths with proper values


                      WLMAT(j,i) =1e8/(levels(j)-levels(i))

                END IF       

                WRITE(20,21) j, i, WLMAT(j,i), AMAT(j,i), UPSILONMAT(j,i)  ! AMAT(j,i)/6.67e13*gvec(j)/gvec(i)*(WLMAT(j,i)/10.0)**2

              
                21 FORMAT(2I6, F20.2, ES15.2, ES15.2)


      END IF

    END DO
  END DO

CLOSE(20)


END PROGRAM
