PROGRAM READER_kurucz_SI
IMPLICIT NONE

DOUBLE PRECISION, DIMENSION(700) :: levels, gvec, alpha, alpha_T0_long
LOGICAL :: LOWNEW, HIGHNEW
DOUBLE PRECISION :: code
DOUBLE PRECISION, DIMENSION(100000) :: wl, A, Elow, Ehigh, Jlow, Jhigh
DOUBLE PRECISION, DIMENSION(700,700) :: WLMAT, AMAT
CHARACTER(len=5) :: name
CHARACTER(len=13), DIMENSION(6000) :: config_low, config_high
INTEGER :: i, i_lev, j, line, i_line, j_line, FLAG, counter, n, u, l
CHARACTER :: trash, temp
CHARACTER(len=13), DIMENSION(1000) :: config, term, ref
INTEGER, DIMENSION(:), ALLOCATABLE :: indvec
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: tempvec, tempvec3
CHARACTER(len=13), DIMENSION(:), ALLOCATABLE :: tempvec2
CHARACTER(len=13) :: trash2

! ------------------------------------------------

WLMAT = 0
AMAT = 0
levels = 0
gvec = 0
FLAG = 2

counter = 0

! -------------------------------------------------

OPEN(10, file='sI_kur_withref.dat'); rewind(10)

      DO i = 1,4
         READ(10,*) trash
      END DO

      i_lev = 0
      line = 0

      DO WHILE (counter < 834)

         counter = counter + 1
   
         READ(10,11, END=100, ERR=120) wl(line+1), A(line+1), code, name, Elow(line+1), Jlow(line+1), config_low(line+1), Ehigh(line+1), Jhigh(line+1), config_high(line+1), ref(line+1)
11       FORMAT (F11.4, E11.3, F7.2, A5, F16.3, F6.1, A9, F15.3, F6.1, A12, A4) 

        !print *, ref(line+1)

        IF (ref(line+1) == 'GUES') THEN

          ! print *, 'cycling'

          CYCLE

         END IF

         line = line + 1

         wl(line) = 10*wl(line)        ! transform to 
 
         IF (line > 2) THEN
            IF (wl(line) == wl(line-1)) THEN
               IF (Elow(line) .EQ. Elow(line-1) .AND. Jlow(line) .EQ. Jlow(line-1) .AND. Ehigh(line) .EQ. Ehigh(line-1) .AND. Jhigh(line) .EQ. Jhigh(line-1)) THEN

                     WRITE(*,*) 'Identical lines!', wl(line)
                     stop 1
                     END IF

            END IF
         END IF

        
         LOWNEW = .TRUE.
         HIGHNEW = .TRUE.

         DO j = 1, i_lev
            IF (levels(j) .EQ. Elow(line)) THEN
         
               LOWNEW = .FALSE.

            ELSE IF ( levels(j) .EQ. Ehigh(line)) THEN

               HIGHNEW = .FALSE.
          
            END IF
         END DO

         IF (LOWNEW) THEN
            i_lev = i_lev + 1
            levels(i_lev) = Elow(line)
            gvec(i_lev) = 2*Jlow(line)+1
            config(i_lev) = config_low(line)
         END IF

         IF (HIGHNEW) THEN
            i_lev = i_lev + 1
            levels(i_lev) = Ehigh(line)
            gvec(i_lev) = 2*Jhigh(line)+1
            config(i_lev) = config_high(line)
         END IF       

      END DO

CLOSE(10)

GOTO 100

120 PRINT *,'READ ERROR at line';STOP

100 PRINT *, line, 'lines found'

PRINT *, i_lev, 'levels found'

ALLOCATE(indvec(i_lev)); indvec = 0

CALL indexx(i_lev, REAL(levels(1:i_lev)), indvec)

ALLOCATE(tempvec(i_lev)); tempvec=0
ALLOCATE(tempvec3(i_lev)); tempvec3 = 0
ALLOCATE(tempvec2(i_lev));

DO i = 1, i_lev
   tempvec(i) = levels(indvec(i))
   tempvec2(i) = config(indvec(i))
   tempvec3(i) = gvec(indvec(i))
END DO

levels(1:i_lev) = tempvec
gvec(1:i_lev) = tempvec3
config(1:i_lev) = tempvec2



DO i = 1, line

   DO j = 1, i_lev

      IF (levels(j) .EQ. Elow(i)) THEN
         i_line = j
         EXIT
      END IF

   END DO

   DO j = 1, i_lev

      IF (levels(j) .EQ. Ehigh(i)) THEN

         j_line = j
         EXIT

      END IF

   END DO

   WLMAT(j_line,i_line) = wl(i)
   AMAT(j_line,i_line) = A(i)

END DO

! ADD ON EXTRA LINES - TYPICALLY FORBIDDEN FROM NIST
! ---------------------------------

OPEN(30, file='sI_lines_NIST.dat');REWIND(30)

DO i = 1, 5
   READ(30,*) trash
END DO

n = 1
DO 

   READ(30,*,END=200) wl(n), trash, A(n), trash, trash, trash, Elow(n), trash, Ehigh(n)  ! These are all defined before, not further needed

   IF (n>2) THEN
      IF (wl(n) .EQ. wl(n-1)) THEN
         WRITE(*,*) 'SAME WL!', n
         STOP 1
      END IF
   END IF

   print *, Elow(n), Ehigh(n)

   DO u = 2, i_lev   
      DO l = 1, u-1

         IF ( (Ehigh(n) .EQ. levels(u)) .AND. (Elow(n) .EQ. levels(l) ) .AND. (AMAT(u,l) == 0.) ) THEN  ! see if this transition can be identified

            WLMAT(u,l) = wl(n)
            AMAT(u,l) = A(n)
            print *, 'hit'
           

         END IF

      END DO

   END DO

   n = n + 1

END DO

200 continue

close(30)


! ---- WRITING ---------------------------

OPEN(20, file='sI.dat', STATUS='REPLACE');

  WRITE(20,*) 'SI - Kurusc data'
  WRITE(20,*) 'i        E [cm-1]         g'

  DO i = 1, i_lev 

      WRITE(20,'(I6, F15.3, I7, A20)') i, levels(i), INT(gvec(i)), config(i)

  END DO

  WRITE(20,*) 'Lines'
  WRITE(20,*) ' --------'

  PRINT *, i_lev

  DO j = 2, i_lev
    DO i = 1, j-1
       

      IF (AMAT(j,i) > 0) THEN
         
        
         WRITE(20,21,ERR=300) j, i, WLMAT(j,i), AMAT(j,i)
         21 FORMAT(2I6, F20.2, ES15.2)

      END IF

    END DO
  END DO

GOTO 400

CLOSE(20)

300 PRINT *, 'ERROR'

400 continue


END
