PROGRAM READER_SiI
IMPLICIT NONE

DOUBLE PRECISION, DIMENSION(700) :: levels, gvec, alpha, alpha_T0_long
DOUBLE PRECISION, DIMENSION(49) :: alphaE, alpha_short, alpha_T0
LOGICAL :: LOWNEW, HIGHNEW
DOUBLE PRECISION :: code
DOUBLE PRECISION, DIMENSION(100000) :: wl, A, Elow, Ehigh, Jlow, Jhigh
DOUBLE PRECISION, DIMENSION(700,700) :: WLMAT, AMAT
CHARACTER(len=5) :: name
CHARACTER(len=13), DIMENSION(6000) :: config_low, config_high
INTEGER :: i, i_lev, j, line, i_line, j_line, FLAG
CHARACTER :: trash, temp
CHARACTER(len=13), DIMENSION(1000) :: config, term
INTEGER, DIMENSION(:), ALLOCATABLE :: indvec
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: tempvec, tempvec3
CHARACTER(len=13), DIMENSION(:), ALLOCATABLE :: tempvec2
CHARACTER(len=13) :: trash2

! ------------------------------------------------

WLMAT = 0
AMAT = 0
levels = 0
gvec = 0
FLAG = 2
alphaE = 0
alpha = 0
alpha_T0 = 0
alpha_T0_long = 0

! -------------------------------------------------

OPEN(10, file='siI_kurucz.dat'); rewind(10)

      DO i = 1,4
         READ(10,*) trash
      END DO

      i_lev = 0
      line = 0

      DO 

         line = line + 1
   
         READ(10,11, END=100, ERR=120) wl(line), A(line), code, name, Elow(line), Jlow(line), config_low(line), Ehigh(line), Jhigh(line), config_high(line)
11       FORMAT (F11.4, E11.3, F7.2, A5, F16.3, F6.1, A9, F15.3, F6.1, A13) 

         wl(line) = 10*wl(line)        ! transform to 
  
         LOWNEW = .TRUE.
         HIGHNEW = .TRUE.

         DO j = 1, i_lev
            IF (levels(j) .EQ. Elow(line)) THEN
         
               LOWNEW = .FALSE.

            ELSE IF ( levels(j) .EQ. Ehigh(line)) THEN

               HIGHNEW = .FALSE.
          
            END IF
         END DO

         IF (LOWNEW) THEN
            i_lev = i_lev + 1
            levels(i_lev) = Elow(line)
            gvec(i_lev) = 2*Jlow(line)+1
            config(i_lev) = config_low(line)
         END IF

         IF (HIGHNEW) THEN
            i_lev = i_lev + 1
            levels(i_lev) = Ehigh(line)
            gvec(i_lev) = 2*Jhigh(line)+1
            config(i_lev) = config_high(line)
         END IF

      END DO

CLOSE(10)

GOTO 100

120 PRINT *,'READ ERROR at line';STOP

100 PRINT *, line, 'lines found'

PRINT *, i_lev, 'levels found'

ALLOCATE(indvec(i_lev)); indvec = 0

CALL indexx(i_lev, REAL(levels(1:i_lev)), indvec)

ALLOCATE(tempvec(i_lev)); tempvec=0
ALLOCATE(tempvec3(i_lev)); tempvec3 = 0
ALLOCATE(tempvec2(i_lev));

DO i = 1, i_lev
   tempvec(i) = levels(indvec(i))
   tempvec2(i) = config(indvec(i))
   tempvec3(i) = gvec(indvec(i))
END DO

levels(1:i_lev) = tempvec
gvec(1:i_lev) = tempvec3
config(1:i_lev) = tempvec2


OPEN(11,file='siI_recombdata.dat', STATUS='OLD'); REWIND(11)

    DO i = 1,3

       READ(11,*) trash

    END DO

    i = 1
    DO WHILE (i .LE. 49)  ! TEMP

       READ(11,'(A10)', END=200, ADVANCE='no') trash2


       IF (trash2(1:1) .NE. ' ') THEN

          READ(11,*) trash, trash, trash, trash, trash, alphaE(i), trash,  alpha_short(i), alpha_T0(i)

       ELSE


          READ(11,*) trash, trash, trash, trash, alphaE(i), trash, alpha_short(i), alpha_T0(i)
 
        

       END IF
 
       i = i + 1
50     CONTINUE

    END DO

200 CONTINUE

close(11)

j=0

DO i = 1, 49

   DO j = 1, i_lev

      IF (levels(j) .EQ. alphaE(i)) THEN

         alpha(j) = alpha_short(i)
         alpha_T0_long(j) = alpha_T0(i)

         EXIT
      END IF
   END DO

END DO


DO i = 1, line

   DO j = 1, i_lev

      IF (levels(j) .EQ. Elow(i)) THEN
         i_line = j
         EXIT
      END IF

   END DO

   DO j = 1, i_lev

      IF (levels(j) .EQ. Ehigh(i)) THEN

         j_line = j
         EXIT

      END IF

   END DO

   WLMAT(j_line,i_line) = wl(i)
   AMAT(j_line,i_line) = A(i)

END DO

OPEN(60, file='siI_FS.dat',STATUS='OLD')

DO i = 1, 3
   READ(60,*) trash
END DO

DO WHILE (1 .EQ. 1)

   READ(60,*,END=321) j, i, AMAT(j,i)
   WLMAT(j,i) = 1/(levels(j)-levels(i))*1E8

END DO

321 close(60)

! ---- WRITING ---------------------------

OPEN(20, file='siI.dat', STATUS='REPLACE');

  WRITE(20,*) 'SiI - Kurusc data. Rec from Nahar2000'
  WRITE(20,*) 'i        E [cm-1]         g'

  DO i = 1, i_lev 

      WRITE(20,'(I6, F15.3, I7, ES12.2, F10.0, A20)') i, levels(i), INT(gvec(i)), alpha(i), alpha_T0_long(i), config(i)

  END DO

  WRITE(20,*) 'Lines'
  WRITE(20,*) ' --------'

  PRINT *, i_lev

  DO j = 2, i_lev
    DO i = 1, j-1
       

      IF (AMAT(j,i) > 0) THEN
         
        
         WRITE(20,21,ERR=300) j, i, WLMAT(j,i), AMAT(j,i)
         21 FORMAT(2I6, F20.2, ES15.2)

      END IF

    END DO
  END DO

GOTO 400

CLOSE(20)

300 PRINT *, 'ERROR'

400 continue


END
