import numpy as np 
import matplotlib.pyplot as plt


def k3n(t):
    return  9.1 * 1e-22 * (t**(-3.08)) * np.exp(2114/t)

def kran(t):
    
    return 2*1e16 * k3n(t)

def kce1(t):
    return 1.4 * 1e-10 * (t/300)**-0.5 


n0 = 4.2*1e9


nheI = n0 * 0.811

ncI = n0 * 0.027 * 0.6
noI = n0 * 0.127 * 0.99

ncII = ncI * 0.4
noII = noI * 0.01




x = np.linspace(2000, 10000, 100)
y1 = noI * ncI * kran(x)

y2 = ncI * noI * nheI * k3n(x)


#plt.figure()
#plt.plot(x, y)

#plt.figure()

#plt.plot(x, y)
#plt.yscale('log')


plt.figure()

plt.plot(x, y1 / n0)
plt.plot(x, y2 / n0)

plt.yscale('log')
plt.ylim(1e-16, 1e-6)
plt.xlim(2000, 10000)


plt.savefig('test.pdf')




# value for each chemical reaction at 4000k !

t = 4000. 


k = 2.73*1e-14

r1 = ncII * noI * k
r2 = ncI * noII * k


k = 2 * 10e-7 * (300/t)**(48)

nsh = 1.
n2a  = [0.13, 0.55, 0.8] 

#100     200     300
#0.13    0.55    0.8

od  = 1e-17
tda = [100, 200, 300]


for i in range(3):

    td = tda[i]; n2 = n2a[i]
    ryd = 7 * 1e20 * nsh * n2 * np.exp(-td/114.)/(td**2) * od

    ryi = 2 * 1e21 * nsh * ( 1 - 0.5*n2) * np.exp(-td/114.)/(td**2) * od

    tot = ryd + ryi

    print(tot, ryd / tot)



x = [[100,2.98E-06, 1.01E-06],
    [200, 4.64E-06, 1.22E-06],
    [300, 8.08E-06, 1.31E-06]]


x = np.transpose(np.array(x))

plt.figure()

plt.plot(x[0], x[1], label = 'co')
plt.plot(x[0], x[2], label = 'co+')

plt.yscale('log')
plt.ylim(1e-6, 1e-3)
plt.xlim(100, 400)
plt.savefig('result_covstime.pdf')


k = 1e-10

fraco = 0.77696701957879311 * n0 * 0.127
fracc = 3.6516957079953638E-010 * n0 * 0.027

print(k*fraco*fracc)


frac_co = 0.10802968601430973 * 
gamma = 1.0


Solve the system of equations 

3 * x0 + x1 = 9  
x0 + 2 * x1 = 8:

>>>
>>> a = np.array([[3,1], [1,2]])
>>> b = np.array([9,8])
>>> x = np.linalg.solve(a, b)
>>> x
array([2.,  3.])

a = np.array([  [-1, 50, 0, 1], 
                [0, -50, 0, 0],
                [1,0,-1, 0],
                [1,1,1,1]])
b = np.array([0,0,0,1])


np.linalg.solve(a,b)


























plt.show()
