PROGRAM ADCOOLCOLLECTOR
USE M1
USE FILES, ONLY : file_runparameters, file_adcool, file_adcoolordered
IMPLICIT NONE

INTEGER :: i
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: adcool, frac, trec, treco111, heat, exc, ion
DOUBLE PRECISION, DIMENSION(:, :), ALLOCATABLE :: heatfracs, COOL
CHARACTER :: trash
INTEGER, DIMENSION(:), ALLOCATABLE :: recmain

IF (COMMAND_ARGUMENT_COUNT() >= 1) THEN
  CALL GET_COMMAND_ARGUMENT(1, file_runparameters) ! Run parameters file name (optional)
END IF

open(10,file=file_runparameters,STATUS='OLD')

do i = 1, 4; read(10,*) trash; end do

read(10,*) trash, Nr

close(10)

ALLOCATE(adcool(Nr)); adcool=0
ALLOCATE(frac(Nr)); frac=0
ALLOCATE(trec(Nr)); trec=0
ALLOCATE(treco111(Nr)); treco111=0
ALLOCATE(heat(Nr)); heat=0
ALLOCATE(exc(Nr)); exc=0
ALLOCATE(ion(Nr)); ion=0
ALLOCATE(heatfracs(Nr,10)); heatfracs=0
ALLOCATE(COOL(Nr,6)); COOL=0
ALLOCATE(recmain(Nr)); recmain=0

!CHARACTER(len=2), DIMENSION(15) :: R_index_str=['01','02','03','04','05','06','07','08','09','10','11','12','13','14','15']

DO i = 1, Nr

  OPEN(10,file=TRIM(file_adcool)//R_index_str(i),STATUS='OLD')

  READ(10,*) adcool(i), frac(i)

  close(10)

END DO



open(10,file=file_adcoolordered,STATUS='REPLACE')

DO i = 1, Nr

  write(10,*) i, adcool(i), frac(i)

END DO

close(10)

! COLLECT HEATFRACS FILES ----------

DO i = 1, Nr

  OPEN(10,file='out/main/heatfracs'//R_index_str(i),STATUS='OLD')

  READ(10,*) trash, trash, trash, trash, trash, heatfracs(i,1:10)

  close(10)

END DO

open(10,file='out/main/heatfracsordered.dat',STATUS='REPLACE')

write(10,'(5A9,5A12)') '      NT','PI','CD','CT','BR', 'NT','PI','CD','CT','BR'

DO i = 1, Nr

  write(10,'(I3, 5F9.2, 5ES12.1)') i, heatfracs(i,1:5), heatfracs(i,6:10)

END DO

close(10)

! COLLECT COOLING FILES ----------------

DO i = 1, Nr

   open(10,file='out/netheating/cooling.dat'//R_index_str(i),STATUS='OLD')

   read(10,*) trash, trash, trash, trash, trash, trash, trash, trash, trash, trash, trash, COOL(i,1:6)

   close(10)

END DO

open(10,file='out/netheating/coolingordered.dat',STATUS='REPLACE')

write(10,*) 'Lines  Recombinations  Free-free   Collion  CO   SiO'

DO i = 1, NR

   write(10,'(5F12.2)') COOL(i,1:6)

END DO

close(10)

! COLLECT TREC FILES -------------------------------

DO i = 1, Nr

  OPEN(10,file='out/ionization/trec.dat'//R_index_str(i),STATUS='OLD')

  READ(10,*) trash, trec(i), treco111(i), recmain(i)

  close(10)

END DO

open(10,file='out/ionization/trecordered.dat',STATUS='REPLACE')


DO i = 1, Nr

  write(10,*) i, trec(i), treco111(i), recmain(i)

END DO

close(10)

! COLLECT SF FILES ----------------------

DO i = 1, Nr

   OPEN(10,file='out/statisticalandthermalequilibrium/sf'//R_index_str(i),STATUS='OLD')

   read(10,*) trash, trash, trash, heat(i), exc(i), ion(i)

   close(10)

END DO

open(10,file='out/statisticalandthermalequilibrium/sfcollected.dat',STATUS='REPLACE')

write(10,*) 'Heating   Excitation  Ionization'

DO i = 1, Nr

   write(10,'(I5, 3ES10.1)') i, heat(i), exc(i), ion(i)

END DO

close(10)

DEALLOCATE(adcool, frac, trec, treco111, heat, exc, ion, heatfracs, COOL, recmain)

END
