SUBROUTINE ALLOC_MOL(mols)
!USE FILES, ONLY: dir_atomic_data
USE M1, ONLY : mmol, Nmol, Nabin
IMPLICIT NONE

TYPE (mmol), DIMENSION(Nmol), INTENT(INOUT) :: mols

! ===============================================
! Task   : Allocates fundamental properties of molecules : charge, mass, abincode etc.
! Input  : mmol            mols
! Output : mmol
! =============================================
CHARACTER :: trash
INTEGER :: i

open(12, file="DATA/mol_input/moldata_input.csv")

!the number of rows and columns in the input file
read(12, *) trash

do i=1, Nmol
    read(12, *), mols(i)%name, mols(i)%mbin, mols(i)%abin_parent1, mols(i)%abin_parent2, mols(i)%n_p1, mols(i)%n_p2, mols(i)%mass, mols(i)%z
    mols(i)%abin = Nabin + mols(i)%mbin
end do

close(12)



END 
