SUBROUTINE CHARGEREADER(atom, errsig)
USE M1, ONLY : atomm
IMPLICIT NONE

TYPE(atomm), INTENT(INOUT) :: atom
INTEGER, INTENT(OUT) :: errsig
! ==================================
! Task   : Determine the charge of the atom/ion by analysing its name
! Input  :  Atom        struct type atomm whose atom%NAME property must have been set
! Output :  Fills the atom%CHARGE slot
! ===================================

character(len=3) :: chargename

! ------------------------------------------------
errsig = 0
atom%charge = 0
! -----------------------------------------------

chargename = atom%NAME(3:5)  ! First two slots is letters, last three is I, II (or 2), III, IV or V

!sl: FIXME make this read the species type instead
IF (atom%NAME .EQ. 'H2  ' .OR. atom%NAME .EQ. 'SiOI ' .OR. atom%NAME .EQ. 'SiSI ' .OR. chargename .EQ. 'I  ') THEN

   atom%charge = 0

ELSE IF (chargename .EQ. 'II ' .OR. chargename .EQ. '2  ') THEN   ! Singly ionized

   atom%charge = 1

ELSE IF (chargename .EQ. 'III' .OR. chargename .EQ. '3  ') THEN   ! Doubly ionized
 
   atom%charge = 2

ELSE IF (chargename .EQ. 'IV ' .OR. chargename .EQ. '4  ') THEN   ! Triply ionized
   
   atom%charge = 3

ELSE IF (chargename .EQ. 'V  ') THEN   ! Quadroply ionized

   atom%charge = 4

ELSE IF (chargename .EQ. 'VI ') THEN   ! Five times ionized

   atom%charge = 5

ELSE
  
   WRITE(*,*) 'Error in chargereader: unknown charge', chargename

   atom%CHARGE = -1

   errsig = 1

END IF



END 
