PROGRAM CHECKCONV
USE M1, ONLY : Nr, Nelem, Nabin, R_index_str
USE FILES
IMPLICIT NONE

INTEGER :: i, j, k, largest_i=0, largest_j=0, largest_k=0, maxT_ind, maxxe_ind
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: Tnew, Told, Tchange, xenew, xeold, xechange
DOUBLE PRECISION, DIMENSION(:,:,:), ALLOCATABLE :: xmatnew, xmatold, ionchange, exccubenew, exccubeold, excchange
CHARACTER :: trash
DOUBLE PRECISION :: maxT, maxxe, largestsofar=0, temp, lbolnew, lbolold, maxL
LOGICAL :: EXISTS
DOUBLE PRECISION, DIMENSION(3) :: temp3

IF (COMMAND_ARGUMENT_COUNT() >= 1) THEN
  CALL GET_COMMAND_ARGUMENT(1, file_runparameters) ! Run parameters file name (optional)
END IF

open(10,file=file_runparameters,STATUS='OLD')

do i = 1,4; read(10,*) trash; end do

read(10,*) trash, Nr

close(10)

ALLOCATE(Tnew(Nr)); Tnew=0
ALLOCATE(Told(Nr)); Told=0
ALLOCATE(Tchange(Nr)); Tchange=0
ALLOCATE(xenew(Nr)); xenew=0
ALLOCATE(xeold(Nr)); xeold=0
ALLOCATE(xechange(Nr)); xechange=0
ALLOCATE(xmatnew(Nr,Nelem,3)); xmatnew=0
ALLOCATE(xmatold(Nr,Nelem,3)); xmatold=0
ALLOCATE(ionchange(Nr,Nelem,3)); ionchange=0
ALLOCATE(exccubenew(Nr,Nabin,1000)); exccubenew =0
ALLOCATE(exccubeold(Nr,Nabin,1000)); exccubeold=0
ALLOCATE(excchange(Nr,Nabin,1000)); excchange=0


! READ OLD SOLUTION ----------------------------------------------

! Lbol

inquire(file='out/checkconv/lbolold.dat',exist=EXISTS)

IF (EXISTS) THEN

  open(10,file='out/checkconv/lbolold.dat',STATUS='OLD')

  read(10,*) lbolold

  close(10)

ELSE

  lbolold = 0

END IF

! Temperature

inquire(file='out/checkconv/Told.dat',exist=EXISTS)

IF (EXISTS) THEN

   open(10,file='out/checkconv/Told.dat',STATUS='OLD')

   DO

      read(10,*,END=100) i, temp

      IF (i <= Nr) Told(i) = temp

   END DO

100 close(10)

ELSE

  Told = 0

END IF

! IONIZATION

inquire(file='out/checkconv/xeold.dat',exist=EXISTS)

IF (EXISTS) THEN

   open(10,file='out/checkconv/xeold.dat',STATUS='OLD')

   DO

      read(10,*,END=200) i, temp

      IF (i <= Nr) xeold(i) = temp

   END DO

200 close(10)

ELSE

   xeold = 0

END IF

inquire(file='out/checkconv/ionold.dat',exist=EXISTS)

IF (EXISTS) THEN

   open(10,file='out/checkconv/ionold.dat',STATUS='OLD')

   DO

      read(10,*,END=300) i, j, temp3

      IF (i <= Nr .and. j > 0 .and. j <= Nelem .and. i > 0) xmatold(i,j,1:3) = temp3

   END DO

300 close(10)

ELSE

   xmatold = 0

END IF

! EXCITATION ----------------

inquire(file='out/checkconv/excold.dat',exist=EXISTS)

IF (EXISTS) THEN

   open(10,file='out/checkconv/excold.dat',STATUS='OLD')

   DO

      read(10,*,END=110) i, j, k, temp

      IF (i <= Nr) exccubeold(i,j,k) = temp

   END DO

110 close(10)

ELSE

   exccubeold = 0

END IF

! READ NEW SOLUTIONS ---------------------------------------------

open(10,file='out/process/lbol.dat',STATUS='OLD')

read(10,*) lbolnew

close(10)

DO i = 1, Nr

   ! Temperatures

   open(10,file=TRIM(file_temps)//R_index_str(i),STATUS='OLD')

   read(10,*) Tnew(i)

   close(10)

   ! Ionization

   open(10,file=TRIM(file_ionfracs)//R_index_str(i),STATUS='OLD')

   read(10,*) trash, xenew(i)

   DO j = 1, Nelem

      read(10,*) trash, xmatnew(i,j,1:3)

   END DO

   close(10)

   open(10,file=TRIM(file_EXCCUBE)//R_index_str(i),STATUS='OLD')

   DO

      read(10,*,END=400) trash, j, k, exccubenew(i,j,k)

   END DO

   400 close(10)

END DO

! COMPUTE CHANGES -----------------------------------------

! Temperature ---------------------

Tchange = abs(Tnew/Told - 1.)

maxT = maxval(Tchange)

maxT_ind = maxloc(Tchange,1)


!print *, 'TCHANGE', maxT, maxT_ind

inquire(file='out/checkconv/Tchangelong.dat',exist=EXISTS)

IF (EXISTS) THEN

   open(10,file='out/checkconv/Tchangelong.dat',STATUS='OLD',POSITION='APPEND')

ELSE

    open(10,file='out/checkconv/Tchangelong.dat',STATUS='NEW')

END IF


  write(10,('(10000ES12.3)')) Tnew/Told - 1


close(10)



! IONIZATION --------------------------------

xechange = abs(xenew/xeold-1.)

!print *, 'XECHANGE', xechange

maxxe = maxval(xechange)

maxxe_ind = maxloc(xechange,1)

inquire(file='out/checkconv/xechangelong.dat',exist=EXISTS)

IF (EXISTS) THEN

   open(10,file='out/checkconv/xechangelong.dat',STATUS='OLD',POSITION='APPEND')

ELSE

   open(10,file='out/checkconv/xechangelong.dat',STATUS='NEW')

END IF

   write(10,('(10000ES12.2)')) xenew/xeold-1.

close(10)

DO i = 1, Nr

   DO j = 1, Nelem

      DO k = 1, 3

         IF ((xmatnew(i,j,k) == 0) .AND. (xmatold(i,j,k) == 0)) THEN  !both solutions are zero

            ionchange(i,j,k) = 0

         ELSE

            ionchange(i,j,k) = abs(xmatnew(i,j,k)/xmatold(i,j,k) - 1.)

         END IF

      END DO

   END DO

END DO

! EXCITATION -------------------------------

DO i = 1, Nr

   DO j = 1, Nabin

      DO k = 1, 1000

         IF ((exccubenew(i,j,k) == 0) .AND. (exccubeold(i,j,k) == 0)) THEN  !both solutions are zero

            excchange(i,j,k) = 0

         ELSE

            excchange(i,j,k) = abs(exccubenew(i,j,k)/exccubeold(i,j,k) - 1.)

            IF (excchange(i,j,k) > largestsofar) THEN

               largestsofar = excchange(i,j,k)

               largest_i = i

               largest_j = j

               largest_k = k

            END IF

         END IF

      END DO

   END DO

END DO

print '(A12, F8.2, A10, I4)', 'Max T change', maxT*100, '% in shell:', maxT_ind
print '(A13, F8.2, A10, I4)', 'Max xe change', maxxe*100, '% in shell:', maxxe_ind
!print '(A14, F8.2, A7, I4, A8, I4, A12, I4)', 'Max exc change', largestsofar, ' shell ', largest_i, ' Nelem: ', largest_j, ' ion. state:',  largest_k
print '(A11, F8.2, A1)', 'Lbol change', abs(lbolnew/lbolold-1.)*100, '%'
maxL = abs(lbolnew/lbolold-1.)

open(10,file='out/checkconv/maxchanges.dat',STATUS='REPLACE')

!write(10,*) 'T  xe  Lbol'

write(10,'(3F20.10)') maxT, maxxe, maxL

close(10)


! WRITE CHANGES TO FILE ----------------------------

open(10,file='out/checkconv/ionchanges.dat',STATUS='REPLACE')

DO i  = 1, Nr

   DO j = 1, Nelem

      write(10,'(2I6,10000ES12.3)'), i, j, ionchange(i,j,:)

   END DO

END DO

close(10)

! EXCITATION

open(10,file='out/checkconv/excchanges.dat',STATUS='REPLACE')

DO i  = 1, Nr

   DO j = 1, Nabin

      DO k = 1, 1000

         IF (excchange(i,j,k) > 0) THEN

            write(10,'(3I6,ES12.3)'), i, j, k, excchange(i,j,k)

         END IF

      END DO

   END DO

END DO

close(10)

!  WRITE NEW DATA TO OLD ---------------------------------------

open(10,file='out/checkconv/lbolold.dat',STATUS='REPLACE')

write(10,*) lbolnew

close(10)

! Temperature

open(10,file='out/checkconv/Told.dat',STATUS='REPLACE')

DO i = 1, Nr

  write(10,*) i, Tnew(i)

END DO

close(10)

! IONIZATION

open(10,file='out/checkconv/xeold.dat',STATUS='REPLACE')

DO i = 1, Nr

  write(10,*) i, xenew(i)

END DO

close(10)

open(10,file='out/checkconv/ionold.dat',STATUS='REPLACE')

DO i = 1, Nr

   DO j = 1, Nelem

      write(10,'(2I6, 3ES12.4)') i, j, xmatnew(i,j,1:3)

   END DO

END DO

close(10)

! EXCITATION

open(10,file='out/checkconv/excold.dat',STATUS='REPLACE')

DO i = 1, Nr

   DO j = 1, Nabin

      DO k = 1, 1000

         IF (exccubenew(i,j,k) > 0) THEN

            write(10,'(3I6, ES12.4)') i, j, k, exccubenew(i,j,k)

         END IF

      END DO

   END DO

END DO

close(10)

DEALLOCATE(Tnew, Told, Tchange, xenew, xeold, xechange, xmatnew, xmatold, ionchange, exccubenew, exccubeold, excchange)

END PROGRAM CHECKCONV
