import numpy as np
import os
import sys

# =====================================================
# Script to compare a SUMO run against a stored test solution.
# Example usage:
# python compare.py andersrun1 test2_400
# Prints SUCCESS or FAILURE for each specific output compared.
# ==============================

SUCCESS=True

rundir = sys.argv[1]
m_stored = sys.argv[2]

fid = open('tests/'+m_stored+'/teqsordered.dat','r')

TEQS_STORED = np.loadtxt(fid)

fid.close()

fid = open(rundir+'/out/plts/teqsordered.dat','r')

TEQS_THIS = np.loadtxt(fid)

#for i in range(0,len(TEQS_STORED[:,0])):
#	print(i+1,TEQS_STORED[i,1],TEQS_THIS[i,1], abs(TEQS_THIS[i,1]-TEQS_STORED[i,1])/TEQS_STORED[i,1])

if (m_stored == "test4_600"):
    multizone=False
else:
    multizone=True

if (multizone):
    array_T = abs(TEQS_THIS[:,1]-TEQS_STORED[:,1])/TEQS_STORED[:,1]
else:
    array_T = abs(TEQS_THIS[:][1]-TEQS_STORED[:][1])/TEQS_STORED[:][1]

T_max = np.max(array_T)

T_max_pos = np.argmax(array_T)

print("The maximum T error is",round(T_max*100,2),'%','in shell ',T_max_pos+1)

if (T_max < 0.01):
	print("PASS at 1% threshold")
else:
	print("FAIL")
	SUCCESS=False

print("The mean T error is",round(np.mean(array_T)*100,2),'%')
if (np.mean(array_T) < 0.01):
	print("PASS at 1% threshold")
else:
	print("FAIL")
	SUCCESS=False
# =======

print(" ")

fid = open('tests/'+m_stored+'/xeordered.dat','r')

XE_STORED = np.loadtxt(fid)

fid.close()

fid = open(rundir+'/out/xelong/xeordered.dat','r')

XE_THIS = np.loadtxt(fid)

#for i in range(0,len(XE_STORED[:,0])):
#        print(i+1,XE_STORED[i,1],XE_THIS[i,1], abs(XE_THIS[i,1]-XE_STORED[i,1])/XE_STORED[i,1])

if (multizone):
    array_xe=abs(XE_THIS[:,1]-XE_STORED[:,1])/XE_STORED[:,1]
else:
    array_xe=abs(XE_THIS[:][1]-XE_STORED[:][1])/XE_STORED[:][1]

xe_max = np.max(array_xe)

xe_max_pos = np.argmax(array_xe)

print("The maximum xe error is",round(xe_max*100,3),'%','in shell ',xe_max_pos+1)
if (xe_max < 0.02):
	print("PASS at 2% threshold")
else:
	print("FAIL")
	SUCCESS=False

print("The mean xe error is",round(np.mean(array_xe)*100,2),'%')
if (np.mean(array_xe) < 0.01):
	print("PASS at 1% threshold")
else:
	print("FAIL")
	Success=False

# Spectrum ==============

print(" ")

fid = open('tests/'+m_stored+'/spectrum.dat'+m_stored,'r')

SPECTRUM_STORED = np.loadtxt(fid)[:,1]

fid.close()

fid = open(rundir+'/out/modelspectra/spectrum.dat'+m_stored,'r')

BIG = np.loadtxt(fid)
SPECTRUM_THIS = BIG[:,1]

fid.close()

ind = np.where(BIG[:,0] > 3000.)
    #print(ind[0:10])
array_spectrum=abs(SPECTRUM_THIS[ind]-SPECTRUM_STORED[ind])/SPECTRUM_STORED[ind]
#print(" ")
#print(array_spectrum[0:10])
spectrum_max = np.max(array_spectrum)
spectrum_max_pos = np.argmax(array_spectrum)
print("The maximum spectrum error is",round(spectrum_max*100,3),'%','in bin ',spectrum_max_pos+1)

print("No test implemented.")

print("The median spectrum error is",round(np.median(array_spectrum)*100,2),'%, mean is',round(np.mean(array_spectrum)*100,2),'%')

if (np.median(array_spectrum < 0.02)):
	print("PASS at 2% threshold")
else:
	print("FAIL at 2% threshold")
	SUCCESS=False

print("=========")
if (SUCCESS):
	print("=OVERALL SUCCESS=")
else:
	print("=AT LEAST ONE FAILURE=")
print("=========")
