SUBROUTINE createbeta_l(atom, N_levels, TAU_S, T, BETA_L)
USE M1, ONLY : atomm, betal_Lyalpha, betal_Lybeta
IMPLICIT NONE
! ----------------------------------------
TYPE(atomm), INTENT(IN) :: atom
INTEGER, INTENT(IN) :: N_levels
DOUBLE PRECISION, DIMENSION(N_LEVELS, N_LEVELS), INTENT(IN) :: TAU_S
DOUBLE PRECISION, INTENT(IN) :: T
DOUBLE PRECISION, DIMENSION(N_LEVELS, N_LEVELS), INTENT(OUT) :: BETA_L
! ---------------------------------------------
! TASK : Compute proabilities for branching into another line
! INPUT :  atom        Type atomm (M1)
!          N_levels    Number of levels 
!          TAU_S       Sobolev taus
! Output : BETA_L      Line escape probabilities
! GLOBALS : betal_Lyalpha
!           betal_Lybeta
! -----------------------------------------------

LOGICAL, SAVE :: FIRST = .TRUE.

! --------------------------------------------------

BETA_L = 0

IF (atom%NAME .EQ. ' HI  ') THEN

   BETA_L(3,1) = betal_Lyalpha  ! CARE

   BETA_L(5,1) = betal_Lybeta   ! 4-1 and 6-1 have A=0

END IF


!IF ((FIRST) .AND. (atom%NAME .EQ. ' HI  ') .AND. (MCRUN .EQV. .FALSE.)) THEN

!   OPEN(20,file=file_log(1:10)//TRIM(idrun)//'_log.dat',STATUS='OLD',POSITION='APPEND')

!   WRITE(20,*) 'Beta_l Ly-alpha:', BETA_L(3,1)

!   CLOSE(20)

!   FIRST = .FALSE.

!END IF


END SUBROUTINE createbeta_l
		
