SUBROUTINE createbeta_s(name, N_up, N_down, TAU_S, BETA)
USE INTERFACE, ONLY : beta_s_func
IMPLICIT NONE
CHARACTER(len=5), INTENT(IN) :: name
INTEGER, INTENT(IN) :: N_up, N_down
DOUBLE PRECISION, DIMENSION(N_up, N_down), INTENT(IN) :: TAU_S
DOUBLE PRECISION, DIMENSION(N_up, N_down), INTENT(OUT) :: BETA
! ========================================
! Task : Compute sobolev escape probabilityes given the optical depths
! =======================================
INTEGER :: i,j				! Loop indeces
DOUBLE PRECISION :: tau
!DOUBLE PRECISION, EXTERNAL :: beta_s_func

! ----------------------------------------

BETA = 1.				! Initialize
	
DO j = 2, N_up
	
   DO i = 1, j-1			! j always the larger index
	
      tau = TAU_S(j,i)

      BETA(j,i) = beta_s_func(tau)
	
   END DO

END DO

IF (name .EQ. ' HI  ') THEN                 ! Two-photon

   BETA(2,1) = 1.

ELSE IF (name .EQ. 'HeI  ') THEN

   BETA(3,1) = 1.

END IF

END	
		
