This file was created by Sofie Liljegren sofie.liljegren@astro.su.se, jun-2020

FOR CREATING NEW ABIN FILES WHEN THE NUMBER OF ABIN ENTRIES ARE INCREASED. OBS! THIS IS A TEMPORARY FIX THAT SHOULD BE UPDATED WITH A MOLECULE CLASS. 
-------------------------------------

-------------------------------------
PREPARING THE BINCODE FILES
-------------------------------------
1. Adding new elements in ABINCODES

Add the new elements in the ABINCODES in `DATA/mol_input`, if this is an element that is to be included in radiative transfer. The current naming convention is -number - name - charge (e.g. `106 CM I` for singly charged CO). 

2. Adding new element in MBINCODES

If the new entry is a molecule, add this at the end of the `MBINCODES` file, similarily to new entry in `ABINCODES`.

-------------------------------------
RUN PYTHON SCRIPT TO UPDATE NUCCON FILES + NETWORK
-------------------------------------
In  `DATA/mol_input` run the python script 
```bash
func_db2fort.py 
```
This script does two things:
1. The function `suib_input_writer('file_in', 'file_out')` takes a human readable network file (file_in), stored in the hr_network folder, and creates a machine readable file (file_out), saved in the mr_folder, which is used in the suib routine for the chemical network. 

2. The function `fcons()` creates text files, saved in the nuccon folder, that keeps track of conservation of the molecules (i.e. which is the parent atom for each molecule, how many of the different parents does the molecule contain, what is the atomic weight of the molecule etc.). 

-------------------------------------

Three files are created from `fcons()`
1. `nuccon_input.csv`

This file is used in `getf.f90`, and keeps track of the conservation equation, i.e. which molecule is conserved by what nuclei and how many atoms are in the molecule, making the number of nuclei of a specific species constant. 

For example, C2O contains both carbon and oxygen, and therefore must be counted towards the conservation of these species. In this case the number carbon atoms for each molecule is also 2, so if we know the number density n(C2O), this has to be multiplied with 2 in the conservation equation of carbon. 

The form of nuccon_input.csv is:

1 entry with abin code of conserved quantity (typically the doubly ionized atoms - 20 entries with the abin codes of species that is part of the conservation - the multipicity of those species. 

E.g for Si we then have
``` bash
...
conserved species
|
| lhs atoms
| | | |
| | | |  --------lhs molecules
| | | |  |   |   |   |   |   |
6,4,5,6,109,110,117,118,121,122,123,124,0,0,0,0,0,0,0,0,0
&,1.0,1.0,1.0,1.0,1.0,2.0,2.0,1.0,1.0,2.0,2.0,0,0,0,0,0,0,0,0,0
  |    |   |   |   |   |   |   |   |   |   |
  multi of atoms----   |   |   |   |   |   |
...                     multi of molecules
```

2. `nuccon_input2.csv`

This file is used in `getf.f90` and in `ionization.f90`, and keeps track of the parent molecules, how many of the parent molecules there are, and charge of the molecule. 

The form is:

abin parent 1 - abin parent 2 - how many p1 - how many p2 - abin of molecule - charge of molecules

E.g. C2O 
``` bash
...
4,14,2.0,1.0,123,0.0 ! C2O I
4,14,2.0,1.0,124,1.0 ! C2O II
...
```
2. `nuccon_input3.csv`

This file is used in `ionization.f90`, and keeps track of the main parent species (p1) and the atomic mass. 

The form is:

abin of molecule - abin of parent1 - atomic mass

E.g. C2O I
``` bash
...
123,4,40 ! C2O I
124,4,40 ! C2O II
...
```






















