SUBROUTINE FEI_COLLISIONRATES(T, UPSILON)
IMPLICIT NONE

DOUBLE PRECISION, INTENT(IN) :: T
DOUBLE PRECISION, DIMENSION(10,10), INTENT(OUT) :: UPSILON

INTEGER i, upper, lower,  ind, bin
CHARACTER :: trash
DOUBLE PRECISION, DIMENSION(5), SAVE :: Tvec
DOUBLE PRECISION, DIMENSION(5) :: upsilonvec
DOUBLE PRECISION, DIMENSION(10,10,4), SAVE :: ALPHA, C

LOGICAL, SAVE :: FIRST = .TRUE.

! ------------------------------------------------------

UPSILON = 0

! ------------------------------------------------------

IF (FIRST) THEN

   alpha = 0

   C = 0 

   OPEN(10,file='DATA/atoms/FeI/feI_finestructurecollisions.dat'); REWIND(10)

   DO i = 1, 2
      READ(10,*) trash
   END DO

   READ(10,*) trash, Tvec(1:5)

   DO

      READ(10,*,END=100) lower, upper, upsilonvec(1:5)

      DO i = 1, 4

         alpha(upper,lower,i) = LOG(upsilonvec(i)/upsilonvec(i+1))/LOG(Tvec(i)/Tvec(i+1))

         C(upper,lower,i) = upsilonvec(i)/Tvec(i)**alpha(upper,lower,i)

      END DO

   END DO

   100 close(10)

   FIRST = .FALSE.

END IF

IF (T < Tvec(1)) THEN

   UPSILON(:,:) = C(:,:,1)*T**alpha(:,:,1)

ELSE IF (T > Tvec(5)) THEN

   UPSILON(:,:) = C(:,:,4)*T**alpha(:,:,4)

ELSE

   CALL findbin2(5, Tvec, T, bin)

   UPSILON(:,:) = C(:,:,bin)*T**alpha(:,:,bin)

END IF




END SUBROUTINE FEI_COLLISIONRATES
      

   
