SUBROUTINE fileEMISS_CUBE(R_index, EMISS_MAT, DIMS, x)
USE M1, ONLY : R_index_str
USE FILES
IMPLICIT NONE
INTEGER, INTENT(IN) :: R_index, DIMS
DOUBLE PRECISION, DIMENSION(:,:), INTENT(IN) :: EMISS_MAT
DOUBLE PRECISION, DIMENSION(DIMS), INTENT(IN) :: x
! =====================================
! Task : Write emissivities to file
! Input : R_index         zone number
!         EMISS_MAT       Matrix with emissivities [erg s^-1 cm^-3]
!         DIMS            Length of array x
!         x               Array with zone data
! Output : WRites to file
! Globals : --
! ====================================
INTEGER :: i, j
! ------------------------------------------------------------

OPEN(10, file=TRIM(file_EMISSCUBE)//R_index_str(R_index), STATUS='REPLACE')

i = 1
DO WHILE(EMISS_MAT(i,4) .NE. 0)

   WRITE(10,11) R_index, i, INT(EMISS_MAT(i,1)), INT(EMISS_MAT(i,2)), INT(EMISS_MAT(i,3)), EMISS_MAT(i,4), EMISS_MAT(i,5)*x(DIMS-8), INT(EMISS_MAT(i,6))
11    FORMAT (I4, I8, 3I6 , F22.2, ES15.5E3, I6)

      i = i + 1

END DO

CLOSE(10)

END SUBROUTINE fileEMISS_CUBE
