MODULE FILES
IMPLICIT NONE

! ==============================
! Module content: All file associations used by all MC routines.
! A non-iterative run needs input files marked with *
! An iterative run needs input files marked with * ITERATIVE
! ==============================

  INTEGER, PARAMETER :: max_file_name_len = 100 ! To be increased?

  CHARACTER(LEN=*), PARAMETER :: dir_atomic_data = 'DATA/atoms'
  CHARACTER(LEN=*), PARAMETER :: dir_molecular_data = 'DATA/molecules'

  CHARACTER(LEN=*), PARAMETER :: file_ionandTstart = 'DATA/ionandTstart.dat', &
       ! *
file_ionfracs = 'out/ionization/ionfracs.dat', &                                         ! * ITERATIVE
file_ionfracsprev = 'out/ionization/ionfracsprev.dat', &     
file_temps = 'out/plts/teqs.dat', &                                                   ! * ITERATIVE
file_tempsprevious = 'out/plts/teqsprev.dat', &
file_timeprev = 'out/timeprev.dat', &
file_xeprev = 'out/xelong/xeprev.dat', &                                          ! * ITERATIVE
file_penning = 'out/calculatecubes/penning.dat', &
file_EXCCUBE = 'out/calculatecubes/EXC_CUBE.dat', &
file_EMISSCUBE = 'DATA/EMISS_CUBE.dat', &
file_Eemit = 'out/calculatecubes/Eemit.dat', &
file_gammant ='out/statisticalandthermalequilibrium/gammant.dat', &
file_gammantprev ='out/statisticalandthermalequilibrium/gammantprev.dat', & 
file_NABSNT = 'out/statisticalandthermalequilibrium/NABS_NT.dat', &
file_radmaker_ionratesspecific = 'out/radmaker/radmaker_ionrates_specific.dat', &      ! * ITERATIVE
file_nlevelsabsorb = 'out/main/n_levels_absorb.dat', &
file_lineratedata = 'out/main/lineratedata.dat', &
file_thick = 'out/main/thick.dat', &
file_spectralrange = 'out/main/spectralrange.dat', &
file_ionedges = 'out/writeionedges/ionedges.dat', &                                                ! * 
file_TAU = 'out/calculatecubes/TAU.dat', &
file_BETAC = 'DATA/BETA_C.dat', &
file_nabspreion = 'out/calculatecubes/nabspreion.dat', &
file_totpreion = 'out/calculatecubes/totpreion.dat', &
file_preheating = 'out/calculatecubes/preheating.dat', &
file_radmaker_nabsrad = 'out/radmaker/NABS_RAD.dat', &                                 ! * ITERATIVE
file_radmaker_nabsfracs = 'out/radmaker/NABS_fractions.dat', &                
file_dep = 'out/main/dep.dat', &
file_radmaker_ionrates = 'out/radmaker/radmaker_ionrates.dat', &
file_radmaker_radheating = 'out/radmaker/radmaker_radiativeheating.dat', &             ! * ITERATIVE
file_numberfractionsused = 'out/modelreader/numberfractions_used.dat', &
file_volume = 'out/modelreader/volume.dat', &
file_rads = 'out/modelreader/rads.dat', &
file_ionstructure = 'out/modelreader/ionstructure.dat', &
file_ionization_ntandgamma = 'out/ionization/ionization_ntandgamma.dat', &
file_ionization_xelong = 'out/ionization/xelong.dat', & !file doesn't exist, out/xelong/xelong.dat?
file_blobsize = 'out/depositionfunction/blobsize.dat', &
file_tc = 'out/thinspectrum/tc.dat', &
file_tci = 'out/thinspectrum/tci.dat', &
file_tnc = 'out/thinspectrum/tnc.dat', &
file_thinspecs = 'out/thinspectrum/spec.dat', &
file_tod = 'out/main/tod.dat', &
file_twophoton = 'out/twophoton/twophoton.dat', &
file_linefluor = 'out/writelinefluor/linefluor.dat', &
file_heatfracs = 'out/statisticalandthermalequilibrium/heatfracs.dat', &
file_nsend = 'out/main/nsend.dat', &
file_cd = 'out/main_radtrans/cdall.dat', &
file_dead = 'out/main_radtrans/deadall.dat', &
file_edeps = 'out/ionization/shells/edeps_s', &
file_radfield = 'out/main/radfield.dat', &
file_moldens = 'out/ionization/moldens.dat', &
file_molres = 'out/ionization/molres.dat', &
file_molresprev = 'out/ionization/molresprev.dat', &
file_fbig = 'out/thinspectrum/fbig.dat',&
file_nlines = 'out/main/nlines_', &
file_molcool = 'out/main/molcool.dat', &
file_ctheating = 'out/ionization/ctheating.dat', &
file_lambdalambda =  'out/main_radtrans/lambdalambdaall.dat', &
file_cttoexc = 'out/ionization/cttoexc', &
file_photoexcall = 'out/main_radtrans/photoexcall.dat', &  ! CARE sync with gather.sh
file_photoexcrates = 'out/radmaker/photoexcrates.dat', &
file_photoexc_long = 'out/radmaker/photoexc_long.dat', &
file_lineabstot = 'out/main_radtrans/deadphotoexcall.dat', &  ! CARE sync with gather.sh
file_ebalance = 'out/radmaker/ebalance.dat', &
file_ebalance_this = 'out/radmaker/ebalancethis.dat', &
file_dustabs = 'out/radmaker/dustabs.dat', &
file_edeadforeign = 'out/radmaker/Edeadforeign.dat', &
file_natoms = 'out/main/N_atoms', &
file_glevels = 'out/main/glevels.dat', &
file_elevels = 'out/main/elevels.dat', &
file_trec = 'out/radmaker/trec_years.dat', &
file_radmerged = 'out/main_radtrans/radmerged.dat', &
file_groundfracs = 'out/radmaker/groundfracs.dat', &
file_emergent = 'out/main_radtrans/outall.dat', &
file_wlvec = 'out/main/wlvec.dat', &
file_convproblems_suse = 'out/convproblems_suse', &
file_popsave = 'out/stateq/popsave.dat', &
file_mainheatfracs = 'out/main/heatfracs', &
file_lines = 'out/main/lines/', &
file_emisstot = 'out/calculatecubes/emisstot', &
file_hIextra = 'out/calculatecubes/hIextra', &
file_sf = 'out/statisticalandthermalequilibrium/sf', &
file_molcool2 = 'out/statisticalandthermalequilibrium/molcool', &
file_taucont = 'out/statisticalandthermalequilibrium/taucont', &
file_adcool = 'out/statisticalandthermalequilibrium/adcool', &
file_regemorter = 'out/regemorter/regemorter', &
file_timedays = 'out/modelreader/timedays.dat', &
file_tempsused = 'out/modelreader/tempsused.dat', &
file_modelsummary = 'out/modelreader/modelsummary.dat', &
file_masses = 'out/modelreader/masses.dat', &
file_HECS = 'DATA/atoms/FeII/HECS/crsm', &
file_outside = 'out/thinspectrum/outsideflux', &
file_energybalance = 'out/main_radtrans/radiativedivergence.dat', &
file_energybalancelong = 'out/main_radtrans/radiativedivergencelong.dat', &
file_thomson = 'out/modelreader/thomson.dat', &
file_adcoolordered = 'out/statisticalandthermalequilibrium/adcoolordered.dat'

  CHARACTER(LEN=max_file_name_len) :: file_runparameters = 'runparameters.dat'
  CHARACTER(LEN=max_file_name_len) :: file_log = '/dev/null'

  CHARACTER(LEN=*), PARAMETER, PRIVATE :: log_prefix = 'out/log/'
  CHARACTER(LEN=*), PARAMETER, PRIVATE :: log_suffix = '_log.dat'

  SAVE

CONTAINS

  ! This needs to be called before referencing file_log
  SUBROUTINE files_init (idrun)
    CHARACTER(LEN=*), INTENT(IN) :: idrun

    file_log = log_prefix // TRIM(idrun) // log_suffix

  END SUBROUTINE files_init

END MODULE FILES
