#! /bin/bash
# Command line arguments : $1 : ID  $2 Nshells
if [ $2 -ge "250" ]; then
    echo "ERROR : Nshells > max allowed (250)"
    exit 1
fi
cp $DD/saved/$1/$1dep.dat out/main/dep.dat
#list=(01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99) # care 00 must be there
list=(001 002 003 004 005 006 007 008 009 010 011 012 013 014 015 016 017 018 019 020 021 022 023 024 025 026 027 028 029 030 031 032 033 034 035 036 037 038 039 040 041 042 043 044 045 046 047 048 049 050 051 052 053 054 055 056 057 058 059 060 061 062 063 064 065 066 067 068 069 070 071 072 073 074 075 076 077 078 079 080 081 082 083 084 085 086 087 088 089 090 091 092 093 094 095 096 097 098 099 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250)
list2=${list[@]:0:$2}  # Here $2 is treated as a number
for ic in ${list2}
do
# Radiative heating rates
  if [ -f $DD/saved/$1/$1radmaker_radiativeheating.dat$ic ]; then
      cp $DD/saved/$1/$1radmaker_radiativeheating.dat$ic out/radmaker/radmaker_radiativeheating.dat$ic
  else  # If file does not exist, remove previous files and replace with empty ones (handled by reading)
      echo "No radiative heating rates found, shell",$ic
      rm out/radmaker/radmaker_radiativeheating.dat$ic
      touch out/radmaker/radmaker_radiativeheating.dat$ic
  fi
# Specific ionization rates
  if [ -f $DD/saved/$1/$1radmaker_ionrates_specific.dat$ic ]; then 
      cp $DD/saved/$1/$1radmaker_ionrates_specific.dat$ic out/radmaker/radmaker_ionrates_specific.dat$ic
  else
      echo "No specific ion. rates found, shell",$ic
      rm out/radmaker/radmaker_ionrates_specific.dat$ic
      touch out/radmaker/radmaker_ionrates_specific.dat$ic  # Empty files handled
  fi
# Photoexcitation rates
  if [ -f $DD/saved/$1/$1photoexcrates.dat$ic ]; then 
      cp $DD/saved/$1/$1photoexcrates.dat$ic out/radmaker/photoexcrates.dat$ic 
  else
      echo "No photoexcrates found, shell",$ic
      rm out/radmaker/photoexcrates.dat$ic
      touch out/radmaker/photoexcrates.dat$ic   # Empty files handled
  fi
# Mol dens
  if [ -f $DD/saved/$1/$1moldens.dat$ic ]; then
      cp $DD/saved/$1/$1moldens.dat$ic out/ionization/moldens.dat$ic
  else
      echo "No moldens found, shell",$ic
      rm out/ionization/moldens.dat$ic
      touch out/ionization/moldens.dat$ic  # Empty files handled
  fi
# Mol res
  if [ -f $DD/saved/$1/$1molres.dat$ic ]; then
      cp $DD/saved/$1/$1molres.dat$ic out/ionization/molres.dat$ic
  else
      echo "No molres found, shell",$ic
      rm out/ionization/molres.dat$ic
      touch out/ionization/molres.dat$ic  # Empty files handled                              
  fi  
# Charge transfer heating
  if [ -f $DD/saved/$1/$1ctheating.dat$ic ]; then
      cp $DD/saved/$1/$1ctheating.dat$ic out/ionization/ctheating.dat$ic
  else
      echo "No ct heating found, shell",$ic
      rm out/ionization/ctheating.dat$ic
      touch out/ionization/ctheating.dat$ic  # Empty files handled
  fi
# Ionfracs
  if [ -f $DD/saved/$1/$1ionfracs.dat$ic ]; then 
      cp $DD/saved/$1/$1ionfracs.dat$ic out/ionization/ionfracs.dat$ic
  else
      echo "No ionfracs found, shell",$ic  # Dont remove, thes files must exist
  fi  
# Temperatures 
  if [ -r $DD/saved/$1/$1teqs.dat$ic ]; then
      cp $DD/saved/$1/$1teqs.dat$ic out/plts/teqs.dat$ic
  else
    echo "No teqs found, shell",$ic  # Dont remove, these files must exist
  fi
# Charge transfer level pumping
  if [ -f $DD/saved/$1/$1cttoexc$ic ]; then
      cp $DD/saved/$1/$1cttoexc$ic out/ionization/cttoexc$ic
  else
      echo "No ct-to-exc found, shell",$ic
      rm out/ionization/cttoexc$ic
      touch out/ionization/cttoexc$ic  # Empty files handled
  fi
# Absorbing lines
  if [ -f $DD/saved/$1/$1n_levels_absorb.dat$ic ]; then
      cp $DD/saved/$1/$1n_levels_absorb.dat$ic out/main/n_levels_absorb.dat$ic
  else
      echo "No n_levels_absorb found, shell",$ic
      rm out/main/n_levels_absorb.dat$ic
      touch out/main/n_levels_absorb.dat$ic  # Empty files handled
  fi
# Groundfracs
  if [ -f $DD/saved/$1/$1groundfracs.dat$ic ]; then
      cp $DD/saved/$1/$1groundfracs.dat$ic out/radmaker/groundfracs.dat$ic
  else
      echo "No groundfracs found, shell",$ic
      rm out/radmaker/groundfracs.dat$ic
      touch out/radmaker/groundfracs.dat$ic
  fi
# Level populations 
  if [ -f $DD/saved/$1/$1EXC_CUBE.dat$ic ]; then
      cp $DD/saved/$1/$1EXC_CUBE.dat$ic out/calculatecubes/EXC_CUBE.dat$ic
  else
      echo "No EXC_CUBES found, shell",$ic
      rm out/calculatecubes/EXC_CUBE.dat$ic
      touch out/calculatecubes/EXC_CUBE.dat$ic
  fi
#Previous Ionfracs for time dep process 
  if [ -f $DD/saved/$1/$1ionfracsprev.dat$ic ]; then 
      cp $DD/saved/$1/$1ionfracsprev.dat$ic out/ionization/ionfracsprev.dat$ic
  else
      echo "No previous ionfracs found, shell",$ic  # File must exist for time dep run
  fi
  if [ -f $DD/saved/$1/$1gammant.dat$ic ]; then cp $DD/saved/$1/$1gammant.dat$ic out/statisticalandthermalequilibrium/gammant.dat$ic; fi
  if [ -f $DD/saved/$1/$1gammantprev.dat$ic ]; then cp $DD/saved/$1/$1gammantprev.dat$ic out/statisticalandthermalequilibrium/gammantprev.dat$ic; fi

#Single files without zone number  
done
if [ -f $DD/saved/$1/$1Told.dat ]; then cp $DD/saved/$1/$1Told.dat out/checkconv/Told.dat; fi
if [ -f $DD/saved/$1/$1xeold.dat ]; then cp $DD/saved/$1/$1xeold.dat out/checkconv/xeold.dat; fi
if [ -f $DD/saved/$1/$1ionold.dt ]; then cp $DD/saved/$1/$1ionold.dat out/checkconv/ionold.dat; fi
if [ -f $DD/saved/$1/$1blobsize.dat ]; then cp $DD/saved/$1/$1blobsize.dat out/depositionfunction/blobsize.dat; fi
if [ -f $DD/saved/$1/$1timedays.dat ]; then cp $DD/saved/$1/$1timedays.dat out/modelreader/timedays.dat; fi

# Time dependent process files
if [ -f $DD/saved/$1/$1teqsprev.dat ]; then cp $DD/saved/$1/$1teqsprev.dat out/plts/teqsprev.dat; fi
if [ -f $DD/saved/$1/$1timeprev.dat ]; then cp $DD/saved/$1/$1timeprev.dat out/timeprev.dat; fi
if [ -f $DD/saved/$1/$1xeprev.dat ]; then cp $DD/saved/$1/$1xeprev.dat out/xelong/xeprev.dat; fi
#Not sure if necessary
if [ -f $DD/saved/$1/$1xeordered.dat ]; then cp $DD/saved/$1/$1xeordered.dat out/xelong/xeordered.dat; fi
if [ -f $DD/saved/$1/$1teqsordered.dat ]; then cp $DD/saved/$1/$1teqsordered.dat out/plts/teqsordered.dat; fi

