!      SUBROUTINE hI_collandrecomb(T, N_levels, E, G, alpha, Q)
!      IMPLICIT NONE

!      DOUBLE PRECISION, INTENT(IN) :: T
!      INTEGER, INTENT(IN) :: N_levels
!      DOUBLE PRECISION, DIMENSION(N_levels), INTENT(IN) :: E, G
!      DOUBLE PRECISION, DIMENSION(N_levels), INTENT(OUT) :: alpha
!      DOUBLE PRECISION, DIMENSION(N_levels, N_levels), INTENT(OUT) :: Q

!      DOUBLE PRECISION, DIMENSION(340) :: RECO 
!      COMMON/RECAL/RECO

!      call cex_new(T, N_levels, E, G, Q)

      !call hI_recombinationrates(T, N_levels, alpha(1:N_levels))
      
      
!      RETURN
!      END


     
 
      SUBROUTINE HORATE(ION,R,TE)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NL=340,NLP1=NL+1)
C
C     CALCULATE RECOMBINATION AND PHTOOIONIZATION RATES 
C
      COMMON/IND/I
      COMMON/A14/C(NL,NL),CI(NL),G(NL),EN(NL),A(NL,NL),
     &WL(NL,NL),DCDT(NL,NL),DCIDT(NL)
      COMMON/A17/RECNET(NL),RECNDT(NL),RECCO(NL),RTE(NL),
     &PH(NL),DRDT(NL),RECT(6,NL),PHET(NL)
      COMMON/NLEV/e00,NION,N,NP1H,NHMAX,NHMIN
      COMMON/PHEAT/PHE(NL)
      COMMON/PHOTOHEAT/PHEAT(6,NL),PHEATT(6,NL)
      COMMON/HEIION/ZHEICO,ZHEILA,ZOTSHI,ZBALM,ZHBALM
      COMMON/RECAL/RECO(NL)
      common/hydphot/phhi(nl)
      common/ctionfe/phfe(2)
      common/fill/filling
      parameter(nlp=15000)
      common/linepoint/nlines,jline(nlp),iion(nlp)
      common/lineopac/totopl(nlp)
      common/linephoto/phline(nlp) 
      common/timecheck/time,itime
      common/preion/ipre
      DATA PI/3.1415926E0/,ELCH/1.60219E-12/,AMU/1.660531E-24/
      TS=TE
      !write(0,*)' horate ',itime,ion,n


      if(ion.eq.5) then
         nj=12
      else
         nj=n
      endif
      DO 500 J=1,Nj
C
C     FIRST CALCULATE THE RECOMBINATION RATE FOR ALL LEVELS
C
         CALL RECOMB(ION,J,TS,AL,RI)
         RECO(J)=AL

 500  CONTINUE


      RETURN
      END

           
     

      SUBROUTINE CION(ION,N,N0,T,CI)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NL=340,NLP1=NL+1)
C
C     COLLISIONAL IONIZATION RATES
C
      COMMON/A14/CQ(NL,NL),CIQ(NL),G(NL),E(NL),AQ(NL,NL),WL(NL,NL)
     &,DCDT(NL,NL),DCIDT(NL)
       COMMON/NLEV/e00,NION,NHY,NP1H,NHMAX,NHMIN
c      write(0,*)' cion',ion,n,n0
      CI=0.
      IF(ION.NE.1) GOTO 6
C     COLLISIONAL IONIZATION RATES FOR CA II FROM SHINE
      TEV=T/1.1609E4
      EI=E00-E(N)
      EITEV=DMIN1(700.D0,EI/TEV)
      CI=1.14E-10*SQRT(T)*EXP(-EITEV)/EI**2
      GOTO 500

C     H I
6     IF(ION.NE.5) GOTO 500
      CALL CIONH(N,N0,T,CI)
500   CONTINUE
      RETURN
      END

      

      SUBROUTINE CIONH(N,N0,T,CI)
      IMPLICIT REAL*8(A-H,O-Z)
C
C     COLLISIONAL IONIZATION RATES FROM JOHNSON (AP J 174:227)
C
c      write(0,*)' cionh',n,n0
      PI=3.14159
      CON=1.092E-10
      Q=DBLE(N)
      T4=T/1.E4
      X0=1.-(Q/REAL(N0))**2
      YN=X0*15.72/(Q**2*T4)
      IF(N.NE.1) GOTO 1
      G0=1.133
      G1=-.4059
      G2=.07014
      BN=-.603
      RN=.45
1     IF(N.NE.2) GOTO 2
      G0=1.0785
      G1=-.2319
      G2=.02947
      BN=(4.-18.63/Q+36.24/Q**2-28.09/Q**3)/Q
      RN=1.94/Q**1.57
2     IF(N.LT.3) GOTO 3
      G0=.9935+.2328/Q-.1296/Q**2
      G1=-(.6282-.5598/Q+.5299/Q**2)/Q
      G2=(.3887-1.181/Q+1.470/Q**2)/Q**2
      BN=(4.-18.63/Q+36.24/Q**2-28.09/Q**3)/Q
      RN=1.94/Q**1.57
3     AN=32.*Q*(G0/(X0**3*3.)+G1/(X0**4*4.)+G2/(X0**5*5.))
     &/(3.*SQRT(3.)*PI)
      BN=2.*Q**2*(3.+2./X0+BN/X0**2)/(3.*X0)
      ZN=X0*(RN+15.72/(Q**2*T4))
      A1=EXP1(YN)/YN-EXP1(ZN)/ZN
      A2=(1.+2./YN)*E2(YN)-EXP(-YN)/YN-(1.+2./ZN)*E2(ZN)+EXP(
     &-ZN)/ZN
      CI=CON*SQRT(T)*Q**2*YN**2*(AN*A1+(BN-AN*LOG(2.*Q**2
     &/X0))*A2)/X0
      RETURN
      END


      SUBROUTINE RECOMB(ION,I,TE,A,RI)
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NL=340,NLP1=NL+1)

      parameter (mh=2,mhe=3,mc=7,mn=8,mo=9,mne=11,mna=12,mmg=13,
     &     mal=14,msi=15,ms=17,mar=19,mca=21,mfe=27,mni=29,
     &     mmat=mh+mhe+mc+mn+mo+mne+mna+mmg+mal+msi+ms+mar+mca+mfe+mni,
     &     ispecy=15)
      common/abc1/alc(mc),aln(mn),alo(mo),alne(mne),alna(mna),
     &     almg(mmg),alal(mal),alsi(msi),alsu(ms),alar(mar),alca(mca),
     &     alfe(mfe),alni(mni)

      COMMON/ABC/AL(16)

      COMMON/NLEV/e00,NION,N,NP1H,NHMAX,NHMIN
      COMMON/A14/C(NL,NL),CI(NL),G(NL),E(NL),AS(NL,NL),
     &WL(NL,NL),DCDT(NL,NL),DCIDT(NL)
      COMMON/HEIRECION/AL0(16),BE(16),B0(16),GA(16)
      DATA CSAHA/2.0708E-16/
      !write(0,*)' recomb ',ion,i

      A=0.
      TEV=TE/1.1609E4
      TEV0=TEV*10.
      T4=TE/1.E4
C     HE I
      T5000=TE/5.E3
      IF(I.EQ.1) A=2.23E-13/T5000**.488
      IF(I.EQ.2) A=1.98E-14/T5000**.42
      IF(I.EQ.3) A=3.6E-14/T5000**.784
      IF(I.EQ.4) A=1.135E-13/T5000**.610
      IF(I.EQ.5) A=7.2E-14/T5000**.784
      IF(I.EQ.6) A=8.45E-15/T5000**.45
      IF(I.EQ.7) A=3.92E-14/T5000**.63
      IF(I.EQ.8) A=4.894E-14/T5000**.85
      IF(I.EQ.9) A=0.343E-14/T5000**.478
      IF(I.EQ.10) A=1.77E-14/T5000**.620
      IF(I.EQ.11) A=3.14E-14/T5000**.851
      IF(I.EQ.12) A=4.87e-14/T5000**1.173
C     FROM ALMOG & NETZER
      A=AL0(I)*T4**BE(I)
      RI=A*EXP((E(I)-E00)/TEV)*TE**1.5/(CSAHA*G(I))
      RETURN
      END



   
      double precision function gbf(n,e)
C
C     Calculation of bound-free gaunt factor from Mihalas, D., 
C     Ap.J. 149:169 (1967)
C     e in eV    
C     1s, 2s, 2p, 3s, 3p, 3d covered

      implicit real*8 (a-h,o-z)
      parameter(nl=6)
      dimension a0(nl),a1(nl),a2(nl),a3(nl),am1(nl),am2(nl),am3(nl)
      dimension wl0(nl)
      data wl0/915.3291d0, 3704.9034d0, 8504.7783d0, 15560.594d0, 25260.706d0,38194.187d0/
      data a0/1.2302628d0, 1.1595421d0, 1.1450949d0, 1.1306695d0, 1.1190904d0, 1.1168376d0/
      data a1/-2.9094219d-3, -2.0735860d-3, -1.9366592d-3, -1.3482273d-3, -1.0401085d-3, -8.9466573d-4/
      data a2/7.3993579d-6, 2.7033384d-6, 2.3572356d-6, -4.6949424d-6, -6.9943488d-6, -8.8393113e-6/
      data a3/-8.7356966d-9, 0.d0, 0.d0, 2.3548636d-8, 2.8496742d-8, 3.4696768d-8/
      data am1/-5.5759888d0, -1.2709045d0, -0.55936432d0, -0.31190730d0, -0.16051018d0, -0.13075417d0/
      data am2/12.803223d0, 2.1325684d0, 0.52471924d0, 0.19683564d0, 5.5545091d-2, 4.1921183d-2/
      data am3/0.d0, -2.0244141d0, -0.23387146d0, -5.4418565d-2, -8.9182854d-3,-5.5303574d-3/

      wlmy = 1.239854/e

      gbf = 0

      IF (wlmy.lt.wl0(n)/1.d4) THEN

            x=1./wlmy

            gbf = a0(n) + a1(n)*x + a2(n)*x*x + a3(n)*x*x*x + am1(n)/x + am2(n)/(x*x) + am3(n)/(x*x*x)

      END IF

      RETURN

      END

      double precision function gaunt(z,t,e)
c     this routine calculates the free-free gaunt factor according to
c     D.G. Hummer in Ap.J. 327: 477 (1988)
c
      implicit real*8(a-h,o-z)
      dimension cm(11),c(8),d(0:7,0:10),d1(0:7,0:8),d2(0:7,1:2)
      data d1/
     &  +8.986940175d-0,-4.009515855d-0,+8.808871266D-1,+2.640245111d-2,
     &  -4.580645915d-2,-3.568055702d-3,+2.827798067d-3,+3.365860195d-4,
     &  -8.006936989d-1,+9.466021705d-1,+9.043402532d-2,-9.608451450d-2,
     &  -1.885629865d-2,+1.050313890d-2,+2.800889961d-3,-1.078209202d-3,
     &  -3.781305103d-1,+1.102726332d-1,-1.543619180d-2,+8.310561114d-3,
     &  +2.179620525d-2,+4.259726289d-3,-4.181588794d-3,-1.770208330d-3,
     &  +1.877213132d-2,-1.004885705d-1,-5.483366378d-2,-4.520154409d-3,
     &  +8.366530426d-3,+3.700273930d-3,+6.889320423d-4,+9.460313195d-5,
     &  +7.300158392d-2,+3.576785497d-3,-4.545307025d-3,-1.017965604d-2,
     &  -9.530211924d-3,-3.450186162d-3,+1.040482914d-3,+1.407073544d-3,
     &  -1.744671550d-3,+2.864013856d-2,+1.903394837d-2,+7.091074494d-3,
     &  -9.668371391d-4,-2.999107465d-3,-1.820642230d-3,-3.874082085d-4,
     &  -1.707268366d-2,-4.694254776d-3,+1.311691517d-3,+5.316703136d-3,
     &  +5.178193095d-3,+2.451228935d-3,-2.277321615d-5,-8.182359057d-4,
     &  +2.567331664d-4,-9.155339970d-3,-6.997479192d-3,-3.571518641d-3,
     &  -2.096101038d-4,+1.553822487d-3,+1.509584686d-3,+6.212627837d-4,
     &  +4.098322531d-3,+1.635218463d-3,-5.918883504d-4,-2.333091048d-3,
     &  -2.484138313d-3,-1.359996060d-3,-5.371426147d-5,+5.553549563d-4/
      data d2/
     &  +3.837562402d-5,+2.938325230d-3,+2.393747064d-3,+1.328839809d-3,
     &  +9.135013312d-5,-7.137252303d-4,-7.656848158d-4,-3.504683798d-4,
     &  -8.491991820d-4,-3.615327726d-4,+3.148015257d-4,+8.909207650d-4,
     &  +9.869737522d-4,+6.134671184d-4,+1.068883394d-4,-2.046080100d-4/
      data elch /1.602d-12/      
      data bolz /1.38d-16/
      !write(0,*)' gaunt '
      do i=0,7
        do j=0,10
          if(j.le.8) then
            d(i,j)=d1(i,j)
          else
            d(i,j)=d2(i,j-8)             
          endif
        enddo
      enddo
      a1=-1.
      b1=1.
      a2=-10.5/5.5
      b2=0.5/5.5
      m=11
      n=8
      g2=z*15.72e4/t
      u=e*elch/(bolz*t)                
      xg=log10(g2)/3.
      xu=(2.*log10(u)-2.5)/5.5
      gff=0.
      do j=1,n
            do i=1,m
                  cm(i)=d(j-1,i-1)
            enddo
            c(j)=chebev(a1,b1,cm,m,xg)
      enddo            
      gaunt=chebev(a2,b2,c,n,xu)
      return
      end

      DOUBLE PRECISION FUNCTION CHEBEV(A,B,C,M,X)
      implicit real*8(a-h,o-z)
      DIMENSION C(M)
      !write(0,*)' cheb '
      D=0.
      DD=0.
      Y=(2.*X-A-B)/(B-A)
      Y2=2.*Y
      DO 11 J=M,2,-1
        SV=D
        D=Y2*D-DD+C(J)
        DD=SV
11    CONTINUE
      CHEBEV=Y*D-DD+0.5*C(1)
      RETURN
      END



      subroutine romb(fx,aa,bb,err,fi,fail,k)
      implicit real*8(a-h,o-z)
      external fx
      dimension tr(100),w(100)
      a=aa
      b=bb
      dx=(b-a)/2.
      fi1=0.5*(fx(a)+fx(b))
      fi2=fx(a+dx)
      tr(1)=dx*(fi1+fi2)
      n=1
      k=1
      w(1)=4.
1     fi=tr(1)
      w(k+1)=4.*w(k)
      n=2*n
      k=k+1
      tdx=dx
      dx=dx/2.
      x=a+dx
      do 2 i=1,n
      fi2=fi2+fx(x)
2     x=x+tdx
      tr(k)=dx*(fi1+fi2)
      kk=k-1
      do 3 j=1,kk
      m=k-j
3     tr(m)=(w(j)*tr(m+1)-tr(m))/(w(j)-1.)
      fail=abs(tr(1)-fi)/abs(tr(1))
c      write(0,*)' i romb ',k,tr(1),fail,err
      if(fail-err)6,6,4
4     if(k-100)1,6,6
6     fi=tr(1)
      return
      end




      DOUBLE PRECISION FUNCTION EXP1(X)
      IMPLICIT REAL*8(A-H,O-Z)
      IF(X.LT.1.) THEN
            E1=-LOG(X)-.577216+X-.24991*X*X+.0552*X*X*X-.00976
     &            *X*X*X*X
      ELSE
            E1=EXP(-X)*(X*X+2.334733*X+.250621)/((X*X+3.330657*X
     &            +1.681534)*X)
      ENDIF
      EXP1=E1
      RETURN
      END

      DOUBLE PRECISION FUNCTION E2(X)
      IMPLICIT REAL*8(A-H,O-Z)
      IF(X.GT.0.) GOTO 500
      E2=1.
      GOTO 400
500   IF(X.GT.300.) GOTO 100
      IF(X.GT.1.) GOTO 200
      E1=-LOG(X)-.577216+X-.24991*X*X+.0552*X*X*X-.00976
     &*X*X*X*X
      GOTO 300
200   E1=EXP(-X)*(X*X+2.334733*X+.250621)/((X*X+3.330657*X+1.681534
     &)*X)
300   E2=EXP(-X)-X*E1
      GOTO 400
100   E2=0.
400   CONTINUE
      RETURN
      END
      
            
!      SUBROUTINE CEX_NEW(T, N_levels, E, G, Q)
!      IMPLICIT NONE

!      DOUBLE PRECISION, INTENT(IN) :: T
!      INTEGER, INTENT(IN) :: N_levels
!      DOUBLE PRECISION, DIMENSION(N_levels), INTENT(INOUT) :: E, G
!      DOUBLE PRECISION, DIMENSION(N_levels, N_levels), INTENT(OUT) :: Q

!      character*10 dum

!      DOUBLE PRECISION, DIMENSION(N_levels, N_levels) :: OM, omh
!      DOUBLE PRECISION, DIMENSION(15,15,8) :: cexhi, alfa, cextab
!      DOUBLE PRECISION, DIMENSION(8) :: teex, cqq
!      DOUBLE PRECISION :: trash, c2p2s, eij, C_up, EXPO, Qup_500K
!      INTEGER :: n_lower, n_upper, initcexh, i, j, k, lower, upper, aij
!      DOUBLE PRECISION, PARAMETER :: eV = 1.602E-12
 
!      common/initcexh/initcexh

!      save teex,cexhi,alfa
      
     
!      IF (initcexh .EQ. 1) THEN

!         initcexh = 0

!         open(52,file='DATA/atoms/HI/h_excit_anderson.dat');rewind(52)

!           DO i = 1, 17
!              read(52,*) dum
!           END DO

!           read(52,*) trash, trash, (teex(k), k=1,8)

!           DO i = 1, 85

!             read(52,*) upper, lower, aij, (cextab(upper,lower,k),k=1,8), trash

!           END DO

!         close(52)

!         DO k = 1, 8                                            !  Transfer to an atom with only n=2 split
         
!            cexhi(2,1,k) = cextab(2,1,k) 
!            cexhi(3,1,k) = cextab(3,1,k) 
!            cexhi(4,1,k) = sum(cextab(4:6,1,k))  
!            cexhi(5,1,k) = sum(cextab(7:10,1,k))  
!            cexhi(6,1,k) = sum(cextab(11:15,1,k))

!            cexhi(3,2,k) = cextab(3,2,k) 
!            cexhi(4,2,k) = sum(cextab(4:6,2,k))  
!            cexhi(5,2,k) = sum(cextab(7:10,2,k))  
!            cexhi(6,2,k) = sum(cextab(11:15,2,k))

 !           cexhi(4,3,k) = sum(cextab(4:6,3,k))
!            cexhi(5,3,k) = sum(cextab(7:10,3,k))  
!            cexhi(6,3,k) = sum(cextab(11:15,3,k))

!            cexhi(5,4,k) = sum(cextab(7:10,4:6,k))
!            cexhi(6,4,k) = sum(cextab(11:15,4:6,k))

!            cexhi(6,5,k) = sum(cextab(11:15,7:10,k))

                       
!         END DO

!         DO i =2, 6
!            DO j = 1, i-1
!               DO k = 1, 7
!                  alfa(i,j,k) = log10(cexhi(i,j,k+1)/cexhi(i,j,k))/log10(teex(k+1)/teex(k))
!               END DO

!            END DO
!         END DO        

!      END IF

        
!      DO upper = 2, N_levels
!         DO lower = 1, upper-1

!            IF (upper .LE. 6) THEN

!               IF (upper .EQ. 3 .AND. lower .EQ. 2) THEN                ! The 2s-2p treatment

!                        IF (T .LT. 1.e4) THEN
                     
!                                c2p2s = 2.5e-4*(1.e4/T)**0.234 + 2.3e-4  

!                        ELSE

!                                c2p2s = 2.5e-4*(1.e4/T)**0.272 + 2.25e-4  

!                        END IF

!                        omh(3,2) = c2p2s*T**0.5*6.0/8.63e-6
                
!               ELSE         ! interpolate anderson table

!                        IF (T .LT. teex(1)) then
!                                omh(upper,lower) = cexhi(upper,lower,1)*(T/teex(1))**alfa(upper,lower,1)
                         
!                        ELSE IF (T .GT. teex(8)) THEN
!                                omh(upper,lower) = cexhi(upper,lower,8)*(T/teex(8))**alfa(upper,lower,7)
                         
!                        ELSE
!                               DO k =1, 7
!                                      IF (T .GT. teex(k) .AND. T .LE. teex(k+1)) THEN
!                                             omh(upper,lower) = cexhi(upper,lower,k)*(t/teex(k))**alfa(upper,lower,k)
                               
!                                            goto 34
!                                  END IF
!     END DO
!34                             continue
!                       END IF
!              END IF

 
!               Q(upper,lower) =  8.629E-6*omh(upper,lower)/(g(upper)*T**0.5)     ! Down rate         

!               eij = (E(upper)-E(lower))*eV                         ! i is the upper index
	       
!               Q(lower,upper) = g(upper)/g(lower)*Q(upper,lower)*exp(-eij/(1.38E-16*T))     ! Up rate     


!           ELSE                                                ! Levels above 6

!               n_upper = upper-1

!               IF (lower .GE. 4) THEN
!                  n_lower = lower-1
!               ELSE IF (lower .EQ. 2 .OR. lower .EQ. 3) THEN
!                  n_lower = 2
!               ELSE IF (lower .EQ. 1) THEN
!                  n_lower = 1
!               END IF

!               IF (n_upper .NE. n_lower) THEN

!                  CALL CEXH(n_lower, n_upper, T, N_levels, E, G, C_up)     ! Note CEXH returns up rate

!               ELSE

!                  C_up=0.

!               END IF

!               IF ( lower .EQ. 2) THEN

!                  Q(2,upper) = 0.25*C_up
!                  Q(3,upper) = 0.75*C_up   ! TEMP this factor was 2/3 before, wrong ?

!               ELSE

 !                 Q(lower,upper) = C_up

!               END IF

!               EXPO = (E(upper)-E(lower))*eV/(k*T)

!               IF (EXPO < 600.0) THEN

!                       Q(upper,lower) = Q(lower,upper)*g(lower)/g(upper)*EXPO         ! Down rate

!               ELSE                                                                  ! Make 1/sqrt(T) extrap from 500 K

!                       CALL CEXH(n_lower, n_upper, DBLE(500.0), N_levels, E, G, C_up)
!                       Qup_500K = C_up*g(upper)/g(lower)*exp((E(upper)-E(lower))*1.16e4/500.0)
!                       Q(upper,lower) = Qup_500K*SQRT(500.0/T)

!               END IF

!           END IF


!	END DO
!      END DO
      
!      RETURN
!      END







            

      SUBROUTINE ATDATH
      PARAMETER (NL=340,NLP1=NL+1)
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/NBA/NBACK
      COMMON/A16/SIG(NL),GA(NL),BP(NL)
      COMMON/NLEV/e00,NION,N,NP1H,NHMAX,NHMIN
      COMMON/A14/C(NL,NL),CI(NL),G(NL),E(NL),A(NL,NL),
     &WL(NL,NL),DCDT(NL,NL),DCIDT(NL)
      N=200
      NP1=N+1
      NP1H=NP1
c      n=5
      E00=13.5972
      E(1)=0.
      E(2)=10.1981
      E(3)=12.0866
      E(4)=12.7477
      E(5)=13.0536
      E(6)=13.2198
      G(1)=2.
      G(2)=8.
      G(3)=18.
      G(4)=32.
      G(5)=50.
      G(6)=72.
      DO I=7,N
         RN=DBLE(I)
         G(I)=2.*RN**2.
         E(I)=E00*(1.-1./RN**2.)
      enddo
      G(N+1)=1.
      DO 5395 I=1,N
      DO 5394 J=1,N
      WL(I,J)=0.0
      IF(I.EQ.J) GOTO 5394
      IF(E(I).EQ.E(J)) GOTO 5394
      WL(I,J)=ABS(12398.54/(E(I)-E(J)))
5394  CONTINUE
5395  CONTINUE
C     A:S FROM JOHNSON APJ 174:227
      DO  I=1,N
         DO  J=1,N
            C(I,J)=0.
 7352       A(I,J)=0.
         enddo
      enddo
      DO J=1,N
         IMAX=J-1
         DO I=1,IMAX
            RN1=DBLE(I)
            RN2=DBLE(J)
            X=1.-(RN1/RN2)**2.
            IF(I.eq.1) then
               G0=1.1330
               G1=-.4059
               G2=0.07014
            elseIF(I.eq.2) then
               G0=1.0785
               G1=-.2319
               G2=0.02947
            elseIF(I.ge.3) then
               G0=.9935+.2328/RN1-.1296/RN1**2.
               G1=-(.6282-.5598/RN1+.5299/RN1**2.)/RN1
               G2=(.3887-1.181/RN1+1.470/RN1**2.)/RN1**2.
            endif
            GAUNT=1.
            IF(X.GT.0.) then
               GAUNT=G0+G1/X+G2/X**2.
            endif
            A(J,I)=1.
            IF(X.gt.0) then
               A(J,I)=1.57283E10*GAUNT/(RN1*RN2**3.*(RN2**2.-RN1**2.))
            endif
         enddo
      enddo

      GOTO 7362
      A(3,1)=6.257E8
      A(4,1)=5.575E7
      A(5,1)=1.278E7
      A(6,1)=4.125E6
      A(7,1)=1.644E6
      A(4,2)=7.48E6
      A(5,2)=1.811E6
      A(6,2)=5.934E5
      A(7,2)=2.381E5
C     A(4,3)=3.659E7
C     A(5,3)=6.602E6
C     A(6,3)=1.936E6
C     A(7,3)=7.346E5
      A(5,4)=1.067E7
      A(6,4)=2.199E6
      A(7,4)=7.778E5
      A(6,5)=2.698E6
      A(7,5)=7.707E5
      A(7,6)=1.025E6
7362  CONTINUE
C
C     COLL. IONIZATION RATES FROM DRAKE& ULRICH AP J SUPP 42:351
C
      do i=1,n
         ci(n)=0.
      enddo
      CI(1)=4.88E-16
      CI(2)=1.75E-9
      CI(3)=6.58E-8
      CI(4)=3.72E-7
      CI(5)=1.09E-6
      CI(6)=2.35E-6
      CI(7)=4.28E-6
      CI(8)=7.05E-6
      CI(9)=1.09E-5
      CI(10)=1.61E-5
C
      TE=1.E4
      DO I=1,N
         SIG(I)=7.91*REAL(I)
      enddo
      DO I=1,N
         GA(I)=3.
      enddo
      DO I=1,N
         C(I,I)=0.
      enddo

      RETURN
      END




      SUBROUTINE ATDAT
      IMPLICIT REAL*8(A-H,O-Z)
      PARAMETER (NL=340,NLP1=NL+1)
      COMMON/A14/C(NL,NL),CI(NL),G(NL),E(NL),A(NL,NL),
     &WL(NL,NL),DCDT(NL,NL),DCIDT(NL)
      COMMON/NBA/NBACK
      COMMON/A16/SIG(NL),GA(NL),BP(NL)
      COMMON/NLEV/e00,NION,NH,NP1H,NHMAX,NHMIN
      N=NHMAX
      E00=11.871
      E(1)=0.
      E(2)=7323.9
      E(3)=7291.5
      e(4)=3968.5
      e(5)=3933.7
      do i=2,5
         e(i)=12398.54/e(i)
      enddo
      G(1)=2.
      G(2)=4.
      G(3)=6.
      g(4)=2.
      g(5)=4.
c     CA III 1S0
      G(N+1)=1.
      DO  I=1,N
         DO  J=1,N
            WL(I,J)=0.0
            IF(I.ne.J) then
               IF(E(I).ne.E(J)) then
                  WL(I,J)=ABS(12398.54/(E(I)-E(J)))
               endif
            endif
         enddo
      enddo
      DO 7352 I=1,N
      DO 7352 J=1,N
      C(I,J)=0.
 7352 A(I,J)=0.
      A(2,1)=1.3
      a(3,1)=1.3
      A(4,1)=1.46e8
      a(5,1)=1.50e8
      A(3,2)=0.
      a(4,2)=1.06e7
      a(5,2)=1.11e6
      a(4,3)=0.
      a(5,3)=9.9e6
      a(5,4)=0.
7362  CONTINUE
C
      SIG(1)=0.20
      SIG(2)=6.15
      sig(3)=sig(2)
      SIG(4)=2.38
      sig(5)=sig(4)
      GA(1)=0.
      GA(2)=1.0
      ga(3)=ga(2)
      GA(4)=3.65
      ga(5)=ga(4)
      DO 165 I=1,N
165   C(I,I)=0.
      RETURN
      END

           
!      SUBROUTINE CEXH(N,NP,T,N_levels, E, CE)
!      IMPLICIT REAL*8(A-H,O-Z)
!      PARAMETER (NL=340,NLP1=NL+1)

!     COLLISIONAL EXCITATION RATES FROM JOHNSON (AP J 174:227)

!      INTEGER, INTENT(IN) :: N_levels
!      DOUBLE PRECISION, DIMENSION(N_levels) :: E


!      PI=3.14159
!      CON=1.092E-10
!      QP=DBLE(NP)
!      Q=DBLE(N)
!      T4=T/1.E4
!      IN=N
!      INP=NP
!      EIJ=ABS(E(IN)-E(INP))
!      TEV=T/1.1609E4
!      X=1.-(Q/QP)**2
!      YN=EIJ/TEV
!      IF(N.NE.1) GOTO 1
!      G0=1.133
!      G1=-.4059
!      G2=.07014
!      BN=-.603
!      RN=.45
!1     IF(N.NE.2) GOTO 2
!      G0=1.0785
!      G1=-.2319
!      G2=.02947
!      BN=(4.-18.63/Q+36.24/Q**2-28.09/Q**3)/Q
!      RN=1.94/Q**1.57
!2     IF(N.LT.3) GOTO 3
!      G0=.9935+.2328/Q-.1296/Q**2
!      G1=-(.6282-.5598/Q+.5299/Q**2)/Q
!      G2=(.3887-1.181/Q+1.470/Q**2)/Q**2
!      BN=(4.-18.63/Q+36.24/Q**2-28.09/Q**3)/Q
!      RN=1.94/Q**1.57
 
!3     GN=G0+G1/X+G2/X**2
!      ANN=64.*Q**3*GN/(3.*SQRT(3.)*PI*X**4*QP**3)
!      FNN=ANN*X/(2.*Q**2)
!      BNN=4.*Q**4*(1.+4./(3.*X)+BN/X**2)/(QP**3*X**2)
!      RNN=X*RN
!      ZN=RNN+YN
!      A1=(1./YN+.5)*EXP1(YN)-(1./ZN+.5)*EXP1(ZN)
!      A2=E2(YN)/YN-E2(ZN)/ZN
!      CE=CON*SQRT(T)*Q**2*YN**2*(ANN*A1+(BNN-ANN*LOG(2.*Q**2/X))*A2)/X
!      RETURN
!      END

