SUBROUTINE IONIZATION(TESTRUN, nlev, sizeuse, Elevels, fracground2, fracground3, CTON, MOLON, totalnumberdensity, numberfractions, volume, Edep, gammarad, useshell, mols)
USE M1, ONLY : time, time_prev, TIMEDEPENDENT_ION, Nabin, Nelem, Nmol, R_index_str, globid, DOPRINT, IDP, Nr, map2, map3, ITERATIVERUN, map_abin2elem2, map_abin2elem3, mmol, Nstages, Nmol_NLTE, Npis
USE PARAMETERS, ONLY : mp, eV
USE INTERFACE, ONLY : makealpha, chargetransfer, getf, getjacnum, chargetransferheating

USE FILES, ONLY : file_ionfracs, file_ionfracsprev, file_temps, file_numberfractionsused, file_penning, file_gammant, file_gammantprev, file_radmaker_ionrates, file_cttoexc, file_ionfracs, file_ionization_ntandgamma, file_volume, file_ctheating, file_moldens, file_molres, file_molresprev

IMPLICIT NONE

LOGICAL, INTENT(IN) :: TESTRUN
INTEGER, INTENT(IN) :: sizeuse
DOUBLE PRECISION, DIMENSION(Nabin,sizeuse) :: Elevels
INTEGER, DIMENSION(Nabin) :: nlev ! Array with number of excitation levels for each ion
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem), INTENT(IN) :: fracground2
DOUBLE PRECISION, DIMENSION(Nstages*Nelem), INTENT(IN) :: fracground3
LOGICAL, INTENT(IN) :: CTON, MOLON
DOUBLE PRECISION, INTENT(IN) :: totalnumberdensity, volume, Edep
DOUBLE PRECISION, DIMENSION(Nelem), INTENT(IN) :: numberfractions
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem+Nmol), INTENT(IN) :: gammarad
INTEGER, OPTIONAL :: useshell

! --------------------------------------------------
! Task : Compute ionization balance, given ionization rates.
! Input : TESTRUN           Boolean, is this a test run?
!         nlev              Number of levels for each atom
!         Elevels           Excitation energies for all atoms (use in charge transfer reactions)
! Output : files (see ~/fc/mods/files.f90)
! Globals :
! ---------------------------------------------------

INTEGER :: neq, info, i, j, k, ii, jj, abin, n_row, m, niter, reds, p, Nsol, lev, ind, q,  R_index, shell, r1, nfirst, nsecond, recmain, abin_parent1, abin_parent2, abin_mol, nrow, ncol, a, retrieve
DOUBLE PRECISION, DIMENSION(Nstages*Nelem+Nmol) :: x=0, xtry, dx, dxfrac, f
DOUBLE PRECISION, DIMENSION(Nelem+1) :: n=0
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem+Nmol) :: alpha_tot, gamma, gammant, gammant_prev, gammact, gammacollion=0., n2vec=0
DOUBLE PRECISION, DIMENSION(Nstages*Nelem+Nmol,Nstages*Nelem+Nmol) :: JAC, JACTEMP
DOUBLE PRECISION :: eldens, dxlim, ct, tol, xelast, damping, meanneutral=0, meanionized=0, meandoubleionized=0, meanall ,Amean, sum1, sumf2_comb, sumf2_alone, pop, ff1, ff2, ff3, gsmall, T, xe, xe_old, penning, ct_heating, trec, mass_mol, mass_h2, n_mol,n_h2, ctheating=0, ss, frac_dissociate, molmass, nsmall, xtry_min, xtry_max, capup, capdown
CHARACTER :: trash
INTEGER, DIMENSION(Nelem) :: selvec
INTEGER, DIMENSION(:), ALLOCATABLE :: ipiv
LOGICAL :: CONVERGED, READOLD, RAISEZEROS, WRITENEW=.TRUE., fileexists
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem+Nmol,Nstages*Nelem+Nmol,Nstages*Nelem+Nmol) :: CREATE=0
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem+Nmol,Nstages*Nelem+Nmol) :: DESTROY=0, CTH=0
INTEGER, DIMENSION((Nstages-1)*Nelem+Nmol,Nstages*Nelem+Nmol) :: CTABIN=0, CTLEVEL=0
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem+Nmol,Nstages*Nelem+Nmol) :: XTOEXC
DOUBLE PRECISION, DIMENSION(:, :), ALLOCATABLE :: xmat, xmat_old, xmatuse, xmat_prev
DOUBLE PRECISION, DIMENSION(100) :: cal, ans
LOGICAL :: ERROR
DOUBLE PRECISION, DIMENSION(Nelem) :: gammavec
DOUBLE PRECISION, DIMENSION(Nelem) :: ones = 1.
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem+Nmol) :: counter = 1
LOGICAL , DIMENSION(Nelem) :: valuepresent
LOGICAL , DIMENSION((Nstages-1)*Nelem+Nmol) ::gammant_present
CHARACTER(len=2) :: mname
DOUBLE PRECISION, DIMENSION(Nabin, Npis) :: collionmat, collionmat_norm
DOUBLE PRECISION, DIMENSION(Nmol) :: nmol_prev=0., nmol_old
TYPE(mmol), DIMENSION(Nmol), INTENT(IN) :: mols
TYPE(mmol) :: co1, mol
INTEGER, PARAMETER :: elpos=3
!Making some fake variables to extract alpha_tot from test values
!DOUBLE PRECISION, DIMENSION(3) :: test_T
!DOUBLE PRECISION, DIMENSION(2*Nelem) :: test_alphatot

collionmat = 0.

collionmat_norm = 0.

! ------------------------------------------------

RAISEZEROS   = .TRUE. ! For elements with no computed ionization rates, use values calculated for others?

damping = 0.5       ! Damping of Newton-Raphson step (1 = normal step)

dxlim = 5E-3      ! Convergence criteria : stop when relative change in solution is smaller than dxlim

sumf2_comb = 1E-8  ! converge if sum of net rates squared is smaller than this AND dx < dx_lim

sumf2_alone = 1E-19  ! CARE converge if net rates are smaller than this, no matter what dx is

tol = 3E-2          ! Tolerance for test runs

nsmall = 1E-10     ! number density to use when abundance is zero

xtry_min = 1E-10

xtry_max = 0.9999999

capup = 2.

capdown = 0.5

gammant = 0
GAMMACT = 0
n_mol = 0
n_h2 = 0
mass_mol = 0
mass_h2 = 0
COLLIONMAT = 0.
COLLIONMAT_NORM = 0.
ALLOCATE(xmat(Nelem,Nstages+1)); xmat=0 !NOT TO BE CONFUSED WITH x_MAT FROM MODELREADER.F90
ALLOCATE(xmat_old(Nelem,Nstages+1)); xmat_old = 0
ALLOCATE(xmatuse(Nelem,Nstages+1)); xmatuse = 0
ALLOCATE(xmat_prev(Nelem,Nstages+1)); xmat_prev = 0

! --------------------------------------------------------

IF (ITERATIVERUN) THEN

   READOLD = .TRUE.

ELSE

   READOLD = .FALSE.

END IF

!READOLD = .FALSE. ! Try marking in if convergence problems (may be stuck at bad starting guess)

neq = Nstages*Nelem + Nmol  ! Eq system involves creation=destruction for three levels of each atom (neutral, singly and doubly ionized) + for each molecule

penning = 0

! --------------------------------------------------------

ALLOCATE(ipiv(neq)); ipiv = 0   ! Signal vector used for DGESV

IF (TESTRUN) THEN

   globid = useshell

   PRINT *, 'WARNING THIS IS A TEST RUN.'

   ! Shell 1 HI only
   ! Shell 2 HeI only
   ! Shell 3 HI and HeI equal proportions and equal rates
   ! Shell 4 HI and HeI equal proportions but unequal rates
   ! Shell 5 HeI and FeI

END IF

IF (READOLD) THEN    ! Used only as starting point for iterative run

    OPEN(10, file=TRIM(file_ionfracs)//R_index_str(globid), STATUS='OLD')

    READ(10,*) trash, xe_old

    DO j = 1, Nelem

        READ(10,*) trash, xmat_old(j,1:Nstages)

    END DO

    CLOSE(10)

    OPEN(10, file=TRIM(file_molres)//R_index_str(globid), STATUS='OLD')

    DO i = 1, Nelem*Nstages+1

        READ(10,*) trash

    END DO

    DO i = 1, Nmol

   	    READ(10,*) trash, nmol_old(i)

    END DO

    CLOSE(10)

END IF

IF (TIMEDEPENDENT_ION) THEN   

    OPEN(10, file=TRIM(file_ionfracsprev)//R_index_str(globid),STATUS='OLD')

    READ(10,*) trash

    DO j = 1, Nelem

        READ(10,*) trash, xmat_prev(j,1:Nstages)

    END DO

    CLOSE(10)

    IF (MOLON) THEN

        OPEN(10,file=TRIM(file_molresprev)//R_index_str(globid),STATUS='OLD')

        DO i = 1, Nelem*Nstages+1

            READ(10,*) trash

        END DO

        DO i = 1, Nmol

            READ(10,*) trash, nmol_prev(i)

        END DO

        CLOSE(10)

    END IF

END IF

OPEN(10, file=TRIM(file_temps)//R_index_str(globid), STATUS='OLD')   ! Read temperatures

    READ(10,*) T

CLOSE(10)

INQUIRE(file=TRIM(file_penning)//R_index_str(globid), EXIST=fileexists)

IF (fileexists .EQV. .TRUE.) THEN

  OPEN(10,file=TRIM(file_penning)//R_index_str(globid),STATUS='OLD')

  READ(10,*) i, penning

  CLOSE(10)

ELSE

  penning = 0.

END IF

! Read the nonthermal ionization rates

INQUIRE(file=TRIM(file_gammant)//R_index_str(globid), EXIST=fileexists)

IF (fileexists .EQV. .TRUE.) THEN

    OPEN(10,file=TRIM(file_gammant)//R_index_str(globid),STATUS='OLD')

    DO

        READ(10,*,END=200) trash, j, gammant(j)         ! Read NT energy deposition per volume for each species

    END DO


ELSE

    gammant = 0

END IF

200 CLOSE(10)

DO i = 1, (Nstages-1)*Nelem

    abin = map2(i)

    IF (abin == 0) THEN

        CYCLE

    END IF

    gammacollion(i) = sum(collionmat_norm(abin,:)) ! Totall ionization rate due to collionsional ionization (needs to be multiplied with ne as well)

END DO

IF (RAISEZEROS) THEN

    selvec = [((Nstages-1)*(i-1)+1,i=1,Nelem)]   ! (Nstages-1)*Nelem Indices of neutral atoms

    gammavec = gammant(selvec);  ! Vector with ion. rates for the neutral

    valuepresent = .FALSE.; WHERE (gammavec > 0) valuepresent = .TRUE.  ! Only some of them (the most abundant) are computed

    IF (SUM(ones,valuepresent) > 0) THEN  ! There is at least one value: compute the average

        meanneutral = SUM(gammavec,valuepresent)/SUM(ones,valuepresent)  ! Mean rate for the neutrals

    ELSE

        meanneutral = 0.  ! CARE

    END IF

    selvec = [((Nstages-1)*(i-1)+2,i=1,Nelem)]   ! Indeces of singly ionized atoms

    gammavec = gammant(selvec);  ! Vector of ion. rates for ionized atoms

    valuepresent = .FALSE.; WHERE (gammavec > 0) valuepresent = .TRUE.

    IF (SUM(ones,valuepresent) > 0) THEN  ! There is at least one value: compute average

        meanionized = SUM(gammavec,valuepresent)/SUM(ones,valuepresent)   ! Mean nonthermal rate for the ionized

    ELSE

        meanionized = 0. ! CARE

    END IF

    IF (Nstages >= 4) THEN

        selvec = [((Nstages-1)*(i-1)+3,i=1,Nelem)]   ! Indeces of doubly ionized atoms

        gammavec = gammant(selvec)

        valuepresent = .FALSE.; WHERE (gammavec > 0) valuepresent = .TRUE.

        IF (SUM(ones,valuepresent) > 0) THEN  ! There is at least one value: compute average

            meandoubleionized = SUM(gammavec,valuepresent)/SUM(ones,valuepresent)   ! Mean nonthermal rate for the ionized

        ELSE

            meandoubleionized = 0. ! CARE

        END IF

    END IF

    meanall = maxval([(meanneutral+meanionized+meandoubleionized)/3.,1D-10]) ! Same value for all ion states?

    IF (meanall .EQ. 0) THEN !if all gamma nt values are 0, use previous values

        print*, "WARNING all gamma-nt values zero. Using previous gamma-nt values."

        gammant_prev = 0.

        OPEN(20, file=TRIM(file_gammantprev)//R_index_str(globid),STATUS='OLD')

        DO

            READ(20,*,END=211) trash, k, gammant_prev(k) !Read old NT ionization rates

        END DO

        211 CLOSE(20)

        gammant_present = .FALSE.; WHERE (gammant_prev > 0) gammant_present = .TRUE.

        meanall = SUM(gammant_prev,gammant_present)/SUM(counter,gammant_present)

    END IF

    DO j = 1,Nelem

        DO jj = 1, Nstages - 1

            IF (gammant((Nstages-1)*(j-1)+jj) .EQ. 0) gammant((Nstages-1)*(j-1)+jj) = meanall

        END DO

    END DO

END IF

gsmall = 1E-30

close(10)

n(1:Nelem) = totalnumberdensity*numberfractions(1:Nelem)   ! Number densities of all nuclei in zone

n(Nelem+1) = SUM(n(1:Nelem))    ! n(Elem+1) = Total number density

WHERE (n .EQ. 0.) n = nsmall  ! TEMP 1e-10  avoid zero abundances for numerical reasons

gamma = gammarad + gammant ! Total ionization rate

gamma(1) = gamma(1) + penning   ! Add Penning ionizations to total ionizations of Hydrogen

!FIXME move the molecule stuff into makealpha
CALL makealpha(T, alpha_tot(1:(Nstages-1)*Nelem))         ! Get all the (total) recombination rates at the T in this zone

!-------------------------------------------------------------------------------

!IF (MOLON .EQV. .TRUE.) THEN !Using MOLON switch causes ionfracs to be NaN

do i=1, Nmol, 2 ! FIXME -> molecule stuff hardcoded
   if (i == 1) then
      alpha_tot((Nstages-1)*Nelem + 1) = 2e-07 * (T/300.)**(-0.48)    ! UMIST CO
      !alpha_tot(2*Nelem + 1) = 2E-7*(T/300.)**(-0.48)   ! CO+ + e- --> CO  Mitchel and Hus 1985
   elseif (i == 3) then
      alpha_tot((Nstages-1)*Nelem + 3) = alpha_tot((Nstages-1)*Nelem+1) ! CARE for now equal to CO+
   elseif (i == 5) then
      alpha_tot((Nstages-1)*Nelem + 5) = 2.25E-6*T**(-0.4)  ! CM95
   elseif (i == 7) then
      alpha_tot((Nstages-1)*Nelem + 7) = 1.7E-7*T**(-0.5) ! Culhane1995
   elseif (i == 9) then
      alpha_tot((Nstages-1)*Nelem + 9) = 3e-07 * (T/300.)**(-0.5)  ! UMIST C2
   elseif (i == 11) then
      alpha_tot((Nstages-1)*Nelem + 11) = 1.95e-07 * (T/300.)**(-0.7)   ! UMIST O2
   elseif (i == 13) then
      alpha_tot((Nstages-1)*Nelem + 13) = 3.8e-07 * (T/300.)**(-0.5)    ! UMIST CO2
   elseif (i == 15) then
      alpha_tot((Nstages-1)*Nelem + 15) = 3e-07 * (T/300.)**(-0.5)      ! UMIST C2O
   elseif (i == 17) then
      alpha_tot((Nstages-1)*Nelem + 17) = 2e-07 * (T/300.)**(-0.5)      ! FIXME temp for SiS
   elseif (i == 19) then
      alpha_tot((Nstages-1)*Nelem + 19) = 2e-07 * (T/300.)**(-0.5)      ! FIXME temp for SO
   else
      alpha_tot((Nstages-1)*Nelem + i) = alpha_tot((Nstages-1)*Nelem+1)
   endif
enddo

IF (Nmol > 0) THEN ! FIXME -> molecules hardcoded into the code!
   do i=1, Nmol, 2

	select case(i)
		case(3)
			retrieve = 5
		case(17)
			retrieve = 3
		case(19)
			retrieve = 1
		case default
			retrieve = max((2*Nmol_NLTE) - 1,0) ! CO position TEMP hardcoded
     end select

     if (gammant((Nstages-1)*Nelem - retrieve) > 0) then
        gamma((Nstages-1)*Nelem+i) = gammant((Nstages-1)*Nelem - retrieve) ! FIXME CARE set to be the same as CO for all other species atm
     else
        gamma((Nstages-1)*Nelem+i) = meanall
     end if

     if (globid == 5) print *, 'bbb', i, gamma((Nstages-1)*Nelem+i)

     enddo

END IF

!IF (CTON .EQV. .true.) THEN

!    CALL chargetransfer(T, nlev, Elevels, CREATE, DESTROY, CTH, CTABIN, CTLEVEL, XTOEXC)   ! Charge transfer rates as well as moleular rates

!END IF

! if molecules are included
IF (MOLON .EQV. .TRUE.) THEN

    print*, 'Goes into molecules..'

    call molecules(T, DESTROY, CREATE, CTH)

END IF

!if (globid == 1) then
!print *, 'DESTROY', DESTROY

!print *, 'CREATE', CREATE

!print *, 'fracground', fracground2
!end if

! ---------------------------------------------------------------------------
! ---------------------------------------------------------------------------

DO i = 1, Nstages*Nelem

    DO j = 1, Nstages*Nelem

       CREATE(:,i,j) = CREATE(:,i,j)*fracground3(i)*fracground3(j) ! Correct for that only ground multiplets contribute to rates

    END DO

END DO

DO i = 1, (Nstages-1)*Nelem

    DO j = 1, Nstages*Nelem

       DESTROY(i,j) = DESTROY(i,j)*fracground2(i)*fracground3(j) ! Correct for that only ground multiplets contribute to rates

    END DO

END DO

IF (TESTRUN .AND. globid <= 9) THEN

   CREATE = 0.

   DESTROY = 0.

   IF (globid .EQ. 6) THEN

      gamma(9) = 0.   ! No ionization of oxygen

      CREATE((Nstages-1)*Nelem+1,6,12) = 1E-18  ! Set CI + OI --> CO rate

      DESTROY(5,12) = 1E-18

      DESTROY(9,6) = 1E-18

   ELSE IF (globid .EQ. 7) THEN

      gamma(9) = 0

      CREATE((Nstages-1)*Nelem+1,6,12) = 1E-10  ! CI + OI --> CO  high rate

      DESTROY(5,12) = 1E-10

      DESTROY(9,6) = 1E-10

   ELSE IF (globid .EQ. 8) THEN    ! Test data

      DESTROY(1,4) = 1E-9  ! Destruction of HI by HeII (CT)

      DESTROY(4,1) = 1E-9

      CREATE(2,1,4) = 1E-9

      CREATE(3,1,4) = 1E-9

   ELSE IF (globid .EQ. 9) THEN  ! SiI + OI --> SiO  and CI + OI --> CO

      gamma(9) = 0.  ! Dont ionize the OI

      gamma(17) = 0. ! Dont ionize the Si

      CREATE((Nstages-1)*Nelem+3,24,12) = 1E-17   ! SiI + OI --> SiO

      DESTROY(17,12) = 1E-17

      DESTROY(9,25) = 1E-17

      CREATE((Nstages-1)*Nelem+1,6,12) = 1E-18  ! Set CI + OI

      DESTROY(5,12) = 1E-18

      DESTROY(9,6) = 1E-18

   END IF

END IF

! STARTING GUESSES

IF (READOLD) THEN
    
    x = 0

    x(1) = xmat_old(1,1)

    x(2) = xmat_old(1,2)

    x(elpos) = xe_old

    DO j = 2, Nelem

        x(Nstages*(j-1)+1:Nstages*(j-1)+Nstages) = xmat_old(j,1:Nstages)

    END DO

    IF (Nmol > 0 .AND. MOLON) THEN ! Molecules
  
        DO i = 1, Nmol

            x(Nstages*Nelem+i) = nmol_old(i) / n((map_abin2elem2(mols(i)%abin_parent1) / (Nstages-1) + 1)) * mols(i)%n_p1 ! Fundamental definition of x quantity for molecules in getf.f90

        END DO

    END IF

ELSE

    DO j = 1, Nelem

        x(Nstages*(j-1)+1) = 0.90  ! Neutrals
        xmat_old(j,1) = x(Nstages*(j-1)+1)

        x(Nstages*(j-1)+2) = 0.09 ! Singly ionised
        xmat_old(j,2) = x(Nstages*(j-1)+2)

        x(Nstages*(j-1)+3) = 0.01  ! Doubly ionised
        xmat_old(j,3) = x(Nstages*(j-1)+3)

        IF (Nstages >= 4) THEN
            x(Nstages*(j-1)+4) = 0.001 ! Triply ionized
            xmat_old(j,4) = x(Nstages*(j-1)+4)
        END IF

        IF (Nstages >= 5) x(Nstages*(j-1)+5) = 0.001 ! Quadruply ionized

    END DO

    ! -----------------------------------------------------------------------------------
    IF (Nmol > 0 .AND. MOLON) THEN

        DO i = 1, Nmol

            x(Nstages*Nelem+i) = 1e-6

        END DO

    END IF

END IF

x(elpos) = 0.  ! Molecular ion contributions ignored here for the starting guess
DO k = 2, Nstages

    selvec = [(Nstages*(i-1)+k,i=1,Nelem)]

    x(elpos) = x(elpos) + 1./n(Nelem+1)*(k-1)*DOT_PRODUCT(n(1:Nelem),x(selvec))

END DO

print * ,'xe', x(elpos)

!x(elpos) = 0.1 !electron fraction guess

IF (totalnumberdensity .EQ. 0) THEN

   CONVERGED = .TRUE.     ! If zone is empty

   x = 0

ELSE

   CONVERGED = .FALSE.

END IF

niter = 0

WHERE (gamma == 0)

   gamma = gsmall

END WHERE

DO i = 1, Nstages*Nelem+Nmol
  DO j = 1, Nstages*Nelem+Nmol

     !if (globid == 5) print*, 'aaa', i, DESTROY(Nelem*(Nstages-1)+1,i), DESTROY(Nelem*(Nstages-1)+1,i)/sum(DESTROY(Nelem*(Nstages-1)+1,:))

     frac_dissociate = CREATE(Nelem*(Nstages-1)+1,i,j)

     if (globid == 5 .and. frac_dissociate > 0.) print*, 'aaa', i,j,frac_dissociate

  END DO

END DO

DO WHILE (CONVERGED .EQV. .FALSE.)  ! Newton-Raphson iteration, iterate until convergence for the ionization balance...

    !   The ratio of different desctruction paths from gamma_rd and gamma_nt.
    !   For molecules here we only take destruction by compton elections into account
    !   at the moment, and other processes are ignored.
    !   This is done using extrapolation from Liu+95 plots, defined in the functions
    !   comptondiss and comptonion, which depend on the fractional ionization, which
    !   is found in x(3)

    frac_dissociate = CO_comptonion(x(3)) /(CO_comptonion(x(3)) + CO_comptondiss(x(3)))

    print *, 'frac_dissociate', frac_dissociate

    IF (globid .EQ. IDP) print *, 'niter1', niter, globid, x

    CALL getf(neq, x, n, gamma, gammacollion, alpha_tot, T, CREATE, DESTROY, MOLON, xmat_prev, nmol_prev, f, frac_dissociate, mols)    ! Compute net rates

    print *, 'getf out', f

    CALL getjacnum(neq, x, n, gamma, gammacollion, alpha_tot, T, CREATE, DESTROY, MOLON, xmat_prev, nmol_prev, JAC, frac_dissociate, mols)  ! numerical Jacobian..

    dx = -f

    JACTEMP = JAC

    if (globid .EQ. IDP) then 

         print *, 'JAC', JAC

         print *, 'RHS', dx

    end if

    CALL DGESV(neq,1,JAC,neq,ipiv,dx,neq,info)    ! solve equation system for dx...(input dx = -f, output = step)

    if (globid .EQ. IDP) then

         print *, 'out', dx

    end if

    IF (info .NE. 0) THEN   ! No solution was found..

        WRITE(*,*) 'WARNING : ERROR IN DGESV. Shell', globid

        print *, 'niter', niter
        print*, 'info', info
        DO i = 1, neq

            print *, i, -f(i), dx(i)

        END DO

        CONVERGED = .FALSE.  ! SUPERCARE

        WRITENEW = .FALSE.  ! CARE

        GOTO 222 ! SUPERCARE

    ELSE    ! a solution was found..

        xtry = x + damping*dx

        ! FIXME change name to ne or something
        xelast = xtry(elpos)

        WHERE(xtry < 0)    ! No ionization fraction can be negative..

            xtry = xtry_min

        ELSEWHERE(xtry > 1)  ! Or > 1 ....

            xtry = xtry_max

        END WHERE

        !       electron density can go over 1
        xtry(elpos) = xelast  ! Important except xe can be larger than 1, reset

        reds = 0

        WHERE (x > 1D-15)

            dxfrac = ABS(dx/x)    ! relative step size..

        ELSEWHERE

            dxfrac = 0

        END WHERE

        x = xtry   ! move to new solution point

    END IF

    !  more than 2 iters..     ..relative step no too big..    ..sum of the total error not too big..
    IF (niter >= 2 .and. (((MAXVAL(dxfrac) < dxlim) .AND. (SUM(f**2) < sumf2_comb)) .OR. (SUM(f**2) < sumf2_alone)) .or. niter > 100) THEN  ! If step size is small CARE check here

        IF (niter <= 200) then

            CONVERGED = .TRUE.

            PRINT *, 'Convergence in zone ', globid, ' after ', niter, ' iterations', MAXVAL(dxfrac), SUM(f**2)

            DO j = 1, Nstages*Nelem

                print *, j, x(j)

			END DO

			where (x < 1D-50) x = 1D-50

        	!if (Nmol >= 1) n_co = x(Nstages*Nelem+1)*n(3)

        	!if (Nmol >= 3) n_co2 = x(Nstages*Nelem+2)*n(3)

        ELSE

            print *, 'WARNING, exceeding iteration limit in ionization. Deploying a low cap (10%).', globid

            capup = 1.1

            capdown = 0.9

            !IF (x(1) > xmat_old(1,1)) THEN

            !    x(1) = xmat_old(1,1)*1.1

            !ELSE

            !    x(1) = xmat_old(1,1)*0.9

            !END IF

            !IF (x(2) > xmat_old(1,2)) THEN

            !    x(2) = xmat_old(1,2)*1.1

            !ELSE

            !    x(2) = xmat_old(1,2)*0.9

            !END IF

            !DO j = 2, Nelem

            !    DO jj = 1, Nstages
                
            !        IF (x(Nstages*(j-1)+jj) > xmat_old(j,jj)) THEN

            !            x(Nstages*(j-1)+jj) = xmat_old(j,jj)*1.1

            !        ELSE
                   
            !            x(Nstages*(j-1)+jj) = xmat_old(j,jj)*0.9
               
            !        END IF

            !    END DO

            !END DO

            CONVERGED = .TRUE. ! TEMP

            where (x < 1D-50) x = 1D-50

        END IF

        IF (n(1) .EQ. 0) THEN

          x([1,2]) = [1,0]

       	END IF

        DO q = 2, Nelem

            IF (n(q) .EQ. 0) THEN     ! Put  1 0 0 for species that had zero density
                
                x(Nstages*(q-1)+1:Nstages*(q-1)+3) = [1,0,0]

            END IF

        END DO

    ELSE

      IF (DOPRINT .AND. (globid .EQ. IDP))  PRINT *, 'No', MAXVAL(dxfrac(selvec)), SUM(f**2)

   END IF

    niter = niter + 1

END DO

!-------------------------------------------
!CALL chargetransferheating(n, x, DESTROY, CTH, ctheating)

gammact= 0  ! Imp

DO m = 1, (Nstages-1)*nelem    ! compute CT rate for each neutral and singly ionized species

   WRITE(unit=mname,FMT='(I2)') m   ! 2, 4, 6,   ie all the singly ionized

   OPEN(10,file='out/ionization/ctdest/'//mname//'_ctdest'//R_index_str(globid),STATUS='REPLACE')  ! write which elements destroy OII by CT

   WRITE(10,*) 1, DESTROY(m,1), DESTROY(m,1)*n(1)*x(1), DESTROY(m,2)*n(1)*x(2)  ! destruction with HI and HII

   IF (m >= 2) GAMMACT(m) = GAMMACT(m) + DESTROY(m,1)*n(1)*x(1) + DESTROY(m,2)*n(1)*x(2)   ! Add CT destruction by HI and HII to total CT destruction rate

   write(10,*) 'CT   CT*n_i   CT*n_i / sum(CT*n_i)   CT   CT*n_i   CT*n_i/ sum'

   sum1 = 1D-50 ! CARE

   sum1 = sum1 +  DESTROY(m,1)*n(1)*x(1) + DESTROY(m,2)*n(1)*x(2)  ! for bookkeeping

   DO i = 2, Nelem  ! Skip H (done above)

	  DO j = 1, Nstages

          sum1 = sum1 + DESTROY(m,Nstages*(i-1)+j)*n(i)*x(Nstages*(i-1)+j)

      END DO

      IF (i .NE. m) then

         DO j = 1, Nstages

 			GAMMACT(m) = GAMMACT(m) + DESTROY(m,Nstages*(i-1)+j)*n(i)*x(Nstages*(i-1)+j)

         END DO

      END IF

   END DO

   DO i = 2, Nelem

      WRITE(10,'(I6, 9ES12.3)') i, DESTROY(m,Nstages*(i-1)+1), DESTROY(m,Nstages*(i-1)+1)*n(i)*x(Nstages*(i-1)+1), DESTROY(m,Nstages*(i-1)+1)*n(i)*x(Nstages*(i-1)+1)/sum1,&
                                   DESTROY(m,Nstages*(i-1)+2), DESTROY(m,Nstages*(i-1)+2)*n(i)*x(Nstages*(i-1)+2), DESTROY(m,Nstages*(i-1)+2)*n(i)*x(Nstages*(i-1)+2)/sum1,&
                                   DESTROY(m,Nstages*(i-1)+3), DESTROY(m,Nstages*(i-1)+3)*n(i)*x(Nstages*(i-1)+3), DESTROY(m,Nstages*(i-1)+3)*n(i)*x(Nstages*(i-1)+3)/sum1  ! write destruction with neutral species only DESTROY(2*(m-1)+2,2+3*(i-2)+2)*n(i)*x(2+3*(i-2)+2), DESTROY(2*(m-1)+2,2+3*(i-2)+3)*n(i)*x(2+3*(i-2)+3) CARE

   END DO

   CLOSE(10)

END DO

OPEN(10,file=TRIM(file_cttoexc)//R_index_str(globid),STATUS='REPLACE')  ! write CT rates to excited states

DO i = 1, (Nstages-1)*Nelem

   DO j = 1, Nstages*Nelem

      IF (DESTROY(i,j) > 0 .AND. CTABIN(i,j) > 0) THEN

         nfirst = 1 + (i-1)/(Nstages-1)  ! From 2*Nelem to Nelem Integer division OK

         nsecond = 1 + (j-1)/Nstages  ! From 3*Nelem to Nelem

         write(10,'(2I6,ES10.2)') CTABIN(i,j), CTLEVEL(i,j), DESTROY(i,j)*n(nfirst)*x(Nstages*(nfirst-1)+i-2*(nfirst-1))*n(nsecond)*x(j)*XTOEXC(i,j)

      END IF

   END DO

END DO

CLOSE(10)

222   CONTINUE
! FIXME unclear why x(ionized) cant be zero
IF (x(3) == 0) THEN

   selvec = [((Nstages-1)*(i-1)+1,i=1,Nelem)]   ! Indices of neutral atoms
   x(selvec) = 0.99

   selvec = [((Nstages-1)*(i-1)+2,i=1,Nelem)]   ! Indices of singly ionized atoms
   x(selvec) = 0.01

END IF

! ----------------------------------------------------------------------------------------------
! connects all the molecules to parent nuclei. The molecule contribution for each parent nuclei is
! then summed, and printed in column 4 of ionfracs.datxxx.

if (Nmol > 0 .AND. MOLON) then

! loop over all the molecules
   do i=1,Nmol

      ! abin_mol is connected to one or two parent nuclei
      ! the molecule contribution to the first nuclei

      mol = mols(i)

      xmat(map_abin2elem2(mol%abin_parent1) / (Nstages-1) + 1, Nstages+1) = xmat(map_abin2elem2(mol%abin_parent1) / (Nstages-1) + 1,Nstages+1) + x(map_abin2elem3(mol%abin)) ! TEMP should be times n_parent1 here?

      ! checks if the molecule is homonuclear molecule
      if (mol%abin_parent2 /= 0) then

         ! if not, the contribution to parent2 is also added
         xmat(map_abin2elem2(mol%abin_parent2) / (Nstages-1) + 1, Nstages+1) = xmat(map_abin2elem2(mol%abin_parent2) / (Nstages-1) + 1, Nstages+1)  + x(map_abin2elem3(mol%abin)) * n(map_abin2elem2(mol%abin_parent1) / (Nstages-1) + 1) / n(map_abin2elem2(mol%abin_parent2) / (Nstages-1) + 1) ! TEMP should be times n_parent2 here?

      endif

      !print *, 'parent', map_abin2elem2(mol%abin_parent1), map_abin2elem2(mol%abin_parent2)

   end do

   close(12)

end if

print *, 'xmat', xmat(9,:)

! ----------------------------------------------------------------------------------------------
! ----------------------------------------------------------------------------------------------

! Cap changes
DO i = 1, Nelem

   if (i == 1) then ! H, special treatment as no 3d ion stage

      m=1

      xmat(i,1:2) = x(m:m+1)

   else

      m = Nstages*(i-1)+1

      xmat(i,1:Nstages) = x(m:m+Nstages-1)

   end if

   DO j = 1, Nstages+1 ! The Nstages+1 is molecules

      if ((i == 1 .and. j >= 3) .or. (i == 2 .and. j >= 4)) then

		xmatuse(i,j) = 0.

		cycle ! No H III or He IV

      end if

      if (xmat_old(i,j) .ne. 0) then

         if ( (xmat(i,j)-xmat_old(i,j))/xmat_old(i,j) > capup-1.) then

            xmatuse(i,j) = capup*xmat_old(i,j)

            if (DOPRINT) print *, "capping increase", globid, i, j

         elseif ( (xmat(i,j)-xmat_old(i,j))/xmat_old(i,j) < -(1.-capdown)) then

            xmatuse(i,j) = capdown*xmat_old(i,j)

            if (DOPRINT) print *, "capping decrease", globid, i, j

         else

            xmatuse(i,j) = xmat(i,j)

            if (DOPRINT) print *, "no-clip", globid, i, j

         end if

      else

         xmatuse(i,j) = xmat(i,j) ! CARE this needs to be set correctly later

      end if

   END DO

   ss = sum(xmatuse(i,:)) ! normalize including also any molecular abundance

   if (ss > 0) xmatuse(i,:) = xmatuse(i,:)/ss

END DO

! Recalculate xe after possible step dampings
! TEMP molecule ions?
x(3) = 0
DO j = 1, Nstages-1

  x(3) = x(3) + 1./n(Nelem+1)*j*DOT_PRODUCT(n(1:Nelem),xmatuse(:,j+1))

END DO

IF (WRITENEW) THEN

   OPEN(10,file=TRIM(file_ionfracs)//R_index_str(globid), STATUS='REPLACE')   ! File where ion. solution is written to

   WRITE(10,'(I6,ES12.3)') globid, x(3)

   if (Nstages == 3) WRITE(10,'(I5,5ES12.3E3)') 1, xmatuse(1,1), xmatuse(1,2), 0.0

   if (Nstages == 4) WRITE(10,'(I5,5ES12.3E3)') 1, xmatuse(1,1), xmatuse(1,2), 0.0, 0.0

   if (Nstages == 5) WRITE(10,'(I5,5ES12.3E3)') 1, xmatuse(1,1), xmatuse(1,2), 0.0, 0.0, 0.0

   n2vec(1) = n(1)*x(2) ! Its the *ion* population that matters  ! Extract ion populations for trec estimates only

   n2vec(2) = 0         ! No H III

   DO i = 2, Nelem

      m = Nstages*(i-1)+1

      DO j = 1, Nstages-1

       n2vec((Nstages-1)*(i-1)+j) = n(i)*xmatuse(i,j+1)

      END DO

      WRITE(10,'(I5,5ES12.3E3)') i, xmatuse(i,1:Nstages)

   END DO

   close(10)

END IF

xe = x(3)  ! Electron fraction

eldens  = n(Nelem+1)*xe  ! Electron density

recmain = maxloc(n2vec,1)

!write(*,'(A10,I5,I5,100ES12.3)'), 'recmain', globid, recmain, n2vec

trec = 1./(eldens*alpha_tot(recmain))  ! Recombination time scale

open(10,file='out/ionization/ne'//R_index_str(globid), STATUS='REPLACE')

  write(10,*) n(Nelem+1)*x(3), log10(n(Nelem+1)*x(3))

close(10)

OPEN(10,file='out/ionization/trec.dat'//R_index_str(globid),STATUS='REPLACE')

  WRITE(10,*) globid, trec/(24.*3600), trec/(3600*24.*111.5), recmain

close(10)

IF (xe < 1D-30) xe = 1D-30

OPEN(50,file=TRIM(file_ionization_ntandgamma)//R_index_str(globid), STATUS='REPLACE')  ! Not further used

WRITE(50,*) '(Nstages-1)*Nelem:   ', 'NT :   RAD:   CT:  COLLION:'

DO j = 1, (Nstages-1)*Nelem+Nmol

   WRITE(50,'(I5, 4ES10.2)') j, gammant(j), gammarad(j), gammact(j), gammacollion(j)*eldens

END DO

close(50)

NSol = 2
IF (TESTRUN) THEN

   IF (globid == 5) THEN

      cal(1:2) = xmat(2,1:2)    ! Test 5  n(HeI) = 9E9, n(Fe) = 1E9. Nonthermal ionization rates of 1E-6 for HeI, and 3E-6 for Fe I. T=100 --> alfa(He) = 4.00E-11, alfa(Fe) = 1.16E-11.

      ans(1:2) = [0.9966,0.0032]

      cal(3:4) = xmat(13,1:2)  ! 13 = Fe. FeI and Fe II. n(FeI) = 2.7E4 (=trace).
      ans(3:4) = [0.9929,0.0071]

      Nsol = 4

   ELSEIF (globid == 6) THEN

      cal(1) = xmat(3,4)         ! Test 6 CI + OI --> CO
      ans(1) = 3.3E-5

      cal(2) = xmat(3,1)                  ! x_CI ~ 1
      ans(2) = 0.74

      Nsol = 2

   ELSEIF (globid == 7) THEN

      cal(1) = xmat(3,4)         ! Test 7  ! High formation rate of CO --> all C in CO form
      ans(1) = 1.0

      cal(2) = xmat(3,1)       ! CI fraction: 1E-10*nC*x(1)*nO*1 = 1E-10**nC --> x(1) = 1.1E-8
      ans(2) = 1.1E-8

      cal(3) = xmat(5,1)
      ans(3) = 1. - 1./9.                ! O gets depleted by 1/9 (=relative amount of C)

      Nsol = 3

   ELSEIF (globid == 8) THEN

      cal(1:2) = xmat(1,1:2)    ! Test 8  H and He with charge transfer
      ans(1:2) = [0.02,0.98]

      cal(3:4) = xmat(2,1:2)
      ans(3:4) = [0.41, 0.59]

      Nsol = 4

   ELSEIF (globid == 9) THEN

      cal(1:2) = xmat(3,1:2)    ! Test 9 SiO and CO formation
      ans(1:2) = [0.81, 0.19]

      cal(3) = xmat(3,4)  ! CO
      ans(3) = 4.5E-5

      cal(4) = xmat(9,1)
      ans(4) = 1.

      cal(5) = xmat(9,4)
      ans(5) = 5E-4

      Nsol = 5

   END IF

   ! Test 9 SiI + OI --> SiO

   IF (globid <= 9) THEN

      CALL checkerrors(Nsol, cal(1:Nsol), ans(1:Nsol), tol, ERROR)

      IF (ERROR .EQV. .FALSE.) THEN

         PRINT *, 'IONIZATION TEST SUCCESSFUL', globid

      ELSE

         print *, 'IONIZATION TEST FAILED', globid

      END IF

   END IF

END IF

OPEN(10,file=TRIM(file_ctheating)//R_index_str(globid),STATUS='REPLACE')

  WRITE(10,*) ctheating, ctheating*volume

close(10)

OPEN(10,file=TRIM(file_moldens)//R_index_str(globid),STATUS='REPLACE')

   do i = 1, Nmol
      WRITE(10,'(I4,6ES10.2)') i, x(Nstages*Nelem + i)
   end do

close(10)

OPEN(10,file=TRIM(file_molres)//R_index_str(globid),STATUS='REPLACE')

WRITE(10,*) T, n(Nelem+1)*x(3)

! Atomic output:

DO i = 0,Nelem-1

    DO j = 1, Nstages-1

        WRITE(10,'(I4,5ES20.10E3)') map3(i*Nstages + j), x(i*Nstages + j) * n(i+1), 0., x(i*Nstages+j), gamma((Nstages-1)*i + j), alpha_tot((Nstages-1)*i + j)

    END DO

    WRITE(10,'(I4,5ES20.10E3)') map3(i*Nstages + Nstages), x(i*Nstages + Nstages) * n(i+1), 0., x(i*Nstages + Nstages), 0., 0.

END DO

! --------------------------------
! output for molecules
! -------------------------------
! output format:
! abin_mol, number density, mass, gamma, alpha
DO i = 1, Nmol

    mol = mols(i)

    n_mol = x(map_abin2elem3(mol%abin)) * n((map_abin2elem2(mol%abin_parent1) / (Nstages-1) + 1))/mol%n_p1 

    mass_mol =  n_mol * volume * mol%mass * mp / 2E33

    WRITE(10,'(I4,5ES20.10E3)') mol%abin, n_mol , mass_mol, x(map_abin2elem3(mol%abin)), gamma(map_abin2elem2(mol%abin)), alpha_tot(map_abin2elem2(mol%abin))

END DO

CLOSE(10)

! --------------------------------
CONTAINS

DOUBLE PRECISION FUNCTION CO_comptonion(xtemp)
IMPLICIT NONE
DOUBLE PRECISION, INTENT(IN)::xtemp
DOUBLE PRECISION :: temp
temp = log10(xtemp)
CO_comptonion = 10**(0.01218924d0*temp**3 + 0.12972319d0*temp**2 + 0.45998696d0*temp + 1.99534018d0)
END FUNCTION CO_comptonion

DOUBLE PRECISION FUNCTION CO_comptondiss(xtemp)
IMPLICIT NONE
DOUBLE PRECISION, INTENT(IN)::xtemp
DOUBLE PRECISION :: temp
temp = log10(xtemp)
CO_comptondiss = 10**(0.01303392d0*temp**3 + 0.15258833d0*temp**2 + 0.59389675d0*temp + 2.72642324d0)
END FUNCTION CO_comptondiss

END
