#! /bin/sh
# Performs loops over suse-sumo-suib.
# Arg 1 : max iterations
#     2 : Nr + 1
#     3 : Number of procs for MC
#     4 : identifier
#     5 : input file
#     6 : Do gamma dep?
#     7 : Iterative?
#     8 : wlmin
#     9 : wlmax
#    10 : res1000
#    11 : Ntotal
#    12 : minsend
#    13 : minsendUV
#    14 : maxsend
# ------------------------------
let i="1"
converged=0
while [ $converged = 0 ]; do
  echo " " >> logfile
  echo "Starting iteration" $i >> logfile
  echo "DD is" $DD
  rm out/convproblems*
  mpirun -n $2 $SUMODIR/suse $4 $5 $6 $7 $8 $9 ${10} > out/ut  # NLTE computations
  if [ $? = 0 ]; then
      echo "suse successful.." >> logfile
  else
      echo "ERROR in suse in iterate.sh" >> logfile
      exit 1
  fi
  $SUMODIR/tccollector $5   # Merge thin spectra for each zone into a total thin spectrum
  $SUMODIR/teqscollector $5  # Merge all equilibrium temperatures into one file
  rm out/mcphotons/*coll* out/mcphotons/*fir*    # Clean up before MC run
  mpirun -n $3 $SUMODIR/sumo $4 $5 $8 $9 ${10} ${11} ${12} ${13} ${14} $7 > out/ut2    # The Monte Carlo run.
  if [ $? = 0 ]; then
      echo "sumo successful.." >> logfile
  else
      echo "ERROR in sumo in iterate.sh" >> logfile
      exit 1
  fi
  $SUMODIR/gather.sh   # Merges each individual slave output file into one big file (for each type of output)
  mpirun -n $2 $SUMODIR/suib $5 $7 > out/ut3   # Compute new ionization balance
  if [ $? = 0 ]; then
      echo "suib successful.." >> logfile
  else
      echo "ERROR in suib in iterate.sh" >> logfile
      exit 1
  fi
  $SUMODIR/adcoolcollector $5
  $SUMODIR/process $4 $5 1200 3500  # Write model spectrum to file. Calculate line and band fluxes.
  #file=$DD"/modelspectra/spectrum.dat"$4  # The output spectrum (sync with process.f90)
  #filecopy=$DD"/saved/"$4"/spectrum.dat"$4"_"$i  # Name of copy to be saved tagged with this iteration
  #cp $file $filecopy  # Save a copy of spectrum tagged with iteration number
  $SUMODIR/xelong $5
  #./hion $5
  echo "ITERATION" $i "OF" $1 "DONE"
  $SUMODIR/checkconv $5 >> logfile  # Compare solution to previous one
##  ./putfiles.sh $i $5  # Save solutions and rates
  eb=`tail -1 out/process/all_long.dat | cut -c9-27`
  echo "Energy balance "$eb >> logfile
  #convstat=$(<out/process/eb.dat)
  grep -i error out/ut* >> logfile
  read -r convstat eb < out/process/eb.dat
  a=$(bc -l <<< $eb'>'3)  # Check if energy is more than 3 times too high
  tol=0.0275
  c1=$(bc -l <<< $eb'>'1.-$tol)
  c2=$(bc -l <<< $eb'<'1.+$tol)
  if [ $a = 1 ] && [ $i -ge 20 ]; then
      echo "Energy looking weird (>3*dep)..exiting iterate.sh" >> logfile
      exit 3
  fi
  if [ $1 = 1 ]; then
	exit 0 # First, single run
  elif [ $c1 = 1 ] && [ $c2 = 1 ] && [ $i -ge 30 ]; then # Do at least 3 iterations also if energy ok
    	echo "Converged" >> logfile
    	let converged="1"
  elif [ $i -ge $1 ]; then
        echo "Max iterations exceeded" >> logfile
        let converged="1"
	exit 2
  else
        #echo "Not converged" >> logfile
    	let converged="0"
  fi
  let i+=1
done
