MODULE M1
IMPLICIT NONE

INTEGER, PARAMETER :: Nstages=3, Nabin=145, Nelem=26, DIMSADD=14, Nmol = 0, SFMAX=265, Nmol_NLTE = 0

DOUBLE PRECISION, PARAMETER :: kappa_56ni=0.030, kappa_56Co=0.030, kappa_57Co=2.4*kappa_56Co, kappa_44Ti=0.040, kappa_pos=8.5  ! Woosley1989 NOTE All these should be multlied with (Z/A)/0.5. (There is no 'true' kappa value as it is the electrons that absorb). No source for the 56ni value

DOUBLE PRECISION, PARAMETER :: taulife_56Ni = 7.577e5    ! 8.77 days (lu.se)
DOUBLE PRECISION, PARAMETER :: taulife_56Co = 9.634e6  ! 111.5 days (Alburger1991, lu.se)
DOUBLE PRECISION, PARAMETER :: taulife_57Ni = 1.26d5    ! 35h
DOUBLE PRECISION, PARAMETER :: taulife_57Co = 3.388e7   ! 392.1 days (lu.se)
DOUBLE PRECISION, PARAMETER :: taulife_44Ti = 2.745e9   ! 87 years (Ahmad2006)

DOUBLE PRECISION :: time, lambdacut, M44, leakage, lambdastart_radfield, lambdaend_radfield, stepatstart_radfield, betal_Lyalpha, betal_Lybeta, distance_MPc, timestep
DOUBLE PRECISION, POINTER :: time_prev, v_out, dustedge, M_56Ni, M_56Co, M_57Co, M_44Ti
DOUBLE PRECISION, PARAMETER :: Amean_crit_hydrogenrich = 2.0

CHARACTER(len=8) :: datechar, gridtype

CHARACTER(len=6) :: object

CHARACTER(len=10) :: timechar, idrun

INTEGER :: Nsent, myid, sharedcomm, window, globcomm, globid, taskcolor, taskcomm, Nradfield, IDP, PHOTOEXC, RECURSIVES, idum, Nr, Ncore, Npis, MOLECULESWITCH, ind_iron, ind_nickel, ind_cobalt, ind_calcium, ind_titanium
DOUBLE PRECISION :: Halfa_tot, binningcutoff

INTEGER, PARAMETER :: FeI_levs=42, FeII_levs=42, Ts=50, OI_levs=26

LOGICAL :: DOPRINT, FG0_FIRST, MCRUN,  ITERATIVERUN, TIMEDEPENDENT_T, TIMEDEPENDENT_ION
LOGICAL, POINTER :: BLEND

INTEGER, DIMENSION((Nstages-1)*Nelem + Nmol) :: map2

INTEGER, DIMENSION(Nstages*Nelem + Nmol) :: map3

INTEGER, DIMENSION(Nabin + Nmol) :: map_abin2elem2, map_abin2elem3

DOUBLE PRECISION :: FIRFLUX
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: colldeexc, h2diss
DOUBLE PRECISION, DIMENSION(:), POINTER :: Ephotoexc, energyin, energyout, lambda_radfield
DOUBLE PRECISION, DIMENSION(:, :), POINTER :: E_radfield
DOUBLE PRECISION, DIMENSION(:,:,:,:), POINTER :: N_CONTABS
DOUBLE PRECISION, DIMENSION(:,:), POINTER :: OUTPHOTONS_SC, OUTPHOTONS_ABIN, OUTPHOTONS_ORIGZONE, OUTPHOTONS_LASTZONE
DOUBLE PRECISION, DIMENSION(:,:,:,:), ALLOCATABLE :: NPHOTOEXC

! FIXME avoid hardcoding? This should be >= Natoms
DOUBLE PRECISION, DIMENSION(70,1000) :: popsave

!--------------------------------------------------------------
!sl: these are arrays that seem to be missing from master branch

DOUBLE PRECISION, DIMENSION(Nelem) :: massvec

INTEGER, DIMENSION(Nelem) :: Zvec

DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem) :: lambdaion
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem + Nmol) :: ievec

INTEGER, DIMENSION((Nstages-1)*Nelem+Nmol) :: ngvec
INTEGER, DIMENSION((Nstages-1)*Nelem) :: minshellvec, maxshellvec

INTEGER, DIMENSION(Nabin) :: gval

TYPE atomm
  CHARACTER(len=5) :: NAME
  CHARACTER(len=3) :: SPECIES_TYPE
  INTEGER :: Z, CHARGE, N, N_LEVELS, N_LEVELS_ABSORB, POS, SEQ, ABIN, MBIN, DENSITY_ID, NLEVABSMAX, NGROUND, GGROUND, MINSHELL, MAXSHELL, Nlines
  DOUBLE PRECISION :: MASS, N_NUCLEUS, E_ION_GS
  CHARACTER(len=100) :: FILE_ADDRESS
  DOUBLE PRECISION, DIMENSION(:), POINTER :: LEVELS_E, LEVELS_G, RR_ALPHA0, RR_T0, RR_BETA, DISSPROB
  DOUBLE PRECISION, DIMENSION(:,:), POINTER :: LAMBDA  ! TEMP REPLACE BY REAL?
  REAL, DIMENSION(:,:,:), POINTER :: TAU
  REAL, DIMENSION(:,:), POINTER :: A, UPSILON0, UPSILON0_T0, UPSILON0_BETA
  DOUBLE PRECISION, DIMENSION(:,:,:), POINTER :: PHOTOEXCRATES
  LOGICAL :: SENDS, ABSORBS, RR_ALPHA_EXISTS, RR_BETA_EXISTS, UPSILON0_EXISTS, UPSILON0_BETA_EXISTS
END TYPE

TYPE mmol
  CHARACTER(len=7) :: NAME
  INTEGER :: ABIN, MBIN, ABIN_PARENT1, ABIN_PARENT2
  DOUBLE PRECISION :: MASS, Z, N_P1, N_P2
END TYPE


CONTAINS

  PURE ELEMENTAL CHARACTER(LEN=3) FUNCTION R_index_str (i)
    INTEGER, INTENT(IN) :: i
    WRITE (UNIT=R_index_str, FMT='(I3.3)') i
  END FUNCTION R_index_str

END MODULE M1
