PROGRAM MAIN
USE M1, ONLY : idrun, atomm, myid, sharedcomm, window, globcomm, globid, taskcolor, taskcomm, TIMEDEPENDENT_T, gridtype, leakage, betal_lyalpha, betal_lybeta, ITERATIVERUN, DOPRINT, IDP, PHOTOEXC, MOLECULESWITCH, distance_Mpc, lambdacut, time, time_prev, idum, MCRUN, R_index_str, DIMSADD, Ephotoexc, Npis, v_out, dustedge, M_56Co, M_56Ni, M_57Co, M_44Ti, Nelem, map2, colldeexc, firflux, Ncore, Nr, Nmol, Nabin, popsave, ngvec, BLEND, Nstages	  ! Global variables
USE PARAMETERS, ONLY : eV  ! Physical constants
USE INTERFACE   ! Interfaces
USE FILES, ONLY : file_runparameters, file_log, file_nlevelsabsorb, file_moldens, file_heatfracs , file_molcool, file_nabspreion, file_radmaker_radheating, file_ctheating, file_radmaker_ionratesspecific, file_dep, file_temps, file_EXCCUBE, file_nlines, file_tnc, file_spectralrange, files_init, file_photoexcrates, file_groundfracs, file_glevels, file_popsave, file_lines, file_convproblems_suse, file_elevels, file_mainheatfracs, file_natoms, file_tempsprevious, file_timeprev, file_xeprev  ! File names

IMPLICIT NONE
INCLUDE 'mpif.h'    ! A system MPI file
! -----------------------
! Task : Compute steady-state, radioactivity-powered, spherically symmetric SN spectra. Papers: Jerkstrand+ 2011, Jerkstrand+2012.
! Command line arguments : 1    0=compute temperature amd NLTE populations. 1 = compute MC spectrum
!                          2    ID number of the run
!                          3    Time since explosion in days
!                          4    Total number of packets
!                          5    Maximum number of packets for a given zone and wavelength bin
!                          6    y --> computed gamma-ray deposition n --> dont compute (use old value)
!			   7	(optional) name of run parameters input file,
!				defaults to runparameters.dat
! -----------------------------------------------------------------------------------------
INTEGER, PARAMETER :: N_atoms=49    ! Number of atoms included
TYPE (atomm), DIMENSION(N_atoms):: atoms  ! Type atomm is in M1 module
TYPE(LOGICAL), DIMENSION(N_atoms+1) :: convprobs
INTEGER, DIMENSION(:), POINTER :: nlevabsorbs_max  ! It is later set to have the correct dimension when the memory share comes into play
TYPE (atomm) :: atom, HI, HeI, HeII, CI, CII, CIII, NI, N2, OI, OII, OIII, NeI, NeII, NaI, NaII, MgI, MgII, SiI, SiII, SiIII, SI, S2, S3, KI, KII, ArI, ArII, ArIII, CaI, CaII, FeI, FeII, FeIII, CoI, CoII, CoIII, NiI, NiII, NiIII, TiI, TiII, TiIII, AlI, AlII, CrI, CrII, MnI, MnII, ScI, ScII, VI, VII, CMI, CMII, SMI, SMII, SSI, SSII, UMI, UMII
INTEGER :: i, j, EXCMAX, N_UPPER_MAX, R_index, DIMS, Nsend_shell, LINESTOT, abin, abin_old=0, zone, origzone, lastzone, Nblobs, minsend, minsend_uv, Nlines, seq, ii, scattered, nlevabsorbs, N_abs, chunksize, datavecsize, smallcounter, bigcounter, idsend, processID, tag, WLbins, WLbins_old,  ierr, numprocs, m, n, index, N_nuclei, Npacketsmax, shell, upper, lower, Nres, bin, ind, sender, Nfill, maxN=0, lev, time_days_i, Nbig, loops=0, Dustzonemax, FH
INTEGER(8) :: NpacketsTOT, Npackets
LOGICAL :: FORCECAII, OLI, REALRECCONT, LYBETAFOUND=.FALSE., OI6300FOUND=.FALSE., OI6364FOUND=.FALSE., EXISTS
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: wlvec, fracvec
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: flux_noconv_MAT, TAUMAT, EMISS_MAT, EXC_MAT_ABIN
DOUBLE PRECISION, DIMENSION(:), POINTER :: deposition_tot_pervol, deposition_tot_pervol_global
DOUBLE PRECISION, DIMENSION(:), POINTER :: alfa_dust, radii, shellvec, shellvec_log, deposition_tot, gammadep_pervol, pi_heating, cd_heating, br_heating, ctheating, radheating, n_co, n_sio, n_h2, Nlinesvec, T_previous, xe_previous, lambdavec, alfavec
DOUBLE PRECISION, DIMENSION(:,:), POINTER :: x_MAT, ION_STRUCTURE, ABIN_MAT, FGROUND, nmolmat
REAL, DIMENSION(:,:), ALLOCATABLE :: DATAMAT  ! Contains photon packets data (wavelength, energy etc)
DOUBLE PRECISION, DIMENSION(:,:,:), ALLOCATABLE :: FBIG
REAL, DIMENSION(:,:,:), ALLOCATABLE :: EXC_CUBE_ABIN
REAL, DIMENSION(:,:,:), ALLOCATABLE :: TAUCUBE
DOUBLE PRECISION, DIMENSION(:,:,:), POINTER :: IONRATES, EXC_MATRIX
LOGICAL, DIMENSION(:), POINTER :: COMPUTESHELL
CHARACTER(len=5) :: name
CHARACTER(LEN=100) :: file_explmodel, file_photons, file_deadphotons, file_lineabs, file_colldeexc, file_ephotoexc
REAL :: t1, t2, timetot=0
INTEGER, DIMENSION(MPI_STATUS_SIZE) :: status
DOUBLE PRECISION :: r, r_out, r_in, lambda, Ebin, Epp, z, spectrumstart, spectrumend, stepatstart, totalemission, totalemission_log, totalshellemission, wlvec_s, tau_tresh, ntheatrate, T, T_eq, tau_dust, dt_core, r_int, blobsize, aftot, ndens, lum, flow, sf_tresh, alfa_dust_use, rate, T_typical, time_days, fosctot, power, origr, origlambda, resolution1000, sumv, accum, flux, Etot=0, rsend, rint, esend, nco_temp, nsio_temp, piheating_temp, cdheating_temp, ctheating_temp, bremsheating_temp, cool_co, cool_sio, fv1_co, fv1_sio, molcool, alfatot, fff, frac, tautot, tempval, ctheattemp
DOUBLE PRECISION, POINTER :: vterm
CHARACTER(len=1) :: trash, densitystring, dogammadep_s, iterative_s
CHARACTER(len=3) :: processname
CHARACTER(len=4) :: timestring, time_days_str
CHARACTER(len=10) :: Npacketsmax_str
CHARACTER(len=20) :: Npacketstot_str
!DOUBLE PRECISION, DIMENSION(198,198) :: CASC
INTEGER, DIMENSION(:,:), ALLOCATABLE :: NSEND
DOUBLE PRECISION, DIMENSION(:), POINTER :: ff, af, af_accum   ! Filling factors, area factors
CHARACTER :: str
INTEGER, PARAMETER :: Nlambda_c=1000
CHARACTER(len=10) :: weighting, spectrumstart_s, spectrumend_s, resolution1000_s
!INTEGER, DIMENSION(:), ALLOCATABLE :: Nlinesvec
DOUBLE PRECISION, DIMENSION(Nabin) :: vec, fff2
DOUBLE PRECISION :: returndata
DOUBLE PRECISION, DIMENSION(10) :: alfav, alfa
REAL, EXTERNAL :: ran1   ! The random number generator
LOGICAL :: DOGAMMADEP
character(MPI_MAX_PROCESSOR_NAME) hostname
INTEGER :: err_length, err_tmp
CHARACTER(len=MPI_MAX_ERROR_STRING) :: err_message
! -----------------------------------------------------------------------------------
CALL MPI_INIT(ierr)   ! initialize MPI
CALL MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)  ! numprocs is the total number of processors invoked
CALL MPI_COMM_DUP(MPI_COMM_WORLD, globcomm, ierr)  ! Duplicate MPI_COMM_WORLD into a global communicator called globcomm
CALL MPI_COMM_RANK(globcomm, globid, ierr)  ! globid is the GLOBAL RANK for each processor
CALL MPI_COMM_SPLIT_TYPE(MPI_COMM_WORLD, MPI_COMM_TYPE_SHARED, 0, MPI_INFO_NULL, sharedcomm, ierr)  ! This splits the processors into communicators that envelop one (1) node
CALL MPI_COMM_RANK(sharedcomm, myid, ierr)  ! MYID is the ID number for each processor INSIDE ITS OWN NODE (so 0-31)

! Put all myid == 0 into one communicator to allow nodes to update their values to each other
if (myid == 0) then
    taskcolor = 0
else
    taskcolor = MPI_UNDEFINED
endif
CALL MPI_COMM_SPLIT(MPI_COMM_WORLD, taskcolor, 0, taskcomm, ierr)
! ------------------------------------------------------------------------------------

call MPI_Get_Processor_name(hostname, i, ierr)

print '(A23, I5, A8, I5, A17, A10, I5)', "Greetings from process ", globid, " out of ", numprocs, ". My hostname is ", hostname

Nlines = 250000 ! CARE  Maximum number of ABSORPTION LINES in any shell

CALL GET_COMMAND_ARGUMENT(1, idrun)  ! ID number for the iteration

CALL GET_COMMAND_ARGUMENT(2, file_runparameters) ! Run parameters file name (optional)

CALL GET_COMMAND_ARGUMENT(3, dogammadep_s) ! Gamma deposition?

CALL GET_COMMAND_ARGUMENT(4, iterative_s) ! Iterative run?

CALL GET_COMMAND_ARGUMENT(5, spectrumstart_s ) ! Run-parameters file name (optional)

CALL GET_COMMAND_ARGUMENT(6, spectrumend_s ) ! Run-parameters file name (optional)

CALL GET_COMMAND_ARGUMENT(7, resolution1000_s ) ! Run-parameters file name (optional)

if (dogammadep_s == 'y') then

   DOGAMMADEP = .TRUE.

else

   DOGAMMADEP = .FALSE.

end if

if (iterative_s == 'y') then

   ITERATIVERUN = .TRUE.

else

   ITERATIVERUN = .FALSE.

end if

if (globid == 0) print *, "ITERATIVE", ITERATIVERUN

read(spectrumstart_s,*) spectrumstart

read(spectrumend_s,*) spectrumend

read(resolution1000_s,*) resolution1000

TIMEDEPENDENT_T = .FALSE. ! Use time-dependent equation for the temperature?

call cpu_time(t1)  ! For timing purposes..

! Initialise modules
CALL files_init (idrun)  ! exists in files.f90

! Light elements and molecules:
HI%NAME=' HI  ';HeI%NAME='HeI  ';HeII%NAME='HeII ';CI%NAME=' CI  ';CII%NAME=' CII ';NI%NAME=' NI  ';N2%NAME=' N2  ';OI%NAME=' OI  ';OII%NAME=' OII ';OIII%NAME=' OIII';NeI%NAME='NeI  ';NeII%NAME='NeII ';NaI%NAME='NaI  ';NaII%NAME='NaII ';MgI%NAME='MgI  ';MgII%NAME='MgII ';SiI%NAME='SiI  ';SiII%NAME='SiII ';SI%NAME=' SI  ';S2%NAME=' S2  ';S3%NAME=' S3  ';CaI%NAME='CaI  ';CaII%NAME='CaII ';FeI%NAME='FeI  ';FeII%NAME  ='FeII ';FeIII%NAME='FeIII';CoI%NAME='CoI  ';CoII%NAME='CoII ';CoIII%NAME='CoIII';NiI%NAME='NiI  ';NiII%NAME='NiII ';NiIII%NAME = 'NiIII';TiI%NAME='TiI  ';TiII%NAME='TiII ';AlI%NAME='AlI  ';AlII%NAME='AlII ';CrI%NAME='CrI  ';CrII%NAME='CrII ';MnI%NAME='MnI  ';MnII%NAME='MnII ';KI%NAME=' KI  ';KII%NAME=' KII  ';ArI%NAME='ArI  ';ArII%NAME='ArII ';ArIII%NAME = 'ArIII'; ScI%NAME='ScI  ';ScII%NAME='ScII ';VI%NAME=' VI  ';VII%NAME=' VII ';CMI%NAME='CMI  ';CMII%NAME='CMII ';SMI%NAME='SMI  ';SMII%NAME='SMII ';SSI%NAME='SSI  ';SSII%NAME='SSII ';UMI%NAME='UMI  ';UMII%NAME='UMII '!;SiOI%NAME='SiOI ';SiSI%NAME='SiSI '; ! sl parameters
! CaIII has E(2) = 203,000 (493 A) dont need to include!SiIII%NAME      ='SiIII';! NaII has E(2) = 200,000 dont need to include!OIII%NAME       =' OIII';  OIII%SENDS = 1;   OIII%ABSORBS = 1; OIII%N_LEVELS = 0!CIII%NAME       =' CIII';  CIII%SENDS = 1;   CIII%ABSORBS = 1; CIII%N_LEVELS = 0 ! 2  ! 2-1 line at 1907

atoms(1:N_atoms) = [HI, HeI, HeII, CI, CII, NI, N2, OI, OII, OIII, NeI, NeII, NaI, NaII, MgI, MgII, SiI, SiII, SI, S2, S3, ArI, ArII, ArIII, CaI, CaII, FeI, FeII, FeIII, CoI, CoII, CoIII, NiI, NiII, NiIII, TiI, TiII, AlI, AlII, CrI, CrII, MnI, MnII, ScI, ScII, VI, VII, KI, KII]! Put atoms into an array

!atoms(1:N_atoms) = [HI, HeI, HeII, CI, CII, NI, N2, OI, OII, OIII, NeI, NeII, NaI, NaII, MgI, MgII, SiI, SiII, SI, S2, ArI, ArII, ArIII, CaI, CaII, FeI, FeII, FeIII, CoI, CoII, CoIII, NiI, NiII, NiIII, TiI, TiII, AlI, AlII, CrI, CrII, MnI, MnII, ScI, ScII, VI, VII, KI, KII, CMI, CMII,SMI, SMII, SSI, SSII, UMI, UMII]
!, SiOI, SiSI]

! Initialize
DO i = 1, N_atoms
   atoms(i)%N_LEVELS = 0
   atoms(i)%SENDS = .TRUE.
   atoms(i)%ABSORBS = .TRUE.
END DO

! This has to be shared memory early so readrunparameters sets the values correctly
CALL memshare(sharedcomm, myid, BLEND, window); BLEND = .FALSE.
CALL memshare(sharedcomm, myid, time_prev, window); time_prev = 0
CALL memshare(sharedcomm, myid, vterm, window); vterm = 0
CALL memshare(sharedcomm, myid, v_out, window); v_out = 0
CALL memshare(sharedcomm, myid, dustedge, window); dustedge = 0
CALL memshare(sharedcomm, myid, M_56Co, window); M_56Co = 0
CALL memshare(sharedcomm, myid, M_56Ni, window); M_56Ni = 0
CALL memshare(sharedcomm, myid, M_57Co, window); M_57Co = 0
CALL memshare(sharedcomm, myid, M_44Ti, window); M_44Ti = 0

call readrunparameters(time_days, file_explmodel, tau_dust, vterm, Nblobs, tau_tresh, sf_tresh, REALRECCONT, FORCECAII, OLI, Dustzonemax, N_atoms, atoms)   ! Run all runparameters specified in runparameters input file. Also some global ones.

if (globid == 0) print *, 'dogammadep', DOGAMMADEP

stepatstart = resolution1000*spectrumstart/1000.   ! Resolution, step size at shortest wavelength

T_typical = 4000*(time_days/365.)**(-1.5)  ! This is used for computing the Regemorter collision strengths

! ================================================================================

LINESTOT = 0                            ! Dont remove
EXCMAX = 0                              ! Dont remove
N_UPPER_MAX = 0                         ! Dont remove
lambdacut = spectrumend

WRITE(unit=processname,FMT='(I3)') globid   ! Internal conversion, write MYID (integer) to string PROCESSNAME (used to label output files)

time = time_days*24.*3600.  ! time in seconds

write(unit=timestring,FMT='(I4)') INT(time_days)   ! Internal conversion, write time_day to string TIMESTRING (used to label output files)

IF (globid == 0) call writelogs(N_atoms)

CALL init_random_seed()	  ! This (fully independent) process resets the random number seed

call random_number(z)

idum = -floor(z*1000)   ! Initialize random seed for ran1..should be done with random generator

IF (globid == 0) open(10,file=file_convproblems_suse,STATUS='REPLACE'); close(10)  ! Initialize file containing potential convergence problems whe computing level populations

IF (globid == 0) open(10,file=file_convproblems_suse,STATUS='REPLACE'); close(10) !Initialize file containing convergence problems in SUSE

CALL indexnuclei(N_atoms, atoms(1:N_atoms), N_nuclei)     ! Assign bookkeeping numbers to the atoms. Autonomous process, does not need to be changed when adding atoms.

!atoms(N_atoms)%SEQ = N_atoms  ! Set SEQ value for H2  CARE

DIMS = N_atoms + N_nuclei + DIMSADD  ! Total number of parameters, relevant for state vector in each zone

CALL memshare(sharedcomm, myid, alfa_dust, window, (/ Nr /)); alfa_dust = 0
CALL memshare(sharedcomm, myid, radii, window, (/ Nr+1 /)); radii = 0
CALL memshare(sharedcomm, myid, shellvec, window, (/ Nr /)); shellvec = 0
CALL memshare(sharedcomm, myid, shellvec_log, window, (/ Nr /)); shellvec_log = 0
CALL memshare(sharedcomm, myid, COMPUTESHELL, window, (/ Nr /)); COMPUTESHELL = .TRUE.
CALL memshare(sharedcomm, myid, deposition_tot, window, (/ Nr /)); deposition_tot = 0
CALL memshare(sharedcomm, myid, deposition_tot_pervol, window, (/ Nr /)); deposition_tot_pervol = 0
CALL memshare(sharedcomm, myid, deposition_tot_pervol_global, window, (/ Nr /)); deposition_tot_pervol_global = 0
CALL memshare(sharedcomm, myid, gammadep_pervol, window, (/ Nr /)); gammadep_pervol = 0
CALL memshare(sharedcomm, myid, pi_heating, window, (/ Nr /)); pi_heating = 0
CALL memshare(sharedcomm, myid, cd_heating, window, (/ Nr /)); cd_heating = 0
CALL memshare(sharedcomm, myid, br_heating, window, (/ Nr /)); br_heating = 0
CALL memshare(sharedcomm, myid, ctheating, window, (/ Nr /)); ctheating = 0
CALL memshare(sharedcomm, myid, radheating, window, (/ Nr /)); radheating = 0
CALL memshare(sharedcomm, myid, x_MAT, window, (/ Nr, DIMS /)); x_MAT = 0
CALL memshare(sharedcomm, myid, ION_STRUCTURE, window, (/ Nr, Nabin /)); ION_STRUCTURE = 0
CALL memshare(sharedcomm, myid, ABIN_MAT, window, (/ Nr, Nabin /)); ABIN_MAT = 0
CALL memshare(sharedcomm, myid, FGROUND, window, (/ Nr, Nabin /)); FGROUND = 0
CALL memshare(sharedcomm, myid, Ephotoexc, window, (/ Nr /)); Ephotoexc = 0
CALL memshare(sharedcomm, myid, IONRATES, window, (/ Nr, Nabin, maxval([Npis,ngvec]) /)); IONRATES = 0
CALL memshare(sharedcomm, myid, n_co, window, (/ Nr /)); n_co = 0
CALL memshare(sharedcomm, myid, n_sio, window, (/ Nr /)); n_sio = 0
CALL memshare(sharedcomm, myid, n_h2, window, (/ Nr /)); n_h2 = 0
CALL memshare(sharedcomm, myid, nmolmat, window, (/ Nr, maxval([1,Nmol]) /)); nmolmat = 0
CALL memshare(sharedcomm, myid, Nlinesvec, window, (/ Nr /)); Nlinesvec = 0

IF (Ncore > 0) THEN
    CALL memshare(sharedcomm, myid, ff, window, (/ Ncore /)); ff = 0
    CALL memshare(sharedcomm, myid, af, window, (/ Ncore /)); af = 0
    CALL memshare(sharedcomm, myid, af_accum, window, (/ Ncore+1 /)); af_accum = 0
ELSE  ! just to make the interfaces work
    CALL memshare(sharedcomm, myid, ff, window, (/ 1 /)); ff = 0
    CALL memshare(sharedcomm, myid, af, window, (/ 1 /)); af = 0
    CALL memshare(sharedcomm, myid, af_accum, window, (/ 2 /)); af_accum = 0
END IF
CALL memshare(sharedcomm, myid, T_previous, window, (/ Nr /)); T_previous = 0
CALL memshare(sharedcomm, myid, xe_previous, window, (/ Nr /)); xe_previous = 0

CALL memshare(sharedcomm, myid, nlevabsorbs_max, window, (/ N_atoms /)); nlevabsorbs_max = 0

CALL MPI_BARRIER(sharedcomm, ierr)

call makeatoms(N_atoms, atoms, T_typical, maxN)   ! Read atomic data, allocate and fill atoms array

IF (ITERATIVERUN .AND. (myid .EQ. 0)) THEN  ! Master of each node..

   DO i = 1, Nr

      OPEN(20,file=TRIM(file_nlevelsabsorb)//R_index_str(i),STATUS='OLD')  ! If this is a NLTE comp. run, these are the numbers used in last MC run, to get photoexc. rates right

      DO

         READ(20,*,END=225) seq, abin, nlevabsorbs

         !print *, seq, N_atoms

         IF (seq < 1 .OR. seq > N_atoms) STOP 'seq index out of range'

         IF (nlevabsorbs > nlevabsorbs_max(seq)) THEN  ! If this number is larger than the largest so far..

            nlevabsorbs_max(seq) = nlevabsorbs  ! Replace the largest so far..

            IF (nlevabsorbs_max(seq)  > atoms(seq)%N_LEVELS) THEN  ! If N_levels has been lowered, lower also max absorption levels

               nlevabsorbs_max(seq) =  atoms(seq)%N_LEVELS

            END IF

         END IF

      END DO

225   CLOSE(20)

   END DO

   IF (TIMEDEPENDENT_T .EQV. .TRUE.) THEN

        open(20,file=file_tempsprevious,STATUS='OLD')

        DO

           READ(20,*,END=226) seq, T_previous(seq)

        END DO

        226 close(20)

        open(20,file=file_xeprev,status='OLD')

        DO

           READ(20,*,END=227) seq, xe_previous(seq)

        END DO

        227 close(20)

        open(20,file=file_timeprev,STATUS='OLD')

        read(20,*) time_prev

        time_prev = time_prev*24*3600

        close(20)

   ELSE

        T_previous = 0.

        time_prev = 0.

        xe_previous = 0.

   END IF

ELSE IF (myid .EQ. 0) THEN  ! Memory shared so use else-if to avoid potential strangeness

   DO i = 1, N_atoms

      nlevabsorbs_max(atoms(i)%SEQ) = 0

   END DO

END IF

CALL MPI_BARRIER(sharedcomm, ierr)  ! Wait for Master to catch up

IF (ITERATIVERUN .AND. globid >= 1 .AND. globid <= Nr) THEN  ! globalID per string

   open(10,file=TRIM(file_EXCCUBE)//R_index_str(globid),STATUS='OLD')

   DO

      read(10,*,END=331) trash, i, trash, j, tempval  ! Sequence i, level j

      if (j <= atoms(i)%N_LEVELS) popsave(i,j) = tempval   ! Check that a saved level is not higher than what is used in current run time this

      IF (isnan(popsave(i,j))) popsave(i,j) = 1E-20  ! CARE


   END DO

331   close(10)

END IF
!! BCAST(taskcomm, popsave) ?

! This loop only happens in iterative runs (non-iterative has nlevabsorbs_max = 0)
DO i = 1, N_atoms  ! For each element..

   IF ((PHOTOEXC >= 1) .AND. (nlevabsorbs_max(i) > 0)) THEN  ! If photoexcitation rates are to be included in the NLTE solutions, allocate arrays for them

      CALL memshare(sharedcomm, myid, atoms(i)%PHOTOEXCRATES, window, (/ Nr, int(nlevabsorbs_max(i)), atoms(i)%N /))

      atoms(i)%N_LEVELS_ABSORB = nlevabsorbs_max(i)

      atoms(i)%PHOTOEXCRATES = 0


   END IF

END DO

IF (globid .eq. 0) THEN  ! Global-Master only to write...

   open(10,file=file_natoms,STATUS='REPLACE')

     write(10,*) N_atoms

   close(10)

   open(10,file=file_elevels,STATUS='REPLACE')   ! Write energy levels of atoms...this file is used by radmaker.f90

   DO i = 1, N_atoms

      write(10,'(2I8,10000ES12.4)') atoms(i)%ABIN, atoms(i)%N_LEVELS, atoms(i)%LEVELS_E(1:atoms(i)%N_LEVELS)/eV

   END DO

   close(10)

   open(10,file=file_glevels,STATUS='REPLACE')   ! Write statistical weight for each element..this file is used by radmaker.f90

   DO i = 1, N_atoms

      write(10,'(2I8,10000ES12.4)') atoms(i)%ABIN, atoms(i)%N_LEVELS, atoms(i)%LEVELS_G(1:atoms(i)%N_LEVELS)

   END DO

   close(10)

END IF

CALL MPI_BARRIER(globcomm, ierr)  ! Wait for every proces to be sure

IF (myid .EQ. 0) THEN  ! Master for each node..

   CALL modelreader(vterm, N_atoms, atoms, file_explmodel, FORCECAII, DIMS, x_MAT, ION_STRUCTURE, ABIN_MAT, Dustzonemax)   ! Read explosion model, temperature and ionization..

   IF (ITERATIVERUN .EQV. .TRUE.) THEN  ! Is this an run preceded by a previous temperature and level population calculation, radiative transfer calculation giving radiative rates, as well as an ionization solution?

      DO i = 1, Nr

         open(10,file=TRIM(file_groundfracs)//R_index_str(i),STATUS='OLD')  ! Read fractions of atoms in their ground states (from last iteration)

         DO

            read(10,*,END=62) R_index, abin, trash, frac

            IF (abin <= Nabin .and. abin >= 1) FGROUND(i,abin) = frac

         END DO

62       close(10)

      END DO

      DO i = 1, Nr

         OPEN(10,file=TRIM(file_moldens)//R_index_str(i),STATUS='OLD')  ! Read molecular abundances from ion. solutions

         READ(10,*,END=855) trash, nco_temp, nsio_temp  ! Sometimes file is empty (after problems in previous iteration), avoid crashing by allowing a no-read

        855 CLOSE(10)

         nco_temp = 0. !TEMP/CARE bug fix
         nsio_temp = 0.

         n_co(i) = nco_temp

         n_sio(i) = nsio_temp

         nmolmat(i,1) = nco_temp

         if (Nmol >= 3) nmolmat(i,3) = nsio_temp

      END DO

   ELSE  ! Not an iterative run

      FGROUND = 1.

      n_co = 0.

      n_sio = 0.

      nmolmat = 0.

   END IF

END IF

IF (myid .EQ. 0) radii(1:Nr) = x_MAT(:,DIMS-11); radii(Nr+1) = 1.   ! Dimensionless radii, only master has to set the value as it is shared

IF (myid .EQ. 0) CALL writeionedges(N_atoms, atoms(1:N_atoms))  ! Create a file with the ionization edges for the first Npis levels in each atom.

IF (globid .EQ. 0) THEN  ! Write run parameters to a file read by matlab when plotting

   OPEN (UNIT=10, FILE=file_log, STATUS='OLD', POSITION='APPEND')

   write(10,*) 'Time ', time_days

   write(10,*) 'taudust  etc..'

   WRITE(10,'(11(G10.3/), G10.3)') tau_dust, x_MAT(Ncore+1,DIMS-11)*v_out/1e5, x_MAT(Ncore+1,DIMS-10)*v_out/1E5, v_out/1e5, Nblobs, x_MAT(max(Ncore,1),DIMS-3)*x_MAT(max(Ncore,1),DIMS-8)/(x_MAT(max(Ncore,1),DIMS-3)*x_MAT(max(Ncore,1),DIMS-8)+SUM(x_MAT(Ncore+2:Nr,DIMS-3)*x_MAT(Ncore+2:Nr,DIMS-8))), x_MAT(1:max(Ncore,1),DIMS-12)

   CLOSE(10)

END IF

CALL MPI_BARRIER(globcomm, ierr)

IF (Ncore > 0) THEN
   ff = x_MAT(1:Ncore,DIMS-12)  ! Filling factors
   IF (myid .EQ. 0) THEN  ! Do this once for each node
        print *, 'ff', ff
        af = ff**(2./3.)  ! Area factors : each zone has an area that scales as volume^(2/3)
        af_accum(1) = 0; DO i = 1, Ncore; af_accum(i+1) = af_accum(i) + af(i);END DO;  ! accumulate af factors
        af_accum = af_accum/af_accum(Ncore+1)  ! Normalize so that they add to 1.
    ENDIF
END IF

CALL MPI_BARRIER(sharedcomm, ierr)  ! This barrier is important! rest of the code requires correct ff/af values -> each node waits for its master

DO i = 1, Nr  ! For each zone...

   IF (x_MAT(i,DIMS-3) .EQ. 0.) COMPUTESHELL(i) = .FALSE.   ! If density is zero dont compute

END DO

DO i = 1, N_atoms      ! Loop to 1) Find out largest atom size (both N and N_LEVELS)  2) How many lines there are

   IF (atoms(i)%N_LEVELS > EXCMAX) THEN  ! If this atom has more NLTE levels than the maximum encountered so far..

      EXCMAX = atoms(i)%N_LEVELS    ! Update the maximum number encountered so far..

   END IF

   IF (atoms(i)%N > N_UPPER_MAX) THEN  ! If this atom has more number of levels (in radiative transfer) than encountered so far..

      N_UPPER_MAX = atoms(i)%N   ! Update that maximum...

   END IF

   LINESTOT = LINESTOT + atoms(i)%N_LEVELS*(atoms(i)%N_LEVELS-1)/2  ! These are the numer of EMISSION lines. Integer division ok. N_LEVELS levels can make maximum N_LEVELS*(N_LEVELS-1)/2 emission lines.

END DO

LINESTOT = LINESTOT + 10000   ! Add some more to continuum emission (2-photon continuum and free-bound)

IF (Dustzonemax >= 1) THEN

	IF (myid .EQ. 0) alfa_dust(1:Dustzonemax) = tau_dust/dustedge  ! shared memory so only master!

END IF

CALL MPI_BARRIER(sharedcomm, ierr)  ! barrier because we changed values so make sure each node is synched
CALL memshare(sharedcomm, myid, lambdavec, window, (/ Nlambda_c /)); lambdavec = [(500 + i*12000/DBLE(Nlambda_c),i=1,Nlambda_c)]  ! For continuum, CARE
CALL memshare(sharedcomm, myid, alfavec, window, (/ Nlambda_c /)); alfavec = 0

! EXC_MAT_ABIN is unique per zone -> do not memory share
ALLOCATE (EXC_MAT_ABIN (Nabin, EXCMAX)); EXC_MAT_ABIN = 0  ! Matrix to contain nlte solutions

CALL fe2HECSreader()  ! Read high-energy collision cross sections for FeII

! Boot some files that are initialized and are later appended:

IF (globid == 0) THEN  ! Only global master touch

   OPEN(10, file=file_heatfracs, STATUS='REPLACE'); CLOSE(10)

   OPEN(10, file=file_molcool, STATUS='REPLACE'); CLOSE(10)

END IF

CALL MPI_BARRIER(globcomm, ierr)  ! Wait for global master to have touched files before continuing to avoid desyncing

IF (ITERATIVERUN) THEN   ! use previously calculated radiative heating rates etc..

   IF (myid .EQ. 0) THEN  ! Only node-master reads..  (could be globid and then BCAST ?)

      DO R_index = 1, Nr

         inquire(file=TRIM(file_radmaker_radheating)//R_index_str(R_index),exist=EXISTS)  ! Check if file there, this allows to add shells (increase Nr) and continue on iterations

         IF (EXISTS) THEN

            OPEN(20, file=TRIM(file_radmaker_radheating)//R_index_str(R_index), STATUS='OLD')

            DO

               READ(20,*,END=500) i, piheating_temp, cdheating_temp, bremsheating_temp  ! Read heating by photoionizations, collisional deexcitations and free-free absorption from last MC run

               pi_heating(R_index) = piheating_temp

               cd_heating(R_index) = cdheating_temp

               br_heating(R_index) = bremsheating_temp

            END DO

500         CLOSE(20)

         ELSE

            print *, 'WARNING, file_radmaker_radheating unexpectedly did not exist', R_index

            pi_heating(R_index) = 0.

            cd_heating(R_index) = 0.

            br_heating(R_index) = 0.

         END IF

         inquire(file=TRIM(file_ctheating)//R_index_str(R_index),exist=EXISTS)  ! Check if file there, this allows to add shells (increase Nr) and continue on iterations

         IF (EXISTS) THEN

            open(20, file=TRIM(file_ctheating)//R_index_str(R_index), STATUS='OLD')

            ctheattemp = 0.

            READ(20,*,END=502) ctheattemp   ! Read charge transfer heating

502         CLOSE(20)

            ctheating(R_index) = ctheattemp

         ELSE

            print *, 'WARNING, file_ctheating unexpectedly did not exist', R_index

            ctheating(R_index) = 0.

         END IF

         inquire(file=TRIM(file_radmaker_ionratesspecific)//R_index_str(R_index),exist=EXISTS)  ! Check if file there, this allows to add shells (increase Nr) and continue on iterations

         IF (EXISTS) THEN

            OPEN(30,file=TRIM(file_radmaker_ionratesspecific)//R_index_str(R_index), STATUS='OLD')

            DO

               READ(30,*,END=400) i, abin, j, rate     ! Read ionization rates from MC run, element abin, level i

               IF (j <= maxval([Npis,ngvec])) IONRATES(R_index, abin, j) = rate

            END DO

400         CLOSE(30)

         ELSE

            print *, 'WARNING, file_radmaker_ionratesspecific unexpectedly did not exist', R_index

         END IF

         IF ((PHOTOEXC >= 1)) THEN  ! Include photoexcitation rates in NLTE solutions?

            inquire(file=TRIM(file_photoexcrates)//R_index_str(R_index),exist=EXISTS)  ! Check if file there, this allows to add shells (increase Nr) and continue on iterations

            IF (EXISTS) THEN

               open(30,file=TRIM(file_photoexcrates)//R_index_str(R_index),STATUS='OLD')

               DO

                  read(30,*,END=404) trash, abin, i, j, rate

                  IF (abin .NE. abin_old) THEN  ! A new element?

                     abin_old = abin

                     seq = 0

                     DO n = 1, N_atoms  ! Find index of this atom

                        IF (atoms(n)%ABIN == abin) THEN

                           seq = n

                           EXIT

                        END IF

                     END DO

                  END IF  ! D.C. that right extraction is done

                  IF (i <= nlevabsorbs_max(seq)) THEN

                     atoms(seq)%PHOTOEXCRATES(R_index,i,j) = rate ! nlevabsorbs_max still set to its OLD value

                  END IF

               END DO

404            close(30)

            ELSE

                print *, 'WARNING, file_photoexcrates unexpectedly did not exist', R_index
            END IF

         END IF

      END DO

   END IF

   ! This is shared memory now so only node-master updates
   IF (myid .EQ. 0) radheating = pi_heating + cd_heating + br_heating + ctheating  ! Add them all up...Photionization heating, collisional deexcitation heating, bremsstrahlung heating and chemical reactions heating

END IF

CALL MPI_BARRIER(sharedcomm, ierr)

CALL memshare(sharedcomm, myid, EXC_MATRIX, window, (/ Nr, N_atoms, EXCMAX /))  ! This matrix contains NLTE solutions for included atoms only (smaller version of EXC_MAT_ABIN)

ALLOCATE (EMISS_MAT (LINESTOT, 6)) ! Matrix to contain emissivities; EMISS_MAT is unique per zone -> do not memory share
ALLOCATE(TAUMAT(Nlines,6)); ! Unique for zones -> do not memory share TAUMAT

IF (DOGAMMADEP .EQV. .TRUE.) THEN  ! Recompute radioactive deposition?

   ! deposition_tot_pervol is memory shared so depositionfunction sets the correct value now
   CALL depositionfunction(DIMS, x_MAT, Nblobs, deposition_tot_pervol, gammadep_pervol)  ! Compute deposition from radioactive elements [erg cm^{-3} s^{-1}]
   CALL MPI_BARRIER(sharedcomm, ierr)  ! depositionfunction might have issues with all processes replacing a file?

   IF (globid == 0) THEN  ! global master

      OPEN(130,file=file_dep,STATUS='REPLACE')  ! Write deposition in each zone to file

      write(130,*)  SUM(deposition_tot_pervol(:)*x_MAT(:,DIMS-8))

      DO i = 1, Nr

         WRITE(130,'(I5, 4ES12.2)') i, deposition_tot_pervol(i)*x_MAT(i,DIMS-8),  deposition_tot_pervol(i)*x_MAT(i,DIMS-8)/SUM(deposition_tot_pervol(:)*x_MAT(:,DIMS-8)), gammadep_pervol(i)*x_MAT(i,DIMS-8), gammadep_pervol(i)/deposition_tot_pervol(i)

      END DO

      CLOSE(130)

      PRINT *, 'Total dep:', SUM(deposition_tot_pervol(:)*x_MAT(:,DIMS-8))

   END IF

ELSE  ! Do not redo radioactive deposition calculation (if same epoch as last one)..instead read energy deposition from file

   IF (myid == 0) THEN  ! Master of each node does the reading...  NOTE difference between globid/myid here!

      open(444, file=file_dep,STATUS='OLD')

      read(444,*) trash

      DO i = 1, Nr

         read(444, *) trash, deposition_tot(i)

         deposition_tot_pervol(i) = deposition_tot(i)/x_MAT(i,DIMS-8)  ! Divide by volume

      END DO

      close(444)

   END IF

END IF

CALL MPI_BARRIER(globcomm, ierr)  ! Deposition has to be correct so Barrier needed

DO R_index = 1, Nr

   IF (globid == MOD(R_index,numprocs)) THEN   ! Parallelization..*globid* does shell with same number

      IF (COMPUTESHELL(R_index)) THEN

         alfa_dust_use = alfa_dust(R_index)

         ! call routine that calculate steady-state NLTE populations and the temperature

         CALL  statisticalandthermalequilibrium(N_atoms, atoms, R_index, DIMS, x_MAT(R_index,:), ABIN_MAT(R_index,1:Nabin), FGROUND(R_index,1:Nabin), NMOLMAT(R_index,1:Nmol), EXCMAX, deposition_tot_pervol(R_index), radheating(R_index), REAL(IONRATES(R_index,1:Nabin,1:maxval([Npis,ngvec]))), alfa_dust_use, tau_tresh, sf_tresh, T_previous(R_index), xe_previous(R_index), T_eq, EXC_MATRIX(R_index,:,:), cool_co, cool_sio, fv1_co, fv1_sio, ntheatrate, convprobs)

         call MPI_SEND(convprobs, N_atoms+1, MPI_LOGICAL, 0, tag, MPI_COMM_WORLD, ierr)

         x_MAT(R_index,DIMS) = T_eq  ! Equilibrium temperature

         open(80,file=TRIM(file_mainheatfracs)//R_index_str(R_index), STATUS='REPLACE')

         write(80,'(A20, 5F12.4, 5ES12.2)') 'NT PI CD CT FF', ntheatrate/(radheating(R_index)+ntheatrate),  pi_heating(R_index)/(radheating(R_index)+ntheatrate),  cd_heating(R_index)/(radheating(R_index)+ntheatrate), ctheating(R_index)/(radheating(R_index)+ntheatrate), br_heating(R_index)/(radheating(R_index)+ntheatrate), ntheatrate*x_MAT(R_index,DIMS-8), pi_heating(R_index)*x_MAT(R_index,DIMS-8), cd_heating(R_index)*x_MAT(R_index,DIMS-8), ctheating(R_index)*x_MAT(R_index,DIMS-8), br_heating(R_index)*x_MAT(R_index,DIMS-8)  ! Write contributions to heating rates

         close(80)

         OPEN(80, file=TRIM(file_temps)//R_index_str(R_index), STATUS='REPLACE')  ! Write temperature solutions

            WRITE(80,*) x_MAT(R_index,DIMS)

         CLOSE(80)

         !write(*,*) "written data", T_eq, myid, x_MAT(R_index,DIMS), R_index

         DO i = 1, N_atoms   ! Load solutions for excitation structure (EXC_MATRIX) into solution cube (EXC_MAT_ABIN)

            EXC_MAT_ABIN(atoms(i)%ABIN,1:atoms(i)%N_LEVELS) = EXC_MATRIX(R_index,i,1:atoms(i)%N_LEVELS)

         END DO

         DO j = 1, (Nstages-1)*Nelem   ! For unsolved species, put everything in the ground state

            IF ((j .NE. 2) .and. (map2(j) .NE. 0)) THEN  ! j=2 is protons..

               IF (EXC_MAT_ABIN(map2(j), 1) .EQ. 0) EXC_MAT_ABIN(map2(j),1) = ION_STRUCTURE(R_index, map2(j))

            END IF

         END DO

         OPEN(20,file=TRIM(file_nlevelsabsorb)//R_index_str(R_index),STATUS='REPLACE')

         DO i = 1, N_atoms   ! Write how many levels are absorbing (highest lower level for line with tau > tau_tresh) for each atom

            atom = atoms(i)

            WRITE(20,*) atom%SEQ, atom%ABIN, atom%N_LEVELS_ABSORB

         END DO

         CLOSE(20)

         molcool = cool_CO + cool_SiO   ! Total molecular cooling

         OPEN(10,file=file_molcool,STATUS='OLD',POSITION='APPEND')

         WRITE(10,*) R_index, cool_co*fv1_co, cool_sio*fv1_sio, cool_co, cool_sio  ! Total fundamental band cooling for CO and SiO

         CLOSE(10)

         TAUMAT = 0

         ! Create cubes with opacities and emissivities:
         CALL calculatecubes(R_index, N_atoms, atoms, EXCMAX, NMOLMAT(R_index,1:Nmol), EXC_MAT_ABIN, tau_tresh, DIMS, x_MAT(R_index,:), ION_STRUCTURE(R_index,:), alfa_dust(R_index), LINESTOT, COMPUTESHELL(R_index), REALRECCONT, n_co(R_index), Nlines, TAUMAT, N_abs, EMISS_MAT, molcool, lum)  ! Fill EMISS_CUBE with emissicities and TAUCUBE with line optical depths
         CALL sorttaumat(N_abs, TAUMAT)  ! Resort taus in increasing wavelength order

         IF (COMPUTESHELL(R_index) .EQV. .FALSE.) CYCLE

         ! Write files with sorted optical depths
         OPEN(20,file=TRIM(file_lines)//TRIM(R_index_str(R_index))//'_tausorted.dat',STATUS='REPLACE')
         open(21,file=TRIM(file_lines)//TRIM(R_index_str(R_index))//'_a6300.dat',STATUS='REPLACE')
         open(22,file=TRIM(file_lines)//TRIM(R_index_str(R_index))//'_integrated.dat',STATUS='REPLACE')

         DO j = 1, N_abs
            IF (TAUMAT(j,1) <= Nabin .AND. TAUMAT(j,6) > 0.01) THEN  ! Write all line with tau_s > 0.01
               WRITE(20,'(1I6,2F20.4,3I6, ES10.2)') j, TAUMAT(j,5), TAUMAT(j,6), NINT(TAUMAT(j,1)), NINT(TAUMAT(j,3)), NINT(TAUMAT(j,4))
            END IF
            IF (TAUMAT(j,1) <= Nabin .AND. TAUMAT(j,1) > 0 .AND. TAUMAT(j,6) > 0.1 .AND. TAUMAT(j,5) > 6300.) THEN

               WRITE(21,'(1I6,2F20.4,3I6, ES10.2)') j, TAUMAT(j,5), TAUMAT(j,6), NINT(TAUMAT(j,1)), NINT(TAUMAT(j,3)), NINT(TAUMAT(j,4))  ! Write all lines after 6300 Å in a separate file

            END IF
         END DO

         DO j = 3000, 10000, 10  ! For each wavelength from 3000 to 10000, steps of 10
            call findbin2(N_abs, TAUMAT(1:N_abs,5), DBLE(j), bin)  ! Find index of this wavelengths
            tautot = 0
            if (bin .NE. 0) THEN
               ind = bin + 1
               DO while (ind <= N_abs .and. TAUMAT(ind,5) < DBLE(j)*(1. + 3500./3e5))
                  tautot = tautot + TAUMAT(ind,6)
                  ind = ind + 1
               END DO
               write(22,*) j, tautot
            endif
         END DO

         CLOSE(20)
         close(21)
         close(22)

         !CALL fileEMISS_CUBE(R_index, EMISS_MAT, DIMS, x)  ! Write the emissivities to file...these are not further needed

         ! Bin emissivities together into total emissivity vectors (one per zone):
         CALL thinspectrum(R_index, spectrumstart, 100d4, spectrumend, stepatstart, DIMS, x_MAT(R_index,:), EMISS_MAT, WLbins, wlvec, tau_dust)  ! Bin emissivities and put in matrix flux_noconv_MAT which is used for the actual sending. Compute optically thin spectrum up to 100d4 A = 100 microns

      END IF

   END IF

END DO

DEALLOCATE(EMISS_MAT)
DEALLOCATE(EXC_MAT_ABIN)
DEALLOCATE(TAUMAT)

call cpu_time(t2)

print *, 'cpu time', t2-t1

CALL MPI_WIN_FREE(window, ierr)  ! Release all the shared memory!
IF (myid == 0) THEN
    CALL MPI_COMM_FREE(taskcomm, ierr)
ENDIF
CALL MPI_Comm_set_errhandler(MPI_COMM_WORLD, MPI_ERRORS_RETURN, ierr)
CALL MPI_FINALIZE(ierr)   ! Everything done!

IF (ierr /= MPI_SUCCESS) THEN
	IF (globid == 0) THEN
    	CALL MPI_Error_string(ierr, err_message, err_length, err_tmp)
 		print *, "-----------------------------------------------------------------------"
  		print *, "Note: MPI_Finalize returned the following error."
 		print *, "      Please double check your results against single-node calculation."
 		print *, "-----------------------------------------------------------------------"
 		print *, err_message(1:err_length)
 		print *, "-----------------------------------------------------------------------"
  	END IF
END IF

if (globid == 0) print *, 'Program finished. cpu time', t2-t1

END PROGRAM MAIN
