PROGRAM MAIN_RADTRANS
USE M1, ONLY : idrun, atomm, myid, sharedcomm, window, globcomm, globid, taskcolor, taskcomm, RECURSIVES, betal_lyalpha, betal_lybeta, ITERATIVERUN, DOPRINT, IDP, PHOTOEXC, distance_Mpc, lambdastart_radfield, lambdaend_radfield, stepatstart_radfield, Nradfield, lambda_radfield, E_radfield, lambdacut, time, idum, R_index_str, DIMSADD, Ephotoexc, Npis, dustedge, Nelem, map2, N_CONTABS, colldeexc, h2diss, OUTPHOTONS_SC, OUTPHOTONS_ABIN, OUTPHOTONS_ORIGZONE, OUTPHOTONS_LASTZONE, firflux, Ncore, Nr, Nmol, Nabin, ngvec, v_out, energyin, energyout, Nstages, BLEND, M_56Ni, M_56Co, M_57Co, M_44Ti	  ! Global variables
USE PARAMETERS, ONLY : eV, h, c  ! Physical constants
USE INTERFACE   ! Interfaces
USE FILES, ONLY : file_runparameters, file_log, file_nlevelsabsorb, file_moldens, file_heatfracs , file_molcool, file_penning, file_nabspreion, file_radmaker_radheating, file_ctheating, file_radmaker_ionratesspecific, file_dep, file_temps, file_EXCCUBE, file_nlines, file_tnc, file_spectralrange, files_init, file_natoms, file_emergent, file_wlvec, file_radmerged, file_photoexcall, file_dead, file_lineabstot, file_energybalance, file_energybalancelong, file_outside ! File names				
USE MPI
IMPLICIT NONE
!INCLUDE 'mpif.h'    ! A system MPI file
! -----------------------
! Task : Compute steady-state, radioactivity-powered, spherically symmetric SN spectra. Papers: Jerkstrand+ 2011, Jerkstrand+2012.
! Command line arguments :
! 1    ID number
! 2    Name of run parameters input file
! 3    wlmin
! 4    wlmax
! 5    resolution1000A
! 6    Nsendtotal
! 7    minsend
! 8    minsendUV
! 9    maxsend
! -----------------------------------------------------------------------------------------

INTEGER, PARAMETER :: N_atoms=49   ! Number of atoms included
TYPE (atomm), DIMENSION(N_atoms):: atoms  ! Type atomm is in M1 module
INTEGER, DIMENSION(:), POINTER :: nlevabsorbs_max

TYPE (atomm) :: atom, HI, HeI, HeII, CI, CII, CIII, NI, N2, OI, OII, OIII, NeI, NeII, NaI, NaII, MgI, MgII, SiI, SiII, SiIII, SI, S2, S3, KI, KII, ArI, ArII, ArIII, CaI, CaII, FeI, FeII, FeIII, CoI, CoII, CoIII, NiI, NiII, NiIII, TiI, TiII, TiIII, AlI, AlII, CrI, CrII, MnI, MnII, ScI, ScII, VI, VII, CMI, CMII, SMI, SMII, SSI, SSII, UMI, UMII!, SiOI, SiSI ! sl parameters

!TYPE (atomm) :: atom, HI, HeI, HeII, CI, CII, CIII, NI, N2, OI, OII, OIII, NeI, NeII, NaI, NaII, MgI, MgII, SiI, SiII, SiIII, SI, S2, ArI, ArII, ArIII, CaI, CaII, FeI, FeII, FeIII, CoI, CoII, CoIII, NiI, NiII, NiIII, TiI, TiII, TiIII, AlI, AlII, CrI, CrII, MnI, MnII, ScI, ScII, VI, VII, KI, KII, H2, CMI, SiOI, SiSI ! sl parameters

INTEGER :: datamatsize, i, j, EXCMAX, N_UPPER_MAX, R_index, DIMS, Nsend_shell, LINESTOT, abin, abin_old=0, zone, origzone, lastzone, Nblobs, minsend, minsend_uv, Nlines, seq, ii, scattered, nlevabsorbs, N_abs, chunksize, datavecsize, smallcounter, bigcounter, idsend, processID, tag, WLbins, WLbins_old,  ierr, numprocs, m, n, index, N_nuclei, Npacketsmax, shell, upper, lower, Nres, bin, ind, sender, Nfill, maxN=0, lev, time_days_i, Nbig, loops=0, Dustzonemax
INTEGER(8) :: NpacketsTOT, Npackets
LOGICAL :: FORCECAII, OLI, REALRECCONT, DOGAMMADEP, EXISTS
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: fracvec, lambdavec, alfavec, datavec
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: EXC_MATRIX, EMISS_MAT, EXC_MAT_ABIN, flux_noconv_MAT, TAUMAT, DUMMY
DOUBLE PRECISION, DIMENSION(:), POINTER :: radii,  sendinge, blobsize, dummy5, photoexctot, x, ne_vec, alfa_dust, volume, shellvec, shellvec_log, radius_in, radius_out, wlvec
DOUBLE PRECISION, DIMENSION(:,:), POINTER :: x_MAT, RT, ION_STRUCTURE, ABIN_MAT
REAL, DIMENSION(:,:), ALLOCATABLE :: DEPMAT  ! this array is so large that using REAL is preferable...contains starting  photon packets and no high accuracy is needed  !
REAL, DIMENSION(:,:), ALLOCATABLE :: DATAMAT  ! Contains photon packets data (wavelength, energy etc)
DOUBLE PRECISION, DIMENSION(:,:,:), ALLOCATABLE :: FBIG, DUMMY3
REAL, DIMENSION(:,:,:), POINTER :: TAUCUBE, EXC_CUBE_ABIN
LOGICAL, DIMENSION(:), POINTER :: COMPUTESHELL
CHARACTER(len=5) :: name
CHARACTER(LEN=100) :: file_explmodel, file_shells, file_deadphotons, file_lineabs, file_colldeexc, file_ephotoexc
DOUBLE PRECISION :: t1, t2, timetot=0
INTEGER, DIMENSION(MPI_STATUS_SIZE) :: status
DOUBLE PRECISION :: r, r_out, r_in, lambda, Ebin, Epp, z, spectrumstart, spectrumend, stepatstart, totalemission, totalemission_log, totalshellemission, wlvec_s, tau_tresh, ntheatrate, T, T_eq, tau_dust, dt_core, r_int, aftot, ndens, lum, flow, sf_tresh, alfa_dust_use, rate, T_typical, time_days, fosctot, power, origr, origlambda, resolution1000, sumv, accum, flux, Etot=0, rsend, rint, esend, nco_temp, nsio_temp, piheating_temp, cdheating_temp, ctheating_temp, bremsheating_temp, cool_co, cool_sio, fv1_co, fv1_sio,  alfatot, fff, frac, no100d, Blu, beta, theoretical_rate, datatot=0
DOUBLE PRECISION, POINTER :: vterm
CHARACTER(len=1) :: trash, densitystring
CHARACTER(len=3) :: processname
CHARACTER(len=4) :: timestring, time_days_str
CHARACTER(len=10) :: spectrumstart_s, spectrumend_s, resolution1000_s, minsend_s, minsend_UV_s, npacketsmax_s, iterative_s
CHARACTER(len=20) :: NpacketsTOT_s
CHARACTER(len=100) :: longstring
!DOUBLE PRECISION, DIMENSION(198,198) :: CASC
INTEGER, DIMENSION(:,:), ALLOCATABLE :: NSEND
DOUBLE PRECISION, DIMENSION(:), POINTER :: ff, outsideflux, dep, molcool ! filling factors, area factors
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: af, af_accum
CHARACTER :: str
INTEGER, PARAMETER :: Nlambda_c=1000
CHARACTER(len=10) :: weighting
DOUBLE PRECISION, DIMENSION(:), POINTER ::  n_co, n_sio
INTEGER, DIMENSION(:), POINTER :: Nlinesvec
DOUBLE PRECISION, DIMENSION(:, :), POINTER :: nmolmat
DOUBLE PRECISION, DIMENSION(Nabin) :: vec, fff2
DOUBLE PRECISION :: returndata
DOUBLE PRECISION, DIMENSION(10) :: alfav, alfa
REAL, EXTERNAL :: ran1   ! The random number generator
DOUBLE PRECISION, DIMENSION(:,:,:,:), ALLOCATABLE :: DUMMY4
character(MPI_MAX_PROCESSOR_NAME) hostname
INTEGER :: err_length, err_tmp
CHARACTER(len=MPI_MAX_ERROR_STRING) :: err_message
double precision :: wt0,wt1,wtc,t3
double precision, allocatable :: wt0_all(:),wt1_all(:),wtc_all(:)
! -----------------------------------------------------------------------------------
CALL MPI_INIT(ierr)   ! initialize MPI
CALL MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)  ! numprocs is the total number of processors invoked
CALL MPI_COMM_DUP(MPI_COMM_WORLD, globcomm, ierr)  ! Duplicate MPI_COMM_WORLD into a global communicator called globcomm
CALL MPI_COMM_RANK(globcomm, globid, ierr)  ! globid is the GLOBAL RANK for each processor
CALL MPI_COMM_SPLIT_TYPE(MPI_COMM_WORLD, MPI_COMM_TYPE_SHARED, 0, MPI_INFO_NULL, sharedcomm, ierr)  ! This splits the processors into communicators that envelop one (1) node
CALL MPI_COMM_RANK(sharedcomm, myid, ierr)  ! MYID is the ID number for each processor INSIDE ITS OWN NODE (so 0-31)

! Put all myid == 0 into one communicator to allow nodes to update their values to each other
if (myid == 0) then
    taskcolor = 0
else
    taskcolor = MPI_UNDEFINED
endif
CALL MPI_COMM_SPLIT(MPI_COMM_WORLD, taskcolor, 0, taskcomm, ierr)

! ------------------------------------------------------------------------------------
call MPI_Get_Processor_name(hostname, i, ierr)

print '(A23, I5, A8, I5, A17, A10)', "Greetings from process ", globid, " out of ", numprocs, ". My hostname is ", hostname

allocate(wt0_all(numprocs),wt1_all(numprocs),wtc_all(numprocs))
wtc=0.d0

wt0=MPI_WTIME()

Nlines = 250000 ! CARE  Maximum number of ABSORPTION LINES in any shell

! Unnecessary?
! datamatsize = 20000   ! CARE Max number of data chunks..each chunk contains *chunksize* (set below) packets WARNING IF higher than ~30,000 MPI crashes with the btl_tcp_endpoint.c:636:mca_btl_tcp_endpoint_complete_connect error (11% memory)

CALL GET_COMMAND_ARGUMENT(1, idrun)  ! ID for the model

CALL GET_COMMAND_ARGUMENT(2, file_runparameters) ! Run file

IF (COMMAND_ARGUMENT_COUNT() >= 3) THEN ! Spectrum properties

   CALL GET_COMMAND_ARGUMENT(3, spectrumstart_s )
   CALL GET_COMMAND_ARGUMENT(4, spectrumend_s )
   CALL GET_COMMAND_ARGUMENT(5, resolution1000_s )
   CALL GET_COMMAND_ARGUMENT(6, NpacketsTOT_s )
   CALL GET_COMMAND_ARGUMENT(7, minsend_s )
   CALL GET_COMMAND_ARGUMENT(8, minsend_UV_s )
   CALL GET_COMMAND_ARGUMENT(9, Npacketsmax_s )
   CALL GET_COMMAND_ARGUMENT(10, iterative_s)

   read(spectrumstart_s,*) spectrumstart
   read(spectrumend_s,*) spectrumend
   read(resolution1000_s,*) resolution1000
   read(NpacketsTOT_s,*) NpacketsTOT
   read(minsend_s,*) minsend
   read(minsend_UV_s,*) minsend_UV
   read(Npacketsmax_s,*) Npacketsmax
   if (iterative_s == 'y') then
  	ITERATIVERUN=.TRUE.
   else
        ITERATIVERUN=.FALSE.
   end if

   weighting = 'linear' ! CARE

   if (globid == 0) print *, "Total packets to send:", NpacketsTOT

ELSE

   spectrumstart=400; spectrumend=10000;resolution1000=1;NpacketsTOT=1000000;minsend=1;minsend_UV=1;Npacketsmax=10

END IF

t1=MPI_WTIME()  ! For timing purposes..

RECURSIVES = 0

! Initialise modules:
CALL files_init (idrun)  ! exists in mods/files.f90

HI%NAME=' HI  ';HeI%NAME='HeI  ';HeII%NAME='HeII ';CI%NAME=' CI  ';CII%NAME=' CII ';NI%NAME=' NI  ';N2%NAME=' N2  ';OI%NAME=' OI  ';OII%NAME=' OII ';OIII%NAME=' OIII';NeI%NAME='NeI  ';NeII%NAME='NeII ';NaI%NAME='NaI  ';NaII%NAME = 'NaII ';MgI%NAME='MgI  ';MgII%NAME='MgII ';SiI%NAME='SiI  ';SiII%NAME='SiII ';SI%NAME=' SI  ';S2%NAME=' S2  ';S3%NAME=' S3  ';CaI%NAME='CaI  ';CaII%NAME='CaII ';FeI%NAME='FeI  ';FeII%NAME  ='FeII ';FeIII%NAME='FeIII';CoI%NAME='CoI  ';CoII%NAME='CoII ';CoIII%NAME='CoIII';NiI%NAME='NiI  ';NiII%NAME='NiII ';NiIII%NAME = 'NiIII';TiI%NAME='TiI  ';TiII%NAME='TiII ';AlI%NAME='AlI  ';AlII%NAME='AlII ';CrI%NAME='CrI  ';CrII%NAME='CrII ';MnI%NAME='MnI  ';MnII%NAME='MnII ';ArI%NAME='ArI  ';ArII%NAME='ArII ';ArIII%NAME = 'ArIII'; ScI%NAME='ScI  ';ScII%NAME='ScII ';VI%NAME=' VI  ';VII%NAME=' VII ';KI%NAME=' KI  ';KII%NAME=' KII ';CMI%NAME='CMI  ';CMII%NAME='CMII ';SMI%NAME='SMI  ';SMII%NAME='SMII ';SSI%NAME='SSI  ';SSII%NAME='SSII ';UMI%NAME='UMI  ';UMII%NAME='UMII '
!;SiOI%NAME='SiOI ';SiSI%NAME='SiSI '; ! sl parameters

!atoms(1:N_atoms) = [HI, HeI, HeII, CI, CII, NI, N2, OI, OII, OIII, NeI, NeII, NaI, NaII, MgI, MgII, SiI, SiII, SI, S2, ArI, ArII, ArIII, CaI, CaII, FeI, FeII, FeIII, CoI, CoII, CoIII, NiI, NiII, NiIII, TiI, TiII, AlI, AlII, CrI, CrII, MnI, MnII, ScI, ScII, VI, VII, KI, KII, CMI,CMII,SMI, SMII, SSI, SSII, UMI, UMII]
!, SiOI,SiSI] ! Put atoms into an array ! sl parameters

! CaIII has E(2) = 203,000 (493 Å) dont need to include!SiIII%NAME      ='SiIII';! NaII has E(2) = 200,000 dont need to include!OIII%NAME       =' OIII';  OIII%SENDS = 1;   OIII%ABSORBS = 1; OIII%N_LEVELS = 0!CIII%NAME       =' CIII';  CIII%SENDS = 1;   CIII%ABSORBS = 1; CIII%N_LEVELS = 0 ! 2  ! 2-1 line at 1907

atoms(1:N_atoms) = [HI, HeI, HeII, CI, CII, NI, N2, OI, OII, OIII, NeI, NeII, NaI, NaII, MgI, MgII, SiI, SiII, SI, S2, S3, ArI, ArII, ArIII, CaI, CaII, FeI, FeII, FeIII, CoI, CoII, CoIII, NiI, NiII, NiIII, TiI, TiII, AlI, AlII, CrI, CrII, MnI, MnII, ScI, ScII, VI, VII, KI, KII]! Put atoms into an array
!atoms(1:N_atoms) = [HI, HeI, HeII, CI, CII, NI, N2, OI, OII, OIII, NeI, NeII, NaI, NaII, MgI, MgII, SiI, SiII, SI, S2, ArI, ArII, ArIII, CaI, CaII, FeI, FeII, FeIII, CoI, CoII, CoIII, NiI, NiII, NiIII, TiI, TiII, AlI, AlII, CrI, CrII, MnI, MnII, ScI, ScII, VI, VII, KI, KII, CeI, CeII, CeIII, TeI, TeII, TeIII,PtI,PtII,PtIII,ThI,ThII,ThIII,CMI]! Put atoms into an array

! Initialize
DO i = 1, N_atoms

   atoms(i)%N_LEVELS = 0
   atoms(i)%SENDS = .TRUE.
   atoms(i)%ABSORBS = .TRUE.

END DO

call readrunparameters(time_days, file_explmodel, tau_dust, vterm, Nblobs, tau_tresh, sf_tresh, REALRECCONT, FORCECAII, OLI, Dustzonemax, N_atoms, atoms)   ! Run all runparameters specified in runparameters input file

Npacketsmax = maxval([Npacketsmax, minsend, minsend_UV])  ! If MINSEND is set larger than NPACKETSMAX by mistake, put NPACKETSMAX = MINSEND

stepatstart = resolution1000*spectrumstart/1000.   ! Resolution, step size at shortest wavelength [Å]

T_typical = 4000*(time_days/365.)**(-1.5)  ! This is used for computing the Regemorter collision strengths

! PARAMETERS FOR COMPUTATIONS OF THE INTERNAL RADIATION FIELD

lambdastart_radfield = 500.  ! [Å]

lambdaend_radfield = 6000.  ! [Å]

stepatstart_radfield = 0.5  ! [Å]

Nradfield = INT(LOG(lambdaend_radfield/lambdastart_radfield)/LOG(1. + stepatstart_radfield/lambdastart_radfield)) ! Number of bins in the logaritmically spaced wl vector

CALL memshare(sharedcomm, myid, lambda_radfield, window, (/ Nradfield /)); if (myid == 0) lambda_radfield = 0
CALL memshare(sharedcomm, myid, E_radfield, window, (/ Nr, Nradfield /)); if (myid == 0) E_RADFIELD = 0

lambda_radfield(1) = lambdastart_radfield
IF (MYID .EQ. 0) THEN
    DO i = 2, Nradfield
        lambda_radfield(i) = lambda_radfield(i-1)*(1. + stepatstart_radfield/lambdastart_radfield)
    END DO
ENDIF
CALL MPI_BARRIER(sharedcomm, ierr)

LINESTOT = 0                            ! Dont remove
EXCMAX = 0                              ! Dont remove
N_UPPER_MAX = 0                         ! Dont remove
lambdacut = spectrumend

! ---------------------------------------------------------------------------------------------------------------

WRITE(unit=processname,FMT='(I3)') globid   ! Internal conversion, write MYID (integer) to string PROCESSNAME (used to label output files)

time = time_days*24.*3600.  ! time in seconds

write(unit=timestring,FMT='(I4)') INT(time_days)   ! Internal conversion, write time_day to string TIMESTRING (used to label output files)

!file_lineabs = 'out/mcphotons/lineabs'//processname   ! Line absorbed
file_colldeexc = 'out/mcphotons/colldeexc'//processname  ! Collisional deexcitations

file_shells = 'out/shellmaker/shells_'//TRIM(IDRUN)//'.dat'

CALL init_random_seed()	  ! This fully independent process resets the seed

call random_number(z)

idum = -floor(z*1000)   ! Initialize random seed for ran1..should be done with random generator

CALL indexnuclei(N_atoms, atoms(1:N_atoms), N_nuclei)     ! Assign bookkeeping numbers to the atoms. Autonomous process, does not need to be changed when adding atoms.

!atoms(N_atoms)%SEQ = N_atoms  ! Set SEQ value if last element is not in NLTE (e.g. old H2 treatment)

DIMS = N_atoms + N_nuclei + DIMSADD  ! Total number of parameters, relevant for state vector in each zone

! Share the memory
CALL memshare(sharedcomm, myid, sendinge, window, (/ Nr /)); if (myid == 0) sendinge = 0
CALL memshare(sharedcomm, myid, outsideflux, window, (/ Nr /)); if (myid == 0) outsideflux = 0
CALL memshare(sharedcomm, myid, dep, window, (/ Nr /)); if (myid == 0) dep = 0
CALL memshare(sharedcomm, myid, molcool, window, (/ Nr /)); if (myid == 0) molcool = 0
CALL memshare(sharedcomm, myid, dummy5, window, (/ Nr /)); if (myid == 0) dummy5 = 0
CALL memshare(sharedcomm, myid, photoexctot, window, (/ Nr /)); if (myid == 0) photoexctot = 0
CALL memshare(sharedcomm, myid, x, window, (/ DIMS /)); if (myid == 0) x = 0
CALL memshare(sharedcomm, myid, ne_vec, window, (/ Nr /)); if (myid == 0) ne_vec = 0
CALL memshare(sharedcomm, myid, alfa_dust, window, (/ Nr /)); if (myid == 0) alfa_dust = 0
CALL memshare(sharedcomm, myid, volume, window, (/ Nr /)); if (myid == 0) volume = 0
CALL memshare(sharedcomm, myid, radii, window, (/ Nr+1 /)); if (myid == 0) radii = 0
CALL memshare(sharedcomm, myid, shellvec, window, (/ Nr /)); if (myid == 0) shellvec = 0
CALL memshare(sharedcomm, myid, shellvec_log, window, (/ Nr /)); if (myid == 0) shellvec_log = 0
CALL memshare(sharedcomm, myid, COMPUTESHELL, window, (/ Nr /)); if (myid == 0) COMPUTESHELL = .TRUE.
CALL memshare(sharedcomm, myid, radius_in, window, (/ Nr /)); if (myid == 0) radius_in = 0
CALL memshare(sharedcomm, myid, radius_out, window, (/ Nr /)); if (myid == 0) radius_out = 0
CALL memshare(sharedcomm, myid, x_MAT, window, (/ Nr, DIMS /)); if (myid == 0) x_MAT = 0
CALL memshare(sharedcomm, myid, RT, window, (/ Nr, 2 /)); if (myid == 0) RT = 0
CALL memshare(sharedcomm, myid, ION_STRUCTURE, window, (/ Nr, Nabin /)); if (myid == 0) ION_STRUCTURE = 0
CALL memshare(sharedcomm, myid, ABIN_MAT, window, (/ Nr, Nabin /)); if (myid == 0) ABIN_MAT = 0
CALL memshare(sharedcomm, myid, Ephotoexc, window, (/ Nr /)); if (myid == 0) Ephotoexc = 0
CALL memshare(sharedcomm, myid, n_co, window, (/ Nr /)); if (myid == 0) n_co = 0
CALL memshare(sharedcomm, myid, n_sio, window, (/ Nr /)); if (myid == 0) n_sio = 0
CALL memshare(sharedcomm, myid, nmolmat, window, (/ Nr, maxval([1,Nmol]) /)); if (myid == 0) nmolmat = 0
CALL memshare(sharedcomm, myid, Nlinesvec, window, (/ Nr /)); if (myid == 0) Nlinesvec = 0
IF (Ncore > 0) THEN
    CALL memshare(sharedcomm, myid, ff, window, (/ Ncore /)); if (myid == 0) ff = 0
!    CALL memshare(sharedcomm, myid, af, window, (/ Ncore /)); if (myid == 0) af = 0
!    CALL memshare(sharedcomm, myid, af_accum, window, (/ Ncore+1 /)); if (myid == 0) af_accum = 0
    ALLOCATE(af(Ncore)); af=0
    ALLOCATE(af_accum(Ncore+1)); af_accum=0
    CALL memshare(sharedcomm, myid, blobsize, window, (/ Ncore /)); if (myid == 0) blobsize = 0
ELSE  ! just to make the interfaces work
    CALL memshare(sharedcomm, myid, ff, window, (/ 1 /)); if (myid == 0) ff = 0
    !CALL memshare(sharedcomm, myid, af, window, (/ 1 /)); if (myid == 0) af = 0
    !CALL memshare(sharedcomm, myid, af_accum, window, (/ 2 /)); if (myid == 0) af_accum = 0
    ALLOCATE(af(1)); af=0
    ALLOCATE(af_accum(2)); af_accum=0
    CALL memshare(sharedcomm, myid, blobsize, window, (/ 1 /)); if (myid == 0) blobsize = 0
END IF

call makeatoms(N_atoms, atoms, T_typical, maxN)

CALL memshare(sharedcomm, myid, BLEND, window); if (myid == 0) BLEND = .FALSE.
CALL memshare(sharedcomm, myid, v_out, window); if (myid == 0) v_out = 0
CALL memshare(sharedcomm, myid, vterm, window); if (myid == 0) vterm = 0
CALL memshare(sharedcomm, myid, dustedge, window); if (myid == 0) dustedge = 0
CALL memshare(sharedcomm, myid, M_56Ni, window); if (myid == 0) M_56Ni = 0
CALL memshare(sharedcomm, myid, M_56Co, window); if (myid == 0) M_56Co = 0
CALL memshare(sharedcomm, myid, M_57Co, window); if (myid == 0) M_57Co = 0
CALL memshare(sharedcomm, myid, M_44Ti, window); if (myid == 0) M_44Ti = 0
CALL memshare(sharedcomm, myid, nlevabsorbs_max, window, (/ N_atoms /)); if (myid == 0) nlevabsorbs_max = 0

IF (globid .EQ. 0) THEN  ! Master.. for each node

   DO i = 1, Nr

      OPEN(20,file=TRIM(file_nlevelsabsorb)//R_index_str(i),STATUS='OLD')  ! If this is a NLTE comp. run, these are the numbers used in last MC run, to get photoexc. rates right

      DO

         READ(20,*,END=225) seq, abin, nlevabsorbs

         IF (seq < 1 .OR. seq > N_atoms) STOP 'seq index out of range'

         IF (nlevabsorbs > nlevabsorbs_max(seq)) THEN  ! If this number is larger than the largest so far..

            nlevabsorbs_max(seq) = nlevabsorbs  ! Replace the largest so far..

            IF (nlevabsorbs_max(seq)  > atoms(seq)%N_LEVELS) THEN  ! If N_levels has been lowered, lower also max absorption levels

               nlevabsorbs_max(seq) =  atoms(seq)%N_LEVELS

            END IF

         END IF

      END DO

225   CLOSE(20)

   END DO

END IF

IF (myid .EQ. 0) THEN

	call MPI_BCAST(nlevabsorbs_max, N_atoms, MPI_INTEGER, 0, taskcomm, ierr)

END IF

IF (myid .EQ. 0) THEN  ! Master.. for each node

    CALL modelreader(vterm, N_atoms, atoms, file_explmodel, FORCECAII, DIMS, x_MAT, ION_STRUCTURE, ABIN_MAT, Dustzonemax)   ! Read explosion model, temperature and ionization..

    v_out = vterm*1e5

    IF (ITERATIVERUN .EQV. .TRUE.) THEN

        DO i = 1, Nr

        inquire(file=TRIM(file_moldens)//R_index_str(i), exist=EXISTS)

        IF (EXISTS) THEN

         	OPEN(10,file=TRIM(file_moldens)//R_index_str(i),STATUS='OLD')  ! Read molecular abundances from ion. solutions

         	READ(10,*,END=841) trash, nco_temp, nsio_temp

            CLOSE(10)

        ELSE

            nco_temp = 0
            nsio_temp = 0

        END IF

        nco_temp = 0. !TEMP/CARE bug fix
        nsio_temp = 0.

        n_co(i) = nco_temp
        n_sio(i) = nsio_temp

        nmolmat(i,1) = nco_temp
        if (Nmol >= 3) nmolmat(i,3) = nsio_temp

841  continue

      END DO

   ELSE  ! Not an iterative run

      n_co = 0.

      n_sio = 0.

      nmolmat = 0.

   END IF

END IF

CALL MPI_BARRIER(sharedcomm, ierr)  ! Wait for myid-Master to catch up

radii(1:Nr) = x_MAT(:,DIMS-11); radii(Nr+1) = 1.   ! Dimensionless INNER radii

IF (globid .EQ. 0) CALL writeionedges(N_atoms, atoms(1:N_atoms))  ! Create a file with the ionization edges for the first Npis levels in each atom.

if (globid == 0) print *, 'taudust', tau_dust, 'dustedge', dustedge

CALL MPI_BARRIER(globcomm, ierr)  ! Wait for globid-Master to catch up

IF (globid .EQ. 0) THEN  ! Write run parameters to a file read by matlab when plotting

   OPEN (UNIT=10, FILE=file_log, STATUS='OLD', POSITION='APPEND')

   write(10,*) 'Time ', time_days

   write(10,*) 'taudust  etc..'

   WRITE(10,'(11(G10.3/), G10.3)') tau_dust, x_MAT(Ncore+1,DIMS-11)*v_out/1e5, x_MAT(Ncore+1,DIMS-10)*v_out/1E5, v_out/1e5, Nblobs, x_MAT(max(Ncore,1),DIMS-3)*x_MAT(max(Ncore,1),DIMS-8)/(x_MAT(max(Ncore,1),DIMS-3)*x_MAT(max(Ncore,1),DIMS-8)+SUM(x_MAT(Ncore+2:Nr,DIMS-3)*x_MAT(Ncore+2:Nr,DIMS-8))), x_MAT(1:max(Ncore,1),DIMS-12)

   CLOSE(10)

END IF

CALL MPI_BARRIER(globcomm, ierr)

if (Ncore > 0) THEN

   ff = x_MAT(1:Ncore,DIMS-12)  ! Filling factors

   Do i = 1, Ncore

      blobsize(i) = radii(Ncore+1)*(ff(i)/DBLE(Nblobs))**(1./3.)

   END DO

   IF (myid .eq. 0) print *, 'ff', ff

   af = ff**(2./3.)  ! Area factors : each zone has an area that scales as volume^(2/3)

   af_accum(1) = 0; DO i = 1, Ncore; af_accum(i+1) = af_accum(i) + af(i);END DO;  ! accumulate af factors

   af_accum = af_accum/af_accum(Ncore+1)  ! Normalize so that they add to 1.


END if

radius_in = x_MAT(:,DIMS-11)  ! Vector with all the zone inner radii [dim less]

radius_out = x_MAT(:,DIMS-10)  ! Vector with all the zone outer radii [dim less]

DO i = 1, Nr  ! For each zone...

   IF (x_MAT(i,DIMS-3) .EQ. 0.) COMPUTESHELL(i) = .FALSE.   ! If density is zero dont compute

END DO

DO i = 1, N_atoms      ! Loop to 1) Find out largest atom size (both N and N_LEVELS)  2) How many lines there are

   IF (atoms(i)%N_LEVELS > EXCMAX) THEN  ! If this atom has more NLTE levels than the maximum encountered so far..

      EXCMAX = atoms(i)%N_LEVELS    ! Update the maximum number encountered so far..

   END IF

   IF (atoms(i)%N > N_UPPER_MAX) THEN  ! If this atom has more number of levels (in radiative transfer) than encountered so far..

      N_UPPER_MAX = atoms(i)%N   ! Update that maximum...

   END IF

   LINESTOT = LINESTOT + atoms(i)%N_LEVELS*(atoms(i)%N_LEVELS-1)/2  ! These are the numer of EMISSION lines. Integer division ok. N_LEVELS levels can make maximum N_LEVELS*(N_LEVELS-1)/2 emission lines.

END DO

LINESTOT = LINESTOT + 10000   ! Add some more to continuum emission (2-photon continuum and free-bound)

IF (Dustzonemax >= 1) THEN

	alfa_dust(1:Dustzonemax) = tau_dust/dustedge

END IF

RT(:,1) = x_MAT(:,DIMS-11)  ! r_in (normalized) (needs to be sent to followphoton)
RT(:,2) = x_MAT(:,DIMS)   ! Temperatures (needs to be sent to followphoton)
volume = x_MAT(:,DIMS-8)  ! Zone volumes [cm^3]
ne_vec = x_MAT(:,DIMS-3)*x_MAT(:,DIMS-2)  ! Electron densities [cm^{-3}]

DO seq = 1, N_atoms  ! Allocate TAU and PHOTOEXCITATION matrices on each atom struct (TAU is taken from NLTE solutions, PHOTOEXCITATION is built up during MC simulation)

   atoms(seq)%N_LEVELS_ABSORB = nlevabsorbs_max(seq)

   IF (nlevabsorbs_max(seq) > 0) THEN

       CALL memshare(sharedcomm, myid, atoms(seq)%TAU, window, (/ Nr, nlevabsorbs_max(seq), atoms(seq)%N /)); if (myid == 0) atoms(seq)%TAU = 0  ! all optical depths by this atom, in all zones  Can we shrink, using a variable nlevabsorbs_max_upper?

       IF (PHOTOEXC >= 1) THEN

           CALL memshare(sharedcomm, myid, atoms(seq)%PHOTOEXCRATES, window, (/ Nr, nlevabsorbs_max(seq), atoms(seq)%N /)); if (myid == 0) atoms(seq)%PHOTOEXCRATES = 0

        END IF

    END IF

END DO

call MPI_BARRIER(globcomm, ierr) ! sharedcomm enough?

CALL memshare(sharedcomm, myid, EXC_CUBE_ABIN, window, (/ Nr, Nabin, maxval([Npis, ngvec]) /)); if (myid == 0) EXC_CUBE_ABIN = 0

IF (globid .EQ. 0) THEN

   DO shell = 1, Nr

      OPEN(40,file=TRIM(file_EXCCUBE)//R_index_str(shell),STATUS='OLD')   ! Only Npis levels per atom..EXC_CUBE_ABIN only used for photoionizations?

      DO

         READ(40,*,END=700) r_index, trash, abin, i, ndens

         IF (r_index <= Nr .AND. i <= maxval([Npis,ngvec]) .and. ndens < HUGE(ndens) .and. ndens > tiny(ndens)) EXC_CUBE_ABIN(r_index, abin, i) = REAL(ndens)

      END DO

700   CLOSE(40)

   END DO

   DO i = 1, Nr

      OPEN(10,file=TRIM(file_nlines)//R_index_str(i),STATUS='OLD')

      READ(10,*) Nlinesvec(i)

      CLOSE(10)

   END DO

END IF

if (myid == 0) then ! Share with node masters

	CALL MPI_BCAST(EXC_CUBE_ABIN, Nr*Nabin*maxval([Npis, Ngvec]), MPI_REAL, 0, taskcomm, ierr)

    CALL MPI_BCAST(Nlinesvec, Nr, MPI_INTEGER, 0, taskcomm, ierr)

end if

CALL MPI_BARRIER(sharedcomm, ierr)  ! Make sure node processors are synced

datatot = datatot + Nr*Nabin*maxval([Npis, ngvec])

Nlines = MAXVAL(Nlinesvec)  ! Largest number of absorbing lines

CALL memshare(sharedcomm, myid, TAUCUBE, window, (/ Nr, Nlines, 6 /)); if (myid == 0) TAUCUBE = 0

CALL MPI_BARRIER(globcomm, ierr)

IF (globid .EQ. 0) THEN
   CALL readtaucube(N_atoms, atoms, Nlines, TAUCUBE)  ! CARE also atoms are modified (atoms%TAU)
   CALL sorttaucube(int(Nlinesvec), Nlines, TAUCUBE)  ! Sort in wavelength order
END IF

IF (myid == 0) then

	CALL MPI_BCAST(TAUCUBE, Nr*Nlines*6, MPI_REAL, 0, taskcomm, ierr) ! Share to other node masters

	DO i = 1, N_atoms

        if (nlevabsorbs_max(i) > 0) then
    		call MPI_BCAST(atoms(i)%TAU, Nr*nlevabsorbs_max(i)*atoms(i)%N, MPI_REAL, 0, taskcomm, ierr)
        end if

        call MPI_BCAST(atoms(i)%LAMBDA, atoms(i)%N*atoms(i)%N, MPI_DOUBLE_PRECISION, 0, taskcomm, ierr)

    END DO

END IF

CALL MPI_BARRIER(sharedcomm, ierr)

datatot = datatot + Nr*Nlines*6

if (globid == 0) print *, 'Total numbers needing storage, whole grid:', datatot

WLbins = INT(LOG(spectrumend/spectrumstart)/LOG(1.+stepatstart/spectrumstart))  ! Number of bins in wavelength vector (log-spaced). has to match expression in thinspectrum

! Memory share these variables instead of allocating for each processor in the loop below
CALL memshare(sharedcomm, myid, wlvec, window, (/ WLbins /)); if (myid == 0) wlvec = 0
CALL memshare(sharedcomm, myid, energyin, window, (/ Nr /)); if (myid == 0) energyin = 0
CALL memshare(sharedcomm, myid, energyout, window, (/ Nr /)); if (myid == 0) energyout = 0

! These vars are merged together later through taskcomm
!CALL memshare(sharedcomm, myid, OUTPHOTONS_SC, window, (/ WLbins, 2 /)); if (myid == 0) OUTPHOTONS_SC = 0
!CALL memshare(sharedcomm, myid, OUTPHOTONS_ABIN, window, (/ WLbins, Nabin /)); if (myid == 0) OUTPHOTONS_ABIN= 0
!CALL memshare(sharedcomm, myid, OUTPHOTONS_LASTZONE, window, (/ WLbins, Nr /)); if (myid == 0) OUTPHOTONS_LASTZONE = 0
!CALL memshare(sharedcomm, myid, OUTPHOTONS_ORIGZONE, window, (/ WLbins, Nr /)); if (myid == 0) OUTPHOTONS_ORIGZONE = 0
!CALL memshare(sharedcomm, myid, N_CONTABS, window, (/ (Nstages-1)*Nelem+Nmol+2, maxval([Npis, ngvec]), 2, Nr /)); if (myid == 0) N_CONTABS = 0
ALLOCATE(N_CONTABS((Nstages-1)*Nelem+ Nmol + 2, maxval([Npis,ngvec]), 2, Nr)); N_CONTABS = 0
ALLOCATE(OUTPHOTONS_SC(WLbins, 2)); OUTPHOTONS_SC = 0    ! Scattered (col 2) and unscattered (col 1)
ALLOCATE(OUTPHOTONS_ABIN(WLbins, Nabin)); OUTPHOTONS_ABIN = 0   ! Each element that last touched. Matrix size about 0.4 million
ALLOCATE(OUTPHOTONS_LASTZONE(WLbins, Nr)); OUTPHOTONS_LASTZONE = 0   ! For each lastzone
ALLOCATE(OUTPHOTONS_ORIGZONE(WLbins, Nr)); OUTPHOTONS_ORIGZONE = 0


IF (globid .EQ. 0) THEN  ! Only the globid-master needs to read the emissivities

   ALLOCATE(FBIG(Nr,WLbins,Nabin)); FBIG = 0 ! Fraction of emissivity by each atom (for each zone/wl bin)..to tag photons

   ALLOCATE(flux_noconv_MAT(Nr,WLbins)); flux_noconv_MAT = 0  ! to contain emissivity for each zone/wl bin.

   DO i = 1, Nr

      OPEN(60, file=TRIM(file_tnc)//R_index_str(i), STATUS='OLD'); REWIND(60)

      DO

         READ(60,*,END=300) index, wlvec_s, fff, fff2

         IF (index <= WLbins) THEN

            if (i == 1) wlvec(index) = wlvec_s  ! This wavelength array is shared to other nodes after this loop

            flux_noconv_MAT(i, index) = fff   ! Luminosity in this bin

            FBIG(i,index,:) = fff2   ! Luminosity by each element

         END IF

      END DO

300   CLOSE(60)

   END DO

   OPEN(10,file=file_wlvec,STATUS='REPLACE')

   WRITE(10,*) WLbins

   DO i = 1, WLbins

      WRITE(10,*) wlvec(i)  ! write wavelength bins used

   END DO

   close(10)

END IF

IF (myid == 0) THEN  ! Other myid ranks do not know what taskcomm is!

    CALL MPI_ALLREDUCE(MPI_IN_PLACE, wlvec, Wlbins, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)  ! Share the wavelength array across all nodes

ENDIF

CALL MPI_BARRIER(globcomm, ierr)  ! Make sure every process is ready

chunksize = 1000    ! Number of packets sent in each communication to the slaves
datavecsize = 6*chunksize   ! 6 slots per packet, chunksize packets per comm., 1 slot for chunksize
ALLOCATE(datavec(datavecsize)); datavec = 0

IF (globid .EQ. 0) THEN   ! The global master..

   t3 = MPI_WTIME()

   print *, 'Time to start handout cycle', t3-wt0

   ALLOCATE(NSEND(wlbins, Nr)); NSEND = 0  ! Number of packets to send for each wl/zone bin

   OPEN(10,file=file_spectralrange,STATUS='REPLACE'); WRITE(10,*) spectrumstart, spectrumend; CLOSE(10)

   shellvec = SUM(flux_noconv_MAT, 2)  ! Array with total luminosity in each shell

   shellvec_log = SUM(log(flux_noconv_MAT + 1D-100), 2)  ! Array with sum of all logaritmized emissivities in each shell

   totalemission = SUM(shellvec, COMPUTESHELL)  ! Total emission by all shells

   totalemission_log = SUM(shellvec_log, COMPUTESHELL) ! Sum of all logaritmized emissivities in all shells

   bigcounter = 1    ! counter for the bundles (each bundle contains *chunksize* packets)

   smallcounter = 0   ! Counter for packet sequence within each bundle

   DO i = 1, WLbins-1   ! For each wavelength bin (last one is the right edge)...

      DO j = 1, Nr    ! For each shell..

         IF (COMPUTESHELL(j)) THEN  ! Should is emission from this shell turned on?

            Ebin = flux_noconv_MAT(j,i)   ! Flux (erg/s) in wl bin i from shell j

            IF (Ebin > 0) THEN   ! If there is emission in this bin...

               IF (weighting .EQ. 'linear') THEN   ! Npackets ~ Ebin, but never fewer than *minsend* and never more than *Npacketsmax*

                  Npackets = MINVAL([INT(Npacketsmax,8), MAXVAL([INT(minsend,8),INT(NpacketsTOT*Ebin/totalemission,8)])])

               ELSE IF (weighting .EQ. 'log') THEN   ! Npackets ~ log(Ebin), but never fewer than *minsend* and never more than *Npacketsmax*

                  Npackets = MINVAL([Npacketsmax, MAXVAL([minsend,INT(NpacketsTOT*LOG(Ebin)/totalemission_log)])]) ! CARE not correct

               ELSE IF (weighting .EQ. 'uniform') THEN   ! Same number of packages no matter what Ebin is

                  Npackets = minsend

               ELSE

                  PRINT *, 'ERROR in main: weighting not recognized. Stopping'; stop 1

               END IF

               IF (wlvec(i) < 2000. .AND. wlvec(i) > 1000. .AND. Npackets < minsend_uv) THEN   ! Special treatment for UV which may need many emitted photons to get any out

                  Npackets = minsend_uv

               END IF

               Nbig = 10*Npacketsmax  ! TEMP  The number of packets for selected superresolved lines

               IF (wlvec(i+1) > 6300.30 .AND. wlvec(i) < 6300.30) THEN   ! O I 6300

                  Npackets = Nbig

               ELSEIF (wlvec(i+1) > 6363.78 .AND. wlvec(i) < 6363.78) THEN   ! O I 6364

                  Npackets = Nbig

               ELSEIF (wlvec(i+1) > 6564.55 .AND. wlvec(i) < 6564.55) THEN   ! Ha-1

                  Npackets = Nbig

               ELSEIF (wlvec(i+1) > 6564.66 .AND. wlvec(i) < 6564.66) THEN   ! Ha-2

                  Npackets = Nbig

               ELSEIF (wlvec(i+1) > 6564.72 .AND. wlvec(i) < 6564.72) THEN   ! Ha-3

                  Npackets = Nbig

               ELSEIF (wlvec(i+1) > 4571.1 .AND. wlvec(i) < 4571.1) THEN  ! Mg I 4571

                  Npackets = Nbig

               ELSEIF (wlvec(i+1) > 5889.95 .AND. wlvec(i) < 5889.95) THEN  ! Na I 5889

                  Npackets = Nbig

               ELSEIF (wlvec(i+1) > 5895.92 .AND. wlvec(i) < 5895.92) THEN  ! Na I 5896

                  Npackets = Nbig

               ELSEIF (wlvec(i+1) > 6548.05 .AND. wlvec(i) < 6548.05) THEN  ! NII  6548

                  Npackets = Nbig

               ELSEIF (wlvec(i+1) > 6583.45 .AND. wlvec(i) < 6583.45) THEN  ! NII 6583

                  Npackets = Nbig

               END IF

               NSEND(i,j) = Npackets

               esend = Ebin/DBLE(NSEND(i,j))   ! Energy per packet

               r_in = radius_in(j)

               r_out = radius_out(j)

               DO m = 1, NSEND(i,j)    ! sample radius and angle for each packet

                  z = DBLE(ran1(idum))

                  rsend = (z*(r_out**3 - r_in**3) + r_in**3)**(1./3.)    ! Select random radius RSEND to emit packet (from uniform distribution between r_in and r_out) CARE dont use 0.333 then rsend can become larger than r_out (3^0.333 > 1)

                  IF (j .LE. Ncore .AND. BLEND) THEN  ! If the shell is a core shell

                     z = DBLE(ran1(idum))

                     rint = blobsize(j)*z**(1./3.)     ! Internal radius in blob

                  ELSE   ! An envelope zone, rint has no meaning

                     rint = 0

                  END IF

                  z = DBLE(ran1(idum))

                  ! Select emitting element by random draw based on relative emissivities:

                  vec = FBIG(j, i, 1:Nabin)   ! j is the shell, i the WL bin, FBIG contains the emissivities for all ABIN elements

                  sumv = sum(vec)

                  vec = vec/sumv  ! Normalize emissivities

                  accum = 0

                  abin = 0

                  DO WHILE (accum < z)   ! Find element that transcends the random draw

                     accum = accum + vec(abin+1)

                     abin = abin + 1

                  END DO

                  idsend = abin  ! Tag this packet

                  datavec(6*smallcounter+1) = rsend

                  datavec(6*smallcounter+2) = esend/1e20

                  sendinge(j) = sendinge(j) + esend

                  call random_number(z)

                  if (i+2 <= Wlbins) THEN

                     lambda = wlvec(i+1) + z*(wlvec(i+2)-wlvec(i+1))   ! IMPORTANT Take bin on the right-hand side to avoid line self-absorptions

                  ELSE

                     lambda = wlvec(i+1)

                  end if

                  datavec(6*smallcounter+3) = lambda

                  datavec(6*smallcounter+4) = j

                  datavec(6*smallcounter+5) = rint

                  datavec(6*smallcounter+6) = idsend

                  smallcounter = smallcounter + 1

                  IF (smallcounter == chunksize) THEN    ! This bundle is full, send off

                     CALL MPI_RECV(returndata, 1, MPI_DOUBLE_PRECISION, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, status, ierr) ! Listen for available slave..
                     processID = status(MPI_SOURCE)  ! The ID of slave whos calling for data
                     !processID = status%MPI_SOURCE                     

                     tag = 1

                     CALL MPI_SEND(datavec, datavecsize, MPI_DOUBLE_PRECISION, processID, tag, MPI_COMM_WORLD, ierr)   ! Send bundle to slave

                     smallcounter = 0

                     bigcounter = bigcounter + 1

                     datavec = 0 ! Important..last bundle can be half-full.

                  END IF

               END DO

            END IF

         END IF

      END DO

   END DO

   ! Send last half-full bundle

   CALL MPI_RECV(returndata, 1, MPI_DOUBLE_PRECISION, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, status, ierr) ! Listen for available slave..                                     
   
   processID = status(MPI_SOURCE)
   !processID = status%MPI_SOURCE  ! ID of slave whos calling for data
                     
   tag = 1

   CALL MPI_SEND(datavec, datavecsize, MPI_DOUBLE_PRECISION, processID, tag, MPI_COMM_WORLD, ierr)   ! Send bundle to slave

   print *, 'Master handout loop time', MPI_WTIME()-t3

   open(10,file='out/main/nsend.dat',STATUS='REPLACE')  ! Write log of number of packets send in each bin in each zone

   DO i = 1, Wlbins

      write(10,'(F15.4, 100ES12.2)') wlvec(i), REAL(NSEND(i,:))

   END DO

   close(10)

   OPEN(10,file='out/main_radtrans/sendpackets.dat',STATUS='REPLACE')  ! Write log of total number of bundles and packets sent

   write(10,*) 'bigcounter:', bigcounter, 'Total packets sent:', bigcounter*chunksize

   write(10,*) 'Ntot parameter:', NpacketsTOT

   write(10,*) 'minsend per shell and wl bin:', minsend

   write(10,*) 'minsend_UV per shell and wl bin:', minsend_UV

   write(10,*) 'maxsend per shell and wl bin:', Npacketsmax

   close(10)

   t2=MPI_WTIME()

   DO i = 1, numprocs-1       ! All bundles sent, sent termination tag to slaves

      CALL MPI_RECV(returndata, 1, MPI_DOUBLE_PRECISION, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD, status, ierr) ! Listed for the next finished slave..
       
      processID = status(MPI_SOURCE)       
      !processID = status%MPI_SOURCE  ! ID of this slave

      tag = 0   ! Termination tag

      CALL MPI_SEND(datavec, datavecsize, MPI_DOUBLE_PRECISION, processID, tag, MPI_COMM_WORLD, ierr)  ! tell slave to terminate

   END DO

   call MPI_REDUCE(MPI_IN_PLACE, N_CONTABS, Nr*((Nstages-1)*Nelem+Nmol+2)*maxval([Npis,ngvec])*2, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

   call MPI_REDUCE(MPI_IN_PLACE, OUTPHOTONS_SC, Wlbins*2, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)
     
   call MPI_REDUCE(MPI_IN_PLACE, OUTPHOTONS_ABIN, Wlbins*Nabin, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

   call MPI_REDUCE(MPI_IN_PLACE, OUTPHOTONS_LASTZONE, WLbins*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

   call MPI_REDUCE(MPI_IN_PLACE, OUTPHOTONS_ORIGZONE, WLbins*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

   !! In case of multiple nodes, collect the shared variables from each node together (& set in each node)
   !! Do this for each of the global/shared variables that followphoton_ff changes
   !CALL MPI_ALLREDUCE(MPI_IN_PLACE, OUTPHOTONS_SC, Wlbins*2, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
   !CALL MPI_ALLREDUCE(MPI_IN_PLACE, OUTPHOTONS_ABIN, Wlbins*Nabin, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
   !CALL MPI_ALLREDUCE(MPI_IN_PLACE, OUTPHOTONS_LASTZONE, Wlbins*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
   !CALL MPI_ALLREDUCE(MPI_IN_PLACE, OUTPHOTONS_ORIGZONE, Wlbins*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
   CALL MPI_ALLREDUCE(MPI_IN_PLACE, E_RADFIELD, Nradfield*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
   !CALL MPI_ALLREDUCE(MPI_IN_PLACE, N_CONTABS, Nr*((Nstages-1)*Nelem+Nmol+2)*maxval([Npis,ngvec])*2, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
   CALL MPI_ALLREDUCE(MPI_IN_PLACE, energyout, Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
   CALL MPI_ALLREDUCE(MPI_IN_PLACE, energyin, Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
   CALL MPI_ALLREDUCE(MPI_IN_PLACE, Ephotoexc, Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)

   IF (PHOTOEXC >= 1) THEN

       DO j = 1, N_atoms

           IF (nlevabsorbs_max(j) > 0) THEN

               CALL MPI_ALLREDUCE(MPI_IN_PLACE, atoms(j)%PHOTOEXCRATES(1:Nr,1:nlevabsorbs_max(j),1:atoms(j)%N), Nr*nlevabsorbs_max(j)*atoms(j)%N, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)

           ENDIF

       ENDDO

   ENDIF
   !! If you are only running on 1 node then this loop shouldn't change any outcomes


   t3 = MPI_WTIME()

   OPEN(24,file=file_emergent,FORM='UNFORMATTED',STATUS='REPLACE')  ! Emergent spectra : Col 1:bin index, 2:wl [A], 3:total flux [erg s^-1 A^-1] , 4:unscattered, flux 5:scattered flux, 6:6+Nabin flux from each element, 6+Nabin+1:6+Nabin+1+Nr : flux from each zone (last touch), 6+Nabin+1+Nr+1:6+Nabin+1+Nr+1+Nr : flux from each zone (original zone)

   DO i = 1, WLbins

      WRITE(24) i, wlvec(i), SUM(OUTPHOTONS_SC(i,:)), OUTPHOTONS_SC(i,1), OUTPHOTONS_SC(i,2), OUTPHOTONS_ABIN(i,1:Nabin), OUTPHOTONS_LASTZONE(i,1:Nr) , OUTPHOTONS_ORIGZONE(i,1:Nr)

   END DO

   close(24)

   open(24,file=file_radmerged, STATUS='REPLACE')

   DO i = 1, Nradfield-1

      write(24,'(F10.4,100ES12.3E3)') lambda_radfield(i), E_radfield(1:Nr,i)/volume(1:Nr)/(lambda_radfield(i+1)-lambda_radfield(i))

   END DO

   close(24)

   t3 = MPI_WTIME()

   IF (PHOTOEXC >= 1) THEN

      DO i = 1, Nr

         open(10,file=TRIM(file_photoexcall)//R_index_str(i), FORM='UNFORMATTED', STATUS='REPLACE')

         DO j = 1, N_atoms

            DO m = 1, nlevabsorbs_max(j)

               DO n = m + 1, atoms(j)%N  ! photodeexcitation rates are marked by negative values, so m always > n

                  IF (atoms(j)%LAMBDA(n,m) < lambda_radfield(Nradfield)) THEN

                     call findbin2(Nradfield, lambda_radfield, atoms(j)%LAMBDA(n,m), bin)

                  ELSE

                     bin = 0

                  END IF

                  IF (bin .NE. 0) THEN

                     Blu = atoms(j)%LEVELS_G(n)/atoms(j)%LEVELS_G(m)*atoms(j)%A(n,m)*(atoms(j)%LAMBDA(n,m)*1e-8)**3/(2*h*c)

                     IF (atoms(j)%TAU(i,m,n) > 0) THEN

                        beta = (1. - exp(-atoms(j)%TAU(i,m,n)))/atoms(j)%TAU(i,m,n)

                     ELSE

                        beta = 1.
                     END IF

                     theoretical_rate = Blu*beta*E_radfield(i,bin)/volume(i)/(lambda_radfield(bin+1)-lambda_radfield(bin))*1e8*(atoms(j)%LAMBDA(n,m)*1e-8)**2/c

                     IF (abs(atoms(j)%PHOTOEXCRATES(i,m,n)) > 0) THEN

                        IF ((isnan(atoms(j)%PHOTOEXCRATES(i,m,n)) .EQV. .FALSE.) .AND. (atoms(j)%PHOTOEXCRATES(i,m,n) < huge(r)) .AND. (isnan(theoretical_rate) .EQV. .FALSE.) .AND. (theoretical_rate < huge(r))) THEN

                           write(10) i, j, m, n, atoms(j)%PHOTOEXCRATES(i,m,n), theoretical_rate    ! Binary

                        ELSE

                           print *, 'WARNING, problem with photoexcrate', i, j, m, n, atoms(j)%PHOTOEXCRATES(i,m,n), theoretical_rate

                        END IF

                     END IF

                  ELSE

                     !IF (abs(atoms(j)%PHOTOEXCRATES(i,m,n)) > 0) write(10) i, j, m, n, atoms(j)%PHOTOEXCRATES(i,m,n), 0d0    ! Binary
                     IF ((abs(atoms(j)%PHOTOEXCRATES(i,m,n)) > 0)) THEN

                        IF ((isnan(atoms(j)%PHOTOEXCRATES(i,m,n)) .EQV. .FALSE.) .AND. (atoms(j)%PHOTOEXCRATES(i,m,n) < huge(r))) THEN

                           write(10) i, j, m, n, atoms(j)%PHOTOEXCRATES(i,m,n), 0d0    ! Binary

                        ELSE

                           print *, 'WARNING, problem with photoexcrate v2', i, j, m, n, atoms(j)%PHOTOEXCRATES(i,m,n)

                        END IF

                     END IF

                  END IF

               END DO

            END DO

         END DO

         close(10)

      END DO

   END IF

   print *, 'Time to write photoexcrates', MPI_WTIME()- t3

   DO i = 1, Nr  ! For each shell where the absorption occur..

      OPEN(22,file=TRIM(file_dead)//R_index_str(i),FORM='UNFORMATTED',STATUS='REPLACE')  !write all photons that have suffered PHOTOIONIZATION

      DO j = 1, (Nstages-1)*Nelem + Nmol + 2  ! For each element (neutral, singly ionized, molecular and dust)..

         DO m = 1, maxval([Npis,ngvec])   ! For each excitation state (Lev 1 to Npis are actively absorbing)...

            IF (N_CONTABS(j,m,2,i) > 0) THEN  ! Write only continua with non-zero absorptions

               IF ((isnan(N_CONTABS(j,m,2,i)) .EQV. .FALSE.) .AND. (N_CONTABS(j,m,2,i) < huge(r)) .AND. (isnan(N_CONTABS(j,m,1,i)) .EQV. .FALSE.) .AND. (N_CONTABS(j,m,1,i) < huge(r)) ) THEN

                   WRITE(22) i, j, m, N_CONTABS(j,m,1,i), N_CONTABS(j,m,2,i)

               ELSE

                  print *, 'WARNING, problems with photoionization', i, j, m, N_CONTABS(j,m,1,i), N_CONTABS(j,m,2,i)

               END IF

            END IF

         END DO

      END DO

    close(22)

  END DO

  OPEN(23, file=file_lineabstot,STATUS='REPLACE')  ! write the TOTAL PHOTOEXCITATION in each zone

  DO i = 1, Nr
     photoexctot(i) = Ephotoexc(i)
     WRITE(23,*) i, photoexctot(i)

  END DO

  close(23)

  DO i = 1, Nr

     open(10,file=TRIM(file_outside)//R_index_str(i),STATUS='OLD')  ! Flux that was not emitted in MC (assumed to escape freely)

     read(10,*) outsideflux(i)

    close(10)

  END DO

  DO i = 1, Nr

   open(10,file='out/statisticalandthermalequilibrium/molcool'//R_index_str(i),STATUS='OLD')    ! HI rec emission that is not included (because special treatment of HI)
     read(10,*) trash, molcool(i)

   close(10)

  END DO

  open(10,file=file_dep,STATUS='OLD')

  read(10,*) trash

  DO i = 1, Nr

     read(10,*) trash, dep(i)

  END DO

  close(10)

  open(23,file=file_energybalance,STATUS='REPLACE')

  DO i = 1, Nr
     write(*,*) i, energyout(i), outsideflux(i), molcool(i), dep(i)
     write(23,'(I6, 3ES12.3)') i, energyout(i)+outsideflux(i)+molcool(i), (energyout(i)+outsideflux(i)+molcool(i))/dep(i)
  end do

  close(23)

  open(23,file=file_energybalancelong,POSITION='APPEND')

  write(23,'(1000F10.2)') (energyout+outsideflux+molcool-energyin)/dep

  close(23)

  DEALLOCATE(FBIG, flux_noconv_MAT, NSEND)  ! Dont need anymore

ELSE    ! SLAVES - ALL OTHER GLOBID RANKS

   ALLOCATE(colldeexc(Nr)); colldeexc = 0
   ALLOCATE(h2diss(Nr)); h2diss = 0

   FIRFLUX = 0.

   datavec = 0

   tag = 2                 ! Activation code to master is 2

   CALL MPI_SEND(datavec, 1, MPI_INTEGER, 0, tag, MPI_COMM_WORLD, ierr)  ! send ready signal to master..

   tag = 1

   wt1=MPI_WTIME()

   DO WHILE(tag .NE. 0) ! Loop until master sends termination signal (0)..

      CALL MPI_RECV(datavec, datavecsize, MPI_DOUBLE_PRECISION, 0, MPI_ANY_TAG, MPI_COMM_WORLD, status, ierr) !  obtain bundle from master

      t1=MPI_WTIME()

      loops = loops + 1

      tag = status(MPI_TAG)
      !tag = status%MPI_TAG 
        
      IF (tag .NE. 0) THEN   ! Unless termination tag..(needed both here and in the encompassing loop)

         DO i = 0, chunksize-1     ! data is *chunksize* number of photon packages to be sent, loop trough them and send

            r = datavec(6*i+1)     ! each packet has 6 entries, radius (dimless)
            Epp = datavec(6*i+2)*1E20    ! Energy CARE we use a temporary transformation factor 1D20 to keep real in the precious matrix, transform back here
            lambda = datavec(6*i+3)  ! wl
            origlambda = lambda      ! bookkeeping
            zone = NINT(datavec(6*i+4))  ! zone
            origzone = zone
            lastzone = zone
            r_int = datavec(6*i+5)  ! internal radius (if in a blob)
            sender = NINT(datavec(6*i+6))  ! element
            scattered = 0
            dt_core = 0

            RECURSIVES = 0

            IF (Epp > 0.) THEN   ! Last bundle is half-full. Dont use Epp == 0 EXIT here doesnt work for some reason

               CALL followphoton_ff(zone, r, Epp, lambda, sender, scattered, origzone, lastzone, origr, origlambda, dt_core, r_int, N_atoms, atoms, RT, ION_STRUCTURE, EXC_CUBE_ABIN, NMOLMAT, radii, ne_vec, alfa_dust, Nlines, Nlinesvec, TAUCUBE, OLI, Nblobs, blobsize, af_accum, WLbins, wlvec)  ! Follow photon out..the absorption/output it (and its possible fluorescence) creates are stored in global variables N_CONTABS, OUTPHOTONS_SC, OUTPHOTONS_ABIN, etc..

            end if

            returndata = 0

         END DO

         t2=MPI_WTIME()

 	     if (myid == 10 .AND. DOPRINT) print *, 'time between', t2-t1

         CALL MPI_SEND(returndata, 1, MPI_DOUBLE_PRECISION, 0, tag, MPI_COMM_WORLD, ierr)  ! bundle finished, tell master and then loop back to obtain new bundle (or termination signal)

         timetot = timetot + t2 - t1

      ELSE    ! termination tag (0) received..

         print *, 'time at termination tag', timetot

         ! Send the accumulated data matrices to master... might need updating due to memsharing

         !! In case of multiple nodes, collect the shared variables from each node together (& set in each node)
         !! Do this for each of the global/shared variables that followphoton_ff changes
         !! ONLY myid==0 ranks know what taskcomm is!!
		call MPI_REDUCE(N_CONTABS, N_CONTABS, Nr*((Nstages-1)*Nelem+Nmol+2)*maxval([Npis,ngvec])*2, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)  ! Send in contribution to N_CONTABS from this slave to master

		call MPI_REDUCE(OUTPHOTONS_SC, OUTPHOTONS_SC, Wlbins*2, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

        call MPI_REDUCE(OUTPHOTONS_ABIN, OUTPHOTONS_ABIN, Wlbins*Nabin, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

        call MPI_REDUCE(OUTPHOTONS_LASTZONE, OUTPHOTONS_LASTZONE, Wlbins*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)

        call MPI_REDUCE(OUTPHOTONS_ORIGZONE, OUTPHOTONS_ORIGZONE, Wlbins*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, 0, MPI_COMM_WORLD, ierr)
		IF (myid == 0) THEN  ! myid==0 are all in the taskcomm communicator => this avoids duplicating shared data
             t1=MPI_WTIME()
             !CALL MPI_ALLREDUCE(MPI_IN_PLACE, OUTPHOTONS_SC, Wlbins*2, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
             !CALL MPI_ALLREDUCE(MPI_IN_PLACE, OUTPHOTONS_ABIN, Wlbins*Nabin, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
             !CALL MPI_ALLREDUCE(MPI_IN_PLACE, OUTPHOTONS_LASTZONE, Wlbins*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
             !CALL MPI_ALLREDUCE(MPI_IN_PLACE, OUTPHOTONS_ORIGZONE, Wlbins*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
             CALL MPI_ALLREDUCE(MPI_IN_PLACE, E_RADFIELD, Nradfield*Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
             !CALL MPI_ALLREDUCE(MPI_IN_PLACE, N_CONTABS, Nr*((Nstages-1)*Nelem+Nmol+2)*maxval([Npis,ngvec])*2, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
             CALL MPI_ALLREDUCE(MPI_IN_PLACE, energyout, Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
             CALL MPI_ALLREDUCE(MPI_IN_PLACE, energyin, Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
             CALL MPI_ALLREDUCE(MPI_IN_PLACE, Ephotoexc, Nr, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
             IF (PHOTOEXC >= 1) THEN
                 DO j = 1, N_atoms
                     IF (nlevabsorbs_max(j) > 0) THEN
                         CALL MPI_ALLREDUCE(MPI_IN_PLACE, atoms(j)%PHOTOEXCRATES(1:Nr,1:nlevabsorbs_max(j),1:atoms(j)%N), Nr*nlevabsorbs_max(j)*atoms(j)%N, MPI_DOUBLE_PRECISION, MPI_SUM, taskcomm, ierr)
                     ENDIF
                 ENDDO
             ENDIF
             t2=MPI_WTIME()
             print *, 'end comm time', t2-t1

             wtc=wtc+(t2-t1)
         ENDIF
         !! If you are only running on 1 node then this loop shouldn't change any outcomes. NOTE: all taskcomm-ranks MUST call the MPI_ALLREDUCE

         OPEN(23, file=file_colldeexc,STATUS='REPLACE')  ! each slave writes the total COLLISIONAL DEEXCITATIONS

         DO i = 1, Nr

            WRITE(23,*) i, colldeexc(i)

         END DO

         close(23)

         ! Send emergent photons to master

         returndata = 0

         OPEN(24,file='out/mcphotons/fir.dat'//processname,STATUS='REPLACE')

         write(24,*) firflux

         close(24)

      END IF

   END DO

   wt1=MPI_WTIME()-wt1
   DEALLOCATE(colldeexc, h2diss)

END IF

PRINT *, 'Process', globid, ' terminates.'

t2=MPI_WTIME()

!print *, 'cpu time', t2-t1, myid

wt0=MPI_WTIME()-wt0
!print *, 'WTIME_0', wt0, myid

CALL MPI_Gather(wt0,1,MPI_DOUBLE_PRECISION,wt0_all,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD, ierr)
CALL MPI_Gather(wt1,1,MPI_DOUBLE_PRECISION,wt1_all,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD, ierr)
CALL MPI_Gather(wtc,1,MPI_DOUBLE_PRECISION,wtc_all,1,MPI_DOUBLE_PRECISION,0,MPI_COMM_WORLD, ierr)
IF (globid == 0) THEN
   PRINT '(A)','--------------------------------------------------------'
   PRINT '(A)','TIMINGS (based on MPI_WTIME):'
   PRINT '(A,3F10.4)','WT0   : min/max/avg time [s]:',minval(wt0_all(1:numprocs)),maxval(wt0_all(1:numprocs)),sum(wt0_all(1:numprocs))/numprocs
   PRINT '(A,3F10.4)','WT1   : min/max/avg time [s]:',minval(wt1_all(2:numprocs)),maxval(wt1_all(2:numprocs)),sum(wt1_all(2:numprocs))/(numprocs-1)
   PRINT '(A,3F10.4)','WTCOMM: min/max/avg time [s]:',minval(wtc_all(2:numprocs)),maxval(wtc_all(2:numprocs)),sum(wtc_all(2:numprocs))/(numprocs-1)
END IF

DEALLOCATE(wt0_all,wt1_all,wtc_all, datavec)

CALL MPI_WIN_FREE(window, ierr)  ! Release all the shared memory!
IF (myid == 0) THEN
    CALL MPI_COMM_FREE(taskcomm, ierr)
ENDIF
CALL MPI_Comm_set_errhandler(MPI_COMM_WORLD, MPI_ERRORS_RETURN, ierr)

CALL MPI_BARRIER(globcomm, ierr)

CALL MPI_FINALIZE(ierr)

IF (ierr /= MPI_SUCCESS) THEN
    IF (globid == 0) THEN
        CALL MPI_Error_string(ierr, err_message, err_length, err_tmp)
        print *, "-----------------------------------------------------------------------"
        print *, "Note: MPI_Finalize returned the following error."
        print *, "      Please double check your results against single-node calculation."
        print *, "-----------------------------------------------------------------------"
        print *, err_message(1:err_length)
        print *, "-----------------------------------------------------------------------"
    END IF
END IF

if (globid == 0) print *, 'Program finished. cpu time', t2-t1

END PROGRAM MAIN_RADTRANS
