#! /bin/bash
#wc -l < $1 > xxx
#read n trash < xxx
#echo $n
np=$2
# --------------------
let wlstart="400"  # Fat final ("fourth iterate")
let wlend="25000"
wlres="1.0"
let Ntot="1000000000"
let Nmin="1000"
let NminUV="1000"
let Nmax="5000"
let nitermax="10" # 10
# -------------------------
#np=$2
let j="0"
echo "Logfile" > logfile
echo "Summary" > summary
let nsuccess="0"
declare -a array
declare -a arrayget
declare -a iterarray
while read -r idrun iter idget || [[ -n "$idrun" ]]; do
	if [ "${idrun:0:1}" != "#" ]; then
		let j+=1
		#echo $idrun
        	array[$j]=$idrun
		iterarray[$j]=$iter
		arrayget[$j]=$idget
		echo "Reading model name", ${array[$j]} >> logfile
	fi
done < "$1"

echo $j "models to run" >> logfile

for ((i=1; i<=$j; i++)); do
        idrun=${array[$i]}
        idrunget=${arrayget[$i]}
	echo "==========================" >> logfile
        echo "Model $i, $idrun" >> logfile
	STARTTIME=$(date +%s)
	RUNFILE="ip$idrun"
	if [ ! -f $RUNFILE ]; then
	    echo "ERROR Runfile not found. Breaking." >> logfile
	    echo "$idrun 1 Runfile not found" >> summary	
	    continue
	else
	    echo "Found file $RUNFILE" >> logfile
	fi
	nrplus=$((`grep -h Nr $RUNFILE | awk '{print $2}'`+1))
	if [ $? = 0 ]; then
	    echo "Read number of shells $(($nrplus-1))" >> logfile
	else
	    echo "ERROR in reading number of shells. Aborting." >> logfile
	    echo "$idrun 1 Nr read error" >> summary
	    continue
	fi
        if [ $idrunget = "0" ]; then
	   echo "Not reading from saved.." >> logfile
        else
	   echo "Doing getfiles.." >> logfile
	   ./getfiles.sh $idrunget $(($nrplus-1))
	fi
	if [ $np -lt $nrplus ]; then
	    echo "ERROR, too few cores. Breaking" >> logfile
	    echo "$idrun 1 Too few cores" >> summary
	    continue
	fi
	echo "Starting iterate.sh ..." >> logfile
        if [ ! -f out/main/dep.dat ]; then
		echo "ERROR depfile not found" >> logfile
		continue
        fi
	./iterate.sh $nitermax $nrplus $np $idrun $RUNFILE n y $wlstart $wlend $wlres $Ntot $Nmin $NminUV $Nmax # High res. iterations
        outsignal=$?
 	if [ $outsignal = 0 ]; then
	    echo "Iterate.sh successful." >> logfile
	    ./process_special $idrun $RUNFILE       # Write line fluxes to file
	    echo "Doing putfiles..." >> logfile
	    ./putfiles.sh $idrun $((nrplus-1)) $RUNFILE
            ENDTIME=$(date +%s)
	    minutes=$(bc -l <<< "scale=2; $[$ENDTIME-$STARTTIME]/60")
	    echo "$idrun 0 $minutes min" >> summary
	    let nsuccess+=1
        elif [ $outsignal = 2 ]; then
	    echo "Third iterate.sh, exceeed niter.." >> logfile
	    read -r convstat eb < out/process/eb.dat
	    ENDTIME=$(date +%s)
	    minutes=$(bc -l <<< "scale=2; $[$ENDTIME-$STARTTIME]/60")
	    echo "$idrun 2 Exceed niter, $eb $minutes" >> summary
	    echo "Doing putfiles..." >> logfile
	    ./putfiles.sh $idrun $((nrplus-1)) $RUNFILE
	else
	    echo "ERROR iterate.sh" >> logfile
	    echo "$idrun 1 third iterate.sh" >> summary
	fi
done 
echo "Nmodels",$j, "computed, ", $nsuccess, "successful." >> logfile
echo "All done, TERMINATE." >> logfile
#echo "Runs on R2 done" | mail -s "R2 done" a.jerkstrand@qub.ac.uk 
