SUBROUTINE MOLECULES(T, DESTROY, CREATE, DE)
USE M1, ONLY : Nmol, Nelem, map_abin2elem2, map_abin2elem3, Nstages
USE PARAMETERS, ONLY : eV, k
IMPLICIT NONE
DOUBLE PRECISION, INTENT(IN) :: T
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem+Nmol,Nstages*Nelem+Nmol), INTENT(OUT)  :: DESTROY, DE
DOUBLE PRECISION, DIMENSION((Nstages-1)*Nelem+Nmol,Nstages*Nelem+Nmol,Nstages*Nelem+Nmol), INTENT(OUT) :: CREATE

DOUBLE PRECISION :: ct, temp_ct, CO_radass
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: Tvec, ctvec, ratevec
INTEGER :: bin

character*5 :: FS 
INTEGER :: i, j, m, n, R1, R2, P1, P2
DOUBLE PRECISION :: tmin, tmax, sc, t4
DOUBLE PRECISION, DIMENSION(3) :: funcVar
INTEGER, DIMENSION(5) :: avec_in
DOUBLE PRECISION, DIMENSION(1000) :: securevec

!opens the input file containing the network
open(12, file="DATA/mol_input/mr_network/mr_umistnetwork_allmol3_126.csv")
!open(12, file="DATA/mol_input/mr_umistnetwork_co_108_ra-co.csv")
!open(12, file="DATA/mol_input/temp.csv")
!open(12, file="DATA/mol_input/mr_network/mr_umistnetwork_co_108.csv")
!open(12, file="DATA/mol_input/mr_umistnetwork_sio_109.csv")
!open(12, file="DATA/mol_input/mr_umistnetwork_co_109.csv")
!open(12, file="DATA/mol_input/mr_network/mr_umistnetwork_co_109.csv")
!open(12, file="DATA/mol_input/mr_umistnetwork_sio_109.csv")
!open(12, file="DATA/mol_input/mr_umistnetwork_co_109.csv")
!open(12, file="DATA/mol_input/mr_network/mr_umistnetwork_all_109.csv")
!open(12, file="DATA/mol_input/mr_network/mr_umistnetwork_allmol_109.csv")
!open(12, file="DATA/mol_input/mr_network/mr_umistnetwork_co_109.csv")
!open(12, file="DATA/mol_input/mr_umistnetwork_sio_109.csv")
!open(12, file="DATA/mol_input/mr_umistnetwork_co_109.csv")
! open(12, file="DATA/mol_input/mr_test.csv")

!the number of rows and columns in the input file
read(12, *) n, m
print*, 'Lines in chem. network file: ', n

!goes through the input files, that contains n number of lines
i = 0

do j=1,n
!     reads in the values for the abin numbers (avec_in), the function switch, the function variables

	read(12, *) avec_in, funcVar, tmin, tmax    ! avec_in size 5, funcVar 3. 

	! Check if the temperature is within the temperature limits for the reactions:
    if (T .GE. tmin .AND. T .LE. tmax) then

        i = i + 1

		ct = funcVar(1)*(T/300.)**funcVar(2)*EXP(-funcVar(3)/T)

		DESTROY(map_abin2elem2(avec_in(1)),map_abin2elem3(avec_in(2))) = DESTROY(map_abin2elem2(avec_in(1)),map_abin2elem3(avec_in(2))) + ct

		DESTROY(map_abin2elem2(avec_in(2)),map_abin2elem3(avec_in(1))) = DESTROY(map_abin2elem2(avec_in(2)),map_abin2elem3(avec_in(1))) + ct
        
        temp_ct = ct
        
        CREATE(map_abin2elem2(avec_in(3)), map_abin2elem3(avec_in(1)), map_abin2elem3(avec_in(2))) = CREATE(map_abin2elem2(avec_in(3)), map_abin2elem3(avec_in(1)), map_abin2elem3(avec_in(2))) + temp_ct
        
        if (avec_in(4) .NE. 0) then

            if (map_abin2elem2(avec_in(4)) .NE. 0) then

                CREATE(map_abin2elem2(avec_in(4)), map_abin2elem3(avec_in(1)), map_abin2elem3(avec_in(2))) = CREATE(map_abin2elem2(avec_in(4)), map_abin2elem3(avec_in(1)), map_abin2elem3(avec_in(2))) + temp_ct

			end if

		end if
        
        if (avec_in(5) .NE. 0) then

			if (map_abin2elem2(avec_in(5)) .NE. 0) then

				CREATE(map_abin2elem2(avec_in(5)), map_abin2elem3(avec_in(1)), map_abin2elem3(avec_in(2))) = CREATE(map_abin2elem2(avec_in(5)), map_abin2elem3(avec_in(1)), map_abin2elem3(avec_in(2))) + temp_ct

			end if
        
		end if

		! print*, map_abin2elem3(avec_in(1)), map_abin2elem3(avec_in(2)), map_abin2elem3(avec_in(3)), map_abin2elem3(avec_in(4))
        ! print*, map_abin2elem3(avec_in(1)), map_abin2elem3(avec_in(2))), map_abin2elem3(avec_in(3)), map_abin2elem3(avec_in(4)))
        ! print*, map_abin2elem2(avec_in(1)), map_abin2elem2(avec_in(2))), map_abin2elem2(avec_in(3)), map_abin2elem2(avec_in(4)))
            
    end if

end do

close(12)

END SUBROUTINE MOLECULES
