import numpy as np
import matplotlib.pyplot as plt
import sys

type = sys.argv[1]  # To plot the current outputs use "this" as argument. To plot files downloaded into another folder put folder path.

plotlog = True

if (type == 'this'):
	fid = open("./out/plts/teqslong.dat")
else:
	fid = open(type+"/teqslong.dat")

TEQS = np.loadtxt(fid)

fid.close

if (TEQS.ndim == 2):
	Nplot = len(TEQS[0,:])
else:
	Nplot = 1  # 1 zone

print(Nplot)

if (type == 'this'):
	fid = open("./out/xelong/xelong.dat")
else:
	fid = open(type+"/xelong.dat")

XE = np.loadtxt(fid)

fid.close

if (type == 'this'):
	fid = open("./out/radmaker/ebalance.dat")
else:
	fid = open(type+"/ebalance.dat")

EBAL = np.loadtxt(fid)

fid.close

if (type == 'this'):
	fid = open("./out/process/lboltotlong.dat")
else:
	fid = open(type+"/lboltotlong.dat")

EBALALL = np.loadtxt(fid)

fid.close

plt.figure(figsize=(10,7))

stylevec=['-','-','-','-','-','--','--','--','--','--',':',':',':',':',':','-.','-.','-.','-.','-.']

plt.subplot(2,2,1) # ==============================
for i in range(0,Nplot):
	if (Nplot > 1):
		plt.plot(TEQS[:,i],label=str(i),linestyle=stylevec[i])
	else:    
		plt.plot(TEQS[:])

if (plotlog):
	plt.yscale('log')
plt.title('T')

plt.subplot(2,2,2) # ===============================
for i in range(0,Nplot):
	if (Nplot > 1):
		plt.plot(XE[:,i],label=str(i+1),linestyle=stylevec[i])
	else:
		plt.plot(XE[:],'-*',label=str(i+1)) 

plt.legend(bbox_to_anchor=(1.05, 1.0),loc="upper left")
if (plotlog):
	plt.yscale('log')
plt.title('xe')

plt.subplot(2,2,3) # ================================
for i in range(0,Nplot,1):
	if (Nplot > 1):
		plt.plot(EBAL[:,i],linestyle=stylevec[i])
	else:
		plt.plot(EBAL[:],'-*') # 1 zone

if (plotlog):
	plt.yscale('log')
#plt.xscale('log')
plt.plot(np.ones(len(EBALALL[:,1])),'k--')
plt.title('Ebalance emit/(radioactive + radiative dep.)')

plt.subplot(2,2,4) # =================================
plt.plot(EBALALL[:,1],'-*')
plt.plot(np.ones(len(EBALALL[:,1])),'k')
plt.plot(0.95*np.ones(len(EBALALL[:,1])),'k--')
plt.plot(1.05*np.ones(len(EBALALL[:,1])),'k--')

if (plotlog):
	plt.yscale('log')
#plt.xscale('log')
#plt.ylim([min(EBALALL[:,0]),max(EBALALL[:,0])])
plt.title('Ebalance Escaped/Radioactive dep.')
#plt.ylim(0.5,2.5)

plt.show()
