SUBROUTINE NEXTIONEDGE(lambda, lambdaedge, IONEDGEEXISTS)
use M1, ONLY : Nelem, lambdaion, Nstages
IMPLICIT NONE
DOUBLE PRECISION, INTENT(IN) :: lambda
DOUBLE PRECISION, INTENT(OUT) :: lambdaedge
LOGICAL, INTENT(OUT) :: IONEDGEEXISTS
! =======================================
! Task :  Finds the ionization edge closest to lamda on the red side
! Input :     lambda     Wavelength [A]
! Output :    lambdaedge Ionization edge [A]
!             IONEDGEEXISTS    Boolean, was an ionization edge found? 
! CARE does not currently care about excited states!
! =====================================
INTEGER :: i
DOUBLE PRECISION :: dlambda, dlambda_min

! -------------------------------------------------------------

dlambda_min = 1E30
lambdaedge = 1E30
IONEDGEEXISTS = .FALSE.       ! Do not remove

! ----------------------------------------------------------------

DO i = 1, (Nstages-1)*Nelem     ! For each species except the highest ionized

   dlambda = lambdaion(i) - lambda   ! Distance to ionization edge *i*

   IF(dlambda > 0 .AND. dlambda < dlambda_min) THEN   ! If distance is positive and smallest so far..

      IONEDGEEXISTS = .TRUE.

      lambdaedge = lambdaion(i)

      dlambda_min = dlambda

   END IF

END DO

END
