module PARAMETERS
implicit none

double precision, PARAMETER :: c=2.99792458d10		! Speed of light parameter in cm/s
double precision, PARAMETER :: h=6.62606896d-27		! Planck constant in erg s
double precision, PARAMETER :: pi=3.14159265358979d0	! Pi
double precision, PARAMETER :: k=1.3806504d-16		! Boltzmann constant
double precision, PARAMETER :: mp=1.67262158d-24		! Mass of proton in grams
double precision, PARAMETER :: me = 9.10938d-28         ! gram
double precision, PARAMETER :: Msun=1.9889d33		! Solar mass in grams
double precision, PARAMETER :: Lsun=3.827d33		! Solar luminosity in erg per second
double precision, PARAMETER :: eV=1.60217646d-12             ! 1 eV expressed in ergs
double precision, PARAMETER :: echarge = 4.80320d-10          ! StatCoulomb
double precision, PARAMETER :: a0=5.29d-9  ! Bohr radius in cm

end module PARAMETERS

