PROGRAM PROCESS
USE M1, ONLY : Nr, Ncore, Nabin, R_index_str
USE FILES, ONLY : file_emergent, file_runparameters, file_TEMPS, file_EXCCUBE, file_wlvec, file_hIextra, file_dustabs, file_outside, file_dep, file_Eemit
USE PARAMETERS
IMPLICIT NONE

! ----------------------------------------
! Task : Reads all the MC output and creates spectrum..also measures line fluxes, magnitudes etc and puts in another file.
!        The output files containts a column (3) where the spectra have been SMOOTHED TO THE TELESCOPE RESOLUTION
! Command line arguments :  1 : idrun    To label the output spectrum
!                           2 (optional) : input file (same as needed for suse, sumo)
!                           3 (optional) : Smoothing (km/s)
!                           4 (optional) : Vcut
! -----------------------------------------

INTEGER :: ebold, Nwl, i, ind, iU, iB, iV, iR, iI, iJ, iH, iK, iS1, iS2, bin, j, n4571=0, n6563=0, n7155=0, n7300=0, n5890=0, abin, lev, Nlines, binleft, binright
DOUBLE PRECISION :: Eemittot=0, RP_optical, wl, flux_total, flux_nosc, flux_sc, flux, DF, lbol, lbol_limited, lbol_sc, dist_mpc, l7300, l8500, l7300_env, l7155, lha, lha_env, l6300, l4571, lmg1p5,  l4571_pure, l5890,  l7300_nocont, l8500_nocont, l7155_nocont, lha_nocont, l6300_nocont, l4571_nocont, l5890_nocont, z, sigma, lumFeI, leftedge,rightedge, lumFeII, modeltot, obstot, nfactor, outsidefluxtot=0, fir, mcoutside=0, dustabs=0, hIextra, hIextratot=0, molcooltot=0, Uflux=1D-30, Bflux=1D-30, Vflux=1D-30, Rflux=1D-30, Iflux=1D-30, Jflux=1D-30, Hflux=1D-30, Kflux=1D-30, S1flux=1D-30, S2flux=1D-30, S1flux_dust=1D-30, S2flux_dust=1D-30, Uflux_dust=1D-30, Bflux_dust=1E-30, Vflux_dust=1D-30, Rflux_dust=1D-30, Iflux_dust=1D-30, Jflux_dust=1D-30, Hflux_dust=1D-30, Kflux_dust=1D-30, vcut, vcut_ha, normU=0, normB=0, normV=0, normR=0, normI=0, normJ=0, normH=0, normK=0, normS1=0, normS2=0, FrefU, FrefB, FrefV, FrefR, FrefI, FrefJ, FrefH, FrefK, FrefS1, FrefS2, e_bv, corrf, timedays, dep, continuum8600, continuum, vcont, vcont_ha, hrad, hnt, hratio, maxflux_4571=0, maxflux_5890=0, maxflux_6300=0, maxflux_7155=0, maxflux_7300=0, maxflux_ha=0, maxlambda_4571=0, maxlambda_5890=0, maxlambda_6300=0, maxlambda_ha=0, maxlambda_7155=0, maxlambda_7300=0, tau1, tau2, tauha, FWHM, sigmag, gaussn, RP, pval, neoncont=1e20, lneii=0, wl_feII26mu=259882, feII26mucont=1e20, lfeII26mu=0, coII10p52mucont=1e20, lcoII10p52mu=0,  wl_coII10p52mu=105227, feII24p52mucont=1e20, lfeII24p52mu=0, wl_feII24p52mu=245190, feII17p94mucont=1e20, lfeII17p94mu=0, wl_feII17p94mu=179363, niII6p63mucont=1e20, lniII6p63mu=0, wl_niII6p63mu=66360, niI7p5mucont=1e20, lniI7p5mu=0, wl_niI7p5mu=75065, vcut_fir, vcut_nir, vcont_fir, vcont_nir, RP_MIR, RP_NIR, contneII_r, contneII_l, A_contneii, B_contneii, contneii_wlr, contneii_wll, da, Ltot
DOUBLE PRECISION, DIMENSION(100,12) :: fit
DOUBLE PRECISION, DIMENSION(100000) :: fluxvec_total=0, fluxvec_total_dusted, fluxvec_smooth=0, fluxvec_smooth_dusted, fluxvec_unsc, fluxvec_sc, lambdavec, wl_obs, flux_obs, model_int, lambdaU, lambdaB, lambdaV, lambdaR, lambdaI, lambdaJ, lambdaH, lambdaK, lambdaS1, lambdaS2, filterU, filterB, filterV, filterR, filterI, filterJ, filterH, filterK, filterS1, filterS2, wlt, tc, dlambda, lambdatemp, temp, gaussnvec
DOUBLE PRECISION, DIMENSION(Nabin) :: flux_abin, zerovec
DOUBLE PRECISION, DIMENSION(1000) ::  wl7155, flux7155, wl7300, wl5890, flux7300, wl4571, flux4571, wl6563, flux6563, flux5890
DOUBLE PRECISION, DIMENSION(33000,Nabin) :: fluxmat_abin, fluxmat_abin_smooth=0
DOUBLE PRECISION, DIMENSION(:,:,:), ALLOCATABLE :: pop
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: fluxmat_nr_orig, fluxmat_nr_last, fluxmat_nr_orig_smooth, taumg, tauna, tauO, taucaii, taufeii, neii
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: flux_nr_orig, flux_nr_last, T, adcool, depfrac, depind, heat, ion, exc, cool7155, cool7300, cool6300,  outsideflux, totheat, molcool, Eemit
DOUBLE PRECISION, DIMENSION(5) :: heatrates
CHARACTER(len=20) :: idrun
CHARACTER :: trash
REAL, EXTERNAL :: reddening_cardelli_f
LOGICAL :: CONVOLVE_MIR_FORMEASURING, EXISTS, DOSMOOTH
INTEGER :: vsmooth=600  ! Can be modified as 3d input argument
CHARACTER(len=10) :: vsmooth_str, vcut_str
CHARACTER(len=100) :: file_expmodel

DOSMOOTH = .FALSE.

CALL GET_COMMAND_ARGUMENT(1, idrun)  ! Id number for this simulation

IF (COMMAND_ARGUMENT_COUNT() >= 2) THEN
  CALL GET_COMMAND_ARGUMENT(2, file_runparameters) ! Run parameters file name (optional)
END IF

IF (COMMAND_ARGUMENT_COUNT() >= 3) THEN
  CALL GET_COMMAND_ARGUMENT(3, vsmooth_str) ! Run parameters file name (optional)
  read(unit=vsmooth_str,FMT='(I4)') vsmooth   ! Convert to type integer
END IF

IF (COMMAND_ARGUMENT_COUNT() >= 4) THEN
  CALL GET_COMMAND_ARGUMENT(4, vcut_str) ! Run parameters file name (optional)
  read(unit=vcut_str,FMT='(E4.0)') vcut   ! Convert to type integer
ELSE
  vcut = 3500  ! TEMP
END IF

! --PARAMETERS ------------------------------------------------

CONVOLVE_MIR_FORMEASURING = .TRUE.   !  Convolve MIR spectrum before measuring line fluxes?

open(10,file=file_runparameters,STATUS='OLD')   ! Extract only the distance (dist_mpc) from runparameters.dat file

   read(10,*) trash

   READ(10,*) trash, dist_mpc

   read(10,*) trash

   read(10,*) trash, file_expmodel

   read(10,*) trash, Nr

   read(10,*) trash, Ncore

close(10)

if (Nr <= 0) then
   print *, 'ERROR in process: Nr <= 0'
end if

ALLOCATE(molcool(Nr)); molcool = 0
ALLOCATE(totheat(Nr)); totheat=0
ALLOCATE(pop(Nr,Nabin,10));pop=0
ALLOCATE(fluxmat_nr_orig(33000,Nr)); fluxmat_nr_orig=0
ALLOCATE(fluxmat_nr_last(33000,Nr)); fluxmat_nr_last=0
ALLOCATE(fluxmat_nr_orig_smooth(33000,Nr)); fluxmat_nr_orig_smooth=0
ALLOCATE(flux_nr_orig(Nr)); flux_nr_orig=0
ALLOCATE(flux_nr_last(Nr)); flux_nr_last=0
ALLOCATe(T(Nr)); T=0
ALLOCATE(adcool(Nr)); adcool=0
ALLOCATe(depfrac(Nr)); depfrac=0
ALLOCATE(heat(Nr)); heat=0
ALLOCATE(ion(Nr)); ion=0
ALLOCATE(exc(Nr)); exc=0
ALLOCATE(cool7155(Nr)); cool7155=0
ALLOCATE(cool7300(Nr)); cool7300=0
ALLOCATE(cool6300(Nr)); cool6300=0
ALLOCATE(outsideflux(Nr)); outsideflux=0
ALLOCATE(taumg(Nr,5)); taumg=0
ALLOCATE(tauna(Nr,5)); tauna=0
ALLOCATE(tauO(Nr,5)); tauO=0
ALLOCATE(taucaii(Nr,5)); taucaii=0
ALLOCATE(taufeii(Nr,5)); taufeii=0
ALLOCATE(neii(Nr,5)); neii=0
ALLOCATE(Eemit(Nr)); Eemit=0

RP_MIR = 60  ! CARE Spitzer resolution

RP_NIR = 3e5/vsmooth

RP_optical = 3e5/vsmooth

e_bv = 0.  ! CARE Extinction needed to make observed photometry

vcut_ha = 4*vcut  ! H-alpha is usually broader than other lines, use wider cutoff

vcont = 1.25*vcut   ! Determine continuum within this range of vcut

vcont_ha = 1.25*vcut_ha

vcut_fir = 5000*3/2.35  ! 6400 km/s.

vcont_fir = 1.25*vcut_fir

vcut_nir = 3e5/RP_NIR*3/2.35

vcont_nir = 1.25*vcut_nir

DF = 4*3.1415*(dist_mpc*1e6*3.086e18)**2     ! Area of the sphere [cm^2]

fit = 0
fit(:,5) = 1e3  ! Left continuum, initialize to large value
fit(:,7) = 1e3  ! Right continuum, initialize to large value

Nlines = 12  ! Number of lines to exctract fluxes from

fit(1:Nlines,3) = vcut
fit(1:Nlines,4) = vcont

fit(1,1) = 4571.
fit(1,2) = 4571.

fit(2,1) = 5890.
fit(2,2) = 5896.

fit(3,1) = 6300.
fit(3,2) = 6364.

fit(4,1) = 6563.
fit(4,2) = 6563.
fit(4,3) = vcut_ha
fit(4,4) = vcont_ha

fit(5,1) = 7155.
fit(5,2) = 7155.

fit(6,1) = 7291.
fit(6,2) = 7323.

fit(7,1) = 8498.
fit(7,2) = 8662.

fit(8,1) = 16007
fit(8,2) = 16400
fit(8,3) = vcut_nir
fit(8,4) = vcont_nir

fit(9,1) = 15000
fit(9,2) = 15000
fit(9,3) = vcut_nir
fit(9,4) = vcont_nir

fit(10,1) = 14400
fit(10,2) = 14400
fit(10,3) = vcut_nir
fit(10,4) = vcont_nir

fit(11,1) = 5577.
fit(11,2) = 5577.

fit(12,1) = 15040
fit(12,2) = 15040
! -----------------------------------------------

!FrefU = 1.81e-23*1e7*1e-4*c/(0.36*1e-4)**2*1e-8    ! Zero magnitude fluxes. Johnson-Cousine system. From Bessel 1979  table IV. 1.81e-23 is in W/m2, factor 1e7 converts to erg/m2, factor 1e-4 to erg/cm2, then a dn/dlambda, then to per A
!FrefB = 4.26e-23*1e7*1e-4*c/(0.44*1e-4)**2*1e-8
!FrefV = 3.64e-23*1e7*1e-4*c/(0.55*1e-4)**2*1e-8
!FrefR = 3.08e-23*1e7*1e-4*c/(0.64*1e-4)**2*1e-8
!FrefI = 2.55e-23*1e7*1e-4*c/(0.79*1e-4)**2*1e-8

FrefU = 10**(-20.96/2.5)  ! From M Ergon mail june 3 2013. They are within a few percent of values from Bessel 1979 (discprepancy may be due to bessel listing the zero wavelengt only to closest 100 A's)
FrefB = 10**(-20.46/2.5)
FrefV = 10**(-21.09/2.5)
FrefR = 10**(-21.65/2.5)
FrefI = 10**(-22.33/2.5)
FrefJ = 10**(-23.76/2.5)  ! Cohen 2003, part 14
FrefH = 10**(-24.86/2.5)
FrefK = 10**(-25.92/2.5)
FrefS1 =10**(-27.94/2.5)  ! Ergon mail may 30 2013
FrefS2 =10**(-28.93/2.5)

! -------------------------------------------


lumFeI = 0
lumFeII = 0
leftedge = 4000*(1.-0e3/3e5)
rightedge = 9000*(1.+0e3/3e5)
l4571 = 0
lmg1p5 = 0
l4571_pure = 0
l5890 = 0
l7300 = 0
l7155 = 0
l8500 = 0
l7300_env = 0
l6300 = 0
lha = 0
lha_env = 0
l4571_nocont = 0
l5890_nocont = 0
l7300_nocont = 0
l7155_nocont = 0
l8500_nocont = 0
l6300_nocont = 0
lha_nocont = 0
lbol = 0
lbol_limited = 0
lbol_sc = 0
wl_obs = 0
flux_obs = 0
model_int = 0
modeltot = 0 ! important
obstot = 0  ! importantt
fluxvec_total = 0  ! Imp
fluxvec_total_dusted = 0
fluxvec_smooth_dusted = 0
fluxvec_unsc = 0
fluxvec_smooth = 0
fluxvec_sc = 0
fluxmat_abin = 0
flux_abin = 0
zerovec = 0
fluxmat_nr_orig = 0
fluxmat_nr_last = 0
flux_nr_orig = 0
flux_nr_last = 0

open(10,file=file_dep)

  read(10,*) dep   ! Total deposited energy (erg/s)

  DO i = 1, Nr

     read(10,*) trash, trash, depfrac(i)    ! Fractions of deposition in each zone

  END DO

close(10)

open(10,file='out/modelreader/timedays.dat',STATUS='OLD')

  read(10,*) timedays

close(10)

continuum = 100 ! Initialize, it will find continuum automatically

contneII_r = continuum

contneII_l = continuum

OPEN(10,file=file_wlvec,STATUS='OLD')

READ(10,*) Nwl

DO i = 1, Nwl

   READ(10,*) lambdavec(i)    ! Model lambda vector

END DO

close(10)

! READ FILTERS --------------------------------------------

!open(10,file='DATA/filters/johnsonU.dat',STATUS='OLD')
open(10,file='DATA/filters/U_B12_ST.dat',STATUS='OLD')

iU = 0

read(10,*) trash

DO

  read(10,*,END=102) lambdaU(iU+1), filterU(iU+1)

  !lambdaU(iU+1) = lambdaU(iU+1)*1e4     ! wavelengths are given in microns in the file, convert to A

  IF (iU > 0) normU = normU +  filterU(iU+1)*(lambdaU(iU+1)-lambdaU(iU))  ! compute integral Filter(lambda) dlambda (called withdX here)

  iU = iU + 1

END DO

102 close(10)

!open(10,file='DATA/filters/johnsonB.dat',STATUS='OLD')
open(10,file='DATA/filters/B_B12_ST.dat',STATUS='OLD')

iB = 0

read(10,*) trash

DO

  read(10,*,END=103) lambdaB(iB+1), filterB(iB+1)

  !lambdaB(iB+1) = lambdaB(iB+1)*1e4    ! wavelengths are given in microns in the file, convert to A

  IF (iB > 0) normB = normB +  filterB(iB+1)*(lambdaB(iB+1)-lambdaB(iB))   ! Contribution to the effective norm of the filter

  iB = iB + 1

END DO

103 close(10)

!open(10,file='DATA/filters/johnsonV.dat',STATUS='OLD'); REWIND(10)
open(10,file='DATA/filters/V_B12_ST.dat',STATUS='OLD')

iV = 0

read(10,*) trash

DO

  read(10,*,END=104) lambdaV(iV+1), filterV(iV+1)

  !lambdaV(iV+1) = lambdaV(iV+1)*1e4   ! wavelengths are given in microns in the file, convert to A

  IF (iV > 0) normV = normV +  filterV(iV+1)*(lambdaV(iV+1)-lambdaV(iV))    ! Contribution to the effective norm of the filter

  iV = iV + 1

END DO

104 close(10)

!open(10,file='DATA/filters/cousinR.dat',STATUS='OLD')
open(10,file='DATA/filters/R_B12_ST.dat',STATUS='OLD')


iR = 0

read(10,*) trash

DO

  !read(10,*,END=105) lambdaR(iR+1), trash, filterR(iR+1)  ! These files have three columns, 2 and 3 almost identical. Also wavelengths are now in A.
  read(10,*,END=105) lambdaR(iR+1), filterR(iR+1)  ! These files have three columns, 2 and 3 almost identical. Also wavelengths are now in A


  IF (iR > 0) normR = normR +  filterR(iR+1)*(lambdaR(iR+1)-lambdaR(iR))   ! Contribution to the effective norm of the filter

  iR = iR + 1

END DO

105 close(10)

!open(10,file='DATA/filters/cousinI.dat',STATUS='OLD')
open(10,file='DATA/filters/I_B12_ST.dat',STATUS='OLD')

iI = 0

read(10,*) trash

DO

  !read(10,*,END=106) lambdaI(iI+1), trash, filterI(iI+1)
  read(10,*,END=106) lambdaI(iI+1), filterI(iI+1)

  IF (iI > 0) normI = normI +  filterI(iI+1)*(lambdaI(iI+1)-lambdaI(iI))   ! Contribution to the effective norm of the filter

  iI = iI + 1

END DO

106 close(10)

open(10,file='DATA/filters/2massJ.dat',STATUS='OLD')

iJ = 0

read(10,*) trash

DO

  read(10,*,END=107) lambdaJ(iJ+1), filterJ(iJ+1)

  lambdaJ(iJ+1) = 1e4*lambdaJ(iJ+1)    ! wavelengths are given in microns in the file, convert to A

  IF (iJ > 0) normJ = normJ +  filterJ(iJ+1)*(lambdaJ(iJ+1)-lambdaJ(iJ))    ! Contribution to the effective norm of the filter

  iJ = iJ + 1

END DO

107 close(10)

open(10,file='DATA/filters/2massH.dat',STATUS='OLD')

iH = 0

read(10,*) trash

DO

  read(10,*,END=108) lambdaH(iH+1), filterH(iH+1)

   lambdaH(iH+1) = 1e4*lambdaH(iH+1)   ! wavelengths are given in microns in the file, convert to A

  IF (iH > 0) normH = normH +  filterH(iH+1)*(lambdaH(iH+1)-lambdaH(iH))    ! Contribution to the effective norm of the filter

  iH = iH + 1

END DO

108 close(10)

open(10,file='DATA/filters/2massKs.dat',STATUS='OLD')

iK = 0

read(10,*) trash

DO

  read(10,*,END=109) lambdaK(iK+1), filterK(iK+1)

  lambdaK(iK+1) = 1e4*lambdaK(iK+1)   ! wavelengths are given in microns in the file, convert to A

  IF (iK > 0) normK = normK +  filterK(iK+1)*(lambdaK(iK+1)-lambdaK(iK))    ! Contribution to the effective norm of the filter

  iK = iK + 1

END DO

109 close(10)

! READ SPITZER FILTERS ---------------------

open(10,file='DATA/filters/spitzer3p6mu.dat',STATUS='OLD')

iS1 = 0

DO

  read(10,*,END=110) lambdaS1(iS1+1), filterS1(iS1+1)

  lambdaS1(iS1+1) = 1e4*lambdaS1(iS1+1)   ! wavelengths are given in microns in the file, convert to A

  if (iS1 > 0) normS1 = normS1 + filterS1(iS1+1)*(lambdaS1(iS1+1)-lambdaS1(iS1))

  iS1 = iS1 + 1

END DO

110 close(10)

open(10,file='DATA/filters/spitzer4p5mu.dat',STATUS='OLD')

iS2 = 0

DO

  read(10,*,END=111) lambdaS2(iS2+1), filterS2(iS2+1)

  lambdaS2(iS2+1) = 1e4*lambdaS2(iS2+1)   ! wavelengths are given in microns in the file, convert to A

  if (iS2 > 0) normS2 = normS2 + filterS2(iS2+1)*(lambdaS2(iS2+1)-lambdaS2(iS2))

  iS2 = iS2 + 1

END DO

111 close(10)

! READ MC SPECTRUM --------------------------------

OPEN(10,file=file_emergent,STATUS='OLD',FORM='UNFORMATTED')

DO i=1,Nwl   ! Bin all slave outspectra (stacked in out.dat) into one (fluxvec_total)

  READ(10,END=100) ind, wl, flux_total, flux_nosc, flux_sc, flux_abin(1:Nabin), flux_nr_last(1:Nr), flux_nr_orig(1:Nr) ! ind : wavelength bin, wl : wavelength [A], flux_total : total flux [erg s^-1 A^-1], flux_nosc : flux that was not scattered, flux_sc : flux that was scattered, flux_abin : contributions by various elements, ...


  ! if (flux_total > 0) then
  !     write(*, '(I4, F8.2, ES10.2, 2F8.2)') ind, wl, flux_total, lambdavec(ind+1), lambdavec(ind)
  ! endif

!  END IF

  fluxvec_total(ind) = fluxvec_total(ind) + flux_total

  lbol = lbol +  flux_total*(lambdavec(ind+1)-lambdavec(ind))

  fluxvec_unsc(ind) = fluxvec_unsc(ind) + flux_nosc

  fluxvec_sc(ind) = fluxvec_sc(ind) + flux_sc

  fluxmat_abin(ind,:) = fluxmat_abin(ind,:) + flux_abin(:)

  fluxmat_nr_last(ind,:) = fluxmat_nr_last(ind,:) + flux_nr_last(:)

  fluxmat_nr_orig(ind,:) = fluxmat_nr_orig(ind,:) + flux_nr_orig(:)

END DO

100 close(10)

IF (DOSMOOTH .EQV. .TRUE.) THEN

	DO i = 1, Nwl   ! Create a smoothed spectrum (Gaussian smoothing)

  		IF (lambdavec(i) < 1.0e4) THEN

      		RP = RP_optical 

   		ELSE

      		RP = RP_NIR  

   		END IF

   		FWHM = lambdavec(i)/RP;   ! FWHM at this wavelength

   		sigmag = FWHM/2.35;  

   		call findbin2(Nwl, lambdavec, lambdavec(i)*(1.-5*FWHM), binleft)  ! CARE

   		IF (binleft <= 2) binleft = 2
 
   		call findbin2(Nwl, lambdavec, lambdavec(i)*(1.+5*FWHM), binright)

   		IF (binright == 0) binright = Nwl

   		DO j = binleft, binright
     
      		gaussn = 1/(sqrt(2*3.14)*sigmag)*exp(-(lambdavec(j)-lambdavec(i))**2/(2*sigmag**2));  ! normalized gaussian centered on this wavelength

      		fluxvec_smooth(i) = fluxvec_smooth(i) + fluxvec_total(j)*gaussn*(lambdavec(j)-lambdavec(j-1))

      		fluxmat_abin_smooth(i,:) =  fluxmat_abin_smooth(i,:) +  fluxmat_abin(i,:)*gaussn*(lambdavec(j)-lambdavec(j-1))

      		fluxmat_nr_orig_smooth(i,:) =  fluxmat_nr_orig_smooth(i,:) +  fluxmat_nr_orig(i,:)*gaussn*(lambdavec(j)-lambdavec(j-1))

   END DO

  END DO

END IF

OPEN(10,file='out/modelspectra/spectrum.dat'//TRIM(idrun),STATUS='REPLACE')   ! Write spectrum

WRITE(10,'(10000ES13.4E3)') lambdavec(1), 0., 0., 0., 0., zerovec !, 0., zerovec(1:Nr), 0., zerovec(1:Nr), 0., 0.

DO i = 2, Nwl-1

  ! KEY : 1:lambda [A], 2:total flux [erg s^-1 A^-1 cm^-2], 3: smoothed flux, 4:fluc_scattered, 5:flux_unscattered, 6:ABIN, 107:0(why?), 108:122 flux_Nr_orig, 123:sumoverHenv, 124:138:flux_last_nr, 139:last_nr_sumHeve, 140:sum1:5

   WRITE(10,'(10000ES13.4E3)') lambdavec(i), fluxvec_total(i)/DF, fluxvec_smooth(i)/DF, fluxvec_sc(i)/DF, fluxvec_unsc(i)/DF, fluxmat_abin(i,:)/DF !, 0., fluxmat_nr_orig_smooth(i,:)/DF, SUM(fluxmat_nr_orig(i,min(Nr,Ncore+2):Nr))/DF, fluxmat_nr_last(i,:)/DF, SUM(fluxmat_nr_last(i,min(Nr,Ncore+2):Nr))/DF, SUM(fluxmat_nr_last(i,1:Ncore))/DF  ! CARE col 107 nullified

END DO

close(10)


open(10,file='out/modelspectra/spectrum.dat'//TRIM(idrun),STATUS='OLD') 

DO i = 1, Nwl-1     ! READS again sometimes files changes...read data and find continuum levels as the weakest flux level within +- vcont

  read(10,*) lambdavec(i), fluxvec_total(i), fluxvec_smooth(i), fluxvec_sc(i), fluxvec_unsc(i), fluxmat_abin(i,:) !, trash, fluxmat_nr_orig(i,:), trash, fluxmat_nr_last(i,:)

  DO j = 1, Nlines

     IF (lambdavec(i) > fit(j,2) .AND. lambdavec(i) < fit(j,2)*(1+fit(j,4)/3e5) .AND. fluxvec_smooth(i) < fit(j,7))  THEN

        fit(j,7) = fluxvec_smooth(i)

        fit(j,8) = lambdavec(i)

     END IF

     IF (lambdavec(i) < fit(j,1) .AND. lambdavec(i) > fit(j,1)*(1-fit(j,4)/3e5) .AND. fluxvec_smooth(i) < fit(j,5)) THEN

        fit(j,5) = fluxvec_smooth(i)

        fit(j,6) = lambdavec(i)

     END IF

  END DO

END DO

close(10)

DO j = 1, Nlines

   fit(j,10) = (fit(j,7) - fit(j,5))/(fit(j,8)-fit(j,6)+1D-30)  ! B value (slope)

   fit(j,9) = fit(j,7) - fit(j,10)*fit(j,8)  ! A value (intercept)

END DO

DO i = 1, Nwl - 1

  corrf = reddening_cardelli_f(REAL(e_bv), REAL(lambdavec(i)))   ! Dust correction factor at this wavelength

  fluxvec_total_dusted(i) =  fluxvec_total(i)/corrf    ! Observed (dust-attenuated) flux

  fluxvec_smooth_dusted(i) =  fluxvec_smooth(i)/corrf    ! Observed (dust-attenuated) flux

  IF (lambdavec(i) > leftedge .AND. lambdavec(i) < rightedge) THEN

     lbol_limited = lbol_limited + fluxvec_total(i)*(lambdavec(i+1)-lambdavec(i))

     lbol_sc = lbol_sc + fluxvec_sc(i)*(lambdavec(i+1)-lambdavec(i))

  END IF

  DO j = 1, Nlines

     IF (((lambdavec(i) > fit(j,1)*(1-fit(j,3)/3e5)) .AND. (lambdavec(i) < fit(j,2)*(1+fit(j,3)/3e5)))) THEN

        fit(j,11) = fit(j,11) + (fluxvec_smooth(i)-(fit(j,9) + fit(j,10)*lambdavec(i)))*(lambdavec(i)-lambdavec(i-1)) ! Continuum-subtracted luminosity

        fit(j,12) = fit(j,12) + fluxvec_smooth(i)*(lambdavec(i+1)-lambdavec(i))  ! Non-cintinumm subtracted luminosity

     END IF

  END DO

  call findbin2(iU, lambdaU(1:iU), lambdavec(i), bin)

  IF (bin .NE. 0) THEN

     Uflux = Uflux + fluxvec_smooth(i)*(lambdavec(i)-lambdavec(i-1))*(filterU(bin) + (filterU(bin+1)-filterU(bin))/(lambdaU(bin+1)-lambdaU(bin))*(lambdavec(i)-lambdaU(bin)))

     Uflux_dust = Uflux_dust + fluxvec_smooth_dusted(i)*(lambdavec(i)-lambdavec(i-1))*(filterU(bin) + (filterU(bin+1)-filterU(bin))/(lambdaU(bin+1)-lambdaU(bin))*(lambdavec(i)-lambdaU(bin)))

  END IF

  call findbin2(iB, lambdaB(1:iB), lambdavec(i), bin)

  IF (bin .NE. 0) THEN

     Bflux = Bflux + fluxvec_smooth(i)*(lambdavec(i)-lambdavec(i-1))*(filterB(bin) + (filterB(bin+1)-filterB(bin))/(lambdaB(bin+1)-lambdaB(bin))*(lambdavec(i)-lambdaB(bin)))

     Bflux_dust = Bflux_dust + fluxvec_smooth_dusted(i)*(lambdavec(i)-lambdavec(i-1))*(filterB(bin) + (filterB(bin+1)-filterB(bin))/(lambdaB(bin+1)-lambdaB(bin))*(lambdavec(i)-lambdaB(bin)))

  END IF

  call findbin2(iV, lambdaV(1:iV), lambdavec(i), bin)

  IF (bin .NE. 0) THEN

     Vflux = Vflux + fluxvec_smooth(i)*(lambdavec(i)-lambdavec(i-1))*(filterV(bin) + (filterV(bin+1)-filterV(bin))/(lambdaV(bin+1)-lambdaV(bin))*(lambdavec(i)-lambdaV(bin)))

     Vflux_dust = Vflux_dust + fluxvec_smooth_dusted(i)*(lambdavec(i)-lambdavec(i-1))*(filterV(bin) + (filterV(bin+1)-filterV(bin))/(lambdaV(bin+1)-lambdaV(bin))*(lambdavec(i)-lambdaV(bin)))

  END IF

  call findbin2(iR, lambdaR(1:iR), lambdavec(i), bin)

  IF (bin .NE. 0) THEN

     Rflux = Rflux + fluxvec_smooth(i)*(lambdavec(i)-lambdavec(i-1))*(filterR(bin) + (filterR(bin+1)-filterR(bin))/(lambdaR(bin+1)-lambdaR(bin))*(lambdavec(i)-lambdaR(bin)))

     Rflux_dust = Rflux_dust + fluxvec_smooth_dusted(i)*(lambdavec(i)-lambdavec(i-1))*(filterR(bin) + (filterR(bin+1)-filterR(bin))/(lambdaR(bin+1)-lambdaR(bin))*(lambdavec(i)-lambdaR(bin)))

  END IF

  call findbin2(iI, lambdaI(1:iI), lambdavec(i), bin)

  IF (bin .NE. 0) THEN

     Iflux = Iflux + fluxvec_smooth(i)*(lambdavec(i)-lambdavec(i-1))*(filterI(bin) + (filterI(bin+1)-filterI(bin))/(lambdaI(bin+1)-lambdaI(bin))*(lambdavec(i)-lambdaI(bin)))

     Iflux_dust = Iflux_dust + fluxvec_smooth_dusted(i)*(lambdavec(i)-lambdavec(i-1))*(filterI(bin) + (filterI(bin+1)-filterI(bin))/(lambdaI(bin+1)-lambdaI(bin))*(lambdavec(i)-lambdaI(bin)))

  END IF

  call findbin2(iJ, lambdaJ(1:iJ), lambdavec(i), bin)

  IF (bin .NE. 0) THEN

     Jflux = Jflux + fluxvec_smooth(i)*(lambdavec(i)-lambdavec(i-1))*(filterJ(bin) + (filterJ(bin+1)-filterJ(bin))/(lambdaJ(bin+1)-lambdaJ(bin))*(lambdavec(i)-lambdaJ(bin)))

     Jflux_dust = Jflux_dust + fluxvec_smooth_dusted(i)*(lambdavec(i)-lambdavec(i-1))*(filterJ(bin) + (filterJ(bin+1)-filterJ(bin))/(lambdaJ(bin+1)-lambdaJ(bin))*(lambdavec(i)-lambdaJ(bin)))

  END IF

  call findbin2(iH, lambdaH(1:iH), lambdavec(i), bin)

  IF (bin .NE. 0) THEN

     Hflux = Hflux + fluxvec_smooth(i)*(lambdavec(i)-lambdavec(i-1))*(filterH(bin) + (filterH(bin+1)-filterH(bin))/(lambdaH(bin+1)-lambdaH(bin))*(lambdavec(i)-lambdaH(bin)))

     Hflux_dust = Hflux_dust + fluxvec_smooth_dusted(i)*(lambdavec(i)-lambdavec(i-1))*(filterH(bin) + (filterH(bin+1)-filterH(bin))/(lambdaH(bin+1)-lambdaH(bin))*(lambdavec(i)-lambdaH(bin)))

  END IF

  call findbin2(iK, lambdaK(1:iK), lambdavec(i), bin)

  IF (bin .NE. 0) THEN

     Kflux = Kflux + fluxvec_smooth(i)*(lambdavec(i)-lambdavec(i-1))*(filterK(bin) + (filterK(bin+1)-filterK(bin))/(lambdaK(bin+1)-lambdaK(bin))*(lambdavec(i)-lambdaK(bin)))

     Kflux_dust = Kflux_dust + fluxvec_smooth_dusted(i)*(lambdavec(i)-lambdavec(i-1))*(filterK(bin) + (filterK(bin+1)-filterK(bin))/(lambdaK(bin+1)-lambdaK(bin))*(lambdavec(i)-lambdaK(bin)))

  END IF

END DO

! OPERATIONS ON THIN SPECTRUM --------------------------

open(10,file='out/thinspectrum/tc.dat',STATUS='OLD')

ind = 0

DO

  READ(10,*,END=333) wlt(ind+1), tc(ind+1)   ! This is not convolved with anything

  ind = ind + 1

END DO

333 close(10)


! COMPUTE SPITZER PHOTOMETRY--------------------------

DO i = 1, ind

   if (wlt(i) > 2e4 .and. wlt(i) < 6e4) then

      call findbin2(iS1, lambdaS1(1:iS1), wlt(i), bin)

      IF (bin .NE. 0) THEN

         S1flux = S1flux + tc(i)*(wlt(i)-wlt(i-1))*(filterS1(bin) + (filterS1(bin+1)-filterS1(bin))/(lambdaS1(bin+1)-lambdaS1(bin))*(wlt(i)-lambdaS1(bin)))

         !S1flux_dusted = S1flux_dusted +

      END IF

      call findbin2(iS2, lambdaS2(1:iS2), wlt(i), bin)

      IF (bin .NE. 0) THEN

         S2flux = S2flux + tc(i)*(wlt(i)-wlt(i-1))*(filterS2(bin) + (filterS2(bin+1)-filterS2(bin))/(lambdaS2(bin+1)-lambdaS2(bin))*(wlt(i)-lambdaS2(bin)))

         !S2dusted

      END IF

  END IF

end do

S1flux_dust = S1flux 
S2flux_dust = S2flux 

! divide by intergral of transmission function

Uflux = Uflux/normU
Bflux = Bflux/normB
Vflux = Vflux/normV
Rflux = Rflux/normR
Iflux = Iflux/normI
Jflux = Jflux/normJ
Hflux = Hflux/normH
Kflux = Kflux/normK
S1flux = S1flux/normS1
S2flux = S2flux/normS2

Uflux_dust = Uflux_dust/normU
Bflux_dust = Bflux_dust/normB
Vflux_dust = Vflux_dust/normV
Rflux_dust = Rflux_dust/normR
Iflux_dust = Iflux_dust/normI
Jflux_dust = Jflux_dust/normJ
Hflux_dust = Hflux_dust/normH
Kflux_dust = Kflux_dust/normK
S1flux_dust = S1flux_dust/normS1
S2flux_dust = S2flux_dust/normS2

!call fitpeak(n4571, wl4571(1:n4571), flux4571(1:n4571), a4571, b4571, c4571)

! Read model luminosity not included in the MC spectrum (to check energy cons.)

!open(10,file=file_energybalance,STATUS='OLD')

!DO i = 1, Nr

!   read(10,*) trash, energyout(i), energyin(i)

!end do

!close(10)

DO i = 1, Nr

   open(10,file=TRIM(file_Eemit)//R_index_str(i),STATUS='OLD')  ! Flux that was not emitted in MC (assumed to escape freely)

     read(10,*) Eemit(i)

     Eemittot = Eemittot + Eemit(i)

   close(10)

END DO

DO i = 1, Nr

   open(10,file=TRIM(file_outside)//R_index_str(i),STATUS='OLD')  ! Flux that was not emitted in MC (assumed to escape freely)

     read(10,*) outsideflux(i)

     outsidefluxtot = outsidefluxtot + outsideflux(i)

   close(10)

END DO

DO i = 1, Nr

   open(10,file=TRIM(file_hIextra)//R_index_str(i),STATUS='OLD')    ! HI rec emission that is not included (because special treatment of HI)

     read(10,*) hIextra

     hIextratot = hIextratot + hIextra

   close(10)

END DO

DO i = 1, Nr

   open(10,file='out/statisticalandthermalequilibrium/molcool'//R_index_str(i),STATUS='OLD')    ! HI rec emission that is not included (because special treatment of HI)

     read(10,*) trash, molcool(i)

     molcooltot = molcooltot + molcool(i)

   close(10)

END DO

open(10,file='out/main_radtrans/firall.dat',STATUS='OLD')   ! MC fluorescence that occurs outside the MC range (assumed to escape freely)

DO

  read(10,*,END=531) fir

  mcoutside = mcoutside + fir

END DO

531 close(10)

DO i = 1, Nr

   open(10,file=TRIM(file_dustabs)//R_index_str(i),STATUS='OLD')

   read(10,*) da

    dustabs = dustabs + da

   close(10)

END DO

Ltot = lbol + outsidefluxtot + mcoutside + hIextratot + dustabs + molcooltot

open(10,file='out/process/energybudget.txt',STATUS='REPLACE')

write(*,'(A50,ES10.2,ES10.2)') 'SUSE EMISSION', Eemittot, Eemittot/dep
write(10,'(A50,ES10.2,ES10.2)') 'SUSE EMISSION', Eemittot, Eemittot/dep

write(*,'(A50,ES10.2,ES10.2)') 'LBOLMC', lbol, lbol/dep
write(10,'(A50,ES10.2,ES10.2)') 'LBOLMC', lbol, lbol/dep

write(*,'(A50,ES10.2,ES10.2)') 'THIN OUTSIDE', outsidefluxtot, outsidefluxtot/dep
write(10,'(A50,ES10.2,ES10.2)') 'THIN OUTSIDE', outsidefluxtot, outsidefluxtot/dep

write(*,'(A50,ES10.2,ES10.2)') 'MC OUTSIDE', mcoutside, mcoutside/dep
write(10,'(A50,ES10.2,ES10.2)') 'MC OUTSIDE', mcoutside, mcoutside/dep

write(*,'(A50,ES10.2,ES10.2)') 'HIEXTRA', hIextratot, hIextratot/dep
write(10,'(A50,ES10.2,ES10.2)') 'HIEXTRA', hIextratot, hIextratot/dep

write(*,'(A50,ES10.2,ES10.2)') 'DUST', dustabs, dustabs/dep
write(10,'(A50,ES10.2,ES10.2)') 'DUST', dustabs, dustabs/dep

write(*,'(A50,ES10.2,ES10.2)') 'MOLECULES', molcooltot,  molcooltot/dep
write(10,'(A50,ES10.2,ES10.2)') 'MOLECULES', molcooltot,  molcooltot/dep

write(*,'(A50,ES10.2,ES10.2)') '--- TOTAL ---', Ltot, Ltot/dep
write(10,'(A50,ES10.2,ES10.2)') '--- TOTAL ---', Ltot, Ltot/dep

close(10)
!write(*,'(A30,3ES10.2)') 'Lbol limited', lbol_limited, lbol_limited*DF

!write(*,'(A100)') 'Band   Flux (not dusted), Flux emitted (not dusted), Fraction of lbol,  mag (not dusted), mag (dusted)'

!write(*,'(A30,3ES10.2, 2F10.2)') 'U (Johnson)', Uflux, Uflux*DF, Uflux*DF*normU/Ltot, 2.5*log10(FrefU/Uflux), 2.5*log10(FrefU/Uflux_dust)

!write(*,'(A30,3ES10.2, 2F10.2)') 'B (Johnson)', Bflux, Bflux*DF, Bflux*DF*normB/Ltot, 2.5*log10(FrefB/Bflux), 2.5*log10(FrefB/Bflux_dust)

!write(*,'(A30,3ES10.2, 2F10.2)') 'V (Johnson)', Vflux, Vflux*DF, Vflux*DF*normV/Ltot, 2.5*log10(FrefV/Vflux), 2.5*log10(FrefV/Vflux_dust)

!write(*,'(A30,3ES10.2, 2F10.2)') 'R (Cousine)', Rflux, Rflux*DF, Rflux*DF*normR/Ltot, 2.5*log10(FrefR/Rflux), 2.5*log10(FrefR/Rflux_dust)

!write(*,'(A30,3ES10.2, 2F10.2)') 'I (Cousine)', Iflux, Iflux*DF, Iflux*DF*normI/Ltot, 2.5*log10(FrefI/Iflux), 2.5*log10(FrefI/Iflux_dust)

!write(*,'(A30,3ES10.2, 2F10.2)') 'J (2-mass)',  Jflux, Jflux*DF, Jflux*DF*normJ/Ltot, 2.5*log10(FrefJ/Jflux), 2.5*log10(FrefJ/Jflux_dust)

!write(*,'(A30,3ES10.2, 2F10.2)') 'H (2-mass)',  Hflux, Hflux*DF, Hflux*DF*normH/Ltot, 2.5*log10(FrefH/Hflux), 2.5*log10(FrefH/Hflux_dust)

!write(*,'(A30,3ES10.2, 2F10.2)') 'K (2-mass)',  Kflux, Kflux*DF, Kflux*DF*normK/Ltot, 2.5*log10(FrefK/Kflux), 2.5*log10(FrefK/Kflux_dust)

!write(*,'(A30,3ES10.2, 2F10.2)') 'Spitzer 3.6',  S1flux, S1flux*DF, S1flux*DF*normS1/Ltot, 2.5*log10(FrefS1/S1flux), 2.5*log10(FrefS1/S1flux_dust)

!write(*,'(A30,3ES10.2, 2F10.2)') 'Spitzer 4.5',  S2flux, S2flux*DF, S2flux*DF*normS2/Ltot, 2.5*log10(FrefS2/S2flux), 2.5*log10(FrefS2/S2flux_dust)

!write(*,'(A30,4ES10.2)'), 'MgI 4571 (not dust-damped)', fit(1,11), fit(1,11)*DF, fit(1,9:10)

!write(*,'(A30,4ES10.2)'), 'NaI 5896 (not dust-damped)', fit(2,11), fit(2,11)*DF, fit(2,9:10)

!write(*,'(A30,4ES10.2)'), 'OI 6300-6364 (not dust-damped)', fit(3,11), fit(3,11)*DF, fit(3,9:10)

!write(*,'(A30,4ES10.2)') 'Halpha 6563 (not dust-damped)', fit(4,11), fit(4,11)*DF, fit(4,9:10)

!write(*,'(A30,4ES10.2)') 'FeII 7155 (not dust-damped)', fit(5,11), fit(5,11)*DF, fit(5,9:10)

!write(*,'(A30,4ES10.2)') 'CaII 7291-7323 (not dust-damped)', fit(6,11), fit(6,11)*DF, fit(6,9:10)

!write(*,'(A30,4ES10.2)') 'CaII 8498-8662 (not dust-damped)', fit(7,11), fit(7,11)*DF, fit(7,9:10)

DO i = 1, Nr

   open(10,file=TRIM(file_temps)//R_index_str(i))

     read(10,*) T(i)

   close(10)

END DO

open(10,file='out/process/lbol.dat',STATUS='REPLACE')

write(10,*) Ltot

close(10)

INQUIRE(file='out/process/lboltotlong.dat',Exist=EXISTS)

IF (EXISTS) THEN

   open(10,file='out/process/lboltotlong.dat', STATUS='OLD', POSITION='APPEND')

   write(10,'(8ES12.2)') Ltot, Ltot/dep, lbol/Ltot, outsidefluxtot/Ltot, mcoutside/Ltot, hIextra/Ltot, dustabs/Ltot

   close(10)

ELSE

   open(10,file='out/process/lboltotlong.dat', STATUS='REPLACE')

   write(10,*) 'Total      MC      EMITOUTSIDE      MCOUTSIDE     HIEXTRA    DUST'

   write(10,'(7ES12.2)') Ltot, lbol/Ltot, outsidefluxtot/Ltot, mcoutside/Ltot, hIextra/Ltot, dustabs/Ltot

   close(10)

END IF

hrad = 0
hnt = 0
hratio=0

DO i = 1, Nr

  OPEN(10,file='out/statisticalandthermalequilibrium/sf'//R_index_str(i),STATUS='OLD')

  read(10,*) trash, trash, trash, heat(i), ion(i), exc(i)  ! Fractions of dep. energy going into heating, ionization and excitation.

  close(10)

END DO

tau1 = 0

tau2 = 0

tauha = 0


! SMOOTH TC SPECTRUM TO MIR INSTRUMENT RESOLUTION -----------------

IF (CONVOLVE_MIR_FORMEASURING) THEN

   dlambda(1) = 0;

   DO i = 2, ind

      dlambda(i) = wlt(i) - wlt(i-1)

   end DO

   RP = RP_MIR     ! Resolving power

   DO i = 2, ind

      IF (wlt(i) < 2e4) CYCLE

      FWHM = wlt(i)/RP   ! FWHM at this wavelength

      sigmag = FWHM/2.35

      gaussnvec(1:ind) = 1/(sqrt(2*pi)*sigmag)*exp(-(wlt(1:ind)-wlt(i))**2/(2*sigmag**2))  ! normalized gaussiance centered on this wavelength

      temp(i) = sum(tc(1:ind)*gaussnvec(1:ind)*dlambda(i))

   end DO

   tc(1:ind) = temp(1:ind)

END IF

open(10,file='out/process/tcconv.dat',STATUS='REPLACE')

DO i = 1, ind

  write(10,*) wlt(i), tc(i)

END DO

close(10)

!DO i = 1, ind

!   IF (wlt(i) > 128100. .AND. wlt(i) < 128100.*(1+vcont_fir/3e5) .AND. tc(i) < contneII_r)  THEN

!      contneII_r = tc(i)

!      contneII_wlr = wlt(i)

!   END IF

!   IF (wlt(i) < 128100. .AND. wlt(i) > 128100.*(1-vcont_fir/3e5) .AND. tc(i) < contneII_l) THEN

!      contneII_l = tc(i)

!      contneII_wll = wlt(i)

!   END IF

   !if ((tc(i) < feII26mucont) .AND. (wlt(i) > wl_feII26mu*(1-vcont_fir/3e5)) .AND. (wlt(i) < wl_feII26mu*(1+vcont_fir/3e5))) THEN

   !   feII26mucont = tc(i)

   !end if

   !if ((tc(i) < coII10p52mucont) .AND. (wlt(i) > wl_coII10p52mu*(1-vcont_fir/3e5)) .AND. (wlt(i) < wl_coII10p52mu*(1+vcont_fir/3e5))) THEN

   !   coII10p52mucont = tc(i)

   !end if

   !if ((tc(i) < feII24p52mucont) .AND. (wlt(i) > wl_feII24p52mu*(1-vcont_fir/3e5)) .AND. (wlt(i) < wl_feII24p52mu*(1+vcont_fir/3e5))) THEN

   !   feII24p52mucont = tc(i)

   !end if

   !if ((tc(i) < feII17p94mucont) .AND. (wlt(i) > wl_feII17p94mu*(1-vcont_fir/3e5)) .AND. (wlt(i) < wl_feII17p94mu*(1+vcont_fir/3e5))) THEN

   !   feII17p94mucont = tc(i)

   !end if

   !if ((tc(i) < niII6p63mucont) .AND. (wlt(i) > wl_niII6p63mu*(1-vcont_fir/3e5)) .AND. (wlt(i) < wl_niII6p63mu*(1+vcont_fir/3e5))) THEN

   !   niII6p63mucont = tc(i)

   !end if

   !if ((tc(i) < niI7p5mucont) .AND. (wlt(i) > wl_niI7p5mu*(1-vcont_fir/3e5)) .AND. (wlt(i) < wl_niI7p5mu*(1+vcont_fir/3e5))) THEN

   !   niI7p5mucont = tc(i)

   !end if

!END DO

!B_contneII = (contneII_r - contneII_l)/(contneII_wlr - contneII_wll)

!A_contneII = contneII_r - B_contneII*contneII_wlr

!DO i = 1, ind-1

!   IF (((wlt(i) > 128100*(1-vcut_fir/3e5)) .AND. (wlt(i) < 128100*(1+vcut_fir/3e5)))) THEN

!      lneII = lneII + (tc(i)-(A_contneII + B_contneII*wlt(i)))*(wlt(i)-wlt(i-1))

!   END IF

!   IF (wlt(i) > wl_feII26mu*(1.-vcut_fir/3e5) .AND. wlt(i) < wl_feII26mu*(1.+vcut_fir/3e5) .AND. (tc(i) > feII26mucont)) THEN

!      lfeII26mu = lfeII26mu + (tc(i)-feII26mucont)*(wlt(i+1)-wlt(i))

!   END IF

!   IF (wlt(i) > wl_coII10p52mu*(1.-vcut_fir/3e5) .AND. wlt(i) < wl_coII10p52mu*(1.+vcut_fir/3e5) .AND. (tc(i) > coII10p52mucont)) THEN

!      lcoII10p52mu = lcoII10p52mu + (tc(i)-coII10p52mucont)*(wlt(i+1)-wlt(i))

!   END IF

!   IF (wlt(i) > wl_feII24p52mu*(1.-vcut_fir/3e5) .AND. wlt(i) < wl_feII24p52mu*(1.+vcut_fir/3e5) .AND. (tc(i) > feII24p52mucont)) THEN

!      lfeII24p52mu = lfeII24p52mu + (tc(i)-feII24p52mucont)*(wlt(i+1)-wlt(i))

!   END IF

!   IF (wlt(i) > wl_feII17p94mu*(1.-vcut_fir/3e5) .AND. wlt(i) < wl_feII17p94mu*(1.+vcut_fir/3e5) .AND. (tc(i) > feII17p94mucont)) THEN

!      lfeII17p94mu = lfeII17p94mu + (tc(i)-feII17p94mucont)*(wlt(i+1)-wlt(i))

!   END IF

!   IF (wlt(i) > wl_niII6p63mu*(1.-vcut_fir/3e5) .AND. wlt(i) < wl_niII6p63mu*(1.+vcut_fir/3e5) .AND. (tc(i) > niII6p63mucont)) THEN

!      lniII6p63mu = lniII6p63mu + (tc(i)-niII6p63mucont)*(wlt(i+1)-wlt(i))

!   END IF

!   IF (wlt(i) > wl_niI7p5mu*(1.-vcut_fir/3e5) .AND. wlt(i) < wl_niI7p5mu*(1.+vcut_fir/3e5) .AND. (tc(i) > niI7p5mucont)) THEN

 !     lniI7p5mu = lniI7p5mu + (tc(i)-niI7p5mucont)*(wlt(i+1)-wlt(i))

 !  END IF

!END DO

DO i = 1, Nr

   OPEN(10, file=TRIM(file_EXCCUBE)//R_index_str(i), STATUS='OLD')

   DO

      read(10,*,END=233) trash, trash, abin, lev, trash, pval

      IF (lev <= 10) THEN

         pop(i, abin, lev) = pval

      END IF

   END DO

233 close(10)

END DO

open(10,file='out/main/heatfracsordered.dat',STATUS='OLD')

read(10,*) trash

DO i = 1, Nr

  read(10,*) trash, trash, trash, trash, trash, trash, heatrates(1:5)

  totheat(i) = sum(heatrates)

END DO

close(10)

inquire(file='out/process/all_long.dat', Exist=EXISTS)

IF (EXISTS) THEN

   open(10,file='out/process/all_long.dat',STATUS='OLD',POSITION='APPEND')

ELSE

    open(10,file='out/process/all_long.dat',STATUS='NEW')

END IF

!write(10,'(F8.2, 2ES9.2, 10F6.2, 10000ES11.3)') timedays, Ltot, Ltot/dep, 2.5*log10(FrefU/Uflux_dust), 2.5*log10(FrefB/Bflux_dust), 2.5*log10(FrefV/Vflux_dust),  2.5*log10(FrefR/Rflux_dust),  2.5*log10(FrefI/Iflux_dust),  2.5*log10(FrefJ/Jflux_dust),  2.5*log10(FrefH/Hflux_dust), 2.5*log10(FrefK/Kflux_dust), 2.5*log10(FrefS1/S1flux_dust), 2.5*log10(FrefS2/S2flux_dust), fit(1:15,11), dustabs, T, l4571_nocont, l5890_nocont,  l6300_nocont,  lha_nocont, l7155_nocont, l7300_nocont,  l8500_nocont, adcool, depfrac, hrad, hnt, hratio, heat, ion, exc, cool7155, cool7300, cool6300, molcool(1), molcool(1), 0., 0., 0., vcut, vcut_ha, vcont, vcont_ha, maxlambda_4571, maxlambda_5890, maxlambda_6300, maxlambda_ha, maxlambda_7155, maxlambda_7300, tau1, tau2, tauha, taumg(1:Nr,1), tauna(1:Nr,1), tauna(1:Nr,2), tauO(1:Nr,1), tauO(1:Nr,2), tauCaII(1:Nr,1), tauCaII(1:Nr,2), tauCaII(1:Nr,3),  tauCaII(1:Nr,4),  tauCaII(1:Nr,5), taufeii(1:Nr,1), tauFeII(1:Nr,2), 2.5*log10(FrefU/Uflux), 2.5*log10(FrefB/Bflux), 2.5*log10(FrefV/Vflux),  2.5*log10(FrefR/Rflux),  2.5*log10(FrefI/Iflux),  2.5*log10(1./Jflux)-23.76,  2.5*log10(1./Hflux)-24.86, 2.5*log10(1./Kflux)-25.92, 2.5*log10(FrefS1/S1flux), 2.5*log10(FrefS2/S2flux), pop(11:Nr,29,3), pop(1:Nr,14,4), pop(1:Nr,24,2), pop(1:Nr,24,3), neii(1:Nr,1), 0., 0., 0., 0., 0., 0., 0., totheat(1:Nr), fit(8:12,11)

write(10,'(F8.2, 2ES9.2, 10F6.2, 10000ES11.3)') timedays, Ltot, Ltot/dep, 2.5*log10(FrefU/Uflux_dust), 2.5*log10(FrefB/Bflux_dust), 2.5*log10(FrefV/Vflux_dust),  2.5*log10(FrefR/Rflux_dust),  2.5*log10(FrefI/Iflux_dust),  2.5*log10(FrefJ/Jflux_dust),  2.5*log10(FrefH/Hflux_dust), 2.5*log10(FrefK/Kflux_dust), 2.5*log10(FrefS1/S1flux_dust), 2.5*log10(FrefS2/S2flux_dust), fit(1:15,11), dustabs, T, l4571_nocont, l5890_nocont,  l6300_nocont,  lha_nocont, l7155_nocont, l7300_nocont,  l8500_nocont, 0., depfrac, hrad, hnt, hratio, heat, ion, exc, cool7155, cool7300, cool6300, molcool(1), molcool(1), 0., 0., 0., vcut, vcut_ha, vcont, vcont_ha, maxlambda_4571, maxlambda_5890, maxlambda_6300, maxlambda_ha, maxlambda_7155, maxlambda_7300, tau1, tau2, tauha, taumg(1:Nr,1), tauna(1:Nr,1), tauna(1:Nr,2), tauO(1:Nr,1), tauO(1:Nr,2), tauCaII(1:Nr,1), tauCaII(1:Nr,2), tauCaII(1:Nr,3),  tauCaII(1:Nr,4),  tauCaII(1:Nr,5), taufeii(1:Nr,1), tauFeII(1:Nr,2), 2.5*log10(FrefU/Uflux), 2.5*log10(FrefB/Bflux), 2.5*log10(FrefV/Vflux),  2.5*log10(FrefR/Rflux),  2.5*log10(FrefI/Iflux),  2.5*log10(1./Jflux)-23.76,  2.5*log10(1./Hflux)-24.86, 2.5*log10(1./Kflux)-25.92, 2.5*log10(FrefS1/S1flux), 2.5*log10(FrefS2/S2flux), pop(11:Nr,29,3), pop(1:Nr,14,4), pop(1:Nr,24,2), pop(1:Nr,24,3), neii(1:Nr,1), 0., 0., 0., 0., 0., 0., 0., totheat(1:Nr), fit(8:12,11)

close(10)

open(10,file='out/process/eb.dat',STATUS='REPLACE')

if (Ltot/dep > 0.95 .and. Ltot/dep < 1.05) then

  write(10,*) 1, Ltot/dep

else

  write(10,*) 0, Ltot/dep

end if

close(10)

!print *, molcool(3), molcool(5)
DEALLOCATE(molcool, totheat, pop, fluxmat_nr_orig, fluxmat_nr_last, fluxmat_nr_orig_smooth, flux_nr_orig, flux_nr_last, T, adcool, depfrac, heat, ion, exc, cool7155, cool7300, cool6300, outsideflux, taumg, tauna, tauO, taucaii, taufeii, neii, Eemit)

END PROGRAM PROCESS
