#! /bin/bash
# Input arguments : 1:ID   2:Nshells (<250)  3:runfile
# ------------------------------
if [ $2 -ge "251" ]; then
    echo "ERROR : Nshells > max allowed"
    exit 1
fi
# Check that necessary folders exist, otherwise create them:
mkdir -p $DD/saved # mkdir does nothing if folder already exists, -p suppresses error message
mkdir -p $DD/saved/$1  # Create new directory for these files, unless it exists already
mkdir -p $DD/saved/$1/$1lines
# STORE FILES --------------------------------
for i in `seq 1 $2`; do
  if [ $i -lt 10 ]; then
    ic="00"$i
  elif [ $i -lt 100 ]; then
    ic="0"$i
  elif [ $i -lt 1000 ]; then
    ic=$i
  else
    echo "Too many shells"
  fi
  echo $ic
# Lines
  cp out/main/lines/$ic\_tausorted.dat $DD/saved/$1/$1lines # Not needed
  cp out/main/lines/$ic\_integrated.dat $DD/saved/$1/$1lines # Not needed
  cp out/main/lines/$ic\_a6300.dat $DD/saved/$1/$1lines # Not needed
# Radiative heating rates
  cp out/radmaker/radmaker_radiativeheating.dat$ic $DD/saved/$1/$1radmaker_radiativeheating.dat$ic # Needed
# Total ionization rates
  cp out/radmaker/radmaker_ionrates.dat$ic $DD/saved/$1/$1radmaker_ionrates.dat$ic  # Not needed
# Specific ionization rates
  cp out/radmaker/radmaker_ionrates_specific.dat$ic $DD/saved/$1/$1radmaker_ionrates_specific.dat$ic  # Needed
# Photoexcitation rates
  cp out/radmaker/photoexcrates.dat$ic $DD/saved/$1/$1photoexcrates.dat$ic  # Needed
# Total photoexcitation rates
  cp out/radmaker/photoexctot.dat$ic $DD/saved/$1/$1photoexctot.dat$ic  # Not needed
# Molecule densities
  cp out/ionization/moldens.dat$ic $DD/saved/$1/$1moldens.dat$ic  # Needed
# Molecule something?
  cp out/ionization/molres.dat$ic $DD/saved/$1/$1molres.dat$ic #Needed
# Charge transfer heating
  cp out/ionization/ctheating.dat$ic $DD/saved/$1/$1ctheating.dat$ic # Needed
# Ionization balance
  cp out/ionization/ionfracs.dat$ic $DD/saved/$1/$1ionfracs.dat$ic # Needed
  cp out/ionization/ionfracsprev.dat$ic $DD/saved/$1/$1ionfracsprev.dat$ic #Needed (for time-dep)
  cp out/ionization/molresprev.dat$ic $DD/saved/$1/$1molresprev.dat$ic #Needed (for time-dep)
  cp out/ionization/trecordered.dat $DD/saved/$1/$1trecordered.dat
# Cooling channels
  cp out/netheating/cooling.dat$ic $DD/saved/$1/$1cooling.dat$ic  # Not needed
  cp out/statisticalandthermalequilibrium/adcoolordered.dat $DD/saved/$1/$1adcoolordered.dat # Not needed
# Spencer Fano channels
  cp out/statisticalandthermalequilibrium/sf$ic $DD/saved/$1/$1sf$ic # Not needed
# TD1
  # cp out/statisticalandthermalequilibrium/td1$ic $DD/saved/$1/$1td1$ic # Not needed
  cp out/statisticalandthermalequilibrium/gammant.dat$ic $DD/saved/$1/$1gammant.dat$ic
  # cp out/statisticalandthermalequilibrium/gammantprev.dat$ic $DD/saved/$1/$1gammantprev.dat$ic
# Temperatures
  cp out/plts/teqs.dat$ic $DD/saved/$1/$1teqs.dat$ic  # Needed
# Charge transfer level pumping
  cp out/ionization/cttoexc$ic $DD/saved/$1/$1cttoexc$ic  # Needed
# Absorbing lines
  cp out/main/n_levels_absorb.dat$ic $DD/saved/$1/$1n_levels_absorb.dat$ic  # Needed
# Ionization rates
  cp out/ionization/ionization_ntandgamma.dat$ic $DD/saved/$1/$1ionization_ntandgamma.dat$ic  # Not needed
  cp out/radmaker/NABS_fractions.dat$ic $DD/saved/$1/$1NABS_fractions.dat$ic  # Not needed
# Optical depths
  #cp out/calculatecubes/TAU.dat$ic $DD/saved/$1/$1TAU.dat$ic; gzip -f $DD/saved/$1/$1TAU.dat$ic  # Not needed
# NLTE solutions
  cp out/calculatecubes/EXC_CUBE.dat$ic $DD/saved/$1/$1EXC_CUBE.dat$ic  # Half-needed (they are read as starting guesses in suse)
# Dust absorption
  cp out/radmaker/dustabs.dat$ic $DD/saved/$1/$1dustabs.dat$ic  # Not needed
# Recombination times
  cp out/ionization/trec.dat$ic $DD/saved/$1/$1trec.dat$ic  # Not needed
# groundfracs
  cp out/radmaker/groundfracs.dat$ic $DD/saved/$1/$1groundfracs.dat$ic  # Needed
  #Convproblems
  #cp out/convproblems$ic $DD/saved/$1/$1convproblems$ic #Not needed
done
# Single files
cp $3 $DD/saved/$1/$1runpar.dat
cp out/thinspectrum/tc.dat $DD/modelspectra/$1_t.dat #Thin spectrum
cp out/modelspectra/spectrum.dat$1 $DD/saved/$1/$1spectrum.dat #Total spectrum
cp out/main/dep.dat $DD/saved/$1/$1dep.dat  # Needed
cp out/main/molcool.dat $DD/saved/$1/$1molcool.dat  # Not needed
cp out/main_radtrans/sendpackets.dat $DD/saved/$1/$1sendpackets.dat # Not needed
cp out/modelreader/modelsummary.dat $DD/saved/$1/$1modelsummary.dat # Not needed
cp out/checkconv/Told.dat $DD/saved/$1/$1Told.dat
cp out/checkconv/xeold.dat $DD/saved/$1/$1xeold.dat
cp out/checkconv/ionold.dat $DD/saved/$1/$1ionold.dat
cp out/depositionfunction/blobsize.dat $DD/saved/$1/$1blobsize.dat # Not needed but only computed in deposition run
cp out/main/heatfracsordered.dat $DD/saved/$1/$1heatfracsordered.dat # Not needed
#cp out/depositionfunction/taugamma.dat $DD/saved/$1/$1taugamma.dat # Not needed
cp out/modelreader/masses.dat $DD/saved/$1/$1masses.dat # Not needed
cp out/modelreader/thomson.dat $DD/saved/$1/$1thomson.dat # Not needed
cp out/process/eb.dat $DD/saved/$1/$1eb.dat
cp out/modelreader/timedays.dat $DD/saved/$1/$1timedays.dat
cp out/timeprev.dat $DD/saved/$1/$1timeprev.dat
cp out/plts/teqsordered.dat $DD/saved/$1/$1teqsordered.dat # Needed
cp out/plts/teqsprev.dat $DD/saved/$1/$1teqsprev.dat
cp out/process/lbol.dat $DD/saved/$1/$1lbol.dat
cp out/xelong/xeordered.dat $DD/saved/$1/$1xeordered.dat # Needed (if time-dep. run)
cp out/xelong/xeprev.dat $DD/saved/$1/$1xeprev.dat #Needed (if time-dep. run)

#Set up time dependent files for next epoch
#TEMP copy timedays.dat and teqsordered.dat to out directory for time dependent process, AFTER saving them in $DD/saved/
#TEMP copy ionfrac timestep solution to ionfracprev solution before starting next timestep
#TEMP copy xeordered timestep solution to xeprev solution before starting next timestep
#cp out/modelreader/timedays.dat out/timeprev.dat
#cp out/plts/teqsordered.dat out/plts/teqsprev.dat
#cp out/xelong/xeordered.dat out/xelong/xeprev.dat

for i in `seq 1 $2`; do
  if [ $i -lt 10 ]; then
    ic="00"$i
  elif [ $i -lt 100 ]; then
    ic="0"$i
  elif [ $i -lt 1000 ]; then
    ic=$i
  else
    echo "Too many shells"
  fi
  #TEMP
  #cp out/ionization/ionfracs.dat$ic out/ionization/ionfracsprev.dat$ic
  #cp out/ionization/molres.dat$ic out/ionization/molresprev.dat$ic
  #cp out/statisticalandthermalequilibrium/gammant.dat$ic out/statisticalandthermalequilibrium/gammantprev.dat$ic
done

#Save final runtime files
cp logfile $DD/saved/$1/$1logfile
cp out/ut $DD/saved/$1/$1ut
cp out/ut2 $DD/saved/$1/$1ut2
cp out/ut3 $DD/saved/$1/$1ut3
cp out/convproblems_suse $DD/saved/$1/$1convproblems_suse
cp runinfo.txt $DD/saved/$1/$1runinfo.txt
