SUBROUTINE readtaucube(N_atoms, atoms, Nlines, TAUCUBE)
use M1, ONLY : Nr, atomm, R_index_str, Nabin
USE FILES
IMPLICIT NONE
INTEGER, INTENT(IN) :: N_atoms, Nlines
TYPE(atomm), DIMENSION(N_atoms), INTENT(INOUT) :: atoms
REAL, DIMENSION(:,:,:), INTENT(OUT) :: TAUCUBE  ! Nr*Nlines*6
! ======================================
! Task : Reads in all line optical depths from the file file_TAU (defined in module FILES)
!        to TAU_CUBE
! Input :     N_atoms     Number of atoms
!             atoms       Array with the atoms (type atomm, M1)
!             Nlines      Number of lines
! Output :    TAUCUBE     Cube with line optical depths
! ======================================
INTEGER :: R_index, SEQ, i, j, abin, ind, R_index_old, shell
DOUBLE PRECISION :: lambda, tau
! ----------------------------------------------------------------------------------------------

R_index_old = 0

TAUCUBE = 0

DO shell = 1, Nr  ! For each zone...

   ind = 1   ! DO NOT MOVE UP

   OPEN(20, file = TRIM(file_TAU)//R_index_str(shell), STATUS='OLD')

   DO 

      READ(20,*,END=130) R_index, SEQ, abin, i, j, lambda, tau

      TAUCUBE(R_index,ind,1) = abin
   
      TAUCUBE(R_index,ind,2) = seq
   
      TAUCUBE(R_index,ind,3) = i
   
      TAUCUBE(R_index,ind,4) = j

      IF (abin <= Nabin) THEN

        IF (seq .ne. 0) THEN ! TEMP this is a quick fix

         TAUCUBE(R_index,ind,5) = atoms(seq)%LAMBDA(j,i)  ! CARE lambda has to be exact

         atoms(seq)%TAU(R_index,i,j) = tau   ! This information is retrived following line absorptions in followphotons.f90

        END IF

      ELSE

         TAUCUBE(R_index,ind,5) = lambda   ! Molecular line

      END IF

      TAUCUBE(R_index,ind,6) = tau

      ind = ind + 1

   END DO

130 continue

END DO

END

