REAL FUNCTION REDDENING_CARDELLI_F(eb_v, wl)
IMPLICIT NONE
             ! Extinction from Cardelli et al ApJ 345, 245 -94. Functions given for 0.3 < 1/lambda[mu] < 8 --> 1250 A < lambda[A] < 33,300 A.

REAL :: EB_V, wl, fl, x, wlm, a, b, y, fa, fb, rv, av, awl, corrfactor


   wlm = wl/1.e4  ! To microns

   x = 1./wlm

   IF (x .GT. 0.3 .AND. x .LT. 1.1) THEN
         
      a = 0.574*x**1.61
         
      b = -0.527*x**1.61
      
   ELSEIF (x .GT. 1.1 .AND. x .LT. 3.3) THEN
         
      y = x-1.82
         
      a = 1.+0.17699*y-0.5044*y**2-0.02427*y**3+0.72085*y**4+0.01979*y**5-0.77530*y**6+0.32999*y**7
         
      b = 1.41338*y+2.28305*y**2+1.07233*y**3-5.38434*y**4-0.62251*y**5+5.30260*y**6-2.09002*y**7
      
   ELSEIF (x .GE. 3.3 .AND. x .LT. 8.0) THEN
         
      IF(x .GE. 5.9 .AND. x .LE. 8.0) THEN
            
         fa = -0.04473*(x-5.9)**2-0.009779*(x-5.9)**3
            
         fb = 0.2130*(x-5.9)**2+0.1207*(x-5.9)**3
         
      ELSE
       
         fa = 0.
            
         fb = 0.
         
      ENDIF
         
      a = 1.752-0.316*x-0.104/((x-4.67)**2+0.341)+fa
         
      b = -3.090+1.825*x+1.206/((x-4.62)**2+0.263)+fb

   ELSE  ! Wavelength outside range 

      eb_v = 0

      corrfactor = 1.

      reddening_cardelli_f = 1.

      RETURN    
        
   ENDIF
      
   rv = 3.1
      
   av = eb_v*rv
      
   awl = av*(a + b/rv)
      
   corrfactor = 10.**(0.4*awl)    
         

   reddening_cardelli_f = corrfactor



END FUNCTION REDDENING_CARDELLI_F
