import glob
import subprocess
from shutil import copyfile

import numpy as np
import time


import os

# value of the energy deposition in this model
#def dep_energy(day):
#    return 9.92E41*np.exp(-day/111.) * 0.1

# re-worked deposition energy! 
def dep_energy(day):
    return 9.92E41*np.exp(-day/99.)*0.11 

# type 1bc co zone deposition energy`
#def dep_energy(day):
#    ya = np.exp(day * -1.39262070e-02)*np.exp(9.50184137e+01)
#    return ya


#-----------------------------------
# pick name
#-----------------------------------


file_name = 'test_soadd'

#-----------------------------------
# pick name
#-----------------------------------



days = range(600, 149, -50)

#days = [150, 200]

for d in days:
    print(file_name)
    print('------------------')
    print('model running at %i days'%d)
    print('------------------')
    lines = open('playmodel_ori_co').read().splitlines()
    lines[0] = lines[0].replace('xxx', str(d))
    open('playmodel_temp_co','w').write('\n'.join(lines))
    
    lines = open('out/main/dep_ori.dat').read().splitlines()
    lines[0] = lines[0].replace('xxxxx', '%5.2e'%dep_energy(d))
    lines[1] = lines[1].replace('xxxxx', '%5.2e'%dep_energy(d))
    open('out/main/dep.dat','w').write('\n'.join(lines))
    
    if d == days[0]:
        subprocess.call('bash iterate_mpirun.sh 1 2 4 playmodel playmodel_temp_co n n 500 10000 1 100000000 10 10 10', shell=True)
        subprocess.call('bash iterate_mpirun.sh 30 2 4 playmodel playmodel_temp_co n y 500 10000 1 100000000 10 10 10', shell=True)

    subprocess.call('bash iterate_mpirun.sh 30 2 4 playmodel playmodel_temp_co n y 500 10000 1 100000000 10 10 10', shell=True)

#    subprocess.call('bash iterate_mpirun.sh 1 2 4 playmodel playmodel_temp n n 500 10000 1 100000000 10 10 10', shell=True)

    

    if not os.path.exists('../p1_co-investigation/res/%s'%file_name):
        os.makedirs('../p1_co-investigation/res/%s'%file_name)
    if not os.path.exists('../p1_co-investigation/res/%s/diagnostics'%file_name):
        os.makedirs('../p1_co-investigation/res/%s/diagnostics'%file_name)

    temp = 'cp out/ionization/molres.dat001 ../p1_co-investigation/res/%s/molres_xxx.dat'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)
    
    temp = 'cp out/process/energybudget.txt ../p1_co-investigation/res/%s/eb_xxx.dat'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)
#    
    temp = 'cp $DD/ut ../p1_co-investigation/res/%s/diagnostics/ut_xxx'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)
    
    temp = 'cp $DD/ut2 ../p1_co-investigation/res/%s/diagnostics/ut2_xxx'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)

    temp = 'cp $DD/ut3 ../p1_co-investigation/res/%s/diagnostics/ut3_xxx'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)

    temp = 'cp out/convproblems ../p1_co-investigation/res/%s/diagnostics/cp_xxx'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)


    temp = 'grep WARNING $DD/* > ../p1_co-investigation/res/%s/diagnostics/warning_%i'%(file_name,d)
    subprocess.call(temp, shell = True)
    
    
    temp = 'cp /home/soli1476/Dropbox/SU/SUMO/out/calculatecubes/EXC_CUBE.dat001 /home/soli1476/Dropbox/SU/test/ode_solver/sumo-comp/exc_cube/%s'%(file_name)
    subprocess.call(temp, shell = True)
    
    temp = 'cp /home/soli1476/Dropbox/SU/SUMO/out/calculatecubes/TAU.dat001 /home/soli1476/Dropbox/SU/test/ode_solver/sumo-comp/tau_cube/%s'%(file_name)
    subprocess.call(temp, shell = True)
    
    temp = 'grep WARNING $DD/* > ../p1_co-investigation/res/%s/diagnostics/warning_%i'%(file_name,d)
    subprocess.call(temp, shell = True)
#    temp = 'grep WARNING $DD/* > ../p1_co-investigation/res/%s/diagnostics/warning_%i'%(file_name,d)
#    subprocess.call(temp, shell = True)

    temp = './putfiles.sh %s_%i 1 playmodel_temp'%(file_name,d)
    subprocess.call(temp, shell = True)
    time.sleep(1.0)


#for d in days:
#    
#    
#    subprocess.call("mpirun -n 2 suib playmodel_600 n", shell=True)


















