import glob
import subprocess
from shutil import copyfile

import numpy as np
import time

import os


# re-worked deposition energy! 
def dep_energy(day):
    return 9.92E41*np.exp(-day/99.)*0.11 

# pick time interval - uncomment choice
#-------------------------------------------------------
#reverse time
#days = range(600, 149, -50)

#forward time
#days = range(150, 201, 50)

#one time
#days = [200]


for d in days:
    print('------------------')
    print('model running at %i days'%d)
    print('------------------')
    
    # Sets the time in days in the parameter file
    lines = open('playmodel_ori_co').read().splitlines()
    lines[0] = lines[0].replace('xxx', str(d))
    open('playmodel_temp_co','w').write('\n'.join(lines))
    
    # Sets the deposition energy
    lines = open('out/main/dep_ori.dat').read().splitlines()
    lines[0] = lines[0].replace('xxxxx', '%5.2e'%dep_energy(d))
    lines[1] = lines[1].replace('xxxxx', '%5.2e'%dep_energy(d))
    open('out/main/dep.dat','w').write('\n'.join(lines))
    
    # If its the first time step, there is an initial run
    if d == days[0]:
        subprocess.call('bash iterate_mpirun.sh 1 2 4 playmodel playmodel_temp_co n n 500 10000 1 100000000 10 10 10', shell=True)
    # Iterative run
    subprocess.call('bash iterate_mpirun.sh 12 2 4 playmodel playmodel_temp_co n y 500 10000 1 100000000 10 10 10', shell=True)
    

