import glob
import subprocess
from shutil import copyfile

import numpy as np
import time


import os

# value of the energy deposition in this model
#def dep_energy(day):
#    return 9.92E41*np.exp(-day/111.) * 0.1

# re-worked deposition energy! 
#def dep_energy(day):
#    return 9.92E41*np.exp(-day/99.)*0.11 * 0.28

# re-worked deposition energy 2.0! now for the si-s-o zone
def dep_energy(day):
    return 3.1E41*np.exp(-day/98.)*0.09


# days picked
#days = range(150, 601, 50)
days = range(600, 149, -50)


#days_old = range(450, 149, -50)
#days_new = range(450, 175, -25)

#days = [d for d in days_new if d not in days_old]


file_name = 'mod_o-si-s_ori_cool2_csior'

#days = [450]
#days = range(150, 600, 100)
#days = range(200, 601, 100)
#days = range(550, 149, -100)
#days = [550]
#days = [300]
#days = [150]

#days = [350]

for d in days:
    print('------------------')
    print('model running at %i days'%d)
    print('------------------')
    lines = open('playmodel_ori').read().splitlines()
    lines[0] = lines[0].replace('xxx', str(d))
    open('playmodel_temp','w').write('\n'.join(lines))
    
    lines = open('out/main/dep_ori.dat').read().splitlines()
    lines[0] = lines[0].replace('xxxxx', '%5.2e'%dep_energy(d))
    lines[1] = lines[1].replace('xxxxx', '%5.2e'%dep_energy(d))
    open('out/main/dep.dat','w').write('\n'.join(lines))
    
    if d == days[0]:
        subprocess.call('bash iterate_mpirun.sh 1 2 4 playmodel playmodel_temp n n 500 10000 1 100000000 10 10 10', shell=True)

    subprocess.call('bash iterate_mpirun.sh 12 2 4 playmodel playmodel_temp n y 500 10000 1 100000000 10 10 10', shell=True)
    

    if not os.path.exists('../p2_full-model/res/%s'%file_name):
        os.makedirs('../p2_full-model/res/%s'%file_name)
    if not os.path.exists('../p2_full-model/res/%s/diagnostics'%file_name):
        os.makedirs('../p2_full-model/res/%s/diagnostics'%file_name)

    temp = 'cp out/ionization/molres.dat001 ../p2_full-model/res/%s/molres_xxx.dat'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)
    
    temp = 'cp out/process/energybudget.txt ../p2_full-model/res/%s/eb_xxx.dat'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)
    
    temp = 'cp $DD/ut ../p2_full-model/res/%s/diagnostics/ut_xxx'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)
    
    temp = 'cp $DD/ut2 ../p2_full-model/res/%s/diagnostics/ut2_xxx'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)

    temp = 'cp $DD/ut3 ../p2_full-model/res/%s/diagnostics/ut3_xxx'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)

    temp = 'cp out/convproblems ../p2_full-model/res/%s/diagnostics/cp_xxx'%file_name
    temp = temp.replace('xxx', str(d))
    subprocess.call(temp, shell=True)

    temp = 'grep WARNING $DD/* > ../p2_full-model/res/%s/diagnostics/warning_%i'%(file_name,d)
    subprocess.call(temp, shell = True)

    temp = './putfiles.sh %s_%i 1 playmodel_temp'%(file_name,d)
    subprocess.call(temp, shell = True)
    time.sleep(1.0)


#for d in days:
#    
#    
#    subprocess.call("mpirun -n 2 suib playmodel_600 n", shell=True)

