import glob
import subprocess
from shutil import copyfile
import math
import numpy as np
import time


#Base name for model, to be used when saving across several days
model_ID = 'LargeZoneMemTest'  # DATA/expmodels/file_explmodel_example2

#Runfile name
runfile = 'iptoy06_200'  # playmodel_memtest

#Read in number of zones and explosion file name from runfile
expfile = np.loadtxt(runfile,dtype=str,skiprows=3,max_rows=1,unpack=True)[1]
expfile = expfile.replace("'","")
zone_nr = int(np.loadtxt(runfile,dtype=str,skiprows=4,max_rows=1,unpack=True)[1])

#Write model file containing run information
runinfo = open("runinfo.txt","w")
runinfo.write('Run name: %s \n'%model_ID)
runinfo.write('Runfile: %s \n'%runfile)
runinfo.write('Number of zones: %d \n'%zone_nr)
runinfo.write('Explosion Model: %s \n'%expfile)
runinfo.write('Notes:\n')
runinfo.write('Checking if memory sharing code converges correctly \n')
runinfo.write('Comparing one of the testmodels with 18 zones.')
runinfo.close()

# Days, in desired run order
days = [200.]

for d in days:
    print('------------------')
    print('model running at %f days'%d)
    print('------------------')

    ## for 60 zone test and 512 total cores
    subprocess.call('bash iterate.sh 1 61 128 ' + model_ID + '_' + str(d) + " " + runfile + ' y n 400 25000 1 1000000000 100 100 100', shell=True)

    # Run gamma-dep once with fewer packages then run 50 iterations for iterative with same package count then run 5 more iterative with high count
    # subprocess.call('bash iterate.sh 1 19 32 ' + model_ID + '_' + str(d) + " " + runfile + ' y n 400 24900 1 10000 20 20 80', shell=True)
    # subprocess.call('bash iterate.sh 30 19 32 ' + model_ID + '_' + str(d) + " " + runfile + ' n y 400 24900 1 10000 20 20 80', shell=True)
    # subprocess.call('bash iterate.sh 8 19 512 ' + model_ID + '_' + str(d) + " " + runfile + ' n y 400 24900 1 1000000000 2000 2000 20000', shell=True)

    # subprocess.call('bash iterate.sh 1 19 64 ' + model_ID + '_' + str(d) + " " + runfile + ' n y 400 24900 1 100000 100 100 600', shell=True)

    #Save all relevant output files before moving to next day
    # subprocess.call('bash putfiles.sh ' + model_ID + '_' + str(d) + ' ' + str(zone_nr) + ' ' + runfile, shell=True) #TEMP copy timedays and teqsordered to out directory for time dependent process

    time.sleep(1.0)
