      subroutine sf(xe,abinvec,exc_on,comp_atan,ifail,heat_frac,exc_vec,exc_matrix,ion_vec, 
     &     ion_iochannels, xieff, nexc_vec, n_evec, R_index, Tin, Nstages)
      IMPLICIT NONE

      INCLUDE 'PARAM.SF'
      INCLUDE 'DATIE.SF'

      DOUBLE PRECISION :: xe, heat_frac
      DOUBLE PRECISION, DIMENSION(MIE) ::  ABINVEC,exc_vec,ion_vec,xieff
      DOUBLE PRECISION    :: exc_matrix(mie,mil),ion_iochannels(4)     
      INTEGER :: exc_on,comp_atan,ifail,nexc_vec(mie),n_evec,R_index,Nstages
      REAL :: Tin

      REAL :: jval=0.6, Tuse
      INTEGER :: Nstagesuse

c******************************************
c  this file is the same as sfjh.f in 
c  /hp1/users/cecilia/SF/SFNM/sfjh.f
c******************************************
C
C     the lines marked with cse should be changed when
C     skipping the secondary electrons.
C
C     check the lines marked with cx! before running the program !
C
C     E : ENERGIES IN eV
C     CROSS SECTIONS : CM**2
C     
C     THE SAME PROGRAM AS sfck.f BUT IN 'ENKEL PRECISION'     
c
c  exc_on = 1  :  excitations included
c          0  :  no excitations included
C
c  ifail = 1  :  the run failed
c        = 0  :  the run OK
c
c  comp_atan= 1  :  atan for every,given energy bin are calc.
c          0  :  atan for the energy bins are not calc.
c
C     THE ELEMENTS INCLUDED ARE GIVEN IN FILE 'DATIE'
C

      REAL    :: KE, XI,XIO,EX,EXMIN,AB,XEL,E,E0,EMAX,DT,EDT, SI,SE,Y,TRATE,DL,DC,TINI,PHX,PE,PI,
     & PEIEX,PEMX,PIMX,PIOX,XIEFFX,FATAN,Ekin
      INTEGER :: NL,IEMAX,IK,NIK,MQ,IE,IL,IWREY,J,ISEC,II
      CHARACTER(len=2) :: R_index_string(26) 
      REAL    :: B,A(IMAX),XIE,XJ,TSEC,TEX,TXMEI,DTII,DTIP1, T1,T2,S1,DCSC,TMEJ,DTJ,DTJP1,
     & X1,S2,S3,DTIS, DTISP1,SUMAY,EMTS,pesum,pisum
      
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CY/Y(IMAX)
      COMMON/CMQ/MQ
      COMMON/CELEM/IE,IL
      COMMON/CEBINSF/TRATE,DL,DC
      COMMON/CHL/TINI,PHX,PE,PI
      COMMON/COUT/PEIEX(MIE),PEMX(MIE,MIL),PIMX(MIE),PIOX(4),
     &     XIEFFX(MIE)
      COMMON/CATAN/FATAN(MIE,IMAX)
      SAVE /CATAN/
      COMMON/anders/jval, Tuse, Nstagesuse

      if (Tin >= 1000.) then ! CARE
        Tuse = Tin
      else
        print *, 'WARNING, using a fixed T=1000 K (larger than real T) in sf.f'
        Tuse = 1000.
      end if

      Nstagesuse = Nstages

      print *, 'sf', Nstages, Nstagesuse

!      R_index_string = (['01','02','03','04','05','06','07','08','09','10',
!     & '11','12','13','14','15','16','17','18','19','20','21','22','23','24','25','26'])

      ! Initializations:
      exc_matrix = 0
      exc_vec = 0        
      xel = xe
      ab = abinvec
      phx = 0.
      peiex = 0.
      pimx = 0.
      xieffx = 0.
      pemx = 0.
      piox = 0.
      ifail = 0

      NIK = N_EVEC
      EMAX = 3000.   ! Maximum energy of fast electrons in eV
      EDT = 200.     
      IEMAX = 145    ! CARE sync with Nabin in m1.f90

      DL = 1.         ! Grid parameter
      DC = 7.         ! Grid parameter
             
      CALL EION        ! Set all ionization potentials

      CALL EEX(exc_on)  ! Set excitation energies of all atoms and transitions (if iexfl = 1)

      CALL EBINS       ! define energy vector array for non-thermal electrons

      CALL SIGS        ! Compute cross sections for all excitation and ionization channels, at all energies

      IF (COMP_ATAN.EQ.1) CALL ATANR

      A = 0.  
         
      Y = 0.

      DO I = NIK-1,1,-1  ! For each energy bin, starting from the highest

         A = 0.

         Y(I) = 0.

         Ekin = E(I)

c     The source term.

        IF (Ekin .GT. (EMAX-EDT)) THEN

           B = (EMAX-Ekin)/EDT 

        ELSE

           B = 1.

        ENDIF

C  The diagonal matrix elements :

c  Heat
        A(I) = KE(Ekin)
C
        DO IE = 1,IEMAX

          IF (AB(IE).LE.0.) GOTO 9

          XIE = XI(IE)  

          XJ = JVAL*XIE

          TSEC = 2.*Ekin + XIE

          ISEC = NIK

          IF (TSEC .LT. EMAX) THEN

            DO II = NIK,I,-1

              IF (E(II) .LT. TSEC) THEN

                ISEC = II

                GOTO 10

              ENDIF

            ENDDO

          ENDIF 

 10       CONTINUE

          DO IL = 1,NL(IE)

c  Excitation term

             TEX = Ekin + EX(IE,IL)

             IF (E(I+1) .GT. TEX) THEN

                TXMEI = TEX - E(I)

                DTII = TXMEI*(1.+(E(I+1)-TEX)/DT(I))

                A(I) = A(I) + .5*DTII*SE(IE,IL,I)*AB(IE)

                DTIP1 = (TXMEI*TXMEI)/DT(I)

                A(I+1) = A(I+1) + .5*DTIP1*SE(IE,IL,I)*AB(IE)

             ELSE 

                A(I) = A(I) + .5*DT(I)*SE(IE,IL,I)*AB(IE)

             ENDIF

          ENDDO  

c  Primary electron ionization

          T1 = XIE

          T2 = (Ekin + XIE)*.5

c          if (t.gt.xie) then
C          DCSC=SI(IE,I)/ATAN((Ekin-XIE)/(2.*XJ))
c          else
c          dcsc=0.0
c          endif
          IF (T1 .LT. T2) THEN
C             DCSC=SI(IE,I)/FATAN(IE,I)
C            X1=(T1-XIE)/XJ
C             X2=(T2-XIE)/XJ
C            S1=DCSC*(ATAN(X2)-ATAN(X1))
C             S1=DCSC*FATAN(IE,I)
             S1 = SI(IE,I)
          ELSE
             S1 = 0.
          ENDIF

          A(I) = A(I) + .5*DT(I)*S1*AB(IE)

C  The non-diagonal matrix elements :

          DO J = I+1, NIK-1

C           DCSC=SI(IE,J)/ATAN((E(J)-XIE)/(2.*XJ))
             if (e(j).gt.xie) then

                DCSC=SI(IE,J)/FATAN(IE,J)

             else

                dcsc = 0.

             endif

             DO IL=1,NL(IE)

c  Excitation term

              TEX = Ekin + EX(IE,IL)

              IF (E(J) .LE. TEX) THEN

                 IF (E(J+1) .LT. TEX) THEN

                    A(J) = A(J) + .5*(DT(J-1)+DT(J))*SE(IE,IL,J)*AB(IE)

                 ELSE

                  TMEJ = TEX - E(J)

                  DTJ = DT(J-1) + TMEJ + TMEJ*(E(J+1)-TEX)/DT(J)

                  A(J) = A(J) + .5*DTJ*SE(IE,IL,J)*AB(IE)

                  DTJP1 = TMEJ*TMEJ/DT(J)

                  A(J+1) = A(J+1) + .5*DTJP1*SE(IE,IL,J+1)*AB(IE)

               ENDIF

            ENDIF

         ENDDO  

c     Primary electron ionization

         T1 = E(J) - Ekin

            IF (T1 .LT. XIE) T1 = XIE

            T2 = (E(J)+XIE)*.5

            IF (T1.LT.T2) THEN

              X1 = (T1-XIE)/XJ

C              X2=(T2-XIE)/XJ
C              S2=DCSC*(ATAN(X2)-ATAN(X1))

              S2 = DCSC*(FATAN(IE,J)-ATAN(X1))

            ELSE

               S2 = 0.

            ENDIF

            A(J) = A(J) + .5*(DT(J-1)+DT(J))*S2*AB(IE)

c  Secondary electron ionization 

cse            goto 777
            IF (J .GE. ISEC) THEN

              T1 = Ekin + XIE

              T2 = (E(J)+XIE)*.5

              IF (T1 .LT. T2) THEN

                X1 = (T1-XIE)/XJ
C                X2=(T2-XIE)/XJ
C                S3=DCSC*(ATAN(X2)-ATAN(X1))

                S3 = DCSC*(FATAN(IE,J)-ATAN(X1))

             ELSE

                S3 = 0.

             ENDIF

             IF(J .EQ. ISEC) THEN

                EMTS = E(ISEC+1) - TSEC  

                DTIS = EMTS*EMTS/DT(ISEC) 
 
                A(J) = A(J) - .5*DTIS*S3*AB(IE)

              ELSEIF (J .EQ. ISEC+1) THEN

                EMTS = E(ISEC+1) - TSEC  

                DTISP1 = DT(ISEC+1) + EMTS + EMTS*(TSEC-E(ISEC))/DT(ISEC)  

                A(J) = A(J) - .5*DTISP1*S3*AB(IE)

             ELSE
                A(J) = A(J) - .5*(DT(J-1)+DT(J))*S3*AB(IE)
                
             ENDIF        
          ENDIF
 777      continue
       ENDDO
 9     CONTINUE
      ENDDO

      SUMAY=0.
      DO J=I+1,NIK-1

         SUMAY = SUMAY + A(J)*Y(J)
        
      ENDDO

      Y(I) = (B-SUMAY)/A(I)

      IF (Y(I).LE.0.) THEN

         IFAIL=1

c     WRITE(6,*) ' Y NEGATIVE FOR ', I

         Y(I)=0.

      ENDIF


      ENDDO

C   CHECK IF Y:s ARE OK (IF THEY ARE UNSTABLE SOME WILL BE LESS THAN 
C   ZERO).

C      IF (IFAIL.EQ.1) GOTO 999

      CALL HEI

C     CALL FRACSE
 999  CONTINUE

 701  FORMAT(2E12.4)
 702  FORMAT(I4,3E12.4)

      heat_frac = phx
      pesum = 0.
      pisum = 0.
      do ie = 1,mie

         exc_vec(ie) = peiex(ie)

         ion_vec(ie) = pimx(ie)

         xieff(ie) = xieffx(ie)

         nexc_vec(ie) = nl(ie)

         pisum = pisum + ion_vec(ie)

         do il = 1,nl(ie)

            exc_matrix(ie,il) = pemx(ie,il)

            pesum = pesum + exc_matrix(ie,il)

         enddo
      enddo
      
      ion_iochannels(1:4)=piox(1:4)
 
      RETURN
      END

! ---------------------------------------------------

      REAL FUNCTION F(Ekin)

      IMPLICIT NONE
      REAL :: Ekin

      INCLUDE 'PARAM.SF'

      REAL    :: LAMB
      REAL    :: XI,XIO,EX,EXMIN,AB,XEL,E,E0,EMAX,TIN
      REAL    :: DT,EDT,SI,SE,Y
      INTEGER :: NL,IEMAX,IK,MQ,NIK,IE,IL

      REAL    :: ERR,FSUM,S,A1,YT,TE1,SIGE,A2,A3,E1,FAIL,AS,jval,Tuse
      INTEGER :: MQIN,I,IS,K,Nstagesuse

      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CMQ/MQ
      COMMON/CTIN/TIN
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CELEM/IE,IL
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CY/Y(IMAX)
      DATA ERR/0.05/
      COMMON/anders/jval, Tuse, Nstagesuse

      MQIN=MQ
      TIN=Ekin
      IF (Ekin.GE.(EMAX-EDT)) THEN
        S=1./EDT
      ELSE
        S=0.
      ENDIF
      FSUM=S
      DO IE=1,IEMAX
        IF (AB(IE).LE.0.) GOTO 9
        A1=0.

c  A1 : the excitation term

        DO IL=1,NL(IE)
          E1=EX(IE,IL)
          IF ((Ekin+E1).LT.E(NIK)) THEN
            DO I=1,IMAX
              IF (E(I).GT.(Ekin+E1)) THEN
                IF (I.EQ.1) YT=0.
                IF (I.GT.1) THEN
                  YT=Y(I)-((E(I)-(Ekin+E1))/(E(I)-E(I-1)))*(Y(I)-Y(I-1))
                ENDIF          
                IS=I
                GOTO 100
              ENDIF
            ENDDO
 100        CONTINUE
            TE1=Ekin+E1
            SIGE=SE(IE,IL,IS)+((E(IS)-TE1)/DT(IS-1))*(SE(IE,IL,IS)
     &          -SE(IE,IL,IS-1))
            A1=SIGE*YT+A1
          ENDIF
        ENDDO
c
c  A2 : primary electron ionization term
c
        LAMB=MIN(EMAX-Ekin,Ekin+XI(IE))
        MQ=5
        IF (LAMB.GT.XI(IE)) THEN
          CALL ROMBF(XI(IE),LAMB,ERR,A2,FAIL,K)
        ELSE
          A2=0.
        ENDIF
C        CALL SIMPAF(21,XI(IE),LAMB,A2)
c
c  A3 : secondary electron ionization term
c
        AS=2*Ekin+XI(IE)
        MQ=6
        IF (E(NIK).GT.AS.AND.TIN.GT.0.) THEN
          CALL ROMBF(AS,E(NIK),ERR,A3,FAIL,K)
        ELSE
          A3=0.
        ENDIF
cse        A3=0.
C        CALL SIMPAF(21,AS,E(NIK),A3)
C
        FSUM=AB(IE)*(A1+A2+A3)+FSUM
C
 9      CONTINUE
      ENDDO
      F=FSUM
      MQ=MQIN
C
      RETURN
      END


! ----------------------------------------------------

      REAL FUNCTION KE(Ekin)

      IMPLICIT NONE
      REAL :: Ekin

      INCLUDE 'PARAM.SF'

      REAL    :: AB,XEL
      INTEGER :: NL,IEMAX

      REAL    :: PI,ELCH,EMASS,HPL,EESU,DEL,CONST,ZATA

      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX

      DATA PI/3.1415926E0/,ELCH/1.60219E-12/,EMASS/9.1091E-28/
      DATA HPL/6.626E-27/,EESU/4.803E-10/

      DEL=1.e8
      CONST=XEL*(2.*PI*EESU**4/(Ekin*elch**2))
      IF (Ekin.GT.14) THEN
        ZATA=(HPL/PI)*SQRT(4.*PI*DEL*EESU**2/EMASS)/ELCH
        KE=CONST*LOG(4*Ekin/ZATA)
      ELSEIF (Ekin.LE.14) THEN
        KE=CONST*(0.5*LOG(Ekin**3/DEL)+23.95)
      ENDIF

      RETURN
      END

! ------------------------------------------------------

      REAL FUNCTION DSIG1(IE,Ekin,EN,IS)
      IMPLICIT NONE
      REAL    :: Ekin,EN
      INTEGER :: IE,IS

      REAL    :: XI,XIO,EX,EXMIN,AB,XEL,SI,SE,E,E0,EMAX
      REAL    :: DT,EDT,FATAN
      INTEGER :: NL,IEMAX,IK,NIK

      REAL    :: U,XJ,PET1,PET2,SIG1,SIG2,jval, Tuse
      INTEGER :: Nstagesuse

      INCLUDE 'PARAM.SF'

C   DIFFERENTIAL CROSSECTIONS

C   IS : E(IS-1) < Ekin < E(IS)
      
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CATAN/FATAN(MIE,IMAX)
      COMMON/anders/jval, Tuse, Nstagesuse

      U=Ekin/XI(IE)
      DSIG1=0.
      IF (U.LE.1.) GOTO 99
      IF (AB(IE).LE.0.) GOTO 99
      IF (EN.LE.XI(IE)) GOTO 99
      XJ=JVAL*XI(IE)
      if (fatan(ie,is-1).gt.0.) then
         PET1=1./((XJ*FATAN(IE,IS-1))*(1.+
     &        ((EN-XI(IE))/XJ)**2))      
      else
         pet1=0.
      endif
      PET2=1./((XJ*FATAN(IE,IS))*(1.+
     &    ((EN-XI(IE))/XJ)**2))      
      SIG1=SI(IE,IS-1)
      SIG2=SI(IE,IS)
      DSIG1=PET1*SIG1+((Ekin-E(IS-1))/DT(IS-1))*(PET2*SIG2-PET1*SIG1)
      if (dsig1.lt.0.) then
         write(*,701) 'WARNING dsig1 negative. ie,is,Ekin,dsig1= ',ie,is,Ekin,dsig1
      endif
 99   CONTINUE

 701  format(a,2i4,2e12.4)
      RETURN
      END

! -----------------------------------------------

      SUBROUTINE SIGS
      IMPLICIT NONE
!     ----------------
!     Computes excitation and ionization cross sections for all atoms, transitions and energies
!     -----------------
      REAL    :: AB,XEL,SI,SE,E,E0,EMAX,DT,EDT
      INTEGER :: NL,IEMAX,IK,NIK,NOIF

      REAL    :: Ekin
      INTEGER :: I,IE,IL

      REAL    :: FSIGE,FSIGI
      REAL    :: jval, Tuse
      INTEGER :: Nstagesuse

      INCLUDE 'PARAM.SF'

      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/COI/NOIF  

      COMMON/anders/jval,Tuse,Nstagesuse

      NOIF = 0

      SE = 0.

      SI = 0.

      DO I=1,NIK  ! For each energy (in the non-thermal range)

        Ekin = E(I)  ! Pick out the energy

        DO IE = 1, IEMAX

          IF (AB(IE).LE.0.) GOTO 9

          DO IL=1,NL(IE) ! For each excitation channel....         

              SE(IE,IL,I) = FSIGE(IE,IL,Ekin,Tuse)  ! Get excitation cross section....Care FSIGE is called also from another location
           
          ENDDO        

          SI(IE,I) = FSIGI(IE,Ekin,Nstagesuse)  ! Get ionization cross section...

 9        CONTINUE

        ENDDO

      ENDDO

      RETURN
      END

! ------------------------------------------------------


      SUBROUTINE ROMBSF(AA, BB, ERR, FI, FAIL, K)
      IMPLICIT NONE

      REAL    :: AA,BB,ERR,FI,FAIL
      INTEGER :: K

c     TASK : Compute integral
c     Input :    AA   Left intergration limit ?
c                BB   Right intergration limit ?
c     Output :  ERR   Error signal
c               FI    Integral value
c               K     ?

      REAL    :: TR(100),W(100),A,B,DX,X,FI1,FI2,TDX, FXSF, jval, Tuse
      INTEGER :: N,KK,I,J,M,Nstagesuse

      COMMON/anders/jval, Tuse, Nstagesuse

      A = AA

      B = BB

      DX = (B-A)/2.

      FI1 = 0.5*(FXSF(A) + FXSF(B))

      FI2 = FXSF(A+DX)

      TR(1) = DX*(FI1+FI2)

      N = 1

      K = 1

      W(1) = 4.

1     FI = TR(1)

      W(K+1) = 4.*W(K)

      N = 2*N

      K = K+1

      TDX = DX

      DX = DX/2.

      X = A+DX

      DO 2 I = 1,N

         FI2 = FI2 + FXSF(X)

2     X = X + TDX

      TR(K) = DX*(FI1+FI2)

      KK = K-1

      DO 3 J = 1, KK

      M = K-J

3     TR(M) = (W(J)*TR(M+1)-TR(M))/(W(J)-1.)

      FAIL = ABS(TR(1)-FI)/ABS(TR(1))

      IF(FAIL-ERR)6,6,4

4     IF(K-100)1,6,6

6     FI = TR(1)

      RETURN
      END

c ---------------------------------------

      SUBROUTINE ROMBF(AA,BB,ERR,FI,FAIL,K)
      IMPLICIT NONE
C


      REAL    :: AA,BB,ERR,FI,FAIL
      INTEGER :: K
   
C
      REAL    :: TR,W,A,B,DX,X,FI1,FI2,TDX
      INTEGER :: N,KK,I,J,M
C
      REAL    :: FXSF, jval, Tuse
      INTEGER :: Nstagesuse
C
      COMMON/anders/jval, Tuse, Nstagesuse

      DIMENSION TR(100),W(100)
      A=AA
      B=BB
c      A=DBLE(AA)
c      B=DBLE(BB)
      DX=(B-A)/2.
      FI1=0.5*(FXSF(A)+FXSF(B))
      FI2=FXSF(A+DX)
      TR(1)=DX*(FI1+FI2)
      N=1
      K=1
      W(1)=4.
1     FI=TR(1)
      W(K+1)=4.*W(K)
      N=2*N
      K=K+1
      TDX=DX
      DX=DX/2.
      X=A+DX
      DO 2 I=1,N
      FI2=FI2+FXSF(X)
2     X=X+TDX
      TR(K)=DX*(FI1+FI2)
      KK=K-1
      DO 3 J=1,KK
      M=K-J
3     TR(M)=(W(J)*TR(M+1)-TR(M))/(W(J)-1.)
      FAIL=ABS(TR(1)-FI)/ABS(TR(1))
      IF(FAIL-ERR)6,6,4
4     IF(K-100)1,6,6
6     FI=TR(1)
      RETURN
      END

c ------------------------------------------------------------------

      SUBROUTINE HEI

C     CALCULATES THE FRACTIONS GOING INTO HEATING (PH), EXCITATION (PE), AND IONIZATION (PI).

      IMPLICIT NONE

      REAL    :: XI,XIO,EX,EXMIN,AB,XEL,SI,SE,E,E0,EMAX,DT,EDT, TINI,PH,PE,PI,Y,
     & PEIE,PEM,PIM,PIOX,XIEFF,TINIWR,PH1,PH2,PH3,ERR,KE,YE0,XK,FAIL,SS
      INTEGER :: NL,IEMAX,IE,IL,IK,NIK,MQ,NOIF, K

      INCLUDE 'PARAM.SF'
      INCLUDE 'DATIE.SF'

      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CELEM/IE,IL
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CMQ/MQ
      COMMON/CHL/TINI,PH,PE,PI
      COMMON/CY/Y(IMAX)
      COMMON/COI/NOIF
      COMMON/COUT/PEIE(MIE),PEM(MIE,MIL),PIM(MIE),PIOX(4),
     &     XIEFF(MIE)
      common/cwr/tiniwr,ph1,ph2,ph3
      DATA ERR/0.01/

      TINI = E(NIK) - EDT/2.

C     HEATING ---------

      MQ = 1

      CALL ROMBSF(EXMIN,E(NIK), ERR, PH1, FAIL, K)

      MQ = 4

      CALL ROMBSF(0., EXMIN, ERR, PH2, FAIL, K)

      DO I = 1, NIK

        IF (E(I) .GT. EXMIN) THEN

          YE0 = Y(I-1)+((Y(I)-Y(I-1))*(EXMIN-E(I-1))/DT(I-1)) 
 
          GOTO 10

       ENDIF

      ENDDO

10    CONTINUE

      PH3 = YE0*EXMIN*KE(EXMIN)

      PH = (PH1+PH2+PH3)/TINI

C     EXCITATION ---------------------------

      MQ = 2

      DO IE = 1,IEMAX

        PEIE(IE) = 0.
 
        IF (AB(IE) .GT. 1E-3) THEN ! TEMP abundance threshold for exc rates (was 0)

           DO IL = 1,NL(IE)  

              CALL ROMBSF(EX(IE,IL),E(NIK),ERR,XK,FAIL,K)

              PEM(IE,IL) = AB(IE)*EX(IE,IL)*XK/TINI

              PEIE(IE) = PEIE(IE)+PEM(IE,IL)

           ENDDO

        ENDIF

      ENDDO

      PE = 0.

      DO IE = 1, IEMAX

         DO IL = 1, NL(IE)

            PE = PE + PEM(IE,IL)

         ENDDO

      ENDDO

C     IONIZATION --------------------------------

      MQ = 3

      NOIF = 0

      DO IE = 1, IEMAX

         IF (AB(IE) .GT. 0.) THEN

            CALL ROMBSF(XI(IE),E(NIK),ERR,XK,FAIL,K)

            PIM(IE) = AB(IE)*XI(IE)*XK/TINI

            if (pim(ie) .lt. 1.e-35) pim(ie)=1.e-35

         ENDIF

      ENDDO

C  O I
C  IONIZATION TO 4 DIFFERENT STATES IN O II
C  SEE LAHER AND GILMORE
C  1 : 4So
C  2 : 2Do
C  3 : 2Po
C  4 : 4P

      IF (AB(IO1).GT.0.) THEN

         IE = IO1

CJH      XIO(1:4)=<13.6,16.9,18.6,28.5>    C     IONIZATION ENERGIES TO THE DIFFERENT STATES
c        XIO(1)=13.6
c        XIO(2)=16.9
c        XIO(3)=18.6
c        XIO(4)=28.5

         DO I = 1,4

            NOIF = I
  
c     CALL ROMBSF(XIO(I),E(NIK),ERR,XK,FAIL,K)
c     PIOX(I)=AB(IO1)*XIO(I)*XK/TINI
c
c  really the integral should be from XIO(I) as the cross 
c  section should be zero for smaller E. However, the energy bins
c  for the ionization cross section are big, and the interpolation
c  procedure gives sig.ne.0. In order to be consistent and
c  conserve energy the integral is taken from XI. The errors may be 
c  few ( smaller than approx. 5 % (?)) percent. 
c
            CALL ROMBSF(XI(IE), E(NIK), ERR, XK, FAIL, K)  ! Hmm..uses 13.6 eV for all 4 channels

            PIOX(I) = AB(IO1)*XI(IE)*XK/TINI    ! XK changes with I through NOIF (common block shared w fsigi) (AB XI, TINI do not)

         ENDDO

         NOIF = 0

      ENDIF

      PI = 0.

      DO IE = 1,IEMAX

        PI = PI + PIM(IE)

      ENDDO

CJH      PI=SUM(PIM)
C
C   CALCULATE THE EFFECTIVE IONIZATION POTENTIAL


      DO IE=1,IEMAX
        IF(AB(IE).GT.0.) THEN
          XIEFF(IE)=XI(IE)/(PIM(IE)/AB(IE))                    
        ENDIF
      ENDDO
C
C2
      SS=PH+PE+PI
C2
      tiniwr=tini
      RETURN
      END

c --------------------------------------------------------------


      REAL RECURSIVE FUNCTION FXSF(Ekin)
C
      IMPLICIT NONE
C
      INCLUDE 'PARAM.SF'
      INCLUDE 'DATIE.SF'
c
      REAL    :: Ekin
C
      REAL    :: SI,SE,AB,XEL,XI,XIO,EX,EXMIN,TIN,E,E0,EMAX
      REAL    :: Y,DT,EDT
      INTEGER :: NL,IEMAX,IE,IL,MQ,IK,NIK
C
C      REAL    :: KE,FXSF,YT,XX,XY,YX,X2
      REAL    :: KE,YT,XX,XY,YX,X2
c081114      INTEGER :: I,IS
      INTEGER :: IS
c
      REAL    :: FSIGI,F,DSIG1,XJ,SIGT
      REAL  :: FSIGE, jval, Tuse
      INTEGER :: Nstagesuse
C
      COMMON/CSIGS/SI(MIE,IMAX),SE(MIE,MIL,IMAX)
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CELEM/IE,IL
      COMMON/CMQ/MQ
      COMMON/CTIN/TIN
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CY/Y(IMAX)
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/anders/jval, Tuse, Nstagesuse
C
      FXSF=0.0
      IF (MQ.LE.3) THEN
        DO I=1,IMAX
          IF (E(I).GT.Ekin) THEN
            YT=Y(I-1)+(Y(I)-Y(I-1))*(Ekin-E(I-1))/DT(I-1)
            IF (MQ.EQ.1) FXSF=YT*KE(Ekin)
          
            IF (MQ.EQ.2) FXSF=YT*FSIGE(IE,IL,Ekin,Tuse)
c            IF (MQ.EQ.2) THEN
c               if (ie.eq.ife2) then
c                  SIGT=SE(IE,IL,I-1)+(SE(IE,IL,I)-SE(IE,IL,I-1))*
c     &                 (Ekin-E(I-1))/DT(I-1)
c                  FXSF=YT*SIGT
c               else
c                  FXSF=YT*FSIGE(IE,IL,Ekin)
c               endif
c            ENDIF

            IF (MQ.EQ.3) FXSF=YT*FSIGI(IE,Ekin,Nstagesuse)
            GOTO 100
          ENDIF
        ENDDO
      ELSEIF (MQ.EQ.4) THEN
        FXSF=F(Ekin)*Ekin
      ELSEIF (MQ.EQ.5.OR.MQ.EQ.6) THEN
        IF (MQ.EQ.5) THEN
          XX=TIN+Ekin
          XY=Ekin
        ENDIF
        IF (MQ.EQ.6) THEN
          XX=Ekin
          XY=TIN+XI(IE)
        ENDIF
        DO I=1,IMAX
          IF (E(I).GT.XX) THEN
            IF (I.EQ.1) FXSF=0.
            IF (I.GT.1) THEN
              YX=((XX-E(I-1))/(E(I)-E(I-1)))*(Y(I)-Y(I-1))+Y(I-1)  
              IS=I
C              FXSF=YX*DSIGX(IE,XX,XY,IS)
              FXSF=YX*DSIG1(IE,XX,XY,IS)
            ENDIF
            GOTO 100
          ENDIF
        ENDDO
      ELSEIF (MQ.EQ.7) THEN  
cse 
C
C  SPECIAL CASE. ONLY WHEN NEGLECTING THE SECONDARY ELECTRONS.
C  HAS NEVER BEEN TESTED OR USED !
C
        XJ=JVAL*XI(IE)
        X2=0.5*(Ekin-XI(IE))/XJ
        DO I=1,IMAX
          IF (E(I).GT.Ekin) THEN
            YT=Y(I-1)+(Y(I)-Y(I-1))*(Ekin-E(I-1))/DT(I-1)
            FXSF=YT*FSIGI(IE,Ekin,Nstagesuse)
            GOTO 100
          ENDIF
        ENDDO

      ENDIF
 100  CONTINUE
C
      RETURN
      END

! --------------------------------------------------------------------

      SUBROUTINE EBINS
      IMPLICIT NONE

!     Defines the energy vector over which non-thermal electrons are computed?

      INCLUDE 'PARAM.SF'

      REAL    :: E,E0,EMAX,DT,EDT,TRATE,DL,DC
      INTEGER :: IK,NIK

      REAL    :: HEINT,LEINT,GKRIT
      REAL    :: DTH,DTE,DTSUM,DH
      INTEGER :: I

      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/CEBINSF/TRATE,DL,DC

C    HEINT : THE INTERVAL AT HIGH ENERGIES OVER WHICH A FINER GRID
C            IS WANTED
C    LEINT : THE INTERVAL AT LOW ENERGIES OVER WHICH A COARSER GRID
C            IS WANTED 
C    TRATE : TRANSITION "RATE" FROM FINE TO COARSE GRID

      DT =0.
 
      E =0.

      E(1) = E0

      E(NIK) =EMAX

      GKRIT=(EMAX-E0)/(NIK-1)
      IF (GKRIT.LE.0.5.or.nik.le.700) THEN
c      IF (GKRIT.LE.2.) THEN

C    IF EMAX IS LOW, USE EQUALLY SPACED ENERGY GRID

        DTE=(EMAX-E0)/(NIK-1)
        DO I=1,NIK-1
          DT(I)=DTE
          E(I+1)=E(I)+DT(I)
        ENDDO
      ELSE

C    IF EMAX HIGH (OR NIK LOW), USE FINER GRID IN THE LOW- 
C    AND HIGHENERGY PARTS AND A COARSER GRID IN BETWEEN

C    NF = NUMBER OF INTERVALS IN THE FINER GRID REGIONS (LOW/HIGH 
C         ENERGIES)


        HEINT=EDT+150.
        LEINT=200.

C  FOR THE LOW-ENERGY INTERVAL (E<200eV) THE GRIDSIZE(DT) IS 1 EV
C  DL = GRID SIZE FOR THE LOWER ENERGIES
        
c        DL=1.5
        I=1
        DT(I)=DL
        E(I+1)=E(I)+DT(I)
  11    CONTINUE
        IF (E(I+1).LT.200.) THEN
          I=I+1
          DT(I)=DL
          E(I+1)=E(I)+DT(I)  
          GOTO 11
        ENDIF

C  TRANSITION REGION TO COARESER GRID, WITH 'TRANSITIONRATE' = 1.1   
C  DC = THE COARSER GRID SIZE

c        DC=15.
  12    CONTINUE
        IF (DT(I).LT.DC) THEN
          I=I+1
          DT(I)=DT(I-1)*1.05
          E(I+1)=E(I)+DT(I)
          GOTO 12
        ENDIF  

C  THE COARSE GRID REGION

  13    CONTINUE
        IF (E(I+1).LT.(EMAX-HEINT)) THEN              
          I=I+1
          DT(I)=DC
          E(I+1)=E(I)+DT(I)
          GOTO 13
        ENDIF

C  TRANSITION REGION FROM COARSER TO FINER HIGH ENERGY GRID
C  'TRANSITION RATE' = 0.9
 
  14    CONTINUE
        DTH=(E(NIK)-E(I+1))/(NIK-I-1)        
        IF (DT(I).GT.DTH) THEN
          I=I+1
          DT(I)=DT(I-1)*0.95
          E(I+1)=E(I)+DT(I)  
          GOTO 14
        ENDIF

C  FINER GRID FOR HIGHER ENERGIES   
C  DH = GRID SIZE FOR THE HIGHER ENERGIES
        DH=DTH
  15    CONTINUE
        IF (I+1.LT.NIK) THEN
          I=I+1
          DT(I)=DH
          E(I+1)=E(I)+DT(I)
          GOTO 15
        ENDIF

      ENDIF
      DTSUM=0.
      DO I=1,IMAX
        DTSUM=DTSUM+DT(I)
      ENDDO
CJH      DTSUM=SUM(DT)

c      DO I=1,NIK-1
c        WRITE(6,702) I,DT(I),e(i+1)
c      ENDDO
c      WRITE(6,701) EMAX-E0,DTSUM

 701  FORMAT(2E12.4)
 702  FORMAT(I5,2e12.4)
      RETURN
      END



      SUBROUTINE ATANR
      IMPLICIT NONE
C
      INCLUDE 'PARAM.SF'
      INCLUDE 'DATIE.SF'
C
      REAL    :: E,E0,EMAX,AB,XEL,XI,XIO,EX,EXMIN,FATAN
      REAL    :: DT,EDT
      INTEGER :: IK,NL,IEMAX,NIK
C
      REAL    :: XIE,XJ,Ekin, jval, Tuse
C      INTEGER :: IE,I
      INTEGER :: IE, Nstagesuse
C
      COMMON/CEY/E(IMAX),IK,E0,EMAX
      COMMON/CABUND/AB(MIE),NL(MIE),XEL,IEMAX
      COMMON/CENERG/XI(MIE),XIO(4),EX(MIE,MIL),EXMIN
      COMMON/CATAN/FATAN(MIE,IMAX)
      COMMON/CHEI/DT(IMAX),EDT,NIK
      COMMON/anders/jval, Tuse, Nstagesuse
C
      DO IE=1,MIE
         DO I=1,IMAX
            FATAN(IE,I)=0.
         ENDDO
      ENDDO
      DO IE=1,IEMAX
         XIE=XI(IE)
         XJ=JVAL*XIE
         DO I=1,NIK
            Ekin=E(I)
            FATAN(IE,I)=ATAN((Ekin-XIE)/(2.*XJ))
         ENDDO
      ENDDO
C
      RETURN
      END

      
