SUBROUTINE SORTTAUCUBE(Nlinesvec, Nlines, TAUCUBE)
USE M1, ONLY : Nr
IMPLICIT NONE
INTEGER, INTENT(IN) :: Nlines
INTEGER, DIMENSION(:), INTENT(IN) :: Nlinesvec  ! Nr
REAL, DIMENSION(:,:,:), INTENT(INOUT) :: TAUCUBE  ! Nr*Nlines*6
! ----------------------------------
! Task :  Sorts optical depth cube in wavelength order in each shell
! Input :  Ninesvec      Number of lines in each shell
!          Nlines        Size of TAUCUBE in Number of lines dimension
!          TAUCUBE
! Output : TAUCUBE       
!-------------------------------------

INTEGER, DIMENSION(:), ALLOCATABLE :: indvec
INTEGER :: R_index, i

DO R_index = 1, Nr  ! For each shell..

   IF (Nlinesvec(R_index) > 0) THEN

      ALLOCATE(indvec(Nlinesvec(R_index))); indvec = 0

      CALL indexx(Nlinesvec(R_index), REAL(TAUCUBE(R_index,1:Nlinesvec(R_index),5)), indvec)

      DO i = 1, 6

         TAUCUBE(R_index,1:Nlinesvec(R_index),i) = TAUCUBE(R_index,indvec,i)

      END DO

      DEALLOCATE(indvec)

   END IF

END DO

END

