SUBROUTINE SORTTAUMAT(N_abs, TAUMAT)
IMPLICIT NONE
INTEGER, INTENT(IN) :: N_abs
DOUBLE PRECISION, DIMENSION(:,:), INTENT(INOUT) :: TAUMAT
! ----------------------------------
! Task :   Sorts optical depth matrix in order of increasing wavelengt
! Input :  N_abs          Number of lines
!          TAUMAT
! Output:  TAUMAT      Optical depth matrix, sorted
!-------------------------------------

INTEGER, DIMENSION(:), ALLOCATABLE :: indvec
INTEGER :: R_index, i

IF (N_abs > 0) THEN

   ALLOCATE(indvec(N_abs)); indvec = 0

   CALL indexx(N_abs, REAL(TAUMAT(1:N_abs,5)),indvec)  ! Index on wavelength

   DO i = 1, 6

      TAUMAT(1:N_abs,i) = TAUMAT(indvec,i)
         
   END DO

   DEALLOCATE(indvec)

END IF

END

