PROGRAM TCCOLLECTOR
USE M1
USE FILES, ONLY : file_runparameters
IMPLICIT NONE

! -----------------------
! Task : Collects output from thinspectrum.f90 into one file
! -------------------

INTEGER :: i, WLbins, bin, j, k
DOUBLE PRECISION :: wl, flux, wlstart, wlend, stepatstart, DF
DOUBLE PRECISION, DIMENSION(30000) :: wlvec, fluxvec, totfluxvec
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: lbolvec
DOUBLE PRECISION, DIMENSION(:,:), ALLOCATABLE :: fluxshell
DOUBLE PRECISION, DIMENSION(Nabin,30000) :: fluxmat_abin=0, totfluxmat_abin=0
CHARACTER :: trash

IF (COMMAND_ARGUMENT_COUNT() >= 1) THEN
  CALL GET_COMMAND_ARGUMENT(1, file_runparameters) ! Run parameters file name (optional)
END IF

open(10,file=file_runparameters,STATUS='OLD')

do i = 1,4; read(10,*) trash; end do

read(10,*) trash, Nr

close(10)

ALLOCATE(lbolvec(Nr)); lbolvec=0
ALLOCATE(fluxshell(Nr,30000)); fluxshell=0


totfluxvec = 0

DO i = 1, Nr


   OPEN(10,file='out/thinspectrum/tc.dat'//R_index_str(i),STATUS='OLD')

   j = 0

   DO

      READ(10,*,END=100) wlvec(j+1), fluxvec(j+1), fluxmat_abin(1:Nabin,j+1)

      j = j + 1

   END DO

100 CLOSE(10)

   DO k = 1, j-1    ! For each wavelength..

      totfluxvec(k) = totfluxvec(k) + fluxvec(k)  ! Add contribution of this shell to total..

      fluxshell(i,k) = fluxshell(i,k) +  fluxvec(k)

      totfluxmat_abin(1:Nabin,k) = totfluxmat_abin(1:Nabin,k) + fluxmat_abin(1:Nabin,k)   ! Add contribution of this shell to total..

   END DO

END DO


OPEN(10,file='out/thinspectrum/tc.dat',STATUS='REPLACE')  ! write total tc fluxes


DO i = 1, j-1

   WRITE(10,'(ES12.4, 1000ES12.3E3)') wlvec(i), totfluxvec(i), totfluxmat_abin(1:Nabin,i), fluxshell(1:Nr,i)

END DO

close(10)

DEALLOCATE(lbolvec, fluxshell)

END PROGRAM TCCOLLECTOR
