PROGRAM XELONG
USE FILES
USE M1
IMPLICIT NONE

! -------------------------
! TASK : Appends new electron fraction solutions to log file of these solutions
! GLOBALS USED :  Nr            Nr of shells (M1)
!                 R_index_str   String array w shell numbers (M1)
! ------------------------

INTEGER :: i
CHARACTER :: trash
DOUBLE PRECISION, DIMENSION(:), ALLOCATABLE :: xe
LOGICAL :: EXISTS

IF (COMMAND_ARGUMENT_COUNT() >= 1) THEN
  CALL GET_COMMAND_ARGUMENT(1, file_runparameters) ! Run parameters file name (optional)
END IF


open(10,file=file_runparameters,STATUS='OLD')

do i = 1,4; read(10,*) trash; end do

read(10,*) trash, Nr

close(10)


ALLOCATE(xe(Nr)); xe=0

DO i = 1, Nr  ! For each shell..

   OPEN(10,file=TRIM(file_ionfracs)//R_index_str(i), STATUS='OLD')   ! Read new electron fraction solutions

     READ(10,*) trash, xe(i)

   close(10)

END DO

inquire(file='out/xelong/xelong.dat',exist=EXISTS)

if (exists) then

  OPEN(10,file='out/xelong/xelong.dat',STATUS='OLD',POSITION='APPEND')  ! This is the log file

  WRITE(10,'(10000ES10.2)') xe    ! Append to log file

  close(10)

else

   OPEN(10,file='out/xelong/xelong.dat',STATUS='REPLACE')  ! This is the log file

  WRITE(10,'(10000ES10.2)') xe    ! Append to log file

  close(10)

end if

open(10,file='out/xelong/xeordered.dat',STATUS='REPLACE')   ! Create a file with the xe values in shell order

DO i = 1, Nr

   write(10,'(I3, ES12.2)') i, xe(i)

END DO

close(10)
DEALLOCATE(xe)
END PROGRAM XELONG
